-- Important Rules:

-- 1- GOD_LIKE_SECURITY and CAN_VIEW_ALL_CRI are independent.   July 23, 2004

-- 2- all new Folders are PUBLIC (by default)                   August 16, 2004

-- 3- we just have a Project level CRI system folder and all cri items will be created under this folder,

--   if user creates a folder at project level it does not move to the system folder, but if user creates a folder

--   in deliverable or task level then the folder moves under the system folder.

-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*********************************************
delete CRI TEMPLATES records
*********************************************/

Prompt == FUNCTION DELETE_CRI_TEMPLATE ==
CREATE OR REPLACE FUNCTION DELETE_CRI_TEMPLATE
(
     h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('DELETE_CRI_TEMPLATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('DELETE_CRI_TEMPLATE'), '-- ' || SYSTIMESTAMP, ':r := DELETE_CRI_TEMPLATE(' || 
       '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'DELETE_CRI_TEMPLATE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: DELETE_CRI_TEMPLATE(21) : cri.sql(40) : ' || SYSTIMESTAMP);
   END IF; 

   --local variable
   
   BEGIN
      SELECT PROJECT_ID, T_PARENT_ID, ELEMENT_ID, TYPE_ID, DOC_COUNT
      INTO h_project_id, h_parent_id, h_id, h_type_id, h_count
      FROM TMT_CRI WHERE RANK = h_rank;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(36) : cri.sql(55) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%' AND TYPE_ID = PMO_CNST.SC_TMP_FOLDER1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(68) : cri.sql(87) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI SET TEMPLATED = 'N', T_PARENT_ID = NULL, T_RANK = NULL
         WHERE PROJECT_ID = h_project_id AND T_RANK LIKE h_rank || '%' AND TEMPLATED = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(86) : cri.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_count, 0) > 0 Then
      BEGIN
         DELETE FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(104) : cri.sql(123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_CRI
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(122) : cri.sql(141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_CRI_TEMPLATE', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_CRI_TEMPLATE(140) : cri.sql(159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'DELETE_CRI_TEMPLATE', 145+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: DELETE_CRI_TEMPLATE(146) : cri.sql(165) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION DELETE_CRI_TEMPLATE;
ALTER FUNCTION DELETE_CRI_TEMPLATE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_CLEANS_DUP_CRI_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_DUP_CRI_BY_NAME
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_keywords VARCHAR2(255);
   h_external_reference VARCHAR2(50);
   h_reference_number PLS_INTEGER := 0;
   h_approved PLS_INTEGER := 0;
   h_reference_number_str VARCHAR2(255);
-- Declare Cursors
      CURSOR all_dup_cri_curs IS
         SELECT PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, EXTERNAL_REFERENCE, REFERENCE_NUMBER
         FROM PMO_CRI_DUP_VIEW
         WHERE TYPE_ID <> 145;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_DUP_CRI_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_DUP_CRI_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_DUP_CRI_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_DUP_CRI_BY_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_DUP_CRI_BY_NAME(28) : cri.sql(203) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_dup_cri_curs;
   
   LOOP
      h_element_name := NULL;
      h_keywords := NULL;
      h_external_reference := NULL;
      h_reference_number := NULL;
      h_reference_number_str := NULL;
      
      FETCH all_dup_cri_curs INTO h_project_id, h_element_id, h_element_name, h_external_reference, h_reference_number;
      IF all_dup_cri_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      --trace_printf("\n h_element_name:%s", h_element_name);
      
      h_approved := 1;
      
      h_reference_number_str := TO_CHAR(Coalesce(h_reference_number, 0));
      h_reference_number_str := h_reference_number_str;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         If FC_FIND_KEYWORD(h_external_reference, h_search_option) = 0 Then
            If FC_FIND_KEYWORD(h_reference_number_str, h_search_option) = 0 Then
               h_approved := 0;
            End If;
         End If;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_CRI_DUP_VIEW
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_DUP_CRI_BY_NAME', 82+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_DUP_CRI_BY_NAME(83) : cri.sql(258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_dup_cri_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_DUP_CRI_BY_NAME', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_DUP_CRI_BY_NAME(98) : cri.sql(273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_DUP_CRI_BY_NAME', 104+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_DUP_CRI_BY_NAME(105) : cri.sql(280) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_DUP_CRI_BY_NAME;
ALTER FUNCTION FC_CLEANS_DUP_CRI_BY_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_CLEANS_TEMPLATE_CRI_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_TEMPLATE_CRI_BY_NAME
(
     sh_h_search_option PLS_INTEGER
   , h_root_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_tmp_cri_curs IS
         SELECT PROJECT_ID, ELEMENT_ID, ELEMENT_NAME
         FROM PMO_CRI_VIEW
         WHERE ELEMENT_ID <> h_root_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_TEMPLATE_CRI_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_TEMPLATE_CRI_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_TEMPLATE_CRI_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL')
          || ', ' || '''' || h_root_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_TEMPLATE_CRI_BY_NAME', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_TEMPLATE_CRI_BY_NAME(26) : cri.sql(316) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_tmp_cri_curs;
   
   LOOP
      h_element_name := NULL;
      
      FETCH all_tmp_cri_curs INTO h_project_id, h_element_id, h_element_name;
      IF all_tmp_cri_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         h_approved := 0;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_CRI_VIEW
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_TEMPLATE_CRI_BY_NAME', 67+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_TEMPLATE_CRI_BY_NAME(68) : cri.sql(358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_tmp_cri_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_TEMPLATE_CRI_BY_NAME', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_TEMPLATE_CRI_BY_NAME(83) : cri.sql(373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_TEMPLATE_CRI_BY_NAME', 89+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_TEMPLATE_CRI_BY_NAME(90) : cri.sql(380) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_TEMPLATE_CRI_BY_NAME;
ALTER FUNCTION FC_CLEANS_TEMPLATE_CRI_BY_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_CLEANS_CRI_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_CRI_BY_NAME
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_keywords VARCHAR2(255);
   h_external_reference VARCHAR2(50);
   h_reference_number PLS_INTEGER := 0;
   h_approved PLS_INTEGER := 0;
   h_reference_number_str VARCHAR2(255);
-- Declare Cursors
      CURSOR all_cri_curs IS
         SELECT PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, EXTERNAL_REFERENCE, REFERENCE_NUMBER
         FROM PMO_CRI_VIEW
         WHERE ELEMENT_NAME <> 'WBS';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_CRI_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_CRI_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_CRI_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_CRI_BY_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_CRI_BY_NAME(28) : cri.sql(418) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_cri_curs;
   
   LOOP
      h_element_name := NULL;
      h_keywords := NULL;
      h_external_reference := NULL;
      h_reference_number := NULL;
      h_reference_number_str := NULL;
      
      FETCH all_cri_curs INTO h_project_id, h_element_id, h_element_name, h_external_reference, h_reference_number;
      IF all_cri_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      --trace_printf("\n h_element_name:%s", h_element_name);
      
      h_approved := 1;
      
      h_reference_number_str := TO_CHAR(Coalesce(h_reference_number, 0));
      h_reference_number_str := h_reference_number_str;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         If FC_FIND_KEYWORD(h_external_reference, h_search_option) = 0 Then
            If FC_FIND_KEYWORD(h_reference_number_str, h_search_option) = 0 Then
               h_approved := 0;
            End If;
         End If;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_CRI_VIEW
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_CRI_BY_NAME', 82+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_CRI_BY_NAME(83) : cri.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_cri_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_CRI_BY_NAME', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_CRI_BY_NAME(98) : cri.sql(488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_CRI_BY_NAME', 104+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_CRI_BY_NAME(105) : cri.sql(495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_CRI_BY_NAME;
ALTER FUNCTION FC_CLEANS_CRI_BY_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_ASSIGN_CRI_CHARGECODE ==
CREATE OR REPLACE FUNCTION FC_ASSIGN_CRI_CHARGECODE
(
     h_cb_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_cb_type_id PLS_INTEGER
   , h_cb_chargecode_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_cb_type_id PLS_INTEGER := sh_h_cb_type_id;
   h_cb_rankBase64 VARCHAR2(8);
   h_cb_rank VARCHAR2(200);
   h_cb_broker_type PLS_INTEGER := 8;
   h_cb_level_id PLS_INTEGER := 0;
   h_cb_max_rank PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ASSIGN_CRI_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ASSIGN_CRI_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := FC_ASSIGN_CRI_CHARGECODE(' || 
       '''' || h_cb_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_cb_type_id), 'NULL')
          || ', ' || '''' || h_cb_chargecode_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_CRI_CHARGECODE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ASSIGN_CRI_CHARGECODE(26) : cri.sql(531) : ' || SYSTIMESTAMP);
   END IF; 

   -- Get next sibling count
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_cb_chargecode_id, h_cb_max_rank);
   PMO_STPU.toBase64(Coalesce(h_cb_max_rank, 0), h_cb_rankBase64);
   
   BEGIN
      SELECT RTRIM(RANK) || h_cb_rankBase64, LEVEL_ID + 1
      INTO h_cb_rank, h_cb_level_id
      FROM TMT_CHARGECODES WHERE ELEMENT_ID = h_cb_chargecode_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_CRI_CHARGECODE', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_CRI_CHARGECODE(43) : cri.sql(548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TMT_CHARGECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      VALUES( h_cb_rank, h_cb_chargecode_id, h_cb_element_id, h_cb_type_id, h_cb_level_id, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_CRI_CHARGECODE', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_CRI_CHARGECODE(61) : cri.sql(566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         BEGIN
            UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_cb_broker_type AND EXISTS(SELECT ELEMENT_ID FROM TMT_CHARGECODES WHERE ELEMENT_ID = h_cb_element_id AND LEVEL_ID = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_CRI_CHARGECODE', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_CRI_CHARGECODE(80) : cri.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         PMO_DB2M.SC_STATE := 0;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_CRI_CHARGECODE', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_CRI_CHARGECODE(92) : cri.sql(597) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ASSIGN_CRI_CHARGECODE;
ALTER FUNCTION FC_ASSIGN_CRI_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_TRANS_CRI_CHARGECODE ==
CREATE OR REPLACE FUNCTION FC_TRANS_CRI_CHARGECODE
(
     h_cb_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_cb_type_id PLS_INTEGER
   , h_cb_chargecode_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_cb_type_id PLS_INTEGER := sh_h_cb_type_id;
   h_cb_rankBase64 VARCHAR2(8);
   h_cb_rank VARCHAR2(200);
   h_cb_broker_type PLS_INTEGER := 8;
   h_cb_level_id PLS_INTEGER := 0;
   h_cb_max_rank PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TRANS_CRI_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TRANS_CRI_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := FC_TRANS_CRI_CHARGECODE(' || 
       '''' || h_cb_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_cb_type_id), 'NULL')
          || ', ' || '''' || h_cb_chargecode_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TRANS_CRI_CHARGECODE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TRANS_CRI_CHARGECODE(26) : cri.sql(633) : ' || SYSTIMESTAMP);
   END IF; 

   -- Get next sibling count
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_cb_chargecode_id, h_cb_max_rank);
   PMO_STPU.toBase64(Coalesce(h_cb_max_rank, 0), h_cb_rankBase64);
   
   BEGIN
      SELECT RTRIM(RANK) || h_cb_rankBase64, LEVEL_ID + 1
      INTO h_cb_rank, h_cb_level_id
      FROM TMT_CHARGECODES WHERE ELEMENT_ID = h_cb_chargecode_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TRANS_CRI_CHARGECODE', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TRANS_CRI_CHARGECODE(43) : cri.sql(650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TMT_CHARGECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      VALUES( h_cb_rank, h_cb_chargecode_id, h_cb_element_id, h_cb_type_id, h_cb_level_id, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TRANS_CRI_CHARGECODE', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TRANS_CRI_CHARGECODE(61) : cri.sql(668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         BEGIN
            UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_cb_broker_type AND EXISTS(SELECT ELEMENT_ID FROM TMT_CHARGECODES WHERE ELEMENT_ID = h_cb_element_id AND LEVEL_ID = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TRANS_CRI_CHARGECODE', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TRANS_CRI_CHARGECODE(80) : cri.sql(687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         PMO_DB2M.SC_STATE := 0;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TRANS_CRI_CHARGECODE', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TRANS_CRI_CHARGECODE(92) : cri.sql(699) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TRANS_CRI_CHARGECODE;
ALTER FUNCTION FC_TRANS_CRI_CHARGECODE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRIDATES ==
CREATE OR REPLACE FUNCTION SP_U_CRIDATES
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRIDATES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRIDATES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRIDATES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDATES', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRIDATES(49) : cri.sql(758) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   -- Parse parameters to local variables
   h_bitflag := p_bitflag;
   If (Coalesce(h_bitflag, 0) <> 0) AND (Coalesce(h_bitflag, 0) <> PMO_CNST.SC_PLANNED) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDATES', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDATES(58) : cri.sql(767) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDATES', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDATES(61) : cri.sql(770) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- NEW ROLLUP ***********************************************************************************
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME
      INTO h_project_id, h_start_date, h_finish_date
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(78) : cri.sql(787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRIDATES', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRIDATES(85) : cri.sql(794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDATES', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDATES(88) : cri.sql(797) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(105) : cri.sql(814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date)) INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(121) : cri.sql(830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(143) : cri.sql(852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date)) INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 158+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(159) : cri.sql(868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      PLANNED_START = h_SC,
      PLANNED_FINISH = h_FC,
      PLANNED_DURATION = p_duration
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 184+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(185) : cri.sql(894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRIDATES', 190+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRIDATES(191) : cri.sql(900) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 197+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(198) : cri.sql(907) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDATES', 209+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDATES(210) : cri.sql(919) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRIDATES;
ALTER FUNCTION SP_U_CRIDATES COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_NAME ==
CREATE OR REPLACE FUNCTION SP_U_CRI_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_NAME', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_NAME(24) : cri.sql(959) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_NAME', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_NAME(29) : cri.sql(964) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_NAME', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_NAME(32) : cri.sql(967) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   -- Validate id
   h_id := p_id;
   
   BEGIN
      SELECT WBS_ID, ASSET_ID INTO h_wbs_id, h_asset_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(52) : cri.sql(987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_NAME', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_NAME(59) : cri.sql(994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_NAME', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_NAME(62) : cri.sql(997) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = p_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(81) : cri.sql(1016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_wbs_id, h_id) = PMO_CNST.SC_MATCH Then
      BEGIN
         UPDATE TMT_WBS
         SET ELEMENT_NAME = p_name
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(101) : cri.sql(1036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_asset_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET ELEMENT_NAME = PMO_ORASTD.LEFT(p_name, (PMO_CNST.SC_H_SHORT_DESC - PMO_CNST.TEMP_INC))
         WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(122) : cri.sql(1057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_NAME', 132+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_NAME(133) : cri.sql(1068) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 139+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(140) : cri.sql(1075) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_NAME', 151+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_NAME(152) : cri.sql(1087) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_NAME;
ALTER FUNCTION SP_U_CRI_NAME COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_IDEN ==
CREATE OR REPLACE FUNCTION SP_U_CRI_IDEN
(
     p_id VARCHAR2
   , p_reference_number VARCHAR2
   , p_type_id PLS_INTEGER
   , p_external_reference VARCHAR2
   , p_priority_id PLS_INTEGER
   , p_priority PLS_INTEGER
   , p_planning_type PLS_INTEGER
   , p_planning_unit VARCHAR2
   , p_constraint_type PLS_INTEGER
   , p_constraint_dt VARCHAR2
   , p_effort_duration_flag VARCHAR2
   , p_proposed_by_name VARCHAR2
   , p_proposed_datetime VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_IDEN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_IDEN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_IDEN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_reference_number || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_external_reference || ''''
          || ', ' || COALESCE(TO_CHAR(p_priority_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_planning_type), 'NULL')
          || ', ' || '''' || p_planning_unit || ''''
          || ', ' || COALESCE(TO_CHAR(p_constraint_type), 'NULL')
          || ', ' || '''' || p_constraint_dt || ''''
          || ', ' || '''' || p_effort_duration_flag || ''''
          || ', ' || '''' || p_proposed_by_name || ''''
          || ', ' || '''' || p_proposed_datetime || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_IDEN', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_IDEN(45) : cri.sql(1148) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_IDEN', 49+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_IDEN(50) : cri.sql(1153) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_IDEN', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_IDEN(53) : cri.sql(1156) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   -- Validate id
   h_id := p_id;
   
   BEGIN
      SELECT WBS_ID INTO h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_IDEN', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_IDEN(73) : cri.sql(1176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_IDEN', 79+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_IDEN(80) : cri.sql(1183) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_IDEN', 82+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_IDEN(83) : cri.sql(1186) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   --Do Update
   BEGIN
      UPDATE TMT_CRI
      SET --TYPE_ID = p_type_id,
      EXTERNAL_REFERENCE = p_external_reference,
      PRIORITY_ID = p_priority_id,
      PRIORITY = p_priority,
      PLANNING_TYPE = p_planning_type,
      PLANNING_UNIT = p_planning_unit,
      PROPOSED_BY_NAME = p_proposed_by_name,
      PROPOSED_DATETIME = p_proposed_datetime,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_IDEN', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_IDEN(112) : cri.sql(1215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_wbs_id, h_id) = PMO_CNST.SC_MATCH Then
      BEGIN
         UPDATE TMT_WBS
         SET PRIORITY = p_priority,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_IDEN', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_IDEN(133) : cri.sql(1236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_IDEN', 139+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_IDEN(140) : cri.sql(1243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_IDEN', 146+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_IDEN(147) : cri.sql(1250) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_IDEN', 158+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_IDEN(159) : cri.sql(1262) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_IDEN;
ALTER FUNCTION SP_U_CRI_IDEN COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_QUAN ==
CREATE OR REPLACE FUNCTION SP_U_CRI_QUAN
(
     p_id VARCHAR2
   , p_impact_level_id PLS_INTEGER
   , p_high_estimated_budget NUMBER
   , p_estimated_budget NUMBER
   , p_low_estimated_budget NUMBER
   , p_estimated_revenue NUMBER
   , p_estimated_saving NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_QUAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_QUAN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_QUAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_impact_level_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_high_estimated_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_low_estimated_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_revenue), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_saving), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_QUAN', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_QUAN(34) : cri.sql(1312) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_QUAN', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_QUAN(39) : cri.sql(1317) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_QUAN', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_QUAN(42) : cri.sql(1320) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   -- Validate id
   h_id := p_id;
   h_resource_id := p_rec_user;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CRI_QUAN', 52+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CRI_QUAN(53) : cri.sql(1331) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CRI' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CRI' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   --Do Update
   BEGIN
      UPDATE TMT_CRI SET
      IMPACT_LEVEL_ID = p_impact_level_id,
      ESTIMATED_BUDGET = p_estimated_budget,
      LOW_ESTIMATED_BUDGET = p_low_estimated_budget,
      HIGH_ESTIMATED_BUDGET = p_high_estimated_budget,
      ESTIMATED_REVENUE = p_estimated_revenue,
      ESTIMATED_SAVING = p_estimated_saving,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_QUAN', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_QUAN(86) : cri.sql(1364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_QUAN', 91+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_QUAN(92) : cri.sql(1370) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_QUAN', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_QUAN(99) : cri.sql(1377) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_QUAN', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_QUAN(111) : cri.sql(1389) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_QUAN;
ALTER FUNCTION SP_U_CRI_QUAN COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_RESP ==
CREATE OR REPLACE FUNCTION SP_U_CRI_RESP
(
     p_id VARCHAR2
   , p_approved_datetime VARCHAR2
   , p_approved_impact_level_id PLS_INTEGER
   , p_approved_by_name VARCHAR2
   , p_approved_budget NUMBER
   , p_approved_revenue NUMBER
   , p_approved_saving NUMBER
   , p_closed_by_name VARCHAR2
   , p_closed_datetime VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_closed_by_name VARCHAR2(255);
   h_rev_history VARCHAR2(2048);
   h_rec_user VARCHAR2(32);
   h_cri_task PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_close_stage_id PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_RESP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_RESP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_RESP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_approved_datetime || ''''
          || ', ' || COALESCE(TO_CHAR(p_approved_impact_level_id), 'NULL')
          || ', ' || '''' || p_approved_by_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_approved_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_approved_revenue), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_approved_saving), 'NULL')
          || ', ' || '''' || p_closed_by_name || ''''
          || ', ' || '''' || p_closed_datetime || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_RESP', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_RESP(45) : cri.sql(1450) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_RESP', 49+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_RESP(50) : cri.sql(1455) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_RESP', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_RESP(53) : cri.sql(1458) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT STAGE_ID, TYPE_ID, PROJECT_ID, REVISION_HISTORY, WBS_ID
      INTO h_stage_id, h_type_id, h_project_id, h_rev_history, h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(74) : cri.sql(1479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_RESP', 80+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_RESP(81) : cri.sql(1486) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_RESP', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_RESP(84) : cri.sql(1489) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   h_closed_by_name := p_closed_by_name;
   h_close_stage_id := h_stage_id;
   
   If (h_closed_by_name IS NOT NULL) Then
      If (Coalesce(h_stage_id, 0) = 4910) OR (Coalesce(h_stage_id, 0) = 4920) OR (Coalesce(
             h_stage_id, 0) = 4939) OR (Coalesce(h_stage_id, 0) = 5417) OR (Coalesce(
             h_stage_id, 0) = 5386) OR (Coalesce(h_stage_id, 0) = 4930) OR (Coalesce(
             h_stage_id, 0) = 6117) Then
         h_stage_id := 0;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
         h_stage_id := 2147483641;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 2147483642;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 2147483643;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 2147483644;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 2147483645;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 2147483646;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 2147483647;
      Else
         h_stage_id := 0;
      End If;
      
      If Coalesce(h_stage_id, 0) <> 0 Then
         BEGIN
            SELECT STAGE_ID INTO h_stage_id FROM PROJECT_STATE_DEF
            WHERE PROJECT_ID = h_project_id AND ELEMENT_TYPE = h_type_id AND STAGE_ID = h_stage_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 132+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(133) : cri.sql(1538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               INSERT INTO PROJECT_STATE_TRG VALUES(h_project_id, 3, h_type_id, h_id, h_stage_id, '0', p_rec_user, h_rev_history);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 150+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(151) : cri.sql(1556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (h_wbs_id IS NOT NULL) Then
         h_close_stage_id := getCloseStage(Coalesce(h_type_id, 0));
         
         BEGIN
            UPDATE TMT_WBS
            SET FD = PMO_CNST.SC_AF,
            FORECAST_START = Null,
            FORECAST_FINISH = Null,
            FORECAST_DURATION = 0,
            STAGE_ID = h_close_stage_id,
            REC_USER = h_rec_user
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(180) : cri.sql(1585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If isCRITask(Coalesce(h_type_id, 0)) <> 0 Then
      h_cri_task := 1;
   End If;
   
   --Do Update
   BEGIN
      UPDATE TMT_CRI SET
      APPROVED_DATETIME = p_approved_datetime,
      APPROVED_IMPACT_LEVEL_ID = p_approved_impact_level_id,
      APPROVED_BY_NAME  = p_approved_by_name,
      APPROVED_BUDGET   = p_approved_budget,
      APPROVED_REVENUE  = p_approved_revenue,
      APPROVED_SAVING   = p_approved_saving,
      CLOSED_BY_NAME    = p_closed_by_name,
      CLOSED_DATETIME   = p_closed_datetime,
      REC_USER          = p_rec_user,
      REC_DATETIME      = SYSTIMESTAMP,
      STAGE_ID          = h_close_stage_id,
      CHANGE_TO_TASK    = CASE WHEN h_cri_task = 1 THEN 1 ELSE CHANGE_TO_TASK END
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(217) : cri.sql(1622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_cri_task, 0) = 1 Then
      h_temp_sc_state := FC_CLOSE_EFFORT(h_id, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_RESP', 226+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_RESP(227) : cri.sql(1632) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 233+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(234) : cri.sql(1639) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_RESP', 245+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_RESP(246) : cri.sql(1651) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_RESP;
ALTER FUNCTION SP_U_CRI_RESP COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_RSK_QUAN ==
CREATE OR REPLACE FUNCTION SP_U_RSK_QUAN
(
     p_id VARCHAR2
   , p_mitigation_cost NUMBER
   , p_scope_rank_id PLS_INTEGER
   , p_schedule_rank_id PLS_INTEGER
   , p_cost_rank_id PLS_INTEGER
   , p_quality_rank_id PLS_INTEGER
   , p_probability_rank_id PLS_INTEGER
   , p_precision_rank_id PLS_INTEGER
   , p_impact_rank_id PLS_INTEGER
   , p_exposure_id PLS_INTEGER
   , p_consequense_cost NUMBER
   , p_probability_cost NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RSK_QUAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RSK_QUAN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RSK_QUAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_mitigation_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_schedule_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cost_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_quality_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_probability_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_precision_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_impact_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_exposure_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_consequense_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_probability_cost), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RSK_QUAN', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RSK_QUAN(43) : cri.sql(1710) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RSK_QUAN', 47+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RSK_QUAN(48) : cri.sql(1715) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RSK_QUAN', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RSK_QUAN(51) : cri.sql(1718) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   -- Validate id
   h_id := p_id;
   
   BEGIN
      SELECT PROJECT_ID
      INTO h_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RSK_QUAN', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RSK_QUAN(72) : cri.sql(1739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RSK_QUAN', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RSK_QUAN(79) : cri.sql(1746) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RSK_QUAN', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RSK_QUAN(82) : cri.sql(1749) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   --Do Update
   BEGIN
      UPDATE TMT_CRI
      SET MITIGATION_COST = p_mitigation_cost,
      SCOPE_RANK_ID = p_scope_rank_id,
      SCHEDULE_RANK_ID = p_schedule_rank_id,
      COST_RANK_ID = p_cost_rank_id,
      QUALITY_RANK_ID = p_quality_rank_id,
      PROBABILITY_RANK_ID = p_probability_rank_id,
      PRECISION_RANK_ID = p_precision_rank_id,
      IMPACT_RANK_ID=p_impact_rank_id,
      EXPOSURE_ID = p_exposure_id,
      CONSEQUENSE_COST = p_consequense_cost,
      PROBABILITY_COST = p_probability_cost,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RSK_QUAN', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RSK_QUAN(114) : cri.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE TMT_WBS W
         SET W.RISK_EXPOSURE = (SELECT (SUM(C.CONSEQUENSE_COST*(C.EXPOSURE_ID)))/(CASE WHEN COALESCE(SUM(C.CONSEQUENSE_COST),1) = 0.00 THEN 1 ELSE COALESCE(SUM(C.CONSEQUENSE_COST),1) END) FROM TMT_CRI C WHERE C.PROJECT_ID = h_project_id),
         W.CONSEQUENSE_COST = (SELECT SUM(C.CONSEQUENSE_COST) FROM TMT_CRI C WHERE C.PROJECT_ID = h_project_id)
         WHERE W.ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RSK_QUAN', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RSK_QUAN(135) : cri.sql(1802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RSK_QUAN', 141+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RSK_QUAN(142) : cri.sql(1809) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RSK_QUAN', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RSK_QUAN(149) : cri.sql(1816) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RSK_QUAN', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RSK_QUAN(161) : cri.sql(1828) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RSK_QUAN;
ALTER FUNCTION SP_U_RSK_QUAN COMPILE DEBUG;

/***********************************************************************************************/

Prompt == FUNCTION FC_CRICKIN_ALL ==
CREATE OR REPLACE FUNCTION FC_CRICKIN_ALL
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_checked_in_all PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C21 IS
         SELECT a.PROJECT_ID, a.ELEMENT_ID, a.WBS_ID
         FROM TMT_CRI a, TMT_CRI b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O'
         AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRICKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRICKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := FC_CRICKIN_ALL(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRICKIN_ALL', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRICKIN_ALL(36) : cri.sql(1880) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   OPEN C21;
   
   LOOP
      FETCH C21 INTO h_project_id, h_current_id, h_wbs_id;
      IF C21%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_checked_in_all := 1;
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_CKIN_CRI(h_checked_in_all, h_current_id, h_bitflag, h_rec_user);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_wbs_id IS NOT NULL) Then
         PMO_DB2M.SC_STATE := FC_CHECK_IN(h_checked_in_all, h_id, h_bitflag, h_rec_user);
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C21 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRICKIN_ALL', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRICKIN_ALL(73) : cri.sql(1917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRICKIN_ALL', 78+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRICKIN_ALL(79) : cri.sql(1923) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRICKIN_ALL;
ALTER FUNCTION FC_CRICKIN_ALL COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_CRICKIN_ALL ==
CREATE OR REPLACE FUNCTION SP_CRICKIN_ALL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CRICKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CRICKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := SP_CRICKIN_ALL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRICKIN_ALL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CRICKIN_ALL(22) : cri.sql(1955) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CRICKIN_ALL', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CRICKIN_ALL(28) : cri.sql(1961) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRICKIN_ALL', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CRICKIN_ALL(31) : cri.sql(1964) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- **************************************************************************************
   -- bitflag
   --      = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   h_bitflag := p_bitflag;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_CRICKIN_ALL(h_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CRICKIN_ALL', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CRICKIN_ALL(49) : cri.sql(1982) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRICKIN_ALL', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRICKIN_ALL(56) : cri.sql(1989) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRICKIN_ALL', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRICKIN_ALL(68) : cri.sql(2001) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CRICKIN_ALL;
ALTER FUNCTION SP_CRICKIN_ALL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_CRI ==
CREATE OR REPLACE FUNCTION SP_CKOUT_CRI
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_transfered_item_rec_status VARCHAR2(1);
   h_last_checkin TIMESTAMP;
   h_count PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_CRI(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_CRI(27) : cri.sql(2044) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CKOUT_CRI', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CKOUT_CRI(32) : cri.sql(2049) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CRI(35) : cri.sql(2052) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT REC_STATUS, LAST_CHECKIN, WBS_ID, CASE WHEN REC_USER = h_rec_user THEN 1 ELSE 0 END
      INTO h_rec_status, h_last_checkin, h_wbs_id, h_count
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(56) : cri.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CRI', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CRI(63) : cri.sql(2080) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CRI(66) : cri.sql(2083) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CKOUT_CRI', 72+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CKOUT_CRI(73) : cri.sql(2090) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_ACTIVE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CRI(76) : cri.sql(2093) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_ACTIVE, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'O') AND (Coalesce(h_count, 0) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CRI', 82+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CRI(83) : cri.sql(2100) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_CHECKOUT), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CRI(86) : cri.sql(2103) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_CHECKOUT, h_id, True);
   End If;
   
   If (h_wbs_id IS NOT NULL) Then
      -- test if the transfered element is check out or not
      BEGIN
         SELECT REC_STATUS
         INTO h_transfered_item_rec_status
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(104) : cri.sql(2121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strncmp(h_transfered_item_rec_status, 'O', 1) = PMO_CNST.SC_MATCH Then
         -- transfered element is checked out, it can not be checked out again
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CRI', 111+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CRI(112) : cri.sql(2129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_CHECKOUT), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CRI', 114+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CRI(115) : cri.sql(2132) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_CHECKOUT, h_id, True);
      Else
         BEGIN
            UPDATE TMT_WBS
            SET REC_STATUS = 'O',
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(135) : cri.sql(2152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 157+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(158) : cri.sql(2175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_CRI', 163+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_CRI(164) : cri.sql(2181) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_last_checkin, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 170+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(171) : cri.sql(2188) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CRI', 182+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CRI(183) : cri.sql(2200) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_CRI;
ALTER FUNCTION SP_CKOUT_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_CKIN_CRI ==
CREATE OR REPLACE FUNCTION FC_CKIN_CRI
(
     sh_h_checked_in_all PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_checked_in_all PLS_INTEGER := sh_h_checked_in_all;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_score PLS_INTEGER := 0;
   h_scorecard_id VARCHAR2(32);
   h_table_name VARCHAR2(100);
   h_table_type PLS_INTEGER := 0;
   h_converted_score NUMBER(19) := 0;
   h_wbs_id VARCHAR2(32);
-- Declare Cursors
      CURSOR CH1 IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_CRI
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_CRI(' || 
       COALESCE(TO_CHAR(sh_h_checked_in_all), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CRI', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_CRI(38) : cri.sql(2254) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag
   --  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --  = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --  = 2 check in as the same revision
   -- **************************************************************************************
   h_table_type := PMO_CNST.SC_TABLE_CRI;
   
   BEGIN
      SELECT PROJECT_ID, CONVERTED_SCORE, WBS_ID
      INTO h_project_id, h_converted_score, h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(60) : cri.sql(2276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CH1;
   
   FETCH CH1 INTO h_min_revision;
   IF CH1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(83) : cri.sql(2299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_checked_in_all, 0) = 1 Then
         BEGIN
            UPDATE TMT_CRI
            SET REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(105) : cri.sql(2321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CRI
            SET REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id
            AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 126+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(127) : cri.sql(2343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(141) : cri.sql(2357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 165+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(166) : cri.sql(2382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(189) : cri.sql(2405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 213+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(214) : cri.sql(2430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 236+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(237) : cri.sql(2453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 259+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(260) : cri.sql(2476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(281) : cri.sql(2497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If (Coalesce(h_converted_score, 0) = -1) AND (Coalesce(h_checked_in_all, 0) = 0) Then
      PMO_DB2M.SC_STATE := FC_CHECK_IN_ALL_SC(h_table_type, h_id, h_bitflag, h_rec_user);
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_CRI_RTF
         SELECT h_uniqueID, A.*
         FROM CRI_RTF A
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 312+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(313) : cri.sql(2529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO HISTORY_CRI
         SELECT h_uniqueID, A.*
         FROM TMT_CRI A
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 332+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(333) : cri.sql(2549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET REVISION_HISTORY = Null
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CRI', 351+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CRI(352) : cri.sql(2568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_checked_in_all, 0) = 0 Then
         h_bitflag := 2;
         h_table_name := 'HISTORY_CRI';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_table_name);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CRI', 364+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CRI(365) : cri.sql(2581) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_CRI;
ALTER FUNCTION FC_CKIN_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_CRI ==
CREATE OR REPLACE FUNCTION SP_CKIN_CRI
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_checked_in_all PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_CRI(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CRI', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_CRI(24) : cri.sql(2615) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CKIN_CRI', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CKIN_CRI(29) : cri.sql(2620) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CRI', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CRI(32) : cri.sql(2623) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_id := p_id;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT WBS_ID
      INTO h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CRI', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CRI(52) : cri.sql(2643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_checked_in_all := 0;
   PMO_DB2M.SC_STATE := FC_CKIN_CRI(h_checked_in_all, h_id, h_bitflag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_wbs_id IS NOT NULL) Then
      PMO_DB2M.SC_STATE := FC_CHECK_IN(h_checked_in_all, h_id, h_bitflag, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_CRI', 64+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_CRI(65) : cri.sql(2656) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CRI', 71+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CRI(72) : cri.sql(2663) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CRI', 83+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CRI(84) : cri.sql(2675) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_CRI;
ALTER FUNCTION SP_CKIN_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_UCKOUT_CRI ==
CREATE OR REPLACE FUNCTION FC_UCKOUT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rank VARCHAR2(200);
   h_score PLS_INTEGER := 0;
   h_scorecard_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UCKOUT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UCKOUT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_UCKOUT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UCKOUT_CRI', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UCKOUT_CRI(24) : cri.sql(2715) : ' || SYSTIMESTAMP);
   END IF; 

   If SubStr(h_rec_status, 1, 1) = 'O' Then
      BEGIN
         UPDATE TMT_CRI SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME
         FROM HISTORY_CRI
         WHERE ELEMENT_ID = h_id
         AND REC_DATETIME =  (SELECT MAX(REC_DATETIME) FROM HISTORY_CRI WHERE ELEMENT_ID = h_id))
         WHERE ELEMENT_ID = h_id
         AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UCKOUT_CRI', 45+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UCKOUT_CRI(46) : cri.sql(2737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UCKOUT_CRI', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UCKOUT_CRI(52) : cri.sql(2743) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_UNDO_CHECKOUT;
   End If;
   
   -- CHECK IF ASSIGNED SCORECARDS HAVE BEEN
   BEGIN
      SELECT SCORE, RANK
      INTO h_score, h_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UCKOUT_CRI', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UCKOUT_CRI(69) : cri.sql(2760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_score, 0) < 0 Then
      BEGIN
         SELECT ELEMENT_ID
         INTO h_scorecard_id
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE PARENT_RANK = 'CRI#' || h_rank;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UCKOUT_CRI', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UCKOUT_CRI(86) : cri.sql(2777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_table_type := 3;
      
      PMO_DB2M.SC_STATE := FC_UNDO_SC(h_table_type, h_scorecard_id, h_rec_user);
      
      BEGIN
         UPDATE TMT_CRI
         SET SCORE = ABS(SCORE)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UCKOUT_CRI', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UCKOUT_CRI(109) : cri.sql(2800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UCKOUT_CRI', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UCKOUT_CRI(116) : cri.sql(2807) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UCKOUT_CRI', 119+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UCKOUT_CRI(120) : cri.sql(2811) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UCKOUT_CRI;
ALTER FUNCTION FC_UCKOUT_CRI COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_CRI ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_CRI
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_undo_ckecked_out_tran_item PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_CRI(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CRI', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_CRI(25) : cri.sql(2846) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CRI', 29+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CRI(30) : cri.sql(2851) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CRI', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CRI(33) : cri.sql(2854) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT REC_STATUS, WBS_ID
      INTO h_rec_status, h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CRI', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CRI(55) : cri.sql(2876) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_undo_ckecked_out_tran_item := 1;
      
      PMO_DB2M.SC_STATE := FC_UCKOUT_CRI(h_id, h_rec_status, h_bitflag, h_rec_user);
      
      If (PMO_DB2M.SC_STATE = 0) AND ((h_wbs_id IS NOT NULL)) Then
         PMO_DB2M.SC_STATE := FC_UNDO_CHECKOUT(h_id, h_bitflag, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_CRI', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_CRI(71) : cri.sql(2892) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CRI', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CRI(78) : cri.sql(2899) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CRI', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CRI(90) : cri.sql(2911) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_CRI;
ALTER FUNCTION SP_UCKOUT_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ISOUT_CRI ==
CREATE OR REPLACE FUNCTION SP_ISOUT_CRI
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_CRI(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_CRI', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_CRI(21) : cri.sql(2948) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   OPEN SELECT_READ1 FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_CRI
   WHERE ELEMENT_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_CRI', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_CRI(30) : cri.sql(2957) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN SELECT_READ1;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_CRI', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_CRI(38) : cri.sql(2965) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_CRI(50) : cri.sql(2977) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_CRI;
ALTER FUNCTION SP_ISOUT_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_CRI_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_REVISION', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_REVISION(28) : cri.sql(3021) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_REVISION(36) : cri.sql(3029) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_REVISION', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_REVISION(39) : cri.sql(3032) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CRI_REVISION', 45+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CRI_REVISION(46) : cri.sql(3039) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CRI' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CRI' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CRI SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_REVISION', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_REVISION(75) : cri.sql(3068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_REVISION', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_REVISION(81) : cri.sql(3074) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_REVISION', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_REVISION(89) : cri.sql(3082) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_REVISION', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_REVISION(101) : cri.sql(3094) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_REVISION;
ALTER FUNCTION SP_U_CRI_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_CRI_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_revision VARCHAR2(32);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_xsql VARCHAR2(29999);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_REVISION(27) : cri.sql(3137) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CRI_REVISION', 31+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CRI_REVISION(32) : cri.sql(3142) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_REVISION(35) : cri.sql(3145) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision FROM TMT_SETTINGS WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(54) : cri.sql(3164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CRI_REVISION', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CRI_REVISION(60) : cri.sql(3170) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_REVISION(63) : cri.sql(3173) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      BEGIN
         SELECT TYPE_ID INTO h_type_id
         FROM TMT_CRI WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(78) : cri.sql(3188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_DOCUMENT Then
         h_xsql := 
               'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
                || 'T.ELEMENT_NAME, '
                || 'CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS WHERE PARENT_ID=''' || h_id || ''' AND '
                || 'REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 '
                || 'ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT,  '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
                || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
                || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT,  T.ELEMENT_NUMBER, T.ATTACHEMENT ,'''' AS CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME , '''' AS OUTCOME_NAME '
                || 'FROM HISTORY_DOCUMENTS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
                || ' LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID=DT.ELEMENT_ID '
                || 'WHERE T.ELEMENT_ID = ''' || h_id || ''' '
                || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
      Else
         h_xsql := 
               'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
                || 'T.ELEMENT_NAME, '
                || 'CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS WHERE PARENT_ID=''' || h_id || ''' AND '
                || 'REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 '
                || 'ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT,  '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
                || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
                || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT ,'''' AS CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME ,'''' AS OUTCOME_NAME '
                || 'FROM HISTORY_CRI T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
                || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID= DT.ELEMENT_ID '
                || 'WHERE T.ELEMENT_ID = ''' || h_id || ''' '
                || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
      End If;
   Else
      BEGIN
         SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
         INTO h_revision, h_rank, h_level_id, h_parent_id
         FROM HISTORY_CRI WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(123) : cri.sql(3233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_DOCUMENTS WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(139) : cri.sql(3249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CRI_REVISION', 144+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CRI_REVISION(145) : cri.sql(3255) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 147+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_REVISION(148) : cri.sql(3258) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
         End If;
         
         h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
                || 'T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
                || 'WHERE PARENT_ID=''' || h_parent_id 
                     || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' '
                || '|| RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, '
                || 'T.DELETED_COUNT, '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
                || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
                || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT ,'''' AS CHECKLIST,DT.DESCRIPTION AS STAGE_NAME ,'''' AS OUTCOME_NAME '
                || 'FROM HISTORY_DOCUMENTS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
                || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID=DT.ELEMENT_ID '
                || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
                || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + 1) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
                     || ''' || A.RANK) AS RANK, '
                || '(CASE WHEN A.LEVEL_ID = 1 THEN ''' || h_id || ''' ELSE A.PARENT_ID END) AS PARENT_ID, '
                || 'A.ELEMENT_ID, C.ELEMENT_NAME, 0 AS CHILD_COUNT, '
                || 'A.DELETED_COUNT, A.ELEMENT_NAME AS CYCLE_NAME, A.SUBJECT AS DESCRIPTION, '''' AS REVISION, '
                || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.CREATED_DATE  AS REC_DATETIME, '
                || 'R.FULL_NAME AS AUTHOR, A.SUBJECT AS SUBJECT ,C.CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME, A.OUTCOME_NAME  '
                || 'FROM (TMT_WORKFLOWS A LEFT JOIN TMT_WORKFLOW_CYCLES C ON C.ELEMENT_ID=A.WKF_DEF_ID) '
                || 'LEFT JOIN RESOURCES R ON A.AUTHOR_ID=R.RESOURCE_ID '
                || 'LEFT JOIN TMT_DATAFIELDS DT ON A.STAGE_ID=DT.ELEMENT_ID '
                || ', TMT_WORKFLOWS B  '
                || 'WHERE B.PARENT_ID = ''' || h_parent_id || ''' AND B.REVISION = ''' || h_revision || ''' '
                || ' AND ( B.RANK >= SUBSTR(A.RANK, 1, 8) AND B.RANK <= A.RANK '
                || '       AND substr(A.RANK, 1, case when length(B.RANK) > length(A.RANK) then 1 else length(B.RANK) end) = B.RANK ) '
                || 'ORDER BY RANK';
      Else
         h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
                || 'T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
                || 'WHERE PARENT_ID=''' || h_parent_id 
                     || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' '
                || '|| RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, '
                || 'T.DELETED_COUNT, '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
                || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
                || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT, '''' AS CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME , '''' AS OUTCOME_NAME '
                || 'FROM HISTORY_CRI T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
                || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID=DT.ELEMENT_ID '
                || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
                || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + 1) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
                     || ''' || A.RANK) AS RANK, '
                || '(CASE WHEN A.LEVEL_ID = 1 THEN ''' || h_id || ''' ELSE A.PARENT_ID END) AS PARENT_ID, '
                || 'A.ELEMENT_ID, C.ELEMENT_NAME, 0 AS CHILD_COUNT, '
                || 'A.DELETED_COUNT, A.ELEMENT_NAME AS CYCLE_NAME, A.SUBJECT AS DESCRIPTION, '''' AS REVISION, '
                || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.CREATED_DATE  AS REC_DATETIME, '
                || 'R.FULL_NAME AS AUTHOR, A.SUBJECT AS SUBJECT ,C.CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME, A.OUTCOME_NAME '
                || 'FROM (TMT_WORKFLOWS A LEFT JOIN TMT_WORKFLOW_CYCLES C ON C.ELEMENT_ID=A.WKF_DEF_ID) '
                || 'LEFT JOIN RESOURCES R ON A.AUTHOR_ID=R.RESOURCE_ID '
                || 'LEFT JOIN TMT_DATAFIELDS DT ON A.STAGE_ID=DT.ELEMENT_ID '
                || ', TMT_WORKFLOWS B '
                || 'WHERE B.PARENT_ID = ''' || h_parent_id || ''' AND B.REVISION = ''' || h_revision || ''' '
                || ' AND (B.RANK >= SUBSTR(A.RANK, 1, 8) AND B.RANK <= A.RANK '
                || ' AND substr(A.RANK, 1, case when length(B.RANK) > length(A.RANK) then 1 else length(B.RANK) end) = B.RANK) '
                || 'ORDER BY RANK';
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 210+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_REVISION(211) : cri.sql(3321) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_REVISION', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_REVISION(214) : cri.sql(3324) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 221+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(222) : cri.sql(3332) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_REVISION', 233+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_REVISION(234) : cri.sql(3344) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_REVISION;
ALTER FUNCTION SP_S_CRI_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_DELETE_CRI ==
CREATE OR REPLACE FUNCTION FC_DELETE_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_xsql VARCHAR2(29999);
   h_cri_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_cri_parent_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_res_type VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_cri_type_id PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_workflow_date TIMESTAMP;
   h_current_id VARCHAR2(32);
   h_current_resource_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_current_level_id PLS_INTEGER := 0;
   h_bit_flag1 VARCHAR2(1);
   h_current_rec_status VARCHAR2(1);
   h_folder_rank VARCHAR2(200);
   h_folder_parent_rank VARCHAR2(200);
   h_folder_id VARCHAR2(32);
   h_folder_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_temp_id VARCHAR2(32);
   h_client_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_doc_del_count PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_default_col VARCHAR2(1);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_CRI PMO_DB2M.REF_CURSOR;

      CURSOR C_CRI_DEL IS
         SELECT ELEMENT_ID, RANK, TYPE_ID, PARENT_ID, WBS_ID, LAST_WF_DATETIME, PARENT_RANK, T_PARENT_ID, TEMPLATED, DEFAULT_COL
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%'
         ORDER BY RANK DESC;

      CURSOR C_ASSIGNMENTS IS
         SELECT RES_ASSIGNMENT_ID, RESOURCE_TYPE, PARTICIPANT,
         CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END
         FROM RESOURCE_ASSIGNMENTS WHERE ELEMENT_ID = h_cri_id AND ELEMENT_TYPE = h_cri_type_id;

      CURSOR C_CRI_COUNT IS
         SELECT SUBSTR(PARENT_RANK, 1, 3), SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%' AND LEVEL_ID = 2
         UNION ALL
         SELECT SUBSTR(C.PARENT_RANK, 1, 3), SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4)
         FROM TMT_CRI C, TMT_CRI P
         WHERE C.RANK LIKE h_rank || '%' AND C.LEVEL_ID > 2
         AND P.ELEMENT_ID = C.PARENT_ID
         AND C.PARENT_RANK <> P.PARENT_RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_CRI', 82+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_CRI(83) : cri.sql(3443) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_CRI', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_CRI(88) : cri.sql(3448) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   If (h_id IS NULL) Then
      BEGIN
         SELECT 'WBS#' || RANK INTO h_parent_rank
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(104) : cri.sql(3464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DCRI';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DCRI
         SELECT ELEMENT_ID, RANK FROM TMT_CRI
         WHERE PARENT_RANK = h_parent_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(127) : cri.sql(3487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_TMP_DCRI
         WHERE ELEMENT_ID IN (SELECT B.ELEMENT_ID
         FROM PMO_TMP_DCRI A, PMO_TMP_DCRI B
         WHERE A.RANK < B.RANK AND SUBSTR( B.RANK, 1, LENGTH( A.RANK ) ) = A.RANK );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(147) : cri.sql(3507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_xsql := 
            'SELECT A.RANK, A.REC_STATUS, A.PARENT_ID, A.PARENT_TYPE_ID, A.type_id, A.element_id, A.CLIENT_ID FROM TMT_CRI A, PMO_TMP_DCRI B WHERE ((A.PARENT_ID = ''' 
            || h_parent_id || ''' AND A.LEVEL_ID = 0) OR A.RANK = B.RANK) ORDER BY RANK DESC ';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_ID, PARENT_TYPE_ID, type_id, element_id, CLIENT_ID FROM TMT_CRI WHERE ELEMENT_ID = ''' 
            || h_id || '''  ORDER BY RANK DESC ';
   End If;
   
   --trace_printf("\n%s\n ", (char *) h_xsql);//trace_flush();
   
   OPEN C_CRI FOR h_xsql;
   
   LOOP
      FETCH C_CRI INTO h_rank, h_rec_status, h_parent_id, h_parent_type_id, h_type_id, h_id, h_client_id;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --trace_printf("h_rank: %s\n", h_rank);//trace_flush();
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'D'
         WHERE (ELEMENT_ID, PARENT_ID) IN (SELECT ELEMENT_ID, ASSET_ID FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(205) : cri.sql(3565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_CRI_DEL;
      
      LOOP
         FETCH C_CRI_DEL INTO h_cri_id, h_current_rank, h_cri_type_id, h_cri_parent_id, h_wbs_id,
         h_workflow_date, h_parent_rank, h_t_parent_id, h_bit_flag1, h_default_col;
         IF C_CRI_DEL%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         --trace_printf("h_cri_id: %s, h_t_parent_id: %d %s, h_bit_flag1: %s\n", h_cri_id,h_t_parent_id_Ind,h_t_parent_id,h_bit_flag1);
         If ((h_t_parent_id IS NOT NULL)) AND (SubStr(h_bit_flag1, 1, 1) = 'Y') Then
            BEGIN
               UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_t_parent_id AND TYPE_ID IN (210,175);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 239+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(240) : cri.sql(3600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (h_wbs_id IS NOT NULL) Then
            If PMO_ORASTD.strcmp(h_cri_id, h_wbs_id) <> PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET A_CRI_COUNT = A_CRI_COUNT - 1
                  WHERE ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 261+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(262) : cri.sql(3622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_WBS
                  SET TRANSFER_FLAG = Null
                  WHERE ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 280+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(281) : cri.sql(3641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If isCRITask(Coalesce(h_cri_type_id, 0)) <> 0 Then
               BEGIN
                  DELETE FROM PROJECT_BUDGET_BREAKDOWN
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_cri_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 300+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(301) : cri.sql(3661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TIMEPHASED_DELTA
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_cri_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 318+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(319) : cri.sql(3679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            --DELETE RESOURCE_ASSIGNMENTS
            
            OPEN C_ASSIGNMENTS;
            
            LOOP
               FETCH C_ASSIGNMENTS INTO h_current_id, h_res_type, h_participant, h_current_resource_id;
               IF C_ASSIGNMENTS%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               PMO_DB2M.SC_STATE := FC_DEL_ASSIGNMENT(h_current_id, h_current_resource_id, h_res_type
                                       , h_cri_type_id, h_participant);
            END LOOP;
            BEGIN
               CLOSE C_ASSIGNMENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 350+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(351) : cri.sql(3711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --DELETE TMT_cri_ATTRIBUTES
         h_temp_id := NULL;
         PMO_DB2M.SC_STATE := FC_UA_ATR(h_cri_type_id, h_cri_id, h_temp_id, h_rec_user);
         
         ------------DOCUMENTS ARE HANDLE AFTER THE LOOP. ONCE FOR ALL THE HIERARCHY INSTEAD CALLING ONE BY ONE. ALSO, DOCUMENTS ARE NOT DELETED BUT MOVED TO PROJECT.
         --          Nullify(SC_PARAM(h_temp_id));
         --          SC_STATE = FC_DELETE_DOC(SC_PARAM(h_temp_id),SC_PARAM(h_cri_id), SC_PARAM(h_rec_user));
         ----------------------------------------------------------------------------------------------------
         
         h_table_type := PMO_CNST.SC_TABLE_CRI;
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_DELETE_ATTACHED_WKF(h_table_type, h_cri_id, h_current_rank, h_rec_user);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         
         -- cri is defined as default cri
         If PMO_ORASTD.strncmp(h_default_col, 'Y', 1) = 0 Then
            BEGIN
               DELETE FROM PMO_DEFAULTS
               WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 385+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(386) : cri.sql(3746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE C_CRI_DEL ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 400+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(401) : cri.sql(3761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --move all DOCUMENTS to the PROJECT as soft deleted
      h_host_table := PMO_CNST.SC_TABLE_CRI;
      PMO_DB2M.SC_STATE := FC_MOVE_DOC_UNDER_PROJECT(h_host_table, h_rank, h_project_id, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      --DELETE RESOURCE_ASSIGNMENTS
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%' AND WBS_ID IS Null);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 438+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(439) : cri.sql(3799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE PROJECT_ASSIGNMENTS
      BEGIN
         DELETE FROM PROJECT_ASSIGNMENTS pa WHERE pa.PROJECT_ID = h_project_id AND
         (SELECT COUNT(*) FROM RESOURCE_ASSIGNMENTS ra WHERE ra.PROJECT_ID = h_project_id AND ra.RESOURCE_ID = pa.RESOURCE_ID) = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 457+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(458) : cri.sql(3818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE BUDGETS
      BEGIN
         DELETE FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(480) : cri.sql(3840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- delete cridependencies
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE PRED_ID IN (SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%')
         OR SUCC_ID IN (SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 503+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(504) : cri.sql(3864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- DELETE all assigned SCORECARDS
      h_host_table := PMO_CNST.SC_TABLE_CRI;
      PMO_DB2M.SC_STATE := FC_D_SCD_BY_RANK(h_host_table, h_rank, h_rec_user);
      
      -- DELETE HISTORY_CRI
      BEGIN
         DELETE FROM HISTORY_CRI
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 526+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(527) : cri.sql(3887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- DELETE CRI_RTF
      BEGIN
         DELETE FROM CRI_RTF
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 545+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(546) : cri.sql(3906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- DELETE HISTORY_CRI_RTF
      BEGIN
         DELETE FROM HISTORY_CRI_RTF
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 564+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(565) : cri.sql(3925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- DELETE CLIENTS
      h_bitflag := 2;
      h_temp_sc_state := FC_D_CLIENT(h_id, h_bitflag, h_rec_user);
      --trace_printf("After FC_D_CLIENT:  h_id: %s, h_temp_sc_state: %d\n",h_id,h_temp_sc_state);
      
      -- UPDATE CHILD_COUNT
      
      OPEN C_CRI_COUNT;
      
      LOOP
         FETCH C_CRI_COUNT INTO h_target_parent_rank, h_source_parent_rank;
         IF C_CRI_COUNT%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_WBS
            SET CRI_COUNT = CRI_COUNT - 1
            WHERE RANK = h_source_parent_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 603+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(604) : cri.sql(3964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE C_CRI_COUNT ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 616+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(617) : cri.sql(3977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 634+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(635) : cri.sql(3995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_CRI WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 651+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(652) : cri.sql(4012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      COMMIT;
   END LOOP;
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_CRI', 665+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_CRI(666) : cri.sql(4026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_CRI', 673+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_CRI(674) : cri.sql(4034) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_CRI;
ALTER FUNCTION FC_DELETE_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_CRI ==
CREATE OR REPLACE FUNCTION SP_D_CRI
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_bit_flag1 VARCHAR2(1);
   h_checkout_cnt PLS_INTEGER := 0;
   h_bit_flag2 VARCHAR2(1);
   h_parent_type_id PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_templ_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CRI(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CRI(41) : cri.sql(4085) : ' || SYSTIMESTAMP);
   END IF; 

   -- id and parent_id are both required
   If ((p_id IS NULL)) OR ((p_parent_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CRI', 46+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CRI(47) : cri.sql(4091) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 49+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(50) : cri.sql(4094) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_parent_id := p_parent_id;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   h_templ_type := 0;
   BEGIN
      SELECT RANK, REC_STATUS, LEVEL_ID, PROJECT_ID, TYPE_ID, DEFAULT_COL, T_PARENT_ID, TEMPLATED, STAGE_ID
      INTO h_rank, h_rec_status, h_level_id, h_project_id, h_type_id, h_bit_flag1, h_t_parent_id, h_bit_flag2,
      h_stage_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(74) : cri.sql(4118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_id: %s, h_parent_id: %s, h_t_parent_id: %s\n", SC_STATE,h_id,h_parent_id);
   
   If IsCRISystemFolder(Coalesce(h_type_id, 0), Coalesce(h_stage_id, 0)) = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CRI', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CRI(82) : cri.sql(4126) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(85) : cri.sql(4129) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE, h_id, True);
   End If;
   
   If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) OR ((h_rank IS NULL)) Then
      BEGIN
         SELECT RANK, REC_STATUS, LEVEL_ID, PROJECT_ID, TYPE_ID, DEFAULT_COL, T_PARENT_ID, TEMPLATED
         INTO h_rank, h_rec_status, h_level_id, h_project_id, h_type_id, h_bit_flag1, h_t_parent_id, h_bit_flag2
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(102) : cri.sql(4146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) OR ((h_rank IS NULL)) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CRI', 108+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CRI(109) : cri.sql(4153) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(112) : cri.sql(4156) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      End If;
      
      h_templ_type := 1;
   End If;
   
   --trace_printf("h_rank: %s, h_project_id: %s, h_type_id: %d, h_templ_type: %d\n", h_rank,h_project_id,h_type_id,h_templ_type);
   --trace_printf("h_t_parent_id: %s, h_bit_flag2: %s, h_bit_flag1: %s\n", h_t_parent_id,h_bit_flag2,h_bit_flag1);
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER2) Then
         h_temp_sc_state := DELETE_CRI_TEMPLATE(h_rank, h_rec_user);
      ElsIf Coalesce(h_templ_type, 0) = 1 Then
         If SubStr(h_bit_flag1, 1, 1) = 'Y' Then
            BEGIN
               DELETE FROM PMO_DEFAULTS
               WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 141+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(142) : cri.sql(4186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TMT_CRI SET TEMPLATED = 'N', T_PARENT_ID = NULL, T_RANK = NULL
            WHERE RANK = h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(161) : cri.sql(4205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(180) : cri.sql(4224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_count := 0;
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%' AND ELEMENT_ID = WBS_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(196) : cri.sql(4240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CRI', 202+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CRI(203) : cri.sql(4247) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CAN_NOT_DELETE_TRANSFERED_CRI), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 205+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(206) : cri.sql(4250) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CAN_NOT_DELETE_TRANSFERED_CRI, h_id
                  , True);
         End If;
         
         h_checkout_cnt := 0;
         BEGIN
            SELECT COUNT(*)
            INTO h_checkout_cnt
            FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%'
            AND REC_STATUS = 'O'
            AND REC_USER <> h_rec_user;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(226) : cri.sql(4270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_checkout_cnt IS NOT NULL) AND (Coalesce(h_checkout_cnt, 0) > 0) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CRI', 232+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CRI(233) : cri.sql(4277) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 235+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(236) : cri.sql(4280) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, h_id, True);
         End If;
         
         PMO_DB2M.SC_STATE := FC_DELETE_CRI(h_id, h_parent_id, h_project_id, h_rec_user);
         
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_REMOVE_UNASSIGNED_RESOURCES(h_project_id);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         --trace_printf("SC_STATE: %d, h_level_id: %d, h_bit_flag2: %s\n", SC_STATE,h_level_id,h_bit_flag2);
         
         If (PMO_DB2M.SC_STATE = 0) AND (Coalesce(h_level_id, 0) > 2) Then
            If SubStr(h_bit_flag1, 1, 1) = 'Y' Then
               BEGIN
                  DELETE FROM PMO_DEFAULTS
                  WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 262+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(263) : cri.sql(4307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_CRI
               SET ROLLUP_BITS = PMO_CNST.SC_SET_DATES + PMO_CNST.SC_DELETE_BUDGET_BIT
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 282+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(283) : cri.sql(4327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_temp_sc_state := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CRI', 292+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CRI(293) : cri.sql(4337) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CRI', 295+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CRI(296) : cri.sql(4340) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CRI', 301+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CRI(302) : cri.sql(4346) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 309+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(310) : cri.sql(4354) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CRI', 321+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CRI(322) : cri.sql(4366) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CRI;
ALTER FUNCTION SP_D_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_UN_CRI ==
CREATE OR REPLACE FUNCTION SP_UN_CRI
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_datetime TIMESTAMP;
   h_tree_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_CRI(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_CRI', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_CRI(26) : cri.sql(4408) : ' || SYSTIMESTAMP);
   END IF; 

   -- id and parent_id are both required
   If ((p_id IS NULL)) OR ((p_parent_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UN_CRI', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UN_CRI(32) : cri.sql(4414) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_CRI', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UN_CRI(35) : cri.sql(4417) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   BEGIN
      SELECT RANK, REC_STATUS, REC_DATETIME, case WHEN LEVEL_ID = 0 THEN 1 else 2 END
      INTO h_rank, h_rec_status, h_rec_datetime, h_tree_type
      FROM TMT_CRI WHERE ELEMENT_ID = h_id AND PARENT_ID = p_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(53) : cri.sql(4435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UN_CRI', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UN_CRI(60) : cri.sql(4442) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_CRI', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UN_CRI(63) : cri.sql(4445) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If Coalesce(h_tree_type, 0) = 1 Then
      BEGIN
         UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(82) : cri.sql(4464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(100) : cri.sql(4482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT SYSTIMESTAMP INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(115) : cri.sql(4497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Lock Tree
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      REC_STATUS = 'U',
      REC_DATETIME = h_current_datetime,
      REC_USER = p_rec_user
      WHERE RANK LIKE '0000' || '%'
      AND ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%')
      AND REC_DATETIME = h_rec_datetime;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(152) : cri.sql(4534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI SET
      REC_STATUS = 'U',
      REC_DATETIME = h_current_datetime,
      REC_USER = p_rec_user
      WHERE RANK LIKE h_rank || '%'
      AND REC_DATETIME = h_rec_datetime;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(174) : cri.sql(4556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_CRI', 179+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_CRI(180) : cri.sql(4562) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 186+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(187) : cri.sql(4569) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CRI', 198+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CRI(199) : cri.sql(4581) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_CRI;
ALTER FUNCTION SP_UN_CRI COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_U_CRI_SYS_FOLDER_CHILDCOUNT ==
CREATE OR REPLACE FUNCTION FC_U_CRI_SYS_FOLDER_CHILDCOUNT RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_CRI_SYS_FOLDER_CHILDCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_CRI_SYS_FOLDER_CHILDCOUNT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_CRI_SYS_FOLDER_CHILDCOUNT();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CRI_SYS_FOLDER_CHILDCOUNT', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_CRI_SYS_FOLDER_CHILDCOUNT(9) : cri.sql(4606) : ' || SYSTIMESTAMP);
   END IF; 

   -- update child_count of system folder
   BEGIN
      UPDATE PMO_CRI_VIEW V
      SET V.CHILD_COUNT = 0
      WHERE V.TYPE_ID = PMO_CNST.SC_FOLDER
      AND V.STAGE_ID = PMO_CNST.SC_PROJECT
      AND NOT EXISTS (
      SELECT C.ELEMENT_ID
      FROM PMO_CRI_VIEW C
      WHERE SUBSTR(C.RANK, 1, case when LENGTH(C.RANK) > LENGTH(V.RANK) then LENGTH(V.RANK) else 1 end) = V.RANK
      AND C.TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CRI_SYS_FOLDER_CHILDCOUNT', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CRI_SYS_FOLDER_CHILDCOUNT(33) : cri.sql(4630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CRI_SYS_FOLDER_CHILDCOUNT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_CRI_SYS_FOLDER_CHILDCOUNT(39) : cri.sql(4636) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_CRI_SYS_FOLDER_CHILDCOUNT;
ALTER FUNCTION FC_U_CRI_SYS_FOLDER_CHILDCOUNT COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_APPLY_CAN_VIEW_ALL_CRI_SEC ==
CREATE OR REPLACE FUNCTION FC_APPLY_CAN_VIEW_ALL_CRI_SEC
(
     sh_h_single_element PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := Coalesce(sh_h_single_element, 0);
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_executive_security_int_7 PLS_INTEGER := 0;
   h_int_7 PLS_INTEGER := 0;
   h_can_view_all_cris PLS_INTEGER := 0;
   h_wbs_executive_security CHAR(32);
   h_can_view_pivot PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_APPLY_CAN_VIEW_ALL_CRI_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_APPLY_CAN_VIEW_ALL_CRI_SEC'), '-- ' || SYSTIMESTAMP, ':r := FC_APPLY_CAN_VIEW_ALL_CRI_SEC(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(29) : cri.sql(4675) : ' || SYSTIMESTAMP);
   END IF; 

   
   h_table_type := PMO_CNST.SC_TABLE_WBS;
   h_can_view_pivot := 0;
   ora_temp_sc_state := PMO_DB2M.SC_STATE;
   null_return := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_wbs_executive_security
                                              , h_can_view_pivot);
   PMO_DB2M.SC_STATE := ora_temp_sc_state;
   
   h_executive_security_int_7 := 0;
   h_int_7 := 0;
   If ((h_wbs_executive_security IS NOT NULL)) 
         AND Coalesce(Length(h_wbs_executive_security), 0) > 0 Then
      BEGIN
         SELECT GS.INT_7
         INTO h_executive_security_int_7
         FROM TMT_GLOBAL_SECURITY GS
         WHERE GS.ELEMENT_ID = h_wbs_executive_security;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(55) : cri.sql(4701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --trace_printf("\n h_wbs_executive_security:%s", h_wbs_executive_security);
   
   If h_single_element = 1 Then
      BEGIN
         SELECT GS.INT_7
         INTO h_int_7
         FROM PROJECT_ASSIGNMENTS PA, TMT_GLOBAL_SECURITY GS
         WHERE PA.PROJECT_ID = h_project_id
         AND PA.SECURITY_ID = GS.ELEMENT_ID
         AND PA.RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(77) : cri.sql(4723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_can_view_all_cris := 0;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
            h_can_view_all_cris := 1;
         End If;
      Else
         BEGIN
            SELECT GS.INT_7
            INTO h_int_7
            FROM TMT_GLOBAL_SECURITY GS
            WHERE GS.ELEMENT_ID = 'SCPROJECTVISITOR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(100) : cri.sql(4746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
            h_can_view_all_cris := 1;
         End If;
      End If;
      
      If Coalesce(h_can_view_all_cris, 0) = 0 Then
         -- executive access
         If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) 
               AND ((h_project_flag IS NOT NULL)) Then
            If (BITAND(Coalesce(
                  h_executive_security_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
               h_can_view_all_cris := 1;
            End If;
         End If;
      End If;
      
      -- mark assigned cris
      BEGIN
         UPDATE PMO_CRI_VIEW V
         SET MY_CRI = 1,
         PRIVATE = 'N'
         WHERE V.ELEMENT_ID IN(
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id)
         OR (TYPE_ID = PMO_CNST.SC_FOLDER AND PRIVATE = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(143) : cri.sql(4789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_CRI_VIEW
         WHERE TYPE_ID = PMO_CNST.SC_FOLDER
         AND MY_CRI = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 161+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(162) : cri.sql(4808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove private cris
      BEGIN
         DELETE FROM PMO_CRI_VIEW V
         WHERE V.MY_CRI = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMT_CRI C
         WHERE C.ELEMENT_ID = V.ELEMENT_ID
         AND C.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(186) : cri.sql(4832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_can_view_all_cris, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_CRI_VIEW V
            WHERE V.MY_CRI = 0 AND
            V.ELEMENT_ID IN (
            SELECT C.ELEMENT_ID
            FROM PMO_CRI_VIEW C
            JOIN TMT_WBS W ON
            W.RANK = C.WBS_RANK
            AND W.PROJECT_ID = C.PROJECT_ID
            JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
            AND W.ELEMENT_ID = RA.ELEMENT_ID
            AND RA.RESOURCE_ID = h_resource_id
            JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
            AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT
            WHERE C.MY_CRI = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 216+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(217) : cri.sql(4863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PMO_CRI_VIEW V
            WHERE V.MY_CRI = 0 AND
            V.ELEMENT_ID IN (
            SELECT C.ELEMENT_ID
            FROM PMO_CRI_VIEW C
            JOIN TMT_WBS W ON W.RANK = C.WBS_RANK
            AND W.PROJECT_ID = C.PROJECT_ID
            WHERE C.MY_CRI = 0 AND NOT EXISTS (
            SELECT RA.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
            WHERE W.PROJECT_ID = RA.PROJECT_ID
            AND W.ELEMENT_ID = RA.ELEMENT_ID
            AND RA.RESOURCE_ID = h_resource_id));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 244+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(245) : cri.sql(4891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      -- find assigned cri and public folders
      BEGIN
         UPDATE PMO_CRI_VIEW V
         SET MY_CRI = 1,
         PRIVATE = 'N'
         WHERE V.ELEMENT_ID IN(
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id)
         OR (TYPE_ID = PMO_CNST.SC_FOLDER AND PRIVATE = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 272+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(273) : cri.sql(4919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove unassigned and private folders
      BEGIN
         DELETE FROM PMO_CRI_VIEW
         WHERE TYPE_ID = PMO_CNST.SC_FOLDER
         AND MY_CRI = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 292+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(293) : cri.sql(4939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove private cris
      BEGIN
         DELETE FROM PMO_CRI_VIEW V
         WHERE V.MY_CRI = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMT_CRI C
         WHERE C.ELEMENT_ID = V.ELEMENT_ID
         AND C.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 316+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(317) : cri.sql(4963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(
            h_executive_security_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
         BEGIN
            UPDATE PMO_CRI_VIEW V
            SET V.MY_CRI = 1
            WHERE V.PROJECT_ID IN
            (SELECT P.ELEMENT_ID
            FROM TMP_PROJECTS_LIST P
            WHERE P.CAN_VIEW_ALL_CRIS = 0
            AND P.PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(342) : cri.sql(4988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- delete unassigned cris that thier wbs_element dose not have can_view_all_cri security
      BEGIN
         DELETE FROM PMO_CRI_VIEW V
         WHERE V.MY_CRI = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_CRI_VIEW C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.MY_CRI = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id
         JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
         AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT
         WHERE P.CAN_VIEW_ALL_CRIS = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 375+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(376) : cri.sql(5022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- delete unassiged cris that user is not assigned to the cri wbs_element
      BEGIN
         DELETE FROM PMO_CRI_VIEW V
         WHERE V.MY_CRI = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_CRI_VIEW C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.MY_CRI = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         WHERE P.CAN_VIEW_ALL_CRIS = 0
         AND NOT EXISTS (
         SELECT RA.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
         WHERE W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(409) : cri.sql(5055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_APPLY_CAN_VIEW_ALL_CRI_SEC', 415+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_APPLY_CAN_VIEW_ALL_CRI_SEC(416) : cri.sql(5062) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_APPLY_CAN_VIEW_ALL_CRI_SEC;
ALTER FUNCTION FC_APPLY_CAN_VIEW_ALL_CRI_SEC COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_GOD_LIKE_SECURITY ==
CREATE OR REPLACE FUNCTION FC_GOD_LIKE_SECURITY
(
     sh_h_tree_type PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_security_ids IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_security_int2 PLS_INTEGER := 0;
   h_security_int3 PLS_INTEGER := 0;
   h_security_int4 PLS_INTEGER := 0;
   h_security_int5 PLS_INTEGER := 0;
   h_security_int7 PLS_INTEGER := 0;
   h_security_int19 PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_temp_project_id VARCHAR2(32);
   findGod PLS_INTEGER NOT NULL := 0;
   findViewPivot PLS_INTEGER NOT NULL := 0;
   findViewMap PLS_INTEGER NOT NULL := 0;
   findCanCreate PLS_INTEGER NOT NULL := 0;
   findCanDeletePublicCRI PLS_INTEGER NOT NULL := 0;
   findCanDeletePublicDOC PLS_INTEGER NOT NULL := 0;
   findCanTemplate PLS_INTEGER NOT NULL := 0;
   findSecurity PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_GODLIKE_S IS
         SELECT S.INT_5, S.INT_7, S.INT_2, S.INT_3, S.INT_4, S.INT_19, W.ELEMENT_ID
         FROM TMT_WBS W, RESOURCE_ASSIGNMENTS RA, TMT_GLOBAL_SECURITY S
         WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK 
         AND (W.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
         AND RA.PROJECT_ID = W.PROJECT_ID
         AND RA.ELEMENT_ID = W.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id
         AND RA.SECURITY_ID = S.ELEMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GOD_LIKE_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GOD_LIKE_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := FC_GOD_LIKE_SECURITY(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_security_ids || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GOD_LIKE_SECURITY', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GOD_LIKE_SECURITY(47) : cri.sql(5119) : ' || SYSTIMESTAMP);
   END IF; 

   --  int findViewAll = 0;
   
   h_security_ids := '';
   
   --trace_printf("GODLIKE: %d, %s\n", h_rank_Ind, h_rank);
   --trace_printf("GODLIKE: %s\n", h_resource_id);
   
   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TMT_WBS
      WHERE RANK = h_rank;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GOD_LIKE_SECURITY', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GOD_LIKE_SECURITY(67) : cri.sql(5139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_GODLIKE_S;
   
   LOOP
      FETCH C_GODLIKE_S INTO h_security_int5, h_security_int7,
      h_security_int2, h_security_int3, h_security_int4, h_security_int19,
      h_temp_project_id;
      IF C_GODLIKE_S%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         If findSecurity = 1 Then
            EXIT;
         Else
            findSecurity := 2;
            
            BEGIN
               SELECT S.INT_5, S.INT_7, S.INT_2, S.INT_3, S.INT_4, S.INT_19
               INTO h_security_int5, h_security_int7,
               h_security_int2, h_security_int3, h_security_int4, h_security_int19
               FROM TMT_GLOBAL_SECURITY S
               WHERE ELEMENT_ID = 'SCPROJECTVISITOR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GOD_LIKE_SECURITY', 101+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GOD_LIKE_SECURITY(102) : cri.sql(5174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      --trace_printf("h_tree_type: %d\n", h_tree_type);
      --trace_printf("BITS2: %d\n", h_security_int2);
      --trace_printf("BITS5: %d\n", h_security_int5);
      --trace_printf("BITS7: %d\n", h_security_int7);
      
      If (findSecurity = 0) AND (PMO_ORASTD.strcmp(h_project_id, h_temp_project_id) = 0) Then
         findSecurity := 1;
      End If;
      
      If (findGod = 0) AND ((((BITAND(Coalesce(h_security_int5, 0), PMO_CNST.SC_CRI_GOD_LIKE_BIT)) > 0) 
            AND (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI)) OR (((BITAND(Coalesce(
            h_security_int5, 0), PMO_CNST.SC_DOC_GOD_LIKE_BIT)) > 0) AND (Coalesce(
            h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC)) OR (((BITAND(Coalesce(
            h_security_int5, 0), PMO_CNST.SC_SCD_GOD_LIKE_BIT)) > 0) AND (Coalesce(
            h_tree_type, 0) = PMO_CNST.SC_TABLE_SCD))) Then
         h_security_ids := h_security_ids || 'SCGODLIKESECURITY               ';
      End If;
      
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         If (findViewPivot = 0) AND ((BITAND(Coalesce(
               h_security_int19, 0), PMO_CNST.SC_CAN_VIEW_PIVOT_BIT)) > 0) Then
            findViewPivot := 1;
         End If;
         
         --          if ((findViewAll == 0)  ((h_security_int7  SC_CAN_VIEW_ALL_CRI_BIT) > 0))
         --          {
         --              findViewAll = 1;
         --          }
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_REQ_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_REQ_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEREQUIREMENTSECURITY    ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_REQ_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_CR_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_CR_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATECHANGEREQUESTSECURITY  ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_CR_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_SR_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_SR_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATESERVICEREQUESTSECURITY ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_SR_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_RISK_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_RISK_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATERISKSECURITY           ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_RISK_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_DEFECT_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_DEFECT_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEDEFECTSECURITY         ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_DEFECT_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_ISSUE_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_ISSUE_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEISSUESECURITY          ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_ISSUE_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_ACTION_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_ACTION_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEACTIONITEMSECURITY     ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_ACTION_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_CRI_FOLDER_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_CRI_FOLDER_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATECRIFOLDERSECURITY      ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_CRI_FOLDER_BIT);
         End If;
         
         If ((BITAND(findCanDeletePublicCRI, PMO_CNST.SC_CAN_DELETE_PUBLIC_CRIS)) = 0) AND ((BITAND(Coalesce(
               h_security_int2, 0), PMO_CNST.SC_CAN_DELETE_PUBLIC_CRIS)) > 0) Then
            h_security_ids := h_security_ids || 'CANDELETEPUBLICCRIS             ';
            findCanDeletePublicCRI := PMO_CNST.SC_CAN_DELETE_PUBLIC_CRIS;
         End If;
         
         If ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_CRIS)) = 0) AND ((BITAND(Coalesce(
               h_security_int3, 0), PMO_CNST.SC_CAN_TEMPLATE_CRIS)) > 0) Then
            h_security_ids := h_security_ids || 'CANTEMPLATECRISECURITY          ';
            findCanTemplate := PMO_FUNC.BIT_OR(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_CRIS);
         End If;
         
         If (findViewPivot = 1) AND (findGod = 1) 
               AND ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_CRI_BITS)) = PMO_CNST.SC_CAN_CREATE_CRI_BITS) 
               AND ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_BIT)) = PMO_CNST.SC_CAN_CREATE_DOC_BIT) 
               AND (findCanDeletePublicCRI = PMO_CNST.SC_CAN_DELETE_PUBLIC_CRIS) 
               AND ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_CRIS)) = PMO_CNST.SC_CAN_TEMPLATE_CRIS) 
               AND ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_DOCS)) = PMO_CNST.SC_CAN_TEMPLATE_DOCS) 
               AND (findCanDeletePublicDOC = PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS) Then
            EXIT;
         End If;
      End If;
      
      If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC) OR (Coalesce(
             h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
         --          if ((findViewAll == 0)  ((h_security_int7  SC_CAN_VIEW_ALL_DOC_BIT) > 0))
         --          {
         --              findViewAll = 1;
         --          }
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_DOC_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEDOCUMENTSECURITY       ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_NOTE_MIN_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_NOTE_MIN_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATENOTEMINUTESSECURITY    ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_NOTE_MIN_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_FOLDER_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_DOC_FOLDER_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATEDOCUMENTFOLDERSECURITY ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_FOLDER_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) = 0) AND ((BITAND(Coalesce(
               h_security_int2, 0), PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) > 0) Then
            h_security_ids := h_security_ids || 'CANVIEWALLDELETEDDOCSSECURITY   ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_UNLOCK_ANY_DOCS)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_UNLOCK_ANY_DOCS)) > 0) Then
            h_security_ids := h_security_ids || 'CANUNLOCKANYDOCSSECURITY        ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_UNLOCK_ANY_DOCS);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_PERMANENTLY_DELETE_DOCS)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_PERMANENTLY_DELETE_DOCS)) > 0) Then
            h_security_ids := h_security_ids || 'CANPERMANENTLYDELETEDOCSSECURITY';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_PERMANENTLY_DELETE_DOCS);
         End If;
         
         If ((BITAND(findCanDeletePublicDOC, PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS)) > 0) Then
            h_security_ids := h_security_ids || 'CANDELETEPUBLICDOCS             ';
            findCanDeletePublicDOC := PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS;
         End If;
         
         If ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_DOCS)) = 0) AND ((BITAND(Coalesce(
               h_security_int4, 0), PMO_CNST.SC_CAN_TEMPLATE_DOCS)) > 0) Then
            h_security_ids := h_security_ids || 'CANTEMPLATEDOCUMENTSECURITY     ';
            findCanTemplate := PMO_FUNC.BIT_OR(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_DOCS);
         End If;
         
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
            If (findViewPivot = 1) AND (findGod = 1) 
                  AND ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_CRI_BITS)) = PMO_CNST.SC_CAN_CREATE_CRI_BITS) 
                  AND ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_BIT)) = PMO_CNST.SC_CAN_CREATE_DOC_BIT) 
                  AND (findCanDeletePublicCRI = PMO_CNST.SC_CAN_DELETE_PUBLIC_CRIS) 
                  AND ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_CRIS)) = PMO_CNST.SC_CAN_TEMPLATE_CRIS) 
                  AND ((BITAND(findCanTemplate, PMO_CNST.SC_CAN_TEMPLATE_DOCS)) = PMO_CNST.SC_CAN_TEMPLATE_DOCS) 
                  AND (findCanDeletePublicDOC = PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS) Then
               EXIT;
            End If;
         Else
            If (findGod = 1) AND (findCanCreate = PMO_CNST.SC_CAN_CREATE_DOC_BITS) 
                  AND (findCanDeletePublicDOC = PMO_CNST.SC_CAN_DELETE_PUBLIC_DOCS) 
                  AND (findCanTemplate = PMO_CNST.SC_CAN_TEMPLATE_DOCS) Then
               EXIT;
            End If;
         End If;
      End If;
      
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_SCD Then
         If (findViewMap = 0) AND ((BITAND(Coalesce(
               h_security_int2, 0), PMO_CNST.SC_CAN_VIEW_MAP_BIT)) > 0) Then
            findViewMap := 1;
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_SCD_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_SCD_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATESCORECARDSECURITY      ';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_SCD_BIT);
         End If;
         
         If ((BITAND(findCanCreate, PMO_CNST.SC_CAN_CREATE_SCD_FOLDER_BIT)) = 0) AND ((BITAND(Coalesce(
               h_security_int7, 0), PMO_CNST.SC_CAN_CREATE_SCD_FOLDER_BIT)) > 0) Then
            h_security_ids := h_security_ids || 'CANCREATESCORECARDFOLDERSECURITY';
            findCanCreate := PMO_FUNC.BIT_OR(findCanCreate, PMO_CNST.SC_CAN_CREATE_DOC_FOLDER_BIT);
         End If;
         
         If (findGod = 1) AND (findCanCreate = PMO_CNST.SC_CAN_CREATE_SCD_FOLDER_BIT) Then
            EXIT;
         End If;
      End If;
      
      If findSecurity = 2 Then
         EXIT;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_GODLIKE_S;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GOD_LIKE_SECURITY', 317+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GOD_LIKE_SECURITY(318) : cri.sql(5390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_security_ids: %d, %s\n", h_security_ids_Ind, h_security_ids);
   
   If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      PMO_DB2M.SC_STATE := 0;
      If findViewPivot = 1 Then
         PMO_DB2M.SC_STATE := PMO_FUNC.BIT_OR(PMO_DB2M.SC_STATE, PMO_CNST.SC_CAN_VIEW_PIVOT_BIT);
      End If;
      
      --      if  (findViewAll == 1)
      --      {
      --          SC_STATE = SC_STATE | SC_CAN_VIEW_ALL_CRI_BIT;
      --      }
   ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_SCD) AND (findViewMap = 1) Then
      PMO_DB2M.SC_STATE := PMO_CNST.SC_CAN_VIEW_MAP_BIT;
   End If;
   --  else if ((h_tree_type == SC_TABLE_DOC)  (findViewAll == 1))
   --  {
   --      SC_STATE = SC_CAN_VIEW_ALL_DOC_BIT;
   --  }
   
   --trace_printf("\n h_security_ids:%s", h_security_ids);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GOD_LIKE_SECURITY', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GOD_LIKE_SECURITY(346) : cri.sql(5418) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GOD_LIKE_SECURITY;
ALTER FUNCTION FC_GOD_LIKE_SECURITY COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_IS_ASSIGNED ==
CREATE OR REPLACE FUNCTION FC_IS_ASSIGNED
(
     h_rank IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_security_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_IS_ASSIGNED IS
         SELECT PA.SECURITY_ID
         FROM TMT_WBS W, PROJECT_ASSIGNMENTS PA
         WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK 
         AND (W.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND PA.PROJECT_ID = W.PROJECT_ID
         AND PA.RESOURCE_ID = h_resource_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_ASSIGNED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_ASSIGNED'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_ASSIGNED(' || 
       '''' || h_rank || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_ASSIGNED', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_ASSIGNED(27) : cri.sql(5455) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_IS_ASSIGNED;
   
   FETCH C_IS_ASSIGNED INTO h_security_id;
   IF C_IS_ASSIGNED%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_bitflag := 0;
   Else
      h_bitflag := 1;
   End If;
   
   BEGIN
      CLOSE C_IS_ASSIGNED;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_ASSIGNED', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_ASSIGNED(53) : cri.sql(5481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := Coalesce(h_bitflag, 0);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_ASSIGNED', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_ASSIGNED(60) : cri.sql(5488) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_ASSIGNED;
ALTER FUNCTION FC_IS_ASSIGNED COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_BUILD_CRI_VIEW_SECURITY_ID ==
CREATE OR REPLACE FUNCTION FC_BUILD_CRI_VIEW_SECURITY_ID
(
     sh_h_sp_id PLS_INTEGER
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
   , sh_h_can_view_pivot PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_wbs_rank IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_prj_security_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_can_view_pivot PLS_INTEGER := sh_h_can_view_pivot;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   find_god_like_security PLS_INTEGER;
   h_temp_executive_security VARCHAR2(32);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_CRI_VIEW_SECURITY_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_CRI_VIEW_SECURITY_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_CRI_VIEW_SECURITY_ID(' || 
       COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_can_view_pivot), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_wbs_rank || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_prj_security_id || ''''
          || ', ' || '''' || h_private || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_CRI_VIEW_SECURITY_ID(40) : cri.sql(5538) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 1;
   
   --trace_printf("\n h_project_flag:%d", h_project_flag);
   
   If Coalesce(h_project_flag, 0) < PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT Then
      h_temp_executive_security := '';
   Else
      h_temp_executive_security := h_executive_security;
   End If;
   
   If Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_PROJECT Then
      h_prj_security_id := h_executive_security;
      
      If Coalesce(h_can_view_pivot, 0) = 1 Then
         h_private := 'Y';
      End If;
   Else
      find_god_like_security := 1;
      -- assigned_executive projects
      If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) AND (Coalesce(
             h_project_flag, 0) < PMO_CNST.SC_EXECUTIVE_PROJECT) Then
         If 
               (CASE WHEN InStr(h_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR) > 0 THEN SubStr(h_executive_security, InStr(h_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR)) ELSE '' END > 
               Chr(0)) AND (Coalesce(h_can_view_pivot, 0) = 1) Then
            find_god_like_security := 0;
            h_prj_security_id := h_executive_security;
            h_private := 'Y';
         End If;
      End If;
      
      If find_god_like_security = 1 Then
         If FC_IS_ASSIGNED(h_wbs_rank, h_resource_id) = 0 Then
            -- resource is not assigned
            If 
                  CASE WHEN InStr(h_temp_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR) > 0 THEN SubStr(h_temp_executive_security, InStr(h_temp_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR)) ELSE '' END = 
                  Chr(0) Then
               h_prj_security_id := '';
               h_count := 0;
               PMO_DB2M.SC_STATE := 0;
            End If;
         ElsIf (h_wbs_rank IS NOT NULL) Then
            -- resource is assigned
            h_count := 1;
            h_tree_type := PMO_CNST.SC_TABLE_CRI;
            
            --trace_printf("\n h_wbs_rank:%s", h_wbs_rank);
            --trace_printf("\n h_tree_type:%d", h_tree_type);
            
            PMO_DB2M.SC_STATE := FC_GOD_LIKE_SECURITY(h_tree_type, h_wbs_rank, h_resource_id, h_prj_security_id);
            
            --trace_printf("\n h_prj_security_id:%s \n", h_prj_security_id);
            
            If (PMO_DB2M.SC_STATE = PMO_CNST.SC_CAN_VIEW_PIVOT_BIT) OR (Coalesce(h_can_view_pivot, 0) = 1) Then
               h_private := 'Y';
            End If;
            
            --trace_printf("\n h_executive_security:%s \n", h_executive_security);
            --trace_printf("\n h_temp_executive_security:%s \n", h_temp_executive_security);
            
            If 
                  CASE WHEN InStr(h_temp_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR) > 0 THEN SubStr(h_temp_executive_security, InStr(h_temp_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR)) ELSE '' END > 
                  Chr(0) Then
               h_prj_security_id := h_temp_executive_security;
            Else
               If ((h_prj_security_id IS NULL)) OR (Coalesce(Length(h_prj_security_id), 0) = 0) Then
                  h_prj_security_id := 'SCVOIDSECURITY                  ';
               End If;
            End If;
            
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
         End If;
      End If;
   End If;
   --modify SECURITY_ID
   
   If (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
      --trace_printf("\n cri workflow security_id \n");
      
      BEGIN
         UPDATE PMO_CRI_VIEW T
         SET T.SECURITY_ID = RPAD(COALESCE((SELECT
         case when CRI_SECURITY_ID is null then SECURITY_ID else
         case when length(CRI_SECURITY_ID) < 32 then CRI_SECURITY_ID || substr('                                ', 1, 32 - length(CRI_SECURITY_ID))else  CRI_SECURITY_ID end
         end
         FROM RESOURCE_ASSIGNMENTS R
         WHERE R.ELEMENT_ID = (CASE WHEN T.WBS_ID IS NuLL THEN T.ELEMENT_ID ELSE T.WBS_ID END)
         AND R.PROJECT_ID = h_project_id
         AND R.RESOURCE_ID = h_resource_id), ''), 32) || 
         CASE--WHEN T.PRIVATE = 'Y' OR h_count = 0 THEN ''
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK)       THEN 'SCCHANGEREQUESTWORKFLOWVISITOR  '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK)                           THEN 'SCRISKWORKFLOWVISITOR           '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK)                         THEN 'SCISSUEWORKFLOWVISITOR          '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK)             THEN 'SCREQUIREMENTWORKFLOWVISITOR    '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK)                       THEN 'SCDEFECTWORKFLOWVISITOR         '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK)     THEN 'SCSERVICEREQUESTWORKFLOWVISITOR '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK)             THEN 'SCACTIONITEMWORKFLOWVISITOR     '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_WORK_PRODUCT, PMO_CNST.SC_CRI_SUMMARY_TASK) THEN ''
         WHEN T.TYPE_ID = PMO_CNST.SC_CRI_TASK THEN ''
         WHEN T.TYPE_ID IN (64,145) THEN 'SCFOLDERWORKFLOWVISITOR         ' ELSE '' END
         WHERE T.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(155) : cri.sql(5653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_project_id:%s", h_project_id);
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_count:%d", h_count);
      --trace_printf("\n h_private:%s", h_private);
      --trace_printf("\n h_prj_security_id:%s", h_prj_security_id);
      
      BEGIN
         UPDATE PMO_CRI_VIEW T
         SET T.SECURITY_ID = CASE when T.SECURITY_ID IS NuLL OR T.SECURITY_ID = '' THEN h_prj_security_id
         when h_prj_security_id <> 'SCVOIDSECURITY                  ' then h_prj_security_id || T.SECURITY_ID
         else T.SECURITY_ID END
         WHERE T.PROJECT_ID = h_project_id
         AND TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(183) : cri.sql(5681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_CRI_VIEW
         SET VIEW_PIVOT = h_private
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 201+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(202) : cri.sql(5700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --trace_printf("\n h_project_id:%s", h_project_id);
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_count:%d", h_count);
      --trace_printf("\n h_prj_security_id:%s", h_prj_security_id);
      
      --trace_printf("\n cri security_id \n");
      
      BEGIN
         UPDATE PMO_CRI_VIEW T
         SET T.SECURITY_ID = RPAD(COALESCE((SELECT
         case when CRI_SECURITY_ID is null then SECURITY_ID else
         case when length(CRI_SECURITY_ID) < 32 then CRI_SECURITY_ID || substr('                                ', 1, 32 - length(CRI_SECURITY_ID)) else  CRI_SECURITY_ID end
         end
         FROM RESOURCE_ASSIGNMENTS R
         WHERE R.ELEMENT_ID = (CASE WHEN T.WBS_ID IS NuLL THEN T.ELEMENT_ID ELSE T.WBS_ID END)
         AND R.PROJECT_ID = h_project_id
         AND R.RESOURCE_ID = h_resource_id),
         CASE WHEN T.PRIVATE = 'Y' OR h_count = 0 THEN ''
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK)       THEN 'SCCHANGEREQUESTVISITOR          '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK)                           THEN 'SCRISKVISITOR                   '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK)                         THEN 'SCISSUEVISITOR                  '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK)             THEN 'SCREQUIREMENTVISITOR            '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK)                       THEN 'SCDEFECTVISITOR                 '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK)     THEN 'SCSERVICEREQUESTVISITOR         '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK)             THEN 'SCACTIONITEMVISITOR             '
         WHEN T.TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_WORK_PRODUCT, PMO_CNST.SC_CRI_SUMMARY_TASK) THEN ''
         WHEN T.TYPE_ID = PMO_CNST.SC_CRI_TASK THEN ''
         WHEN T.TYPE_ID IN (64,145) THEN 'SCFOLDERVISITOR                 ' ELSE '' END), 32)
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 245+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(246) : cri.sql(5744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_CRI_VIEW T
         SET T.SECURITY_ID = CASE when T.SECURITY_ID IS NuLL OR T.SECURITY_ID = '' THEN h_prj_security_id
         when h_prj_security_id <> 'SCVOIDSECURITY                  ' then h_prj_security_id || T.SECURITY_ID
         else T.SECURITY_ID END
         WHERE T.PROJECT_ID = h_project_id
         AND TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 267+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(268) : cri.sql(5766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_CRI_VIEW
         SET VIEW_PIVOT = h_private
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 286+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_CRI_VIEW_SECURITY_ID(287) : cri.sql(5785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_CRI_VIEW_SECURITY_ID', 294+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_CRI_VIEW_SECURITY_ID(295) : cri.sql(5793) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_CRI_VIEW_SECURITY_ID;
ALTER FUNCTION FC_BUILD_CRI_VIEW_SECURITY_ID COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_FIX_SECURITY_IN_CRI_VIEW ==
CREATE OR REPLACE FUNCTION FC_FIX_SECURITY_IN_CRI_VIEW
(
     sh_h_single_element PLS_INTEGER
   , sh_h_sp_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_tree_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := sh_h_single_element;
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_project_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_project_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_prj_security_id VARCHAR2(3199);
   h_private VARCHAR2(1);
   h_can_view_pivot PLS_INTEGER := 0;
   h_wbs_rank VARCHAR2(200);
   find_god_like_security PLS_INTEGER;
   myStmt VARCHAR2(29999);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      proj_list PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIX_SECURITY_IN_CRI_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIX_SECURITY_IN_CRI_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_FIX_SECURITY_IN_CRI_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_CRI_VIEW', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIX_SECURITY_IN_CRI_VIEW(48) : cri.sql(5851) : ' || SYSTIMESTAMP);
   END IF; 

   h_can_view_pivot := 0;
   h_count := 0;
   find_god_like_security := 0;
   
   h_count := 1;
   h_private := 'N';
   
   If (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
      BEGIN
         SELECT C.PROJECT_ID, C.RANK, C.PARENT_RANK, W.RANK, W.ELEMENT_NAME
         INTO h_project_id, h_rank, h_parent_rank, h_project_rank, h_project_name
         FROM TMT_CRI C, TMT_WBS W
         WHERE C.ELEMENT_ID = h_id
         AND W.ELEMENT_ID = C.PROJECT_ID
         AND W.PROJECT_ID = C.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(74) : cri.sql(5877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_prj_security_id := '';
      h_count := 1;
      h_wbs_rank := NULL;
      
      If PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
         BEGIN
            SELECT RANK, ELEMENT_ID
            INTO h_wbs_rank, h_parent_id
            FROM TMT_WBS
            WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 94+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(95) : cri.sql(5898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_CRI_VIEW', 100+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_FIX_SECURITY_IN_CRI_VIEW(101) : cri.sql(5904) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
         NULL;
      End If;
      
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_BUILD_CRI_VIEW_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                             , h_can_view_pivot, h_tree_type, h_resource_id
                                             , h_wbs_rank, h_rank, h_project_id, h_prj_security_id
                                             , h_private);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH Then
      BEGIN
         SELECT C.PROJECT_ID, C.RANK, C.PARENT_RANK, W.RANK, W.ELEMENT_NAME
         INTO h_project_id, h_rank, h_parent_rank, h_project_rank, h_project_name
         FROM TMT_CRI C, TMT_WBS W
         WHERE C.ELEMENT_ID = h_id
         AND W.ELEMENT_ID = C.PROJECT_ID
         AND W.PROJECT_ID = C.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(127) : cri.sql(5930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_prj_security_id := '';
      h_count := 1;
      h_wbs_rank := NULL;
      
      BEGIN
         SELECT RANK, ELEMENT_ID
         INTO h_wbs_rank, h_parent_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(147) : cri.sql(5950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_BUILD_CRI_VIEW_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                             , h_can_view_pivot, h_tree_type, h_resource_id
                                             , h_wbs_rank, h_rank, h_project_id, h_prj_security_id
                                             , h_private);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      If Coalesce(h_single_element, 0) = 1 Then
         myStmt := 'SELECT ''';
         myStmt := myStmt || h_id;
         myStmt := myStmt || ''', ';
         myStmt := myStmt || TO_CHAR(h_project_flag);
         myStmt := myStmt || ' FROM DUAL';
      Else
         myStmt := 'SELECT DISTINCT C.PROJECT_ID, wbs.PROJECT_FLAG ';
         myStmt := myStmt || ' FROM PMO_CRI_VIEW C, PMO_TMP_PROJECTS_01 wbs';
         myStmt := myStmt || ' WHERE C.PROJECT_ID = WBS.ELEMENT_ID ';
      End If;
      
      OPEN proj_list FOR myStmt;
      
      LOOP
         FETCH proj_list INTO h_id, h_project_flag;
         IF proj_list%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         BEGIN
            SELECT RANK, PROJECT_ID
            INTO h_rank, h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(196) : cri.sql(5999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, ELEMENT_NAME
            INTO h_project_rank, h_project_name
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(212) : cri.sql(6015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_BUILD_CRI_VIEW_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                             , h_can_view_pivot, h_tree_type, h_resource_id
                                             , h_project_rank, h_rank, h_project_id
                                             , h_prj_security_id, h_private);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
      END LOOP;
      
      BEGIN
         CLOSE proj_list ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 232+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(233) : cri.sql(6036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT PROJECT_ID, RANK, PARENT_RANK
         INTO h_project_id, h_rank, h_parent_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(249) : cri.sql(6052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_parent_rank: %s, h_id: %s\n", SC_STATE,h_parent_rank,h_id);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_CRI_VIEW', 256+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_FIX_SECURITY_IN_CRI_VIEW(257) : cri.sql(6060) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         SELECT RANK, ELEMENT_NAME
         INTO h_project_rank, h_project_name
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 272+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(273) : cri.sql(6076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_prj_security_id := '';
      h_count := 1;
      
      h_wbs_rank := NULL;
      If PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
         BEGIN
            SELECT RANK, ELEMENT_ID
            INTO h_wbs_rank, h_parent_id
            FROM TMT_WBS
            WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_CRI_VIEW', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_CRI_VIEW(294) : cri.sql(6097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_CRI_VIEW', 299+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_FIX_SECURITY_IN_CRI_VIEW(300) : cri.sql(6103) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
         NULL;
      End If;
      
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_BUILD_CRI_VIEW_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                             , h_can_view_pivot, h_tree_type, h_resource_id
                                             , h_wbs_rank, h_rank, h_project_id, h_prj_security_id
                                             , h_private);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_CRI_VIEW', 315+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIX_SECURITY_IN_CRI_VIEW(316) : cri.sql(6119) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIX_SECURITY_IN_CRI_VIEW;
ALTER FUNCTION FC_FIX_SECURITY_IN_CRI_VIEW COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_CRI_NEXT_LEVEL ==
CREATE OR REPLACE FUNCTION FC_CRI_NEXT_LEVEL
(
     sh_h_sp_id PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_project_name IN OUT NOCOPY VARCHAR2
   , h_project_name_str IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_is_cri_system_folder PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_is_cri_system_folder PLS_INTEGER := sh_h_is_cri_system_folder;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   myStmt VARCHAR2(29999);
   h_single_element PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRI_NEXT_LEVEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRI_NEXT_LEVEL'), '-- ' || SYSTIMESTAMP, ':r := FC_CRI_NEXT_LEVEL(' || 
       COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_project_name || ''''
          || ', ' || '''' || h_project_name_str || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_is_cri_system_folder), 'NULL')
          || ', ' || '''' || h_executive_security || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_NEXT_LEVEL', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRI_NEXT_LEVEL(51) : cri.sql(6180) : ' || SYSTIMESTAMP);
   END IF; 

   --BEGIN_SQL
   -- INSERT INTO session.PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
   -- SELECT HOST(h_project_id), HOST(h_project_name), C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
   -- FROM TMT_CRI C
   -- WHERE C.ELEMENT_ID = HOST(h_id);
   --END_SQL;
   
   myStmt := 
          'INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME, WBS_RANK, MY_CRI)';
   myStmt := myStmt || ' SELECT ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''', ''';
   myStmt := myStmt || h_project_name_str;
   
   myStmt := myStmt || ''', C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, ';
   myStmt := myStmt || TO_CHAR(Coalesce(h_level_id, 0) + 1);
   myStmt := myStmt || ' , C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME, ';
   
   --myStmt.strcat("', C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME, ");
   myStmt := myStmt || ' SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4), 0 AS MY_CRI ';
   
   If Coalesce(h_is_cri_system_folder, 0) <> 0 Then
      If (Coalesce(h_sp_id, 0) = 400) OR (Coalesce(h_sp_id, 0) = 401) Then
         myStmt := myStmt || ' FROM TMT_CRI C JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = ''';
         myStmt := myStmt || h_project_id;
         myStmt := myStmt || ''' AND C.ELEMENT_ID = RA.ELEMENT_ID ';
         myStmt := myStmt || ' AND RESOURCE_ID = ''';
         myStmt := myStmt || h_resource_id;
         myStmt := myStmt || ''' ';
      Else
         myStmt := myStmt || ' FROM TMT_CRI C ';
      End If;
      
      myStmt := myStmt || ' WHERE C.RANK LIKE ''';
      myStmt := myStmt || h_rank;
      myStmt := myStmt || '%%'' ';
      myStmt := myStmt || ' AND C.ELEMENT_ID <> ''';
      myStmt := myStmt || h_id;
      myStmt := myStmt || ''' ';
   Else
      myStmt := myStmt || ' FROM TMT_CRI C ';
      myStmt := myStmt || ' WHERE C.PARENT_ID = ''';
      myStmt := myStmt || h_id;
      myStmt := myStmt || ''' ';
   End If;
   
   --trace_printf("\n SECOND LEVEL INSERT INTO CRI TEMPORARY TBALE: \n %s \n",(char *) myStmt);
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_NEXT_LEVEL', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_NEXT_LEVEL(113) : cri.sql(6242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_cri_system_folder, 0) <> 0 Then
      h_single_element := 1;
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_APPLY_CAN_VIEW_ALL_CRI_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_project_flag);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
      
      -- remove all subelements
      BEGIN
         DELETE FROM PMO_CRI_VIEW C
         WHERE EXISTS (SELECT P.ELEMENT_ID
         FROM PMO_CRI_VIEW P 
         WHERE P.RANK < C.RANK
         AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_NEXT_LEVEL', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_NEXT_LEVEL(143) : cri.sql(6272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
      SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, h_level_id, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
      FROM TMT_CRI C
      WHERE C.ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_NEXT_LEVEL', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_NEXT_LEVEL(164) : cri.sql(6293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_CRI_VIEW V
      SET V.PRIVATE = 'N'
      WHERE V.PRIVATE = 'Y'
      AND EXISTS(
      SELECT RA.ELEMENT_ID
      FROM RESOURCE_ASSIGNMENTS RA
      WHERE RA.ELEMENT_ID = V.ELEMENT_ID
      AND RA.PROJECT_ID = V.PROJECT_ID
      AND RA.RESOURCE_ID = h_resource_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_NEXT_LEVEL', 188+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_NEXT_LEVEL(189) : cri.sql(6318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_NEXT_LEVEL', 195+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_NEXT_LEVEL(196) : cri.sql(6325) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRI_NEXT_LEVEL;
ALTER FUNCTION FC_CRI_NEXT_LEVEL COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_PORTAL_PAGE_CRI_VIEW ==
CREATE OR REPLACE FUNCTION FC_PORTAL_PAGE_CRI_VIEW
(
     sh_h_result_set_flag PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_result_set_flag PLS_INTEGER := sh_h_result_set_flag;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_include_completed_items PLS_INTEGER := 0;
   h_include_closed_items PLS_INTEGER := 0;
   h_include_sub_elements PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   myStmt VARCHAR2(29999);
   myList VARCHAR2(999);
   h_single_element PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_sys_folder_stage_id PLS_INTEGER := 0;
   h_my_cri PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PORTAL_PAGE_CRI_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PORTAL_PAGE_CRI_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_PORTAL_PAGE_CRI_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_result_set_flag), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_CRI_VIEW', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PORTAL_PAGE_CRI_VIEW(46) : cri.sql(6381) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_sub_elements := 0;
   If (BITAND(Coalesce(h_active_record, 0), 8)) = 0 Then
      h_include_sub_elements := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed_items := 1;
   End If;
   
   myStmt := 
          'INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME, EXTERNAL_REFERENCE, REFERENCE_NUMBER, WBS_RANK, MY_CRI)';
   myStmt := myStmt || 
                    ' SELECT C.PROJECT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME, C.EXTERNAL_REFERENCE, C.REFERENCE_NUMBER, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4), ';
   
   If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_CRI Then
      myStmt := myStmt || '0';
   Else
      myStmt := myStmt || '1';
   End If;
   
   If Coalesce(h_type_id, 0) = 0 Then
      If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_CRI Then
         --********************* FIRST LEVEL OF ALL CRI VIEW (ALL TYPES)
         -- search cri WITHOUT attributes filter and WITHOUT keyword search
         If ((h_filter_string IS NULL)) AND ((h_name IS NULL)) Then
            myStmt := myStmt || ' FROM TMT_CRI C, TMT_CRI P, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND C.LEVEL_ID > 1 ';
            myStmt := myStmt || ' AND P.ELEMENT_ID = C.PARENT_ID ';
            --trace_printf("\n  PORTAL_PAGE_CRI(1000)");
         ElsIf ((h_filter_string IS NOT NULL)) AND ((h_name IS NULL)) Then
            myStmt := myStmt || ' FROM TMT_CRI C, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            
            --trace_printf("\n  PORTAL_PAGE_CRI(1001)");
         ElsIf ((h_name IS NOT NULL)) Then
            myStmt := myStmt || '  FROM TMT_CRI C, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || '  WHERE (';
            myStmt := myStmt || h_name;
            myStmt := myStmt || ') ';
            
            myStmt := myStmt || ' AND C.TYPE_ID IN (';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_DELV_GROUP_TYPES;
            myStmt := myStmt || ',';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_TASK_GROUP_TYPES;
            
            myList := ', ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' ';
            
            myStmt := myStmt || myList;
            myStmt := myStmt || ')';
            
            myStmt := myStmt || ' AND PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            
            --trace_printf("\n  PORTAL_PAGE_CRI(1002)");
         End If;
      Else
         --********************* FIRST LEVEL OF MY CRI VIEW (ALL TYPES)
         -- search cri WITHOUT attributes filter and WITHOUT keyword search
         If (h_filter_string IS NULL) AND ((h_name IS NULL)) Then
            myStmt := myStmt || ' FROM TMT_CRI C , RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND RA.RESOURCE_ID = ''';
            myStmt := myStmt || h_resource_id;
            myStmt := myStmt || ''' ';
            myStmt := myStmt || ' AND RA.PROJECT_ID = C.PROJECT_ID ';
            myStmt := myStmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID ';
            --trace_printf("\n  PORTAL_PAGE_CRI(1003.2)");
         ElsIf (h_filter_string IS NOT NULL) AND ((h_name IS NULL)) Then
            myStmt := myStmt || ' FROM TMT_CRI C , RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND RA.RESOURCE_ID = ''';
            myStmt := myStmt || h_resource_id;
            myStmt := myStmt || ''' ';
            myStmt := myStmt || ' AND RA.PROJECT_ID = C.PROJECT_ID ';
            myStmt := myStmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID ';
            myStmt := myStmt || ' AND C.TYPE_ID IN (';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_DELV_GROUP_TYPES;
            myStmt := myStmt || ',';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_TASK_GROUP_TYPES;
            
            myList := ', ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' ';
            
            myStmt := myStmt || myList;
            myStmt := myStmt || ')';
            --trace_printf("\n  PORTAL_PAGE_CRI(1004.2)");
         ElsIf (h_name IS NOT NULL) Then
            myStmt := myStmt || ' FROM TMT_CRI C , RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND RA.RESOURCE_ID = ''';
            myStmt := myStmt || h_resource_id;
            myStmt := myStmt || ''' ';
            myStmt := myStmt || ' AND RA.PROJECT_ID = C.PROJECT_ID ';
            myStmt := myStmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID ';
            myStmt := myStmt || ' AND (';
            myStmt := myStmt || h_name;
            myStmt := myStmt || ')';
            myStmt := myStmt || ' AND C.TYPE_ID IN (';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_DELV_GROUP_TYPES;
            myStmt := myStmt || ',';
            myStmt := myStmt || PMO_CNST.SC_STR_CRI_TASK_GROUP_TYPES;
            
            myList := ', ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' ';
            
            myStmt := myStmt || myList;
            myStmt := myStmt || ')';
            --trace_printf("\n  PORTAL_PAGE_CRI(1005)");
         End If;
      End If;
   Else
      CASE h_type_id
         WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
            h_task_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         
         WHEN PMO_CNST.SC_CRI_RISK THEN
            h_task_type_id := PMO_CNST.SC_CRI_RISK_TASK;
         
         WHEN PMO_CNST.SC_CRI_ISSUE THEN
            h_task_type_id := PMO_CNST.SC_CRI_ISSUE_TASK;
         
         WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
            h_task_type_id := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         
         WHEN PMO_CNST.SC_CRI_DEFECT THEN
            h_task_type_id := PMO_CNST.SC_CRI_DEFECT_TASK;
         
         WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
            h_task_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         
         WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
            h_task_type_id := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         
         ELSE
            h_task_type_id := Coalesce(h_type_id, 0);
      END CASE;
      
      If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_CRI Then
         --********************* FIRST LEVEL OF ALL CRI VIEW (SPECIFIC TYPE)
         -- Insert all the public/assigned CRIs with the requested type  in the first level of the tree
         If (h_name IS NULL) Then
            myStmt := myStmt || '  FROM TMT_CRI C, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE TYPE_ID IN (';
            myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                  || ' ';
            myStmt := myStmt || myList;
            myStmt := myStmt || ') ';
            myStmt := myStmt || ' AND C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            
            --trace_printf("\n  PORTAL_PAGE_CRI(1006)");
         Else
            -- h_name is a condition for searching by element_name
            myStmt := myStmt || '  FROM TMT_CRI C, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || '  WHERE (';
            myStmt := myStmt || h_name;
            
            myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                  || ' ';
            
            myStmt := myStmt || ')    AND TYPE_ID IN (';
            myStmt := myStmt || myList;
            myStmt := myStmt || ') AND C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            --trace_printf("\n  PORTAL_PAGE_CRI(1007)");
         End If;
      Else
         --********************* FIRST LEVEL OF MY CRI VIEW (SPECIFIC TYPE)
         -- Insert all the public/assigned CRIs with the requested type  in the first level of the tree
         If (h_name IS NULL) Then
            myStmt := myStmt || ' FROM TMT_CRI C , RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND RA.RESOURCE_ID = ''';
            myStmt := myStmt || h_resource_id;
            myStmt := myStmt || ''' ';
            myStmt := myStmt || ' AND RA.PROJECT_ID = C.PROJECT_ID ';
            myStmt := myStmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID ';
            myStmt := myStmt || ' AND TYPE_ID IN (';
            myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                  || ' ';
            myStmt := myStmt || myList;
            myStmt := myStmt || ') ';
            
            --trace_printf("\n  PORTAL_PAGE_CRI(1008)");
         Else
            myStmt := myStmt || ' FROM TMT_CRI C , RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            myStmt := myStmt || ' WHERE C.PROJECT_ID = wbs.ELEMENT_ID ';
            myStmt := myStmt || 
                    ' AND SUBSTR(C.PARENT_RANK, 1, case when length(C.PARENT_RANK)< length(''WBS#'' || wbs.rank) then 1 else length (''WBS#'' || wbs.rank) end) =  ''WBS#'' || wbs.rank ';
            myStmt := myStmt || ' AND RA.RESOURCE_ID = ''';
            myStmt := myStmt || h_resource_id;
            myStmt := myStmt || ''' ';
            myStmt := myStmt || ' AND RA.PROJECT_ID = C.PROJECT_ID ';
            myStmt := myStmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID ';
            myStmt := myStmt || ' AND C.TYPE_ID IN (';
            
            myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                  || ' ';
            
            myStmt := myStmt || myList;
            myStmt := myStmt || ') AND (';
            myStmt := myStmt || h_name;
            myStmt := myStmt || ') ';
            
            --trace_printf("\n  PORTAL_PAGE_CRI(1009)");
         End If;
      End If;
   End If;
   
   --trace_printf("\n 2- h_include_closed_items:%d", h_include_closed_items);
   --trace_printf("\n 2- h_include_completed_items:%d", h_include_completed_items);
   
   If (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(h_include_completed_items, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND (C.ACTUAL_FINISH IS NULL OR C.CLOSED_DATETIME IS NOT Null OR C.STAGE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
      myStmt := myStmt || ' )) ';
   ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 1) Then
      myStmt := myStmt || ' AND (C.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
      myStmt := myStmt || ') AND C.CLOSED_DATETIME IS Null) ';
   ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND C.ACTUAL_FINISH IS NULL AND C.CLOSED_DATETIME IS Null AND C.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
      myStmt := myStmt || ')';
   End If;
   
   --trace_printf("\n FIRST LEVEL INSERT INTO CRI TEMPORARY TBALE: \n %s \n",(char *) myStmt);
   
   -- execute the main insert into temporary table for the first level of CRI view
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 311+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(312) : cri.sql(6647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_result_set_flag:%d", h_result_set_flag);
   --trace_printf("\n SC_PORTAL_PAGE_ALL_CRI:%d", SC_PORTAL_PAGE_ALL_CRI);
   
   If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_CRI Then
      -- delete all cris with the following conditions:
      -- 1- resource is not assigned to the cri
      -- 2- cri's project dose not have CAN_VIEW_ALL_CRI security
      -- 3- cri's wbs element dose not have CAN_VIEW_ALL_CRI security
      
      h_single_element := 0;
      h_project_id := NULL;
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_APPLY_CAN_VIEW_ALL_CRI_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_single_element);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   Else
      BEGIN
         UPDATE PMO_CRI_VIEW
         SET PRIVATE = 'N';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(347) : cri.sql(6682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_stage_id, 0) <> 0 Then
      BEGIN
         DELETE FROM PMO_CRI_VIEW A
         WHERE PROJECT_ID IN (SELECT wbs.ELEMENT_ID FROM PMO_TMP_PROJECTS_01 wbs)
         AND STAGE_ID <> h_stage_id
         AND TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 368+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(369) : cri.sql(6704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- update child_count of system folder
   --FC_U_CRI_SYS_FOLDER_CHILDCOUNT();
   -- insert system folder
   If (Coalesce(h_type_id, 0) = 0) AND ((h_filter_string IS NULL)) AND ((h_name IS NULL)) Then
      BEGIN
         INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME, EXTERNAL_REFERENCE, REFERENCE_NUMBER, WBS_RANK, MY_CRI)
         SELECT C.PROJECT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2, C.PRIVATE,
         (select count(*) from PMO_CRI_VIEW cc where substr(cc.rank, 1, 16) = c.rank) AS CHILD_COUNT,
         C.STAGE_ID AS STAGE_ID, C.CLOSED_DATETIME, C.EXTERNAL_REFERENCE, C.REFERENCE_NUMBER, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4), 1
         FROM TMT_CRI C, PMO_TMP_PROJECTS_01 wbs
         WHERE C.TYPE_ID = PMO_CNST.SC_FOLDER
         AND C.STAGE_ID = PMO_CNST.SC_PROJECT
         AND C.PRIVATE = 'N'
         AND C.PROJECT_ID = wbs.ELEMENT_ID
         AND C.ELEMENT_ID NOT IN (SELECT R.ELEMENT_ID FROM PMO_CRI_VIEW R WHERE R.ELEMENT_ID = C.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(400) : cri.sql(6735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_CRI_VIEW C
         SET CHILD_COUNT = (SELECT COUNT(*) FROM PMO_CRI_VIEW CC WHERE SUBSTR(CC.RANK, 1, 16) = C.RANK AND CC.RANK> C.RANK)
         WHERE C.TYPE_ID = PMO_CNST.SC_FOLDER
         AND C.STAGE_ID = PMO_CNST.SC_PROJECT
         AND C.PRIVATE = 'N';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(421) : cri.sql(6756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_include_sub_elements, 0) = 0 Then
         /*			BEGIN_SQL
         				UPDATE session.PMO_CRI_VIEW C
         				SET C.LEVEL_ID = 3
         				WHERE C.STAGE_ID <> SC_PROJECT AND EXISTS (
         					SELECT P.ELEMENT_ID
         					FROM session.PMO_CRI_VIEW P
         					WHERE P.STAGE_ID = SC_PROJECT
         					AND P.TYPE_ID = SC_FOLDER
         					AND P.RANK = SUBSTR(C.RANK, 1, 16));
         			END_SQL;*/
         
         BEGIN
            DELETE FROM PMO_CRI_VIEW C                
            WHERE C.STAGE_ID <> PMO_CNST.SC_PROJECT AND EXISTS (
            SELECT P.ELEMENT_ID
            FROM PMO_CRI_VIEW P
            WHERE P.STAGE_ID = PMO_CNST.SC_PROJECT
            AND P.TYPE_ID = PMO_CNST.SC_FOLDER
            AND P.RANK = SUBSTR(C.RANK, 1, 16));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 455+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(456) : cri.sql(6791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_CRI Then
      If (BITAND(Coalesce(h_active_record, 0), 8)) = 8 Then
         BEGIN
            DELETE FROM PMO_CRI_VIEW C
            WHERE EXISTS (SELECT P.ELEMENT_ID
            FROM PMO_CRI_VIEW P
            WHERE P.RANK < C.RANK
            AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 480+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(481) : cri.sql(6816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If (BITAND(Coalesce(h_active_record, 0), 8)) = 8 Then
         BEGIN
            DELETE FROM PMO_CRI_VIEW C
            WHERE EXISTS (SELECT P.ELEMENT_ID
            FROM PMO_CRI_VIEW P
            WHERE P.RANK < C.RANK
            AND P.STAGE_ID <> PMO_CNST.SC_PROJECT
            AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 504+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(505) : cri.sql(6840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (h_filter_string IS NOT NULL) Then
      myStmt := 'DELETE FROM PMO_CRI_VIEW A WHERE A.LEVEL_ID > 0';
      myStmt := myStmt || 
                    ' AND (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM TMT_CRI_ATTRIBUTES PA, TMT_CRI_ATTRIBUTES CA ';
      myStmt := myStmt || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (';
      myStmt := myStmt || h_filter_string;
      myStmt := myStmt || ')';
      myStmt := myStmt || 
                    ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK) < ';
      myStmt := myStmt || TO_CHAR(h_filter_count);
      
      --trace_printf("\n h_filter_string:%s", h_filter_string);
      
      BEGIN
         EXECUTE IMMEDIATE myStmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_CRI_VIEW', 536+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_CRI_VIEW(537) : cri.sql(6872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_CRI_VIEW', 545+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PORTAL_PAGE_CRI_VIEW(546) : cri.sql(6881) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PORTAL_PAGE_CRI_VIEW;
ALTER FUNCTION FC_PORTAL_PAGE_CRI_VIEW COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_CRI_VIEW ==
CREATE OR REPLACE FUNCTION FC_CRI_VIEW
(
     sh_h_single_element PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , sh_h_sp_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
   , sh_h_can_view_pivot PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := sh_h_single_element;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_can_view_pivot PLS_INTEGER := sh_h_can_view_pivot;
   h_element_id VARCHAR2(32);
   h_project_name VARCHAR2(255);
   h_project_name_str VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_parent_type PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_project_rank VARCHAR2(200);
   h_include_completed_items PLS_INTEGER := 0;
   h_include_closed_items PLS_INTEGER := 0;
   h_include_sub_elements PLS_INTEGER := 0;
   h_result_set_flag PLS_INTEGER := 0;
   h_can_view_all_cri PLS_INTEGER := 0;
   h_temp_type_id PLS_INTEGER := 0;
   h_temp_stage_id PLS_INTEGER := 0;
   h_temp_parent_id VARCHAR2(32);
   h_is_cri_system_folder PLS_INTEGER := 0;
   myStmt VARCHAR2(29999);
   myList VARCHAR2(2999);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRI_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRI_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_CRI_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_can_view_pivot), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_VIEW', 75+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRI_VIEW(76) : cri.sql(6967) : ' || SYSTIMESTAMP);
   END IF; 

   --                          h_active_record
   --  h_sp_id             (1st bit of h_active_record)    meaning
   ----------------------------------------------------------------------------------------------------------------------------------------
   --  400                 -                           (MY CRI)    -> assigned CRIs in all/selected projects   (PORTAL_PAGE)
   --  300                 -                           (All CRI)   -> All CRIs in All  Projects                (PORTAL_PAGE)
   --  0(!300  !400)     0                           assigned + public: user does not have god_like_secuirty
   --  0(!300  !400)     1                           all CRIs in a selected project: user has god_like_security
   
   -- August 03 2004:
   -- if user search cris by name or by attribute, we ignore type and stage but we
   -- search in MY and ALL criteria
   
   If (h_name IS NOT NULL) Then
      h_stage_id := 0;
      h_type_id := 0;
      h_sp_id := 300;
      h_filter_string := NULL;
      h_filter_count := 0;
   ElsIf (h_filter_string IS NOT NULL) Then
      h_stage_id := 0;
      h_type_id := 0;
      h_sp_id := 300;
   End If;
   
   If Coalesce(h_sp_id, 0) = 400 Then
      h_result_set_flag := PMO_CNST.SC_PORTAL_PAGE_MY_CRI;
   ElsIf Coalesce(h_sp_id, 0) = 300 Then
      h_result_set_flag := PMO_CNST.SC_PORTAL_PAGE_ALL_CRI;
      
      If (h_name IS NOT NULL) Then
         If (BITAND(Coalesce(h_active_record, 0), 1)) = 0 Then
            h_can_view_all_cri := 0;
            If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
               h_can_view_all_cri := 1;
            End If;
         ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            h_can_view_all_cri := 1;
         End If;
      End If;
   ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 0 Then
      h_result_set_flag := PMO_CNST.SC_CRI_VIEW_WITHOUT_GOD_LIKE;
      
      h_can_view_all_cri := 0;
      If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
         h_can_view_all_cri := 1;
      End If;
   ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
      h_result_set_flag := PMO_CNST.SC_CRI_VIEW_WITH_GOD_LIKE;
      If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
         h_can_view_all_cri := 1;
      End If;
   End If;
   
   h_include_sub_elements := 0;
   If (BITAND(Coalesce(h_active_record, 0), 8)) = 0 Then
      h_include_sub_elements := 1;
   End If;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed_items := 1;
   End If;
   
   h_element_name := '';
   
   If Coalesce(h_single_element, 0) = 0 Then
      PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_CRI_VIEW(h_result_set_flag, h_resource_id, h_name
                                             , h_filter_string, h_filter_count, h_type_id
                                             , h_active_record, h_stage_id, h_executive_security);
   Else
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         BEGIN
            SELECT C.RANK, 0, C.REC_STATUS, C.PROJECT_ID, P.RANK, P.ELEMENT_NAME, REPLACE(P.ELEMENT_NAME, '''', '''''')
            INTO h_rank, h_level_id, h_rec_status, h_project_id, h_project_rank, h_project_name, h_project_name_str
            FROM TMT_WBS C, TMT_WBS P
            WHERE C.ELEMENT_ID = h_id
            AND P.ELEMENT_ID = C.PROJECT_ID
            AND P.PROJECT_ID = C.PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 166+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(167) : cri.sql(7058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_VIEW', 173+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_VIEW(174) : cri.sql(7065) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         BEGIN
            SELECT C.TYPE_ID, C.STAGE_ID, C.PARENT_ID, C.PROJECT_ID, C.RANK, C.LEVEL_ID, C.REC_STATUS, C.PARENT_RANK, P.RANK, P.ELEMENT_NAME, REPLACE(P.ELEMENT_NAME, '''', ''''''),
            case when C.TYPE_ID = PMO_CNST.SC_FOLDER AND C.STAGE_ID IN (PMO_CNST.SC_PROJECT, PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_RISK) /*AND C.PRIVATE = 'Y' */ then C.STAGE_ID else 0 end
            INTO h_temp_type_id, h_temp_stage_id, h_temp_parent_id,
            h_project_id, h_rank, h_level_id, h_rec_status, h_parent_rank, h_project_rank, h_project_name, h_project_name_str , h_is_cri_system_folder
            FROM TMT_CRI C, TMT_WBS P
            WHERE C.ELEMENT_ID = h_id
            AND P.ELEMENT_ID = C.PROJECT_ID
            AND P.PROJECT_ID = C.PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 193+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(194) : cri.sql(7085) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_temp_type_id:%d", h_temp_type_id);
         --trace_printf("\n h_temp_stage_id:%d", h_temp_stage_id);
         --trace_printf("\n h_is_cri_system_folder:%d", h_is_cri_system_folder);
         
         --            if ((IsCRISystemFolder(h_temp_type_id, h_temp_stage_id)==1)  (h_temp_stage_id != 1)  (h_is_cri_system_folder!=0))
         --            {
         --                BEGIN_SQL
         --                    SELECT CASE WHEN C.TYPE_ID = SC_FOLDER AND C.STAGE_ID IN (SC_CRI_SYSTEM_FOLDER_STAGE_ID) AND C.PRIVATE = 'Y' THEN C.STAGE_ID ELSE 0 END
         --                        INTO  HOST(h_is_cri_system_folder)
         --                        FROM TMT_CRI C
         --                        WHERE C.ELEMENT_ID = HOST(h_temp_parent_id);
         --                END_SQL;
         --trace_printf("\n 2- h_is_cri_system_folder:%d", h_is_cri_system_folder);
         --            }
         
         --trace_printf("A.1_* SC_STATE: %d, h_id: %s\n", SC_STATE,h_id);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_VIEW', 217+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_VIEW(218) : cri.sql(7109) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
         
         If (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
               h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
               h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
            If PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  SELECT ELEMENT_NAME
                  INTO h_element_name
                  FROM TMT_WBS
                  WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(238) : cri.sql(7129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_VIEW', 243+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_VIEW(244) : cri.sql(7135) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.RECORD_NOT_FOUND;
               NULL;
            End If;
         End If;
      End If;
      
      If Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT Then
         --trace_printf("\n SC_WORKFLOW_ATTACHMENT -> h_project_name:%s", h_project_name);
         
         BEGIN
            INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
            SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, CASE WHEN C.LEVEL_ID = 1 THEN h_element_name ELSE C.ELEMENT_NAME END,
            C.RANK, CASE WHEN C.LEVEL_ID = 1 THEN PMO_CNST.SC_CUSTOM_FOLDER  ELSE C.TYPE_ID END, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
            FROM TMT_CRI C
            WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK 
            AND (C.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
            AND C.LEVEL_ID > 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(273) : cri.sql(7164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_CRI_VIEW V
            SET PRIVATE = 'N'
            WHERE PRIVATE = 'Y'
            AND V.ELEMENT_ID = h_id
            AND EXISTS (
            SELECT RA.ELEMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE RA.ELEMENT_ID = V.ELEMENT_ID
            AND RA.PROJECT_ID = V.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 298+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(299) : cri.sql(7190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT Then
         --trace_printf("\n SC_REFRESH_WORKFLOW_ATTACHMENT");
         
         BEGIN
            INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
            SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, CASE WHEN C.LEVEL_ID = 1 THEN h_element_name ELSE C.ELEMENT_NAME END,
            C.RANK, CASE WHEN C.LEVEL_ID = 1 THEN h_parent_type_id ELSE C.TYPE_ID END, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
            FROM TMT_CRI C
            WHERE C.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 321+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(322) : cri.sql(7213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_CRI_VIEW V
            SET PRIVATE = 'N'
            WHERE PRIVATE = 'Y'
            AND V.ELEMENT_ID = h_id
            AND EXISTS (
            SELECT RA.ELEMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE RA.ELEMENT_ID = V.ELEMENT_ID
            AND RA.PROJECT_ID = V.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 347+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(348) : cri.sql(7239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT Then
         --trace_printf("\n SC_EXPAND_WORKFLOW_ATTACHMENT");
         
         BEGIN
            INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
            SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, CASE WHEN C.LEVEL_ID = 1 THEN h_element_name ELSE C.ELEMENT_NAME END,
            C.RANK, CASE WHEN C.LEVEL_ID = 1 THEN h_parent_type_id ELSE C.TYPE_ID END, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
            FROM TMT_CRI C
            WHERE C.ELEMENT_ID = h_id OR C.PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 370+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(371) : cri.sql(7262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_CRI_VIEW V
            SET PRIVATE = 'N'
            WHERE PRIVATE = 'Y'
            AND EXISTS (
            SELECT RA.ELEMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE RA.ELEMENT_ID = V.ELEMENT_ID
            AND RA.PROJECT_ID = V.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 395+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(396) : cri.sql(7287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH Then
         BEGIN
            INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
            SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
            FROM TMT_CRI C
            WHERE C.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 415+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(416) : cri.sql(7307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_CRI_VIEW V
            SET PRIVATE = 'N'
            WHERE V.ELEMENT_ID = h_id
            AND EXISTS (
            SELECT RA.ELEMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE RA.ELEMENT_ID = V.ELEMENT_ID
            AND RA.PROJECT_ID = V.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 440+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(441) : cri.sql(7332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n  CRI(1010.1)");
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         myStmt := 
               'INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, WBS_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME, EXTERNAL_REFERENCE, REFERENCE_NUMBER, WBS_RANK)';
         myStmt := myStmt || ' SELECT ''';
         myStmt := myStmt || h_project_id;
         myStmt := myStmt || ''', ''';
         myStmt := myStmt || h_project_name_str;
         myStmt := myStmt || 
                    ''', C.ELEMENT_ID, C.PARENT_ID, C.WBS_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME, C.EXTERNAL_REFERENCE, C.REFERENCE_NUMBER, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)';
         
         If Coalesce(h_type_id, 0) = 0 Then
            If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_CRI_VIEW_WITH_GOD_LIKE Then
               --********************* FIRST LEVEL OF ALL CRI VIEW (ALL TYPES)
               -- search cri WITHOUT attributes filter and WITHOUT keyword search
               If ((h_filter_string IS NULL)) AND ((h_name IS NULL)) Then
                  myStmt := myStmt || ' FROM TMT_CRI C, TMT_CRI P ';
                  myStmt := myStmt || ' WHERE C.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND C.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  myStmt := myStmt || ' AND C.LEVEL_ID > 1 ';
                  myStmt := myStmt || ' AND P.ELEMENT_ID = C.PARENT_ID ';
                  --trace_printf("\n  CRI(1000)");
               ElsIf ((h_filter_string IS NOT NULL)) AND ((h_name IS NULL)) Then
                  myStmt := myStmt || ' FROM TMT_CRI C ';
                  myStmt := myStmt || ' WHERE PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  --trace_printf("\n  CRI(1001)");
               ElsIf ((h_name IS NOT NULL)) Then
                  myStmt := myStmt || '  FROM TMT_CRI C ';
                  myStmt := myStmt || '  WHERE (';
                  myStmt := myStmt || h_name;
                  myStmt := myStmt || ') ';
                  
                  myStmt := myStmt || ' AND C.TYPE_ID IN (';
                  myStmt := myStmt || PMO_CNST.SC_STR_CRI_DELV_GROUP_TYPES;
                  myStmt := myStmt || ',';
                  myStmt := myStmt || PMO_CNST.SC_STR_CRI_TASK_GROUP_TYPES;
                  
                  myList := ', ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' ';
                  
                  myStmt := myStmt || myList;
                  myStmt := myStmt || ')';
                  
                  myStmt := myStmt || ' AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%''';
                  --trace_printf("\n  CRI(1002)");
               End If;
            Else
               --********************* FIRST LEVEL OF MY CRI VIEW (ALL TYPES)
               -- search cri WITHOUT attributes filter and WITHOUT keyword search
               If (h_filter_string IS NULL) AND ((h_name IS NULL)) Then
                  myStmt := myStmt || ' FROM TMT_CRI C, TMT_CRI P';
                  myStmt := myStmt || ' WHERE C.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND C.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  
                  myStmt := myStmt || ' AND C.LEVEL_ID > 1';
                  myStmt := myStmt || ' AND P.ELEMENT_ID = C.PARENT_ID ';
                  myStmt := myStmt || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_CRI CC ';
                  myStmt := myStmt || ' WHERE CC.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND CC.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  myStmt := myStmt || ' AND (C.RANK >= SUBSTR(CC.RANK, 1, 8) AND C.RANK <= CC.RANK ';
                  myStmt := myStmt || 
                        ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK) ';
                  myStmt := myStmt || ' AND ((CC.PRIVATE = ''N'' AND CC.TYPE_ID NOT IN (';
                  
                  myList := ' ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ', ' || TO_CHAR(PMO_CNST.SC_CRI_DELIVERABLE) 
                        || ', ' || TO_CHAR(PMO_CNST.SC_CRI_WORK_PRODUCT) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_TASK) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_MILESTONE) || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ' ))';
                  myStmt := myStmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
                  myStmt := myStmt || ' WHERE R.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
                  myStmt := myStmt || ' AND R.RESOURCE_ID = ''';
                  myStmt := myStmt || h_resource_id;
                  myStmt := myStmt || ''')))) ';
                  --trace_printf("\n  CRI(1003.1)");
               ElsIf (h_filter_string IS NOT NULL) AND ((h_name IS NULL)) Then
                  myStmt := myStmt || ' FROM TMT_CRI C ';
                  myStmt := myStmt || ' WHERE PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  myStmt := myStmt || ' AND C.LEVEL_ID > 1 ';
                  myStmt := myStmt || ' AND EXISTS(SELECT ELEMENT_ID FROM TMT_CRI CC ';
                  myStmt := myStmt || ' WHERE CC.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND CC.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  myStmt := myStmt || ' AND (C.RANK >= SUBSTR(CC.RANK, 1, 8) AND C.RANK <= CC.RANK ';
                  myStmt := myStmt || 
                        ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK ) ';
                  myStmt := myStmt || ' AND ((CC.PRIVATE = ''N'' AND CC.TYPE_ID NOT IN (';
                  
                  myList := ' ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ', ' || TO_CHAR(PMO_CNST.SC_CRI_DELIVERABLE) 
                        || ', ' || TO_CHAR(PMO_CNST.SC_CRI_WORK_PRODUCT) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_TASK) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_MILESTONE) || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ')) ';
                  myStmt := myStmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
                  myStmt := myStmt || ' WHERE R.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
                  myStmt := myStmt || ' AND R.RESOURCE_ID = ''';
                  myStmt := myStmt || h_resource_id;
                  myStmt := myStmt || ''')))';
                  --trace_printf("\n  CRI(1004.1)");
               ElsIf (h_name IS NOT NULL) Then
                  myStmt := myStmt || ' FROM TMT_CRI C';
                  myStmt := myStmt || ' WHERE (';
                  myStmt := myStmt || h_name;
                  myStmt := myStmt || ')';
                  
                  myStmt := myStmt || ' AND C.TYPE_ID IN (';
                  myStmt := myStmt || PMO_CNST.SC_STR_CRI_DELV_GROUP_TYPES;
                  myStmt := myStmt || ',';
                  myStmt := myStmt || PMO_CNST.SC_STR_CRI_TASK_GROUP_TYPES;
                  
                  myList := ', ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' ';
                  
                  myStmt := myStmt || myList;
                  myStmt := myStmt || ')';
                  
                  myStmt := myStmt || ' AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' AND EXISTS(SELECT ELEMENT_ID FROM TMT_CRI CC ';
                  myStmt := myStmt || ' WHERE CC.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND CC.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' AND (C.RANK >= SUBSTR(CC.RANK, 1, 8) AND C.RANK <= CC.RANK ';
                  myStmt := myStmt || 
                        ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK) ';
                  myStmt := myStmt || ' AND ((CC.PRIVATE = ''N'' AND CC.TYPE_ID NOT IN (';
                  
                  myList := ' ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ', ' || TO_CHAR(PMO_CNST.SC_CRI_DELIVERABLE) 
                        || ', ' || TO_CHAR(PMO_CNST.SC_CRI_WORK_PRODUCT) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_TASK) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_MILESTONE) || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ')) ';
                  myStmt := myStmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
                  myStmt := myStmt || ' WHERE R.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
                  myStmt := myStmt || 'AND R.RESOURCE_ID = ''';
                  myStmt := myStmt || h_resource_id;
                  myStmt := myStmt || ''')))';
                  --trace_printf("\n  CRI(1005)");
               End If;
            End If;
         Else
            CASE h_type_id
               WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
                  h_task_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
               
               WHEN PMO_CNST.SC_CRI_RISK THEN
                  h_task_type_id := PMO_CNST.SC_CRI_RISK_TASK;
               
               WHEN PMO_CNST.SC_CRI_ISSUE THEN
                  h_task_type_id := PMO_CNST.SC_CRI_ISSUE_TASK;
               
               WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
                  h_task_type_id := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
               
               WHEN PMO_CNST.SC_CRI_DEFECT THEN
                  h_task_type_id := PMO_CNST.SC_CRI_DEFECT_TASK;
               
               WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
                  h_task_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
               
               WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
                  h_task_type_id := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
               
               ELSE
                  h_task_type_id := Coalesce(h_type_id, 0);
            END CASE;
            
            If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_CRI_VIEW_WITH_GOD_LIKE Then
               --********************* FIRST LEVEL OF ALL CRI VIEW (SPECIFIC TYPE)
               -- Insert all the public/assigned CRIs with the requested type  in the first level of the tree
               If (h_name IS NULL) Then
                  myStmt := myStmt || '  FROM TMT_CRI C ';
                  myStmt := myStmt || ' WHERE TYPE_ID IN (';
                  
                  myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                        || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ') ';
                  myStmt := myStmt || ' AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || '''';
                  myStmt := myStmt || ' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%''';
                  --trace_printf("\n  CRI(1006)");
               Else
                  -- h_name is a condition for searching by element_name
                  myStmt := myStmt || '  FROM TMT_CRI C ';
                  myStmt := myStmt || '  WHERE (';
                  myStmt := myStmt || h_name;
                  
                  myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                        || ' ';
                  
                  myStmt := myStmt || ')    AND TYPE_ID IN (';
                  myStmt := myStmt || myList;
                  myStmt := myStmt || ') AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%''';
                  --trace_printf("\n  CRI(1007)");
               End If;
            Else
               --********************* FIRST LEVEL OF MY CRI VIEW (SPECIFIC TYPE)
               -- Insert all the public/assigned CRIs with the requested type  in the first level of the tree
               If (h_name IS NULL) Then
                  myStmt := myStmt || ' FROM TMT_CRI C ';
                  
                  myStmt := myStmt || ' WHERE TYPE_ID IN (';
                  
                  myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                        || ' ';
                  
                  myStmt := myStmt || myList;
                  myStmt := myStmt || ') ';
                  myStmt := myStmt || 'AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  
                  myStmt := myStmt || ' AND EXISTS(SELECT ELEMENT_ID FROM TMT_CRI CC ';
                  myStmt := myStmt || ' WHERE CC.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND CC.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' ';
                  myStmt := myStmt || ' AND (C.RANK >= SUBSTR(CC.RANK, 1, 8) AND C.RANK <= CC.RANK ';
                  myStmt := myStmt || 
                        ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK) ';
                  myStmt := myStmt || ' AND ((CC.PRIVATE = ''N'' AND CC.TYPE_ID NOT IN (';
                  
                  myList := ' ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ', ' || TO_CHAR(PMO_CNST.SC_CRI_DELIVERABLE) 
                        || ', ' || TO_CHAR(PMO_CNST.SC_CRI_WORK_PRODUCT) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_TASK) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_MILESTONE) || ' ';
                  
                  myStmt := myStmt || myList;
                  myStmt := myStmt || ')) ';
                  myStmt := myStmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
                  myStmt := myStmt || ' WHERE R.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' ';
                  myStmt := myStmt || ' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
                  myStmt := myStmt || ' AND R.RESOURCE_ID = ''';
                  myStmt := myStmt || h_resource_id;
                  myStmt := myStmt || ''')))';
                  --trace_printf("\n  CRI(1008)");
               Else
                  myStmt := myStmt || ' FROM TMT_CRI C';
                  myStmt := myStmt || ' WHERE (';
                  myStmt := myStmt || h_name;
                  myStmt := myStmt || ') AND TYPE_ID IN (';
                  
                  myList := ' ' || TO_CHAR(Coalesce(h_type_id, 0)) || ', ' || TO_CHAR(Coalesce(h_task_type_id, 0)) 
                        || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ') AND PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%''';
                  
                  myStmt := myStmt || ' AND EXISTS(SELECT ELEMENT_ID FROM TMT_CRI CC ';
                  myStmt := myStmt || ' WHERE CC.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND CC.PARENT_RANK LIKE ''WBS#';
                  myStmt := myStmt || h_rank;
                  myStmt := myStmt || '%%'' AND (C.RANK >= SUBSTR(CC.RANK, 1, 8) AND C.RANK <= CC.RANK ';
                  myStmt := myStmt || 
                        ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK) ';
                  myStmt := myStmt || ' AND ((CC.PRIVATE = ''N'' AND CC.TYPE_ID NOT IN (';
                  
                  myList := ' ' || TO_CHAR(PMO_CNST.SC_FOLDER) || ', ' || TO_CHAR(PMO_CNST.SC_CRI_DELIVERABLE) 
                        || ', ' || TO_CHAR(PMO_CNST.SC_CRI_WORK_PRODUCT) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_TASK) || ', ' 
                        || TO_CHAR(PMO_CNST.SC_CRI_MILESTONE) || ' ';
                  
                  myStmt := myStmt || myList;
                  
                  myStmt := myStmt || ')) ';
                  myStmt := myStmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
                  myStmt := myStmt || ' WHERE R.PROJECT_ID = ''';
                  myStmt := myStmt || h_project_id;
                  myStmt := myStmt || ''' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
                  myStmt := myStmt || 'AND R.RESOURCE_ID = ''';
                  myStmt := myStmt || h_resource_id;
                  myStmt := myStmt || ''')))';
                  --trace_printf("\n  CRI(1009)");
               End If;
            End If;
         End If;
         
         If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) AND (Coalesce(h_sp_id, 0) = 0) Then
            If (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(h_include_completed_items, 0) = 0) Then
               myStmt := myStmt || 
                     ' AND (C.ACTUAL_FINISH IS NULL OR C.CLOSED_DATETIME IS NOT Null OR C.STAGE_ID IN (';
               myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
               myStmt := myStmt || ' )) ';
            ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                  h_include_completed_items, 0) = 1) Then
               myStmt := myStmt || ' AND (C.STAGE_ID NOT IN (';
               myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
               myStmt := myStmt || ') AND C.CLOSED_DATETIME IS Null) ';
            ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                  h_include_completed_items, 0) = 0) Then
               myStmt := myStmt || 
                     ' AND C.ACTUAL_FINISH IS NULL AND C.CLOSED_DATETIME IS Null AND C.STAGE_ID NOT IN (';
               myStmt := myStmt || PMO_CNST.SC_ALL_CRI_CLOSED_STATE_STR;
               myStmt := myStmt || ')';
            End If;
         End If;
         
         --trace_printf("\n FIRST LEVEL INSERT INTO CRI TEMPORARY TBALE: \n %s \n",(char *) myStmt);
         
         -- execute the main insert into temporary table for the first level of CRI view
         BEGIN
            EXECUTE IMMEDIATE myStmt;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 826+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(827) : cri.sql(7718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_can_view_all_cri:%d", h_can_view_all_cri);
         --trace_printf("\n h_result_set_flag:%d\n", h_result_set_flag);
         
         h_single_element := 1;
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_APPLY_CAN_VIEW_ALL_CRI_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_project_flag);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_U_CRI_SYS_FOLDER_CHILDCOUNT();
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         
         If (h_filter_string IS NOT NULL) Then
            myStmt := 'DELETE FROM PMO_CRI_VIEW A WHERE A.LEVEL_ID > 0';
            myStmt := myStmt || 
                    ' AND (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM TMT_CRI_ATTRIBUTES PA, TMT_CRI_ATTRIBUTES CA ';
            myStmt := myStmt || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (';
            myStmt := myStmt || h_filter_string;
            myStmt := myStmt || ')';
            myStmt := myStmt || 
                    ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK) < ';
            myStmt := myStmt || TO_CHAR(h_filter_count);
            
            BEGIN
               EXECUTE IMMEDIATE myStmt;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 867+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(868) : cri.sql(7759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
                  END IF; 
               END;
            END;
         End If;
         If ((Coalesce(h_sp_id, 0) <> 300) AND (Coalesce(h_sp_id, 0) <> 400)) OR ((h_name IS NOT NULL)) 
               OR ((h_filter_string IS NOT NULL)) Then
            -- Insert the parent node into the result set
            BEGIN
               INSERT INTO PMO_CRI_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, CLOSED_DATETIME)
               SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.CLOSED_DATETIME
               FROM TMT_CRI C
               WHERE PROJECT_ID = h_project_id AND LEVEL_ID = 1
               AND PARENT_RANK = 'WBS#' || h_project_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 892+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(893) : cri.sql(7784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("\n h_sp_id:%d", h_sp_id);
         
         If (BITAND(Coalesce(h_active_record, 0), 8)) > 0 Then
            BEGIN
               DELETE FROM PMO_CRI_VIEW C
               WHERE EXISTS (SELECT P.ELEMENT_ID FROM PMO_CRI_VIEW P
               WHERE P.RANK < C.RANK AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK
               AND P.PARENT_ID <> h_project_id AND P.LEVEL_ID > 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_VIEW', 916+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_VIEW(917) : cri.sql(7808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_CRI_NEXT_LEVEL(h_sp_id, h_project_id, h_project_name, h_project_name_str
                                       , h_rank, h_level_id, h_id, h_resource_id, h_name
                                       , h_filter_string, h_filter_count, h_active_record
                                       , h_is_cri_system_folder, h_executive_security
                                       , h_project_flag);
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_VIEW', 933+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_VIEW(934) : cri.sql(7825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRI_VIEW;
ALTER FUNCTION FC_CRI_VIEW COMPILE DEBUG;

/**************************************************************************************************
NOTE:
	p_treetype: SC_TABLE_WBS or SC_TABLE_CRI
	p_sp_id:    SC_REFRESH(5): refresh the current element
				SC_WORKFLOW_ATTACHMENT(89): view attached cri in workflow

	active_record parameter used to control the following filters options
			1ST BIT: used to indicate the active record:
				0:  my rows only
				1:  all rows

			2ND 0: USER DOES NOT HAVE A PRIVILAGE TO SEE ALL CRIs
				1: USER HAS A PRIVILAGE TO SEE ALL CRIs

			3RD BIT:NOT USED
			4th bit used to control resultset for filters:
				0:  Flat list (include children)
				1:  Flat list (exclude children)

			5TH BIT:NOT USED

			6TH BIT: used to indicate include/exclude Closed items (32)
				0:  exclude Closed items
				1:  include Closed items

			7TH BIT: used to indicate include/exclude Completed items (64)
				0:  exclude Completed items
				1:  include Completed items

***************************************************************************************************/

Prompt == FUNCTION SP_CRI_VIEW ==
CREATE OR REPLACE FUNCTION SP_CRI_VIEW
(
     p_treetype PLS_INTEGER
   , p_sp_id PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
   , p_stage_id PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_active_record PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_can_view_pivot PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_dummy_private VARCHAR2(1);
   h_executive_security VARCHAR2(32);
   h_fieldName VARCHAR2(255);
   h_filter_string VARCHAR2(8000);
   h_filter_count PLS_INTEGER := 0;
   h_full_name VARCHAR2(255);
   h_ids VARCHAR2(4000);
   h_id VARCHAR2(32);
   h_sp_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_root_node_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_temp_project_id VARCHAR2(32);
   h_keyword_filterString VARCHAR2(8000);
   h_name VARCHAR2(8000);
   h_project_flag PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_search_option PLS_INTEGER := 0;
   h_single_element PLS_INTEGER := 0;
   h_prj_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_templ_type PLS_INTEGER := 0;
   h_cleansing_type PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_CRI_T31 PMO_DB2M.REF_CURSOR;

      CURSOR selected_prjs IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM PMO_TMP_PROJECTS_01
         ) WHERE ROWNUM<=1;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CRI_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CRI_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_CRI_VIEW(' || 
       COALESCE(TO_CHAR(p_treetype), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sp_id), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 76+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CRI_VIEW(77) : cri.sql(7941) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) OR (p_treetype IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CRI_VIEW', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CRI_VIEW(82) : cri.sql(7946) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CRI_VIEW(85) : cri.sql(7949) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   -- Declare host variables
   
   h_prj_security_id := '';
   
   h_tree_type := p_treetype;
   h_sp_id := p_sp_id;
   h_ids := p_ids;
   h_resource_id := p_resource_id;
   h_name := p_name;
   h_filter_string := p_filter_string;
   h_filter_count := p_filter_count;
   h_type_id := p_type;
   h_active_record := p_active_record;
   h_stage_id := p_stage_id;
   
   BEGIN
      SELECT REPLACE(RTRIM(NICK_NAME), '''', '''''' )
      INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(115) : cri.sql(7979) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If ((h_name IS NOT NULL)) OR ((h_filter_string IS NOT NULL)) Then
      -- ignore include closed, include completed, and exclude sub element filter
      h_active_record := PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED);
      -- include closed
      h_active_record := PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED);
      -- include completed
      If (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_EXCLUDE_SUB_ELEMENT)) = PMO_CNST.SC_EXCLUDE_SUB_ELEMENT Then
         h_active_record := Coalesce(h_active_record, 0) - PMO_CNST.SC_EXCLUDE_SUB_ELEMENT;
         -- remove exclude sub element
      End If;
   End If;
   
   If Coalesce(h_sp_id, 0) = PMO_CNST.SC_WBS_TEMPLATE_VIEW Then
      If (h_ids IS NULL) Then
         OPEN C_CRI_T31 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.T_RANK AS RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         TO_TIMESTAMP('1899-12-31 00:00:00') AS START_FINISH_DATE, 480 AS MINUTE_PER_DAY, 0 AS EFFORT_DRIVEN, '' AS VIEW_PIVOT,
         T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC,
         T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC, T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS,
         T.ESTIMATED_HOURS_ETC, T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.LAST_CHECKIN,
         T.PROJECT_ID, T.PARENT_RANK AS ORIGINAL_RANK, '' AS WBS_PARENT_ID_NAME, T.WBS_ID,
         T.TRANSFERRED, T.LAST_TRANSFER_DT, 'N' AS TRANSFER_FLAG,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.REC_DATETIME,
         T.CREATED_BY, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.CREATED_BY) AS CREATED_BY_NAME, T.CREATED_DATETIME,
         T.PROPOSED_BY, T.PROPOSED_BY_NAME, T.PROPOSED_DATETIME,
         T.APPROVED_BY, T.APPROVED_BY_NAME, T.APPROVED_DATETIME,
         T.CLOSED_BY, T.CLOSED_BY_NAME, T.CLOSED_DATETIME,
         T.STAGE_ID, T.PRIORITY_ID, T.PRIORITY, T.STATUS_ID, T.PUBLISHED, T.SHARED,
         T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE, T.TOOLTIP_DESCRIPTION,
         0 AS PERCENT_COMPLETE, T.MILESTONE_PERCENT, T.REC_FLAGS, T.SD, T.FD,
         T.START_DATETIME, T.ESTIMATED_START, T.LOW_ESTIMATED_START, T.HIGH_ESTIMATED_START, T.APPROVED_START, T.UNRESOLVED_START, T.PROPOSED_START, T.PLANNED_START, T.SCHED_START, T.FORECAST_START, T.ACTUAL_START, T.BASELINE1_START,
         T.FINISH_DATETIME, T.ESTIMATED_FINISH, T.LOW_ESTIMATED_FINISH, T.HIGH_ESTIMATED_FINISH, T.APPROVED_FINISH, T.UNRESOLVED_FINISH, T.PROPOSED_FINISH, T.PLANNED_FINISH, T.SCHED_FINISH, T.FORECAST_FINISH, T.ACTUAL_FINISH, T.BASELINE1_FINISH,
         T.DURATION, T.ESTIMATED_DURATION, T.LOW_ESTIMATED_DURATION, T.HIGH_ESTIMATED_DURATION, T.APPROVED_DURATION, T.UNRESOLVED_DURATION, T.PROPOSED_DURATION, T.PLANNED_DURATION, T.SCHED_DURATION, T.FORECAST_DURATION, T.ACTUAL_DURATION, T.BASELINE1_DURATION,
         T.ESTIMATED_EFFORT, T.LOW_ESTIMATED_EFFORT, T.HIGH_ESTIMATED_EFFORT, T.APPROVED_EFFORT, T.PROPOSED_EFFORT, T.PLANNED_EFFORT, T.SCHED_EFFORT, T.FORECAST_EFFORT, T.ETC, T.WORK_TODATE AS ACTUAL_EFFORT, T.BASELINE_WORK_TODATE AS BASELINE1_EFFORT, 0 AS PLANNED_ROLLUP_BIT,
         T.ESTIMATION_BUDGET, T.ESTIMATED_BUDGET, T.LOW_ESTIMATED_BUDGET, T.HIGH_ESTIMATED_BUDGET, T.ESTIMATED_REVENUE, T.ESTIMATED_SAVING,
         T.APPROVED_IMPACT_LEVEL_ID, T.APPROVED_BUDGET, T.APPROVED_REVENUE, T.APPROVED_SAVING,
         T.PROPOSED_BUDGET, T.PLANNED_BUDGET, T.CURRENT_BUDGET, T.FORECAST_BUDGET, T.ACTUAL_BUDGET, T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET,
         T.R_ESTIMATION_BUDGET, T.R_ESTIMATED_BUDGET, T.R_LOW_ESTIMATED_BUDGET, T.R_HIGH_ESTIMATED_BUDGET, T.R_APPROVED_BUDGET, T.R_PROPOSED_BUDGET, T.R_PLANNED_BUDGET, T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET, T.R_ACTUAL_BUDGET, T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET,
         T.S_ESTIMATION_BUDGET, T.S_ESTIMATED_BUDGET, T.S_LOW_ESTIMATED_BUDGET, T.S_HIGH_ESTIMATED_BUDGET, T.S_APPROVED_BUDGET, T.S_PROPOSED_BUDGET, T.S_PLANNED_BUDGET, T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET, T.S_ACTUAL_BUDGET, T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET, T.S_BASELINE3_BUDGET,
         T.ESTIMATION_TOTAL, T.R_ESTIMATION_TOTAL, T.S_ESTIMATION_TOTAL, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
         T.BASELINE1_DATETIME, T.BASELINE2_DATETIME, T.BASELINE3_DATETIME,
         0 AS FORECAST_VARIANCE, 0 AS BASELINE_VARIANCE, 0 AS R_FORECAST_VARIANCE, 0 AS R_BASELINE_VARIANCE, 0 AS S_FORECAST_VARIANCE, 0 AS S_BASELINE_VARIANCE,
         T.PLANNING_TYPE, T.PLANNING_UNIT,
         T.IMPACT_RANK_ID, T.IMPACT_LEVEL_ID, T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID,
         T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID, T.EXPOSURE_ID,
         T.MITIGATION_COST, T.CONSEQUENSE_COST, T.PROBABILITY_COST,
         T.REASSIGN_COUNT, T.OCCURED_DATETIME, T.CLIENT_ID, T.CLIENT_NAME, T.ASSET_ID, T.ASSET_NAME, T.ASSET_FLAG,
         COALESCE(T.FINANCIAL_CATEGORY, 6501) AS FINANCIAL_CATEGORY,
         T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DATETIME,T.PREVIOUS_WKF_STEP,
         T.MAX_REV_REACHED, T.MAX_REVISION, '0.1' AS REVISION,
         T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE, '' AS REVISION_HISTORY,
         T.ASSIGN_NAMES, '' AS ASSIGN_RESPONSIBLE, T.ASSIGN_COUNT, 'N' AS ASSIGNED,
         CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS, 'N' AS SCORECARDS,
         T.SCORECARD_ID, T.CONVERTED_WEIGHT, T.CONVERTED_SCORE, T.DUPLICATE_KEY,
         T.RTF_BITS, CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF, T.TARGET_DATE,
         '' AS PRIVATE, T.VISIBLE_AT_PARENT, T.DEFAULT_COL AS DEFAULT_COL, T.TEMPLATED, 0 AS PRIVATE_UNASSIGNED, '' AS SECURITY_ID, '' AS PROJECT_NAME, 0 AS FILTER_FLAG, T.WBS_ASSIGNED
         FROM TMT_CRI T WHERE T.RANK = '/TLF0000';
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 182+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_CRI_VIEW(183) : cri.sql(8047) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C_CRI_T31;
      Else
         BEGIN
            SELECT LEVEL_ID, T_RANK, TYPE_ID
            INTO h_level_id, h_rank, h_templ_type
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_ids;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(198) : cri.sql(8062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_ids: %s, h_level_id: %d, h_rank: %s\n", SC_STATE,h_ids,h_level_id,h_rank);
         
         If (Coalesce(h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER0) OR (Coalesce(
               h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
               h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER2) Then
            h_keyword_filterString := '';
            If (h_name IS NOT NULL) Then
               h_fieldName := 'T.ELEMENT_NAME(C)';
               h_search_option := FC_PARSE_SEARCH_STR(h_name, h_fieldName, h_keyword_filterString);
               
               If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
                  h_name := NULL;
                  ora_temp_sc_state := PMO_DB2M.SC_STATE;
                  null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_CRI, h_keyword_filterString, h_filter_string
                                    , h_filter_count);
                  PMO_DB2M.SC_STATE := ora_temp_sc_state;
                  
                  If Coalesce(h_filter_count, 0) = 0 Then
                     h_filter_count := 1;
                     h_filter_string := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
                  End If;
               Else
                  If Coalesce(Length(h_keyword_filterString), 0) = 0 Then
                     h_name := NULL;
                  Else
                     h_name := h_keyword_filterString;
                  End If;
               End If;
            End If;
            h_xsql := 
                  'INSERT INTO PMO_CRI_VIEW(PROJECT_ID, ELEMENT_ID, RANK, ELEMENT_NAME, START_FINISH_DATE, MINUTE_PER_DAY, EFFORT_DRIVEN)';
            h_xsql := h_xsql || 
                    ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.RANK, T.ELEMENT_NAME, W.START_FINISH_DATE, W.MINUTE_PER_DAY, W.EFFORT_DRIVEN ';
            h_xsql := h_xsql || 'FROM TMT_CRI T JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID ';
            
            If ((h_name IS NOT NULL)) Then
               h_rank := h_rank || '%%';
               
               h_xsql := h_xsql || 'WHERE T.T_RANK LIKE ''';
               h_xsql := h_xsql || h_rank;
               h_xsql := h_xsql || ''' AND T.REC_STATUS <> ''D''';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 257+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(258) : cri.sql(8122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
               
               h_xsql := 
                     'INSERT INTO PMO_CRI_VIEW(PROJECT_ID, ELEMENT_ID, RANK, ELEMENT_NAME, START_FINISH_DATE, MINUTE_PER_DAY, EFFORT_DRIVEN)';
               h_xsql := h_xsql || 
                     ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.RANK, T.ELEMENT_NAME, W.START_FINISH_DATE, W.MINUTE_PER_DAY, W.EFFORT_DRIVEN ';
               
               h_xsql := h_xsql || ' FROM PMO_CRI_VIEW P, TMT_CRI T, TMT_WBS W ';
               h_xsql := h_xsql || ' WHERE P.ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || 
                     ' AND SUBSTR(T.RANK, 1, CASE WHEN LENGTH(T.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END ) = P.RANK ';
               h_xsql := h_xsql || ' AND (';
               h_xsql := h_xsql || h_name;
               h_xsql := h_xsql || ') ';
               h_xsql := h_xsql || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
               h_xsql := h_xsql || ' AND W.PROJECT_ID = T.PROJECT_ID ';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 294+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(295) : cri.sql(8159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
               
               -- delete templated items that dont match in search by name condition
               h_xsql := ' DELETE FROM PMO_CRI_VIEW ';
               h_xsql := h_xsql || ' WHERE ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || ' AND ELEMENT_ID IN ';
               h_xsql := h_xsql || ' ( ';
               h_xsql := h_xsql || 'SELECT T.ELEMENT_ID ';
               h_xsql := h_xsql || ' FROM PMO_CRI_VIEW T ';
               h_xsql := h_xsql || ' WHERE ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || ' AND NOT (';
               h_xsql := h_xsql || h_name;
               h_xsql := h_xsql || '))';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(330) : cri.sql(8194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
            Else
               If (h_filter_string IS NULL) Then
                  --trace_printf("\n 1- h_filter_string:%s",h_filter_string);
                  h_xsql := h_xsql || 'WHERE T.REC_STATUS <> ''D''';
                  h_xsql := h_xsql || ' AND (T.ELEMENT_ID = ''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''' OR T.T_PARENT_ID=''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''')';
               Else
                  --trace_printf("\n 2- h_filter_string:%s",h_filter_string);
                  h_rank := h_rank || '%%';
                  
                  h_xsql := h_xsql || 'WHERE T.T_RANK LIKE ''';
                  h_xsql := h_xsql || h_rank;
                  h_xsql := h_xsql || ''' AND T.REC_STATUS <> ''D'' AND (T.ELEMENT_ID = ''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''' OR (';
                  h_xsql := h_xsql || 
                        ' (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM TMT_CRI_ATTRIBUTES PA, TMT_CRI_ATTRIBUTES CA ';
                  h_xsql := h_xsql || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (';
                  h_xsql := h_xsql || h_filter_string;
                  h_xsql := h_xsql || ')';
                  h_xsql := h_xsql || 
                        ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK) >= ';
                  h_xsql := h_xsql || TO_CHAR(h_filter_count);
                  h_xsql := h_xsql || '))';
               End If;
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 377+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(378) : cri.sql(8242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
            End If;
            
            If ((h_name IS NOT NULL)) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
               h_temp_sc_state := FC_CLEANS_TEMPLATE_CRI_BY_NAME(h_search_option, h_ids);
            End If;
            
            h_xsql := 'SELECT CASE WHEN T.ELEMENT_ID = ''' || h_ids || ''' THEN T.LEVEL_ID ELSE (' 
                  || TO_CHAR(Coalesce(h_level_id, 0)) 
                  || ' + 1) END AS LEVEL_ID, T.TYPE_ID, T.T_RANK AS RANK, '
                   || 'CASE WHEN T.TEMPLATED=''Y'' THEN T.T_PARENT_ID ELSE T.PARENT_ID END AS PARENT_ID, T.ELEMENT_ID, C.ELEMENT_NAME, '
                   || 'C.START_FINISH_DATE, C.MINUTE_PER_DAY, C.EFFORT_DRIVEN, ''N'' AS VIEW_PIVOT, '
                   || 'T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC, '
                   || 'T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC, T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, '
                   || 'T.ESTIMATED_HOURS_ETC, T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC, '
                   || 'T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.LAST_CHECKIN, '
                   || 'T.PROJECT_ID, T.PARENT_RANK AS ORIGINAL_RANK, '
                   || ' (SELECT ELEMENT_NAME FROM TMT_WBS WHERE RANK = CASE WHEN LENGTH(T.PARENT_RANK)>8 AND T.PARENT_RANK IS NOT NULL THEN SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK)- 4) ELSE ''EMPTY_RANK'' END) AS WBS_PARENT_ID_NAME, T.WBS_ID, '
                   || 'T.TRANSFERRED, T.LAST_TRANSFER_DT, CASE WHEN T.WBS_ID IS NULL THEN ''N'' WHEN T.WBS_ID = T.ELEMENT_ID THEN ''Y'' ELSE ''A'' END AS TRANSFER_FLAG, '
                   || 'T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.REC_DATETIME, '
                   || 'T.CREATED_BY, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.CREATED_BY) AS CREATED_BY_NAME, T.CREATED_DATETIME, '
                   || 'T.PROPOSED_BY, T.PROPOSED_BY_NAME, T.PROPOSED_DATETIME, '
                   || 'T.APPROVED_BY, T.APPROVED_BY_NAME, T.APPROVED_DATETIME, '
                   || 'T.CLOSED_BY, T.CLOSED_BY_NAME, T.CLOSED_DATETIME, '
                   || 'T.STAGE_ID, T.PRIORITY_ID, T.PRIORITY, T.STATUS_ID, T.PUBLISHED, T.SHARED, '
                   || 'T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE, T.TOOLTIP_DESCRIPTION, '
                   || 'CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE, '
                   || 'T.MILESTONE_PERCENT, T.REC_FLAGS, T.SD, T.FD, '
                   || 'T.START_DATETIME, T.ESTIMATED_START, T.LOW_ESTIMATED_START, T.HIGH_ESTIMATED_START, T.APPROVED_START, T.UNRESOLVED_START, T.PROPOSED_START, T.PLANNED_START, T.SCHED_START, T.FORECAST_START, T.ACTUAL_START, T.BASELINE1_START, '
                   || 'T.FINISH_DATETIME, T.ESTIMATED_FINISH, T.LOW_ESTIMATED_FINISH, T.HIGH_ESTIMATED_FINISH, T.APPROVED_FINISH, T.UNRESOLVED_FINISH, T.PROPOSED_FINISH, T.PLANNED_FINISH, T.SCHED_FINISH, T.FORECAST_FINISH, T.ACTUAL_FINISH, T.BASELINE1_FINISH, '
                   || 'T.DURATION, T.ESTIMATED_DURATION, T.LOW_ESTIMATED_DURATION, T.HIGH_ESTIMATED_DURATION, T.APPROVED_DURATION, T.UNRESOLVED_DURATION, T.PROPOSED_DURATION, T.PLANNED_DURATION, T.SCHED_DURATION, T.FORECAST_DURATION, T.ACTUAL_DURATION, T.BASELINE1_DURATION, '
                   || 'T.ESTIMATED_EFFORT, T.LOW_ESTIMATED_EFFORT, T.HIGH_ESTIMATED_EFFORT, T.APPROVED_EFFORT, T.PROPOSED_EFFORT, T.PLANNED_EFFORT, T.SCHED_EFFORT, T.FORECAST_EFFORT, T.ETC, T.WORK_TODATE AS ACTUAL_EFFORT, T.BASELINE_WORK_TODATE AS BASELINE1_EFFORT, 0 AS PLANNED_ROLLUP_BIT, '
                   || 'T.ESTIMATION_BUDGET, T.ESTIMATED_BUDGET, T.LOW_ESTIMATED_BUDGET, T.HIGH_ESTIMATED_BUDGET, T.ESTIMATED_REVENUE, T.ESTIMATED_SAVING, '
                   || 'T.APPROVED_IMPACT_LEVEL_ID, T.APPROVED_BUDGET, T.APPROVED_REVENUE, T.APPROVED_SAVING, '
                   || 'T.PROPOSED_BUDGET, T.PLANNED_BUDGET, T.CURRENT_BUDGET, T.FORECAST_BUDGET, T.ACTUAL_BUDGET, T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, '
                   || 'T.R_ESTIMATION_BUDGET, T.R_ESTIMATED_BUDGET, T.R_LOW_ESTIMATED_BUDGET, T.R_HIGH_ESTIMATED_BUDGET, T.R_APPROVED_BUDGET, T.R_PROPOSED_BUDGET, T.R_PLANNED_BUDGET, T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET, T.R_ACTUAL_BUDGET, T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET, '
                   || 'T.S_ESTIMATION_BUDGET, T.S_ESTIMATED_BUDGET, T.S_LOW_ESTIMATED_BUDGET, T.S_HIGH_ESTIMATED_BUDGET, T.S_APPROVED_BUDGET, T.S_PROPOSED_BUDGET, T.S_PLANNED_BUDGET, T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET, T.S_ACTUAL_BUDGET, T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET, T.S_BASELINE3_BUDGET, '
                   || 'T.ESTIMATION_TOTAL, T.R_ESTIMATION_TOTAL, T.S_ESTIMATION_TOTAL, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING, '
                   || 'T.BASELINE1_DATETIME, T.BASELINE2_DATETIME, T.BASELINE3_DATETIME, '
                   || '(T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS FORECAST_VARIANCE, '
                   || 'CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE, '
                   || '(T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE, '
                   || 'CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE, '
                   || '(T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE, '
                   || 'CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE, '
                   || 'T.PLANNING_TYPE, T.PLANNING_UNIT, '
                   || 'T.IMPACT_RANK_ID, T.IMPACT_LEVEL_ID, T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID, '
                   || 'T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID, T.EXPOSURE_ID, '
                   || 'T.MITIGATION_COST, T.CONSEQUENSE_COST, T.PROBABILITY_COST, '
                   || 'T.REASSIGN_COUNT, T.OCCURED_DATETIME, T.CLIENT_ID, T.CLIENT_NAME, T.ASSET_ID, T.ASSET_NAME, T.ASSET_FLAG, '
                   || 'COALESCE(T.FINANCIAL_CATEGORY, 6501) AS FINANCIAL_CATEGORY, '
                   || 'T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DATETIME,T.PREVIOUS_WKF_STEP, '
                   || 'T.MAX_REV_REACHED, T.MAX_REVISION, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                   || 'T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE, '''' AS REVISION_HISTORY, '
                   || 'T.ASSIGN_NAMES, SUBSTR(T.ASSIGN_NAMES,1,(InStr(T.ASSIGN_NAMES, '';'') -1)) AS ASSIGN_RESPONSIBLE, T.ASSIGN_COUNT, '
                   || 'CASE WHEN InStr(T.ASSIGN_NAMES, ''' || h_full_name 
                        || ';'') > 0 THEN ''M'' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN ''A'' ELSE ''N'' END) END AS ASSIGNED, '
                   || 'CASE WHEN T.DOC_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS DOCUMENTS, '
                   || 'CASE WHEN T.SCORECARD_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS SCORECARDS, '
                   || 'T.SCORECARD_ID, T.CONVERTED_WEIGHT, T.CONVERTED_SCORE, T.DUPLICATE_KEY, '
                   || 'T.RTF_BITS, CASE WHEN T.RTF_BITS = 0 THEN ''N'' ELSE ''Y'' END AS RTF, T.TARGET_DATE, '
                   || 'case when T.TYPE_ID IN (' || PMO_CNST.SC_STR_CRI_RESP_DELV_GROUP || ', ' 
                        || PMO_CNST.SC_STR_CRI_RESP_TASK_GROUP 
                        || ') then '''' else T.PRIVATE end AS PRIVATE, T.VISIBLE_AT_PARENT , T.DEFAULT_COL AS DEFAULT_COL, T.TEMPLATED, '
                   || 'CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED, ''SCPROJECTWORKFLOWVISITOR'' AS SECURITY_ID, C.PROJECT_NAME, C.FILTER_FLAG, T.WBS_ASSIGNED '
                   || 'FROM TMT_CRI T,  PMO_CRI_VIEW C WHERE T.ELEMENT_ID = C.ELEMENT_ID ORDER BY T.RANK';
         Else
            --trace_printf("\n CRI Template Open a CRI Element ");
            
            h_xsql := 
                  'INSERT INTO PMO_CRI_VIEW(PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, START_FINISH_DATE, MINUTE_PER_DAY, EFFORT_DRIVEN)';
            h_xsql := h_xsql || 
                    ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, W.START_FINISH_DATE, W.MINUTE_PER_DAY, W.EFFORT_DRIVEN ';
            h_xsql := h_xsql || 
                    'FROM TMT_CRI T JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID WHERE (T.ELEMENT_ID = ''';
            h_xsql := h_xsql || h_ids;
            h_xsql := h_xsql || ''' OR T.PARENT_ID = ''';
            h_xsql := h_xsql || h_ids;
            h_xsql := h_xsql || ''') AND T.REC_STATUS <> ''D''';
            
            --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
            
            BEGIN
               EXECUTE IMMEDIATE h_xsql;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 475+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(476) : cri.sql(8340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                  END IF; 
               END;
            END;
            
            h_xsql := 
                  'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK AS RANK, T.PARENT_ID, T.ELEMENT_ID, C.ELEMENT_NAME, '
                   || 'C.START_FINISH_DATE, C.MINUTE_PER_DAY, C.EFFORT_DRIVEN, ''N'' AS VIEW_PIVOT, '
                   || 'T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC, '
                   || 'T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC, T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, '
                   || 'T.ESTIMATED_HOURS_ETC, T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC, '
                   || 'T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.LAST_CHECKIN, '
                   || 'T.PROJECT_ID, T.PARENT_RANK AS ORIGINAL_RANK, '
                   || ' (SELECT ELEMENT_NAME FROM TMT_WBS WHERE RANK = CASE WHEN LENGTH(T.PARENT_RANK)>8 AND T.PARENT_RANK IS NOT NULL THEN SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK)- 4) ELSE ''EMPTY_RANK'' END) AS WBS_PARENT_ID_NAME, T.WBS_ID, '
                   || 'T.TRANSFERRED, T.LAST_TRANSFER_DT, CASE WHEN T.WBS_ID IS NULL THEN ''N'' WHEN T.WBS_ID = T.ELEMENT_ID THEN ''Y'' ELSE ''A'' END AS TRANSFER_FLAG, '
                   || 'T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.REC_DATETIME, '
                   || 'T.CREATED_BY, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.CREATED_BY) AS CREATED_BY_NAME, T.CREATED_DATETIME, '
                   || 'T.PROPOSED_BY, T.PROPOSED_BY_NAME, T.PROPOSED_DATETIME, '
                   || 'T.APPROVED_BY, T.APPROVED_BY_NAME, T.APPROVED_DATETIME, '
                   || 'T.CLOSED_BY, T.CLOSED_BY_NAME, T.CLOSED_DATETIME, '
                   || 'T.STAGE_ID, T.PRIORITY_ID, T.PRIORITY, T.STATUS_ID, T.PUBLISHED, T.SHARED, '
                   || 'T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE, T.TOOLTIP_DESCRIPTION, '
                   || 'CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE, '
                   || 'T.MILESTONE_PERCENT, T.REC_FLAGS, T.SD, T.FD, '
                   || 'T.START_DATETIME, T.ESTIMATED_START, T.LOW_ESTIMATED_START, T.HIGH_ESTIMATED_START, T.APPROVED_START, T.UNRESOLVED_START, T.PROPOSED_START, T.PLANNED_START, T.SCHED_START, T.FORECAST_START, T.ACTUAL_START, T.BASELINE1_START, '
                   || 'T.FINISH_DATETIME, T.ESTIMATED_FINISH, T.LOW_ESTIMATED_FINISH, T.HIGH_ESTIMATED_FINISH, T.APPROVED_FINISH, T.UNRESOLVED_FINISH, T.PROPOSED_FINISH, T.PLANNED_FINISH, T.SCHED_FINISH, T.FORECAST_FINISH, T.ACTUAL_FINISH, T.BASELINE1_FINISH, '
                   || 'T.DURATION, T.ESTIMATED_DURATION, T.LOW_ESTIMATED_DURATION, T.HIGH_ESTIMATED_DURATION, T.APPROVED_DURATION, T.UNRESOLVED_DURATION, T.PROPOSED_DURATION, T.PLANNED_DURATION, T.SCHED_DURATION, T.FORECAST_DURATION, T.ACTUAL_DURATION, T.BASELINE1_DURATION, '
                   || 'T.ESTIMATED_EFFORT, T.LOW_ESTIMATED_EFFORT, T.HIGH_ESTIMATED_EFFORT, T.APPROVED_EFFORT, T.PROPOSED_EFFORT, T.PLANNED_EFFORT, T.SCHED_EFFORT, T.FORECAST_EFFORT, T.ETC, T.WORK_TODATE AS ACTUAL_EFFORT, T.BASELINE_WORK_TODATE AS BASELINE1_EFFORT, 0 AS PLANNED_ROLLUP_BIT, '
                   || 'T.ESTIMATION_BUDGET, T.ESTIMATED_BUDGET, T.LOW_ESTIMATED_BUDGET, T.HIGH_ESTIMATED_BUDGET, T.ESTIMATED_REVENUE, T.ESTIMATED_SAVING, '
                   || 'T.APPROVED_IMPACT_LEVEL_ID, T.APPROVED_BUDGET, T.APPROVED_REVENUE, T.APPROVED_SAVING, '
                   || 'T.PROPOSED_BUDGET, T.PLANNED_BUDGET, T.CURRENT_BUDGET, T.FORECAST_BUDGET, T.ACTUAL_BUDGET, T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, '
                   || 'T.R_ESTIMATION_BUDGET, T.R_ESTIMATED_BUDGET, T.R_LOW_ESTIMATED_BUDGET, T.R_HIGH_ESTIMATED_BUDGET, T.R_APPROVED_BUDGET, T.R_PROPOSED_BUDGET, T.R_PLANNED_BUDGET, T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET, T.R_ACTUAL_BUDGET, T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET, '
                   || 'T.S_ESTIMATION_BUDGET, T.S_ESTIMATED_BUDGET, T.S_LOW_ESTIMATED_BUDGET, T.S_HIGH_ESTIMATED_BUDGET, T.S_APPROVED_BUDGET, T.S_PROPOSED_BUDGET, T.S_PLANNED_BUDGET, T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET, T.S_ACTUAL_BUDGET, T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET, T.S_BASELINE3_BUDGET, '
                   || 'T.ESTIMATION_TOTAL, T.R_ESTIMATION_TOTAL, T.S_ESTIMATION_TOTAL, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING, '
                   || 'T.BASELINE1_DATETIME, T.BASELINE2_DATETIME, T.BASELINE3_DATETIME, '
                   || '(T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS FORECAST_VARIANCE, '
                   || 'CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE, '
                   || '(T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE, '
                   || 'CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE, '
                   || '(T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE, '
                   || 'CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE, '
                   || 'T.PLANNING_TYPE, T.PLANNING_UNIT, '
                   || 'T.IMPACT_RANK_ID, T.IMPACT_LEVEL_ID, T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID, '
                   || 'T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID, T.EXPOSURE_ID, '
                   || 'T.MITIGATION_COST, T.CONSEQUENSE_COST, T.PROBABILITY_COST, '
                   || 'T.REASSIGN_COUNT, T.OCCURED_DATETIME, T.CLIENT_ID, T.CLIENT_NAME, T.ASSET_ID, T.ASSET_NAME, T.ASSET_FLAG, '
                   || 'COALESCE(T.FINANCIAL_CATEGORY, 6501) AS FINANCIAL_CATEGORY, '
                   || 'T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DATETIME,T.PREVIOUS_WKF_STEP, '
                   || 'T.MAX_REV_REACHED, T.MAX_REVISION, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
                   || 'T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE, '''' AS REVISION_HISTORY, '
                   || 'T.ASSIGN_NAMES, SUBSTR(T.ASSIGN_NAMES,1,(InStr(T.ASSIGN_NAMES, '';'') -1)) AS ASSIGN_RESPONSIBLE, T.ASSIGN_COUNT, '
                   || 'CASE WHEN InStr(T.ASSIGN_NAMES, ''' || h_full_name 
                        || ';'') > 0 THEN ''M'' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN ''A'' ELSE ''N'' END) END AS ASSIGNED, '
                   || 'CASE WHEN T.DOC_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS DOCUMENTS, '
                   || 'CASE WHEN T.SCORECARD_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS SCORECARDS, '
                   || 'T.SCORECARD_ID, T.CONVERTED_WEIGHT, T.CONVERTED_SCORE, T.DUPLICATE_KEY, '
                   || 'T.RTF_BITS, CASE WHEN T.RTF_BITS = 0 THEN ''N'' ELSE ''Y'' END AS RTF, T.TARGET_DATE, '
                   || 'case when T.TYPE_ID IN (' || PMO_CNST.SC_STR_CRI_RESP_DELV_GROUP || ', ' 
                        || PMO_CNST.SC_STR_CRI_RESP_TASK_GROUP 
                        || ') then '''' else T.PRIVATE end AS PRIVATE, T.VISIBLE_AT_PARENT , T.DEFAULT_COL AS DEFAULT_COL, T.TEMPLATED, '
                   || 'CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED, ''SCPROJECTWORKFLOWVISITOR'' AS SECURITY_ID, C.PROJECT_NAME, C.FILTER_FLAG, T.WBS_ASSIGNED '
                   || 'FROM TMT_CRI T,  PMO_CRI_VIEW C WHERE T.ELEMENT_ID = C.ELEMENT_ID ORDER BY RANK';
         End If;
      End If;
   Else
      h_xsql := 'SELECT C.LEVEL_ID, C.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, C.ELEMENT_NAME, '
             || 'C.START_FINISH_DATE, C.MINUTE_PER_DAY, C.EFFORT_DRIVEN, C.VIEW_PIVOT, '
             || 'T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC, '
             || 'T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC, T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, '
             || 'T.ESTIMATED_HOURS_ETC, T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC, '
             || 'CASE WHEN T.LEVEL_ID = 1 THEN 0 ELSE C.CHILD_COUNT END AS CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.LAST_CHECKIN, '
             || 'T.PROJECT_ID, T.PARENT_RANK AS ORIGINAL_RANK, '
             || ' (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.RANK = case when T.PARENT_RANK is not null and length(T.PARENT_RANK)>8 then SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK)- 4) else ''EMPTY_RANK'' end) AS WBS_PARENT_ID_NAME, T.WBS_ID, '
             || 'T.TRANSFERRED, T.LAST_TRANSFER_DT, CASE WHEN T.WBS_ID IS NULL THEN ''N'' WHEN T.WBS_ID = T.ELEMENT_ID THEN ''Y'' ELSE ''A'' END AS TRANSFER_FLAG, '
             || 'T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.REC_DATETIME, '
             || 'T.CREATED_BY, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.CREATED_BY) AS CREATED_BY_NAME, T.CREATED_DATETIME, '
             || 'T.PROPOSED_BY, T.PROPOSED_BY_NAME, T.PROPOSED_DATETIME, '
             || 'T.APPROVED_BY, T.APPROVED_BY_NAME, T.APPROVED_DATETIME, '
             || 'T.CLOSED_BY, T.CLOSED_BY_NAME, T.CLOSED_DATETIME, '
             || 'T.STAGE_ID, T.PRIORITY_ID, T.PRIORITY, T.STATUS_ID, T.PUBLISHED, T.SHARED, '
             || 'T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE, T.TOOLTIP_DESCRIPTION, '
             || 'CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE, '
             || 'T.MILESTONE_PERCENT, T.REC_FLAGS, T.SD, T.FD, '
             || 'T.START_DATETIME, T.ESTIMATED_START, T.LOW_ESTIMATED_START, T.HIGH_ESTIMATED_START, T.APPROVED_START, T.UNRESOLVED_START, T.PROPOSED_START, T.PLANNED_START, T.SCHED_START, T.FORECAST_START, T.ACTUAL_START, T.BASELINE1_START, '
             || 'T.FINISH_DATETIME, T.ESTIMATED_FINISH, T.LOW_ESTIMATED_FINISH, T.HIGH_ESTIMATED_FINISH, T.APPROVED_FINISH, T.UNRESOLVED_FINISH, T.PROPOSED_FINISH, T.PLANNED_FINISH, T.SCHED_FINISH, T.FORECAST_FINISH, T.ACTUAL_FINISH, T.BASELINE1_FINISH, '
             || 'T.DURATION, T.ESTIMATED_DURATION, T.LOW_ESTIMATED_DURATION, T.HIGH_ESTIMATED_DURATION, T.APPROVED_DURATION, T.UNRESOLVED_DURATION, T.PROPOSED_DURATION, T.PLANNED_DURATION, T.SCHED_DURATION, T.FORECAST_DURATION, T.ACTUAL_DURATION, T.BASELINE1_DURATION, '
             || 'T.ESTIMATED_EFFORT, T.LOW_ESTIMATED_EFFORT, T.HIGH_ESTIMATED_EFFORT, T.APPROVED_EFFORT, T.PROPOSED_EFFORT, T.PLANNED_EFFORT, T.SCHED_EFFORT, T.FORECAST_EFFORT, T.ETC, T.WORK_TODATE AS ACTUAL_EFFORT, T.BASELINE_WORK_TODATE AS BASELINE1_EFFORT, 0 AS PLANNED_ROLLUP_BIT, '
             || 'T.ESTIMATION_BUDGET, T.ESTIMATED_BUDGET, T.LOW_ESTIMATED_BUDGET, T.HIGH_ESTIMATED_BUDGET, T.ESTIMATED_REVENUE, T.ESTIMATED_SAVING, '
             || 'T.APPROVED_IMPACT_LEVEL_ID, T.APPROVED_BUDGET, T.APPROVED_REVENUE, T.APPROVED_SAVING, '
             || 'T.PROPOSED_BUDGET, T.PLANNED_BUDGET, T.CURRENT_BUDGET, T.FORECAST_BUDGET, T.ACTUAL_BUDGET, T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, '
             || 'T.R_ESTIMATION_BUDGET, T.R_ESTIMATED_BUDGET, T.R_LOW_ESTIMATED_BUDGET, T.R_HIGH_ESTIMATED_BUDGET, T.R_APPROVED_BUDGET, T.R_PROPOSED_BUDGET, T.R_PLANNED_BUDGET, T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET, T.R_ACTUAL_BUDGET, T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET, '
             || 'T.S_ESTIMATION_BUDGET, T.S_ESTIMATED_BUDGET, T.S_LOW_ESTIMATED_BUDGET, T.S_HIGH_ESTIMATED_BUDGET, T.S_APPROVED_BUDGET, T.S_PROPOSED_BUDGET, T.S_PLANNED_BUDGET, T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET, T.S_ACTUAL_BUDGET, T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET, T.S_BASELINE3_BUDGET, '
             || 'T.ESTIMATION_TOTAL, T.R_ESTIMATION_TOTAL, T.S_ESTIMATION_TOTAL, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING, '
             || 'T.BASELINE1_DATETIME, T.BASELINE2_DATETIME, T.BASELINE3_DATETIME, '
             || '(T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS FORECAST_VARIANCE, '
             || 'CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE, '
             || '(T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE, '
             || 'CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE, '
             || '(T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE, '
             || 'CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE, '
             || 'T.PLANNING_TYPE, T.PLANNING_UNIT, '
             || 'T.IMPACT_RANK_ID, T.IMPACT_LEVEL_ID, T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID, '
             || 'T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID, T.EXPOSURE_ID, '
             || 'T.MITIGATION_COST, T.CONSEQUENSE_COST, T.PROBABILITY_COST, '
             || 'T.REASSIGN_COUNT, T.OCCURED_DATETIME, T.CLIENT_ID, T.CLIENT_NAME, T.ASSET_ID, T.ASSET_NAME, T.ASSET_FLAG, '
             || 'COALESCE(T.FINANCIAL_CATEGORY, 6501) AS FINANCIAL_CATEGORY, '
             || 'T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DATETIME,T.PREVIOUS_WKF_STEP, '
             || 'T.MAX_REV_REACHED, T.MAX_REVISION, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
             || 'T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE, '''' AS REVISION_HISTORY, '
             || 'T.ASSIGN_NAMES, SUBSTR(T.ASSIGN_NAMES,1,(InStr(T.ASSIGN_NAMES, '';'') -1)) AS ASSIGN_RESPONSIBLE, T.ASSIGN_COUNT, '
             || 'CASE WHEN InStr(T.ASSIGN_NAMES, ''' || h_full_name 
                  || ';'') > 0 THEN ''M'' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN ''A'' ELSE ''N'' END) END AS ASSIGNED, '
             || 'CASE WHEN T.DOC_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS DOCUMENTS, '
             || 'CASE WHEN T.SCORECARD_COUNT > 0 THEN ''Y'' ELSE ''N'' END AS SCORECARDS, '
             || 'T.SCORECARD_ID, T.CONVERTED_WEIGHT, T.CONVERTED_SCORE, T.DUPLICATE_KEY, '
             || 'T.RTF_BITS, CASE WHEN T.RTF_BITS = 0 THEN ''N'' ELSE ''Y'' END AS RTF, T.TARGET_DATE, '
             || ' case when T.TYPE_ID IN (' || PMO_CNST.SC_STR_CRI_RESP_DELV_GROUP || ', ' 
                  || PMO_CNST.SC_STR_CRI_RESP_TASK_GROUP 
                  || ') then '''' else T.PRIVATE end AS PRIVATE, T.VISIBLE_AT_PARENT , T.DEFAULT_COL AS DEFAULT_COL, T.TEMPLATED, ';
      
      If ((h_filter_string IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_filter_string
            , 'EMPTY_TREE_FLAG') = 0) Then
         h_temp_project_id := NULL;
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            If ((h_ids IS NOT NULL)) AND (Coalesce(Length(h_ids), 0) = 32) Then
               BEGIN
                  SELECT ELEMENT_ID INTO h_temp_project_id
                  FROM TMT_CRI
                  WHERE PROJECT_ID = h_ids
                  AND LEVEL_ID = 1
                  AND ELEMENT_NAME = 'WBS';
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 613+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(614) : cri.sql(8478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  h_temp_project_id := NULL;
               End If;
            End If;
         End If;
         
         If (h_temp_project_id IS NOT NULL) Then
            BEGIN
               INSERT INTO PMO_CRI_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
               RANK, TYPE_ID, LEVEL_ID, MINUTE_PER_DAY, STAGE_ID, EFFORT_DRIVEN,
               VIEW_PIVOT, SECURITY_ID, PRIVATE, CHILD_COUNT)
               VALUES(h_temp_project_id, 'Portal page dummy row',  h_temp_project_id, '', 'Portal page',
               '00000000', 145, 1, 0, 0, 1, 'Y','', 'N', 0);   -- for root node return private = 'N';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 641+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(642) : cri.sql(8506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_CRI_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
               RANK, TYPE_ID, LEVEL_ID, MINUTE_PER_DAY, STAGE_ID, EFFORT_DRIVEN,
               VIEW_PIVOT, SECURITY_ID, PRIVATE, CHILD_COUNT)
               VALUES(NuLL, 'Portal page dummy row',  NuLL, '', 'Portal page',
               '0000', 145, 1, 0, 0, 1, 'Y','', 'N', 0);   -- for root node return private = 'N';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 662+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(663) : cri.sql(8527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_tree_type := PMO_CNST.SC_TABLE_NULL;
         
         h_xsql := h_xsql || 
                    ' CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED,';
         h_name := NULL;
      End If;
      
      h_search_option := PMO_CNST.SC_NO_SEARCH_BY_NAME;
      
      h_keyword_filterString := '';
      If (h_name IS NOT NULL) Then
         h_fieldName := 'C.ELEMENT_NAME(C),C.EXTERNAL_REFERENCE(C),C.REFERENCE_NUMBER(N)';
         h_search_option := FC_PARSE_SEARCH_STR(h_name, h_fieldName, h_keyword_filterString);
         
         If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
            h_name := NULL;
            ora_temp_sc_state := PMO_DB2M.SC_STATE;
            null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_CRI, h_keyword_filterString, h_filter_string
                                    , h_filter_count);
            PMO_DB2M.SC_STATE := ora_temp_sc_state;
            
            If Coalesce(h_filter_count, 0) = 0 Then
               h_filter_count := 1;
               h_filter_string := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
            End If;
         Else
            If Coalesce(Length(h_keyword_filterString), 0) = 0 Then
               h_name := NULL;
            Else
               h_name := h_keyword_filterString;
            End If;
         End If;
      End If;
      
      h_executive_security := NULL;
      h_can_view_pivot := 0;
      --trace_printf("1___* h_tree_type: %d\n", h_tree_type);
      
      If ((Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
              h_tree_type, 0) = PMO_CNST.SC_TABLE_PORTFOLIO)) AND ((Coalesce(h_sp_id, 0) >= 300) 
              AND (Coalesce(h_sp_id, 0) < 402)) Then
         If (h_ids IS NULL) Then
            h_table_type := PMO_CNST.SC_TABLE_CRI;
            --trace_printf("\n 1-h_executive_security:%s", h_executive_security);
            h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
            --trace_printf("\n 2-h_executive_security:%s", h_executive_security);
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
            h_id := NULL;
            h_bitflag := Coalesce(h_bitflag, 0);
            ora_temp_sc_state := PMO_DB2M.SC_STATE;
            null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_id, h_resource_id, h_bitflag);
            PMO_DB2M.SC_STATE := ora_temp_sc_state;
         Else
            If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_PORTFOLIO Then
               h_table_type := PMO_CNST.SC_TABLE_CRI;
               --trace_printf("\n 3-h_executive_security:%s", h_executive_security);
               h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
               --trace_printf("\n 4-h_executive_security:%s", h_executive_security);
               h_bitflag := Coalesce(h_bitflag, 0);
               ora_temp_sc_state := PMO_DB2M.SC_STATE;
               null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_bitflag);
               PMO_DB2M.SC_STATE := ora_temp_sc_state;
            ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
               h_tree_type := PMO_CNST.SC_TABLE_WBS;
               
               h_table_type := PMO_CNST.SC_TABLE_CRI;
               --trace_printf("\n 5-h_executive_security:%s", h_executive_security);
               h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
               --trace_printf("\n 6-h_executive_security:%s", h_executive_security);
               h_bitflag := Coalesce(h_bitflag, 0);
               
               If (Coalesce(h_sp_id, 0) = 301) OR (Coalesce(h_sp_id, 0) = 401) Then
                  h_sp_id := Coalesce(h_sp_id, 0) - 1;
                  h_bitflag := 2;
               Else
                  h_bitflag := 0;
               End If;
               
               ora_temp_sc_state := PMO_DB2M.SC_STATE;
               null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_bitflag);
               PMO_DB2M.SC_STATE := ora_temp_sc_state;
            End If;
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
         End If;
         
         If Coalesce(h_sp_id, 0) = 300 Then
            h_active_record := (PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), 1));
         ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            h_active_record := (Coalesce(h_active_record, 0) - 1);
         End If;
         
         h_temp_project_id := NULL;
         
         -- fetch a project_id from PMO_TMP_PROJECTS_01:pick just one project_id to insert a dummy record into PMO_CRI_VIEW to avoid of left join
         
         OPEN selected_prjs;
         
         FETCH selected_prjs INTO h_temp_project_id;
         IF selected_prjs%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_temp_project_id := NULL;
         End If;
         
         BEGIN
            CLOSE selected_prjs ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 786+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(787) : cri.sql(8651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n 7-h_executive_security:%s", h_executive_security);
         
         h_cleansing_type := PMO_CNST.SC_CRI_CLEANSING;
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_CLEANS_PRJ_LIST(Coalesce(h_cleansing_type, 0), h_resource_id
                                  , h_executive_security);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         
         h_single_element := 0;
         h_id := NULL;
         h_temp_sc_state := FC_CRI_VIEW(h_single_element, h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                               , h_filter_string, h_filter_count, h_type_id, h_active_record
                               , h_stage_id, h_project_flag, h_executive_security, h_can_view_pivot);
         
         If ((h_name IS NOT NULL)) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
            h_temp_sc_state := FC_CLEANS_CRI_BY_NAME(h_search_option);
         End If;
         
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_FIX_SECURITY_IN_CRI_VIEW(h_single_element, h_sp_id, h_id, h_tree_type
                                           , h_resource_id, h_project_flag, h_executive_security);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         
         h_dummy_private := 'Y';
         h_count := 0;
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM PMO_CRI_VIEW
            WHERE VIEW_PIVOT = 'N';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 826+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(827) : cri.sql(8691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_dummy_private := 'N';
         End If;
         
         BEGIN
            UPDATE PMO_CRI_VIEW T
            SET (T.START_FINISH_DATE, T.MINUTE_PER_DAY, T.EFFORT_DRIVEN, T.VIEW_PIVOT)
            = ( SELECT W.START_FINISH_DATE, W.MINUTE_PER_DAY, W.EFFORT_DRIVEN, h_dummy_private
            FROM TMT_WBS W
            WHERE W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 851+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(852) : cri.sql(8716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Fetch correct project_id
         BEGIN
            SELECT ELEMENT_ID INTO h_root_node_project_id
            FROM TMT_CRI
            WHERE PARENT_ID = h_temp_project_id AND
            ELEMENT_NAME = 'WBS' AND
            LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 869+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(870) : cri.sql(8734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_root_node_project_id := NULL;
         End If;
         
         -- Insert dummy row into PMO_CRI_VIEW
         -- Keep ELEMENT_ID = PROJECT_ID and LEVEL_ID = 1, for the rest of fields the values are not important
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            If (h_temp_project_id IS NULL) Then
               BEGIN
                  INSERT INTO PMO_CRI_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
                  RANK, TYPE_ID, LEVEL_ID, MINUTE_PER_DAY, STAGE_ID, EFFORT_DRIVEN,
                  VIEW_PIVOT, SECURITY_ID, PRIVATE, CHILD_COUNT)
                  VALUES(NuLL, 'Portal page dummy row',  NuLL, '', 'Portal page',
                  '0000', 145, 1, 0, 0, 1, 'Y','', 'N', 0);   -- for root node return private = 'N';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 898+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(899) : cri.sql(8763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PMO_CRI_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
                  RANK, TYPE_ID, LEVEL_ID, MINUTE_PER_DAY, STAGE_ID, EFFORT_DRIVEN,
                  VIEW_PIVOT, SECURITY_ID, PRIVATE, CHILD_COUNT)
                  VALUES(h_root_node_project_id, 'Portal page dummy row',  h_root_node_project_id, '', 'Portal page',
                  '00000000', 145, 1, 0, 0, 1, 'Y','', 'N', 0);   -- for root node return private = 'N';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 919+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(920) : cri.sql(8784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         h_xsql := h_xsql || 
                    ' CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED,';
      ElsIf Coalesce(h_tree_type, 0) <> PMO_CNST.SC_TABLE_NULL Then
         h_id := SubStr(h_ids, 1, 32);
         h_single_element := 1;
         
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            -- get project_id of the selected item
            BEGIN
               SELECT PROJECT_ID
               INTO h_project_id
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 944+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(945) : cri.sql(8809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
            -- get project_id of the selected item
            BEGIN
               SELECT PROJECT_ID
               INTO h_project_id
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 961+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(962) : cri.sql(8826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
               h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
            -- get project type, that is, NORMAL_PROJECT, EXECUTIVE_PROJECT, ASSIGNED_EXECUTIVE_PROJECT
            h_project_flag := FC_GET_PROJECT_TYPE(h_project_id, h_resource_id);
            
            --trace_printf("\n  h_project_flag:%d \n", h_project_flag);
            
            If Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT Then
               h_table_type := PMO_CNST.SC_TABLE_CRI;
               h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
               
               --trace_printf("\n  h_executive_security:%s \n", h_executive_security);
            Else
               h_project_flag := 1;
               h_executive_security := NULL;
            End If;
         End If;
         
         h_temp_sc_state := FC_CRI_VIEW(h_single_element, h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                               , h_filter_string, h_filter_count, h_type_id, h_active_record
                               , h_stage_id, h_project_flag, h_executive_security, h_can_view_pivot);
         
         If ((h_name IS NOT NULL)) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
            h_temp_sc_state := FC_CLEANS_CRI_BY_NAME(h_search_option);
         End If;
         --trace_printf("\n  1___________* \n");
         
         -- single wbs element/ next level in cri tree/ refresh cri node
         ora_temp_sc_state := PMO_DB2M.SC_STATE;
         null_return := FC_FIX_SECURITY_IN_CRI_VIEW(h_single_element, h_sp_id, h_id, h_tree_type
                                           , h_resource_id, h_project_flag, h_executive_security);
         PMO_DB2M.SC_STATE := ora_temp_sc_state;
         
         If Coalesce(h_temp_sc_state, 0) <> 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CRI_VIEW', 1003+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CRI_VIEW(1004) : cri.sql(8868) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 1006+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_CRI_VIEW(1007) : cri.sql(8871) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(Coalesce(h_temp_sc_state, 0), h_id, True);
         End If;
         
         BEGIN
            UPDATE PMO_CRI_VIEW T
            SET (T.START_FINISH_DATE, T.MINUTE_PER_DAY, T.EFFORT_DRIVEN)
            = ( SELECT W.START_FINISH_DATE, W.MINUTE_PER_DAY, W.EFFORT_DRIVEN
            FROM TMT_WBS W
            WHERE W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1027+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1028) : cri.sql(8892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_xsql := h_xsql || 
                    ' CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED,';
      End If;
      
      If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) AND ((Coalesce(h_sp_id, 0) = 300) 
             OR (Coalesce(h_sp_id, 0) = 400)) Then
         --            if ((h_active_record  8) == 8)
         --            {
         --trace_printf("\n delete sub elements \n");
         --                BEGIN_SQL
         --                    DELETE FROM session.PMO_CRI_VIEW C
         --                    WHERE EXISTS (SELECT P.ELEMENT_ID
         --                            FROM session.PMO_CRI_VIEW P
         --                            WHERE P.RANK < C.RANK
         --                                AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK);
         --                END_SQL;
         --            }
         
         If (Coalesce(h_type_id, 0) = 0) AND ((h_filter_string IS NULL)) Then
            BEGIN
               UPDATE PMO_CRI_VIEW
               SET FILTER_FLAG = 0
               WHERE 1 = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1065+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1066) : cri.sql(8930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PMO_CRI_VIEW
               SET FILTER_FLAG = 1
               WHERE RANK <> '00000000';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1084+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1085) : cri.sql(8949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_tree_type, 0) <> PMO_CNST.SC_TABLE_NULL Then
         If Coalesce(h_type_id, 0) <> 0 Then
            CASE h_type_id
               WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
                  h_task_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
               
               WHEN PMO_CNST.SC_CRI_RISK THEN
                  h_task_type_id := PMO_CNST.SC_CRI_RISK_TASK;
               
               WHEN PMO_CNST.SC_CRI_ISSUE THEN
                  h_task_type_id := PMO_CNST.SC_CRI_ISSUE_TASK;
               
               WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
                  h_task_type_id := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
               
               WHEN PMO_CNST.SC_CRI_DEFECT THEN
                  h_task_type_id := PMO_CNST.SC_CRI_DEFECT_TASK;
               
               WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
                  h_task_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
               
               WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
                  h_task_type_id := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
               
               ELSE
                  h_task_type_id := Coalesce(h_type_id, 0);
            END CASE;
            
            If Coalesce(h_stage_id, 0) <> 0 Then
               BEGIN
                  UPDATE PMO_CRI_VIEW
                  SET FILTER_FLAG = 1
                  WHERE TYPE_ID IN (h_type_id, h_task_type_id) AND STAGE_ID = h_stage_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1132+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1133) : cri.sql(8997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PMO_CRI_VIEW
                  SET FILTER_FLAG = 1
                  WHERE TYPE_ID IN (h_type_id, h_task_type_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1151+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1152) : cri.sql(9016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      
      h_xsql := h_xsql || ' C.SECURITY_ID AS SECURITY_ID ';
      h_xsql := h_xsql || ', C.PROJECT_NAME, C.FILTER_FLAG, T.WBS_ASSIGNED, T.ELEMENT_FLAG ';
      h_xsql := h_xsql || ' FROM TMT_CRI T, PMO_CRI_VIEW C';
      
      If (h_temp_project_id IS NULL) Then
         h_xsql := h_xsql || ' WHERE T.RANK = C.RANK ';
      Else
         h_xsql := h_xsql || ' WHERE T.ELEMENT_ID = C.ELEMENT_ID ';
      End If;
      h_xsql := h_xsql || ' ORDER BY C.RANK';
   End If;
   
   --trace_printf("\n%s\n", (char *)h_xsql);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 1174+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CRI_VIEW(1175) : cri.sql(9039) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CRI_VIEW', 1177+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CRI_VIEW(1178) : cri.sql(9042) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1185+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1186) : cri.sql(9050) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CRI_VIEW', 1197+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CRI_VIEW(1198) : cri.sql(9062) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CRI_VIEW;
ALTER FUNCTION SP_CRI_VIEW COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_C_CRI_ITEM ==
CREATE OR REPLACE FUNCTION FC_C_CRI_ITEM
(
     sh_h_table PLS_INTEGER
   , h_old_id IN OUT NOCOPY VARCHAR2
   , h_new_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_c_assign_names VARCHAR2(400);
   h_c_attached_id VARCHAR2(32);
   h_c_dep_rank VARCHAR2(200);
   h_c_depend_id VARCHAR2(32);
   h_c_doc_parent_rank VARCHAR2(200);
   h_c_doc_rank VARCHAR2(200);
   h_c_element_id VARCHAR2(32);
   h_c_element_name VARCHAR2(255);
   h_c_external_reference VARCHAR2(32);
   h_c_keywords VARCHAR2(255);
   h_c_old_pred_id VARCHAR2(32);
   h_c_old_succ_id VARCHAR2(32);
   h_c_parent_id VARCHAR2(32);
   h_c_planned_finish TIMESTAMP;
   h_c_planned_start TIMESTAMP;
   h_c_planning_unit VARCHAR2(1);
   h_c_pred_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_c_ref_number VARCHAR2(100);
   h_c_security_id VARCHAR2(32);
   h_c_succ_id VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_current_datetime TIMESTAMP;
   h_rankBase64 VARCHAR2(200);
   h_rankBase64_doc VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   h_x_cri_start_dt TIMESTAMP;
   h_x_full_name VARCHAR2(100);
   h_x_new_project_id VARCHAR2(32);
   h_x_new_parent_rank VARCHAR2(200);
   h_x_new_cri_rank VARCHAR2(200);
   h_x_old_project_id VARCHAR2(32);
   h_x_old_cri_rank VARCHAR2(200);
   h_x_wbs_start_dt TIMESTAMP;
   h_history_id VARCHAR2(32);
   h_bit_flag1 VARCHAR2(1);
   h_bit_flag2 VARCHAR2(1);
   h_c_amount PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_c_assign_count PLS_INTEGER := 0;
   h_c_child_count PLS_INTEGER := 0;
   h_c_cost_rank_id PLS_INTEGER := 0;
   h_c_dep_type PLS_INTEGER := 0;
   h_c_doc_level_id PLS_INTEGER := 0;
   h_c_lag_display_unit PLS_INTEGER := 0;
   h_c_lead_or_lag_type PLS_INTEGER := 0;
   h_c_level_id PLS_INTEGER := 0;
   h_c_max_rank PLS_INTEGER := 0;
   h_c_parent_type_id PLS_INTEGER := 0;
   h_c_participant PLS_INTEGER := 0;
   h_c_planned_duration PLS_INTEGER := 0;
   h_c_planned_effort PLS_INTEGER := 0;
   h_c_planned_start_julian PLS_INTEGER := 0;
   h_c_planning_type PLS_INTEGER := 0;
   h_c_pred_object_type PLS_INTEGER := 0;
   h_c_quality_rank_id PLS_INTEGER := 0;
   h_c_schedule_rank_id PLS_INTEGER := 0;
   h_c_scope_rank_id PLS_INTEGER := 0;
   h_c_succ_object_type PLS_INTEGER := 0;
   h_c_type_id PLS_INTEGER := 0;
   h_c_rtf_bits PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_max_rank_doc PLS_INTEGER := 0;
   h_parent_max_rank_doc PLS_INTEGER := 0;
   h_prev_level PLS_INTEGER := 0;
   h_source_level_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_c_estimated_budget NUMBER := 0.00;
   h_c_mitigation_cost NUMBER := 0.00;
   h_c_probability_rank_id PLS_INTEGER := 0;
   h_c_precision_rank_id PLS_INTEGER := 0;
   h_c_impact_rank_id PLS_INTEGER := 0;
   h_c_exposure_id PLS_INTEGER := 0;
   h_c_impact_level_id PLS_INTEGER := 0;
   h_priority_id PLS_INTEGER := 0;
   h_c_consequense_cost NUMBER := 0.00;
   h_c_probability_cost NUMBER := 0.00;
   wbs_cri_count PLS_INTEGER NOT NULL := 0;
   h_level_dif PLS_INTEGER := 0;
   h_x_element_id VARCHAR2(32);
   h_x_level_id PLS_INTEGER := 0;
   h_x_rank VARCHAR2(200);
   h_doc_count PLS_INTEGER := 0;
   h_c_doc_count PLS_INTEGER := 0;
   h_c_scd_count PLS_INTEGER := 0;
   h_c_estimated_start TIMESTAMP;
   h_c_high_start TIMESTAMP;
   h_c_low_start TIMESTAMP;
   h_c_estimated_finish TIMESTAMP;
   h_c_high_finish TIMESTAMP;
   h_c_low_finish TIMESTAMP;
   h_source_date TIMESTAMP;
   h_c_estimated_effort PLS_INTEGER := 0;
   h_c_high_effort PLS_INTEGER := 0;
   h_c_low_effort PLS_INTEGER := 0;
   h_c_estimated_duration PLS_INTEGER := 0;
   h_c_high_duration PLS_INTEGER := 0;
   h_c_low_duration PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_c_r_estimated_budget NUMBER := 0.00;
   h_c_s_estimated_budget NUMBER := 0.00;
   h_c_r_high_estimated_budget NUMBER := 0.00;
   h_c_s_high_estimated_budget NUMBER := 0.00;
   h_c_r_low_estimated_budget NUMBER := 0.00;
   h_c_s_low_estimated_budget NUMBER := 0.00;
   h_temp_sc_state PLS_INTEGER := 0;
   h_c_participants PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_root_level_id PLS_INTEGER := 0;
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_c_parent_rank VARCHAR2(200);
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_new_rank VARCHAR2(200);
   h_prefix VARCHAR2(255);
   h_assign_string VARCHAR2(4000);
   h_private VARCHAR2(1);
   h_parent_type_id PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_effort_driven PLS_INTEGER := 0;
   h_system_folder_exists PLS_INTEGER := 0;
   h_wbs_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR C_CCRI_DATE_1 IS
         SELECT * FROM (SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_x_new_project_id AND DAY_YEAR >= TO_DATE(SYSDATE)
         ) WHERE ROWNUM<=1;

      CURSOR C_READ_SRC_1 IS
         SELECT
         T.ELEMENT_ID, T.RANK, T.TYPE_ID,
         T.PARENT_ID, T.PARENT_RANK, T.LEVEL_ID,
         0, 0, T.ELEMENT_NAME, T.PARENT_TYPE_ID,
         T.PLANNING_TYPE, T.PLANNING_UNIT, T.PLANNED_EFFORT,
         T.PLANNED_START, T.PLANNED_DURATION,
         T.EXTERNAL_REFERENCE,
         T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID,
         T.COST_RANK_ID, T.QUALITY_RANK_ID, T.RTF_BITS,
         T.ESTIMATED_BUDGET,
         T.MITIGATION_COST,
         T.PROBABILITY_RANK_ID,
         T.PRECISION_RANK_ID,
         T.IMPACT_RANK_ID,
         T.EXPOSURE_ID,
         T.CONSEQUENSE_COST,
         T.PROBABILITY_COST,
         T.IMPACT_LEVEL_ID,
         h_x_full_name || ';',T.ASSIGN_COUNT, T.PRIORITY_ID,
         
         T.DOC_COUNT,
         T.SCORECARD_COUNT,
         T.ESTIMATED_START,
         T.ESTIMATED_FINISH,
         T.ESTIMATED_DURATION,
         T.ESTIMATED_EFFORT,
         T.HIGH_ESTIMATED_START,
         T.HIGH_ESTIMATED_FINISH,
         T.HIGH_ESTIMATED_DURATION,
         T.HIGH_ESTIMATED_EFFORT,
         T.LOW_ESTIMATED_START,
         T.LOW_ESTIMATED_FINISH,
         T.LOW_ESTIMATED_DURATION,
         T.LOW_ESTIMATED_EFFORT,
         T.R_ESTIMATED_BUDGET,
         T.S_ESTIMATED_BUDGET,
         T.R_HIGH_ESTIMATED_BUDGET ,
         T.S_HIGH_ESTIMATED_BUDGET ,
         T.R_LOW_ESTIMATED_BUDGET ,
         T.S_LOW_ESTIMATED_BUDGET ,
         T.PRIVATE
         FROM TMT_CRI T
         WHERE RANK LIKE h_x_old_cri_rank || '%'
         AND (WBS_ID IS NuLL OR WBS_ID = ELEMENT_ID)  -- when copy from template dont copy assigned tasks
         ORDER BY T.RANK;

      CURSOR C_DEPEND_1 IS
         SELECT RANK
         FROM PMO_COPY_CRI
         WHERE LEVEL_ID = 2 AND PARENT_ID = h_new_id
         ORDER BY RANK;

      CURSOR CX3DEPENDENCY_1 IS
         SELECT PRED_ID, SUCC_ID, PRED_OBJECT_TYPE, SUCC_OBJECT_TYPE,
         DEP_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT
         FROM CRIDEPENDENCIES, PMO_COPY_CRI
         WHERE RANK LIKE h_c_dep_rank || '%'
         AND SUCC_ID = OLD_ID AND PRED_PROJECT_ID = SUCC_PROJECT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_CRI_ITEM') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_CRI_ITEM'), '-- ' || SYSTIMESTAMP, ':r := FC_C_CRI_ITEM(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_old_id || ''''
          || ', ' || '''' || h_new_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 215+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_CRI_ITEM(216) : cri.sql(9294) : ' || SYSTIMESTAMP);
   END IF; 

   --local variable
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COPY_CRI';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CRI_DEPND';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COPY_DEFAULT_ATTRIBUTE';
   PMO_DB2M.SC_STATE := 0;
   
   If ((h_table IS NULL)) OR NOT ((Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
         h_table, 0) = PMO_CNST.SC_TABLE_CRI)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 235+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(236) : cri.sql(9314) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- If target and source are the same, return error... (potential infinit loop)
   If (h_new_id IS NOT NULL) AND (PMO_ORASTD.strcmp(h_new_id, h_old_id) = PMO_CNST.SC_MATCH) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'FC_C_CRI_ITEM', 243+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: FC_C_CRI_ITEM(244) : cri.sql(9322) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.SAME_TARGET_SOURCE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 246+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(247) : cri.sql(9325) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.SAME_TARGET_SOURCE, False);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 250+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(251) : cri.sql(9329) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SAME_TARGET_SOURCE;
   End If;
   
   h_element_id := '';
   
   -- validate CRI source element
   BEGIN
      SELECT RANK, PROJECT_ID, START_DATETIME, TYPE_ID
      INTO h_x_old_cri_rank, h_x_old_project_id, h_source_date, h_source_type_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_old_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 269+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(270) : cri.sql(9348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_old_id: %s, h_x_old_cri_rank: %s, h_source_type_id: %d\n",SC_STATE,h_old_id,h_x_old_cri_rank,h_source_type_id);
   --trace_printf("h_table: %d, h_foreign_id: %s, h_new_id: %s\n",h_table,h_foreign_id,h_new_id);
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 278+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(279) : cri.sql(9357) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --  Nullify(SC_PARAM(h_x_new_parent_rank));
   If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT RANK, 'WBS#' || RTRIM(RANK), TYPE_ID, PROJECT_ID, CURRENCY_ID
         INTO h_wbs_rank, h_x_new_parent_rank, h_parent_type_id, h_x_new_project_id, h_currency_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 296+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(297) : cri.sql(9375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_x_new_project_id: %s\n",SC_STATE,h_x_new_project_id);
      
      BEGIN
         SELECT ELEMENT_ID, RANK, LEVEL_ID, MAX_RANK, CHILD_COUNT
         INTO h_root_id, h_root_rank, h_root_level_id, h_root_max_rank, h_root_child_count
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_new_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 313+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(314) : cri.sql(9392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT case when LENGTH(PARENT_RANK)>8 then SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK) - 4) else PARENT_RANK end , 
         RTRIM(PARENT_RANK), PARENT_TYPE_ID, PROJECT_ID, ELEMENT_ID, RANK, LEVEL_ID, MAX_RANK, CHILD_COUNT
         INTO h_wbs_rank, h_x_new_parent_rank, h_parent_type_id, h_x_new_project_id,
         h_root_id, h_root_rank, h_root_level_id, h_root_max_rank, h_root_child_count
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_new_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 331+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(332) : cri.sql(9410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT CURRENCY_ID INTO h_currency_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_x_new_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(347) : cri.sql(9425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- check for the existence of system folder
   h_system_folder_exists := 0;
   BEGIN
      SELECT 1 
      INTO h_system_folder_exists
      FROM DUAL WHERE EXISTS(
      SELECT STAGE_ID			
      FROM TMT_CRI
      WHERE PROJECT_ID = h_x_new_project_id 
      AND TYPE_ID = PMO_CNST.SC_FOLDER
      AND STAGE_ID = PMO_CNST.SC_PROJECT);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 369+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(370) : cri.sql(9448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("SC_STATE: %d, h_root_id: %s, h_root_rank: %s, h_root_level_id: %d\n",SC_STATE,h_root_id,h_root_rank,h_root_level_id);
   --trace_printf("h_x_new_parent_rank: %d %s, h_parent_type_id: %d\n",h_x_new_parent_rank_Ind,h_x_new_parent_rank,h_parent_type_id);
   
   BEGIN
      SELECT EFFORT_DRIVEN INTO h_effort_driven
      FROM TMT_WBS
      WHERE PROJECT_ID = h_x_new_project_id AND ELEMENT_ID = h_x_new_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 387+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(388) : cri.sql(9466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_effort_driven: %d\n", SC_STATE,h_effort_driven); //trace_flush();
   
   If Coalesce(h_effort_driven, 0) = 1 Then
      h_bitflag := 0;
      BEGIN
         SELECT COUNT('X') INTO h_bitflag FROM DUAL WHERE EXISTS (
         SELECT 'X' FROM TMT_CRI T JOIN TASK_ASSIGNMENTS TA
         ON TA.PROJECT_ID = T.PROJECT_ID
         AND T.ELEMENT_ID = TA.TASK_ID
         WHERE T.PROJECT_ID = h_x_old_project_id
         AND T.LEVEL_ID > 1
         AND T.RANK LIKE h_x_old_cri_rank || '%');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 409+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(410) : cri.sql(9488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 416+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(417) : cri.sql(9495) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_COPY_EFFORT;
      End If;
   End If;
   
   OPEN C_CCRI_DATE_1;
   
   FETCH C_CCRI_DATE_1 INTO h_x_wbs_start_dt;
   IF C_CCRI_DATE_1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE C_CCRI_DATE_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 439+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(440) : cri.sql(9518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REPLACE( RTRIM(NICK_NAME), '''', '''''' )
      INTO h_x_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 455+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(456) : cri.sql(9534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 461+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(462) : cri.sql(9540) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RESOURCE_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT SYSTIMESTAMP INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 475+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(476) : cri.sql(9554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COPY_CRI_CONSIDER_ASSIGNMENTS, COPY_CRI_ADOPT_PARTICIPANTS INTO h_bit_flag1, h_bit_flag2
      FROM PROJECT_DETAILS WHERE PROJECT_ID = h_x_new_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 489+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(490) : cri.sql(9568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d,h_bit_flag1: %s, h_bit_flag2: %s\n", SC_STATE,h_bit_flag1,h_bit_flag2);
   
   If SubStr(h_bit_flag1, 1, 1) = 'Y' Then
      h_c_participants := 16;
   Else
      h_c_participants := 7;
   End If;
   
   h_doc_count := 0;
   --copy the cri structure
   
   OPEN C_READ_SRC_1;
   
   LOOP
      FETCH C_READ_SRC_1 INTO
      h_c_element_id, h_c_rank, h_c_type_id,
      h_c_parent_id, h_c_parent_rank, h_c_level_id,
      h_c_max_rank, h_c_child_count, h_c_element_name, h_c_parent_type_id,
      h_c_planning_type, h_c_planning_unit, h_c_planned_effort,
      h_c_planned_start, h_c_planned_duration,
      h_c_external_reference,
      h_c_scope_rank_id, h_c_schedule_rank_id,
      h_c_cost_rank_id, h_c_quality_rank_id, h_c_rtf_bits,
      h_c_estimated_budget,
      h_c_mitigation_cost,
      h_c_probability_rank_id,
      h_c_precision_rank_id,
      h_c_impact_rank_id,
      h_c_exposure_id,
      h_c_consequense_cost,
      h_c_probability_cost,
      h_c_impact_level_id,
      h_c_assign_names, h_c_assign_count, h_priority_id,
      h_c_doc_count,
      h_c_scd_count,
      h_c_estimated_start,
      h_c_estimated_finish,
      h_c_estimated_duration,
      h_c_estimated_effort,
      h_c_high_start,
      h_c_high_finish,
      h_c_high_duration,
      h_c_high_effort,
      h_c_low_start,
      h_c_low_finish,
      h_c_low_duration,
      h_c_low_effort,
      h_c_r_estimated_budget,
      h_c_s_estimated_budget,
      h_c_r_high_estimated_budget,
      h_c_s_high_estimated_budget,
      h_c_r_low_estimated_budget,
      h_c_s_low_estimated_budget,
      h_private;
      IF C_READ_SRC_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      -- get new parent_id
      BEGIN
         SELECT ELEMENT_ID, RANK, LEVEL_ID + 1, MAX_RANK + 1
         INTO h_c_parent_id, h_new_rank, h_c_level_id, h_c_max_rank
         FROM PMO_COPY_CRI
         WHERE OLD_ID = h_c_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 569+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(570) : cri.sql(9648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE PMO_COPY_CRI
            SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
            WHERE ELEMENT_ID = h_c_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 589+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(590) : cri.sql(9668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_STPU.toBase64(Coalesce(h_c_max_rank, 0), h_rankBase64);
         h_new_rank := h_new_rank || h_rankBase64;
      Else
         h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
         h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
         
         h_c_level_id := Coalesce(h_root_level_id, 0) + 1;
         h_c_parent_id := h_root_id;
         PMO_STPU.toBase64(Coalesce(h_root_max_rank, 0), h_rankBase64);
         h_new_rank := h_root_rank;
         h_new_rank := h_new_rank || h_rankBase64;
      End If;
      
      --fix start date
      If PMO_ORASTD.strcmp(h_c_planned_start, h_x_wbs_start_dt) < 0 Then
         h_c_planned_start := h_x_wbs_start_dt;
      End If;
      
      h_uniqueID := SYS_GUID();
      
      If Coalesce(Length(h_element_id), 0) = 0 Then
         h_element_id := h_uniqueID;
      End If;
      
      If (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
             h_source_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 4830;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 4809;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 5365;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 5396;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 4852;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 6063;
      ElsIf (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
                h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK) Then
         h_stage_id := 5470;
      Else
         h_stage_id := 786;
         NULL;
      End If;
      
      BEGIN
         INSERT INTO PMO_COPY_CRI (
         OLD_ID, OLD_RANK, ELEMENT_ID, RANK,
         PROJECT_ID, PARENT_ID, PARENT_RANK,
         TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
         ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
         PLANNED_START, PLANNED_DURATION,
         PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
         EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
         COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
         ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
         PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
         CONSEQUENSE_COST, PROBABILITY_COST,
         IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
         ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
         HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
         LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
         R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
         R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
         R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,PRIVATE)
         VALUES (
         h_c_element_id, h_c_rank, h_uniqueID, h_new_rank,
         h_x_new_project_id, h_c_parent_id, h_x_new_parent_rank,
         h_c_type_id, h_c_level_id, 0, 0,
         h_c_element_name, h_c_assign_names, h_c_assign_count,
         h_c_planned_start, h_c_planned_duration,
         h_c_planning_type, h_c_planning_unit, h_c_planned_effort,
         h_c_external_reference, h_c_scope_rank_id, h_c_schedule_rank_id,
         h_c_cost_rank_id, h_c_quality_rank_id, h_c_rtf_bits,
         h_c_estimated_budget, h_c_mitigation_cost, h_c_probability_rank_id,
         h_c_precision_rank_id, h_c_impact_rank_id, h_c_exposure_id,
         h_c_consequense_cost, h_c_probability_cost,
         h_c_impact_level_id, h_stage_id, h_priority_id, h_c_doc_count, h_c_scd_count,
         h_c_estimated_start, h_c_estimated_finish, h_c_estimated_duration, h_c_estimated_effort,
         h_c_high_start, h_c_high_finish, h_c_high_duration, h_c_high_effort,
         h_c_low_start, h_c_low_finish, h_c_low_duration, h_c_low_effort,
         h_c_r_estimated_budget, h_c_s_estimated_budget,
         h_c_r_high_estimated_budget, h_c_s_high_estimated_budget,
         h_c_r_low_estimated_budget, h_c_s_low_estimated_budget,
         h_private);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 694+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(695) : cri.sql(9773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Insert into temporary table PMO_TMP_CRI_DEPND
      BEGIN
         INSERT INTO PMO_TMP_CRI_DEPND (OLD_ID, NEW_ID, ELEMENT_NAME)
         VALUES(h_c_element_id, h_uniqueID, h_c_element_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 713+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(714) : cri.sql(9792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_assign_string := '';
      
      If SubStr(h_bit_flag2, 1, 1) = 'Y' Then
         h_temp_sc_state := 1;
      Else
         h_temp_sc_state := 0;
      End If;
      
      PMO_DB2M.SC_STATE := FC_RESPONSIBLE(h_x_new_project_id, h_uniqueID, h_x_old_project_id
                                    , h_c_element_id, h_c_type_id, h_x_full_name, h_rec_user
                                    , h_rec_user, h_temp_sc_state, h_assign_string);
      
      BEGIN
         UPDATE PMO_COPY_CRI SET ASSIGN_NAMES = h_assign_string
         WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 743+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(744) : cri.sql(9822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_assign_string: %s\n", SC_STATE,h_assign_string);
      
      --do not copy budgets; copy attributes
      PMO_DB2M.SC_STATE := FC_A_ALL_ATTRIBUTE(h_x_new_project_id, h_x_old_project_id, h_uniqueID
                                        , h_c_element_id, h_c_type_id, h_rec_user);
      
      If Coalesce(h_c_scd_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := FC_C_SCD(h_c_type_id, h_source_id, h_c_rank, h_target_id, h_new_rank
                              , h_x_new_project_id, h_rec_user);
      End If;
      
      If Coalesce(h_c_doc_count, 0) > 0 Then
         h_doc_count := Coalesce(h_doc_count, 0) + 1;
      End If;
      
      h_temp_sc_state := FC_COPY_FAC(h_c_element_id, h_uniqueID, h_rec_user);
      
      BEGIN
         INSERT INTO CRI_RTF( PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         SELECT h_x_new_project_id, h_uniqueID, BIT_FLAG, CLOB_DATA
         FROM CRI_RTF
         WHERE PARENT_ID = h_x_old_project_id
         AND ELEMENT_ID = h_c_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 780+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(781) : cri.sql(9859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_READ_SRC_1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 794+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(795) : cri.sql(9873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --InitializeHost(SC_PARAM(h_x_new_parent_rank), h_x_new_parent_rank);
   --trace_printf("h_x_new_parent_rank: %d %s, %d\n", h_x_new_parent_rank_Ind,h_x_new_parent_rank,strlen(h_x_new_parent_rank));
   
   --PMO_VERIFY_RANK(h_x_new_parent_rank, 0);
   --BEGIN_SQL
   -- UPDATE TMT_WBS W
   -- SET W.CRI_COUNT = (SELECT COUNT(DISTINCT C.ELEMENT_ID)
   --  FROM session.PMO_COPY_CRI C, session.PMO_COPY_CRI P
   --  WHERE W.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK) - 4)
   --   AND (C.LEVEL_ID = 2
   --    OR (C.PARENT_ID = P.ELEMENT_ID AND C.PARENT_RANK <> P.PARENT_RANK)))
   -- WHERE RANK LIKE HOST(h_x_new_parent_rank) || '%';
   --END_SQL;
   
   BEGIN
      INSERT INTO TMT_CRI (
      ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK, PARENT_TYPE_ID,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      CREATED_BY, CREATED_DATETIME, PROPOSED_BY, PROPOSED_BY_NAME, PROPOSED_DATETIME, REC_USER, REC_DATETIME, REC_STATUS,
      ROLLUP_BITS,PRIVATE)
      SELECT
      ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK, h_parent_type_id,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      h_rec_user, SYSTIMESTAMP, h_rec_user, h_x_full_name, SYSTIMESTAMP, h_rec_user, SYSTIMESTAMP, 'U',
      PMO_CNST.SC_PLANNED_BIT,PRIVATE
      FROM PMO_COPY_CRI;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 867+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(868) : cri.sql(9946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO HISTORY_CRI (
      HISTORY_ID, ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      CREATED_BY, CREATED_DATETIME, PROPOSED_BY, PROPOSED_BY_NAME, PROPOSED_DATETIME, REC_USER, REC_DATETIME, REC_STATUS)
      SELECT
      SYS_GUID(), ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      h_rec_user, SYSTIMESTAMP, h_rec_user, h_x_full_name, SYSTIMESTAMP, h_rec_user, SYSTIMESTAMP, 'U'
      FROM PMO_COPY_CRI;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 924+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(925) : cri.sql(10003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI
      SET CHILD_COUNT = h_root_child_count, MAX_RANK = h_root_max_rank
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 943+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(944) : cri.sql(10022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS W
      SET W.CRI_COUNT = (
      SELECT COUNT(*)
      FROM TMT_CRI C    
      WHERE C.PARENT_RANK = 'WBS#' || LTRIM(W.RANK)
      AND ((C.LEVEL_ID = 2 + h_system_folder_exists) OR C.PARENT_ID NOT IN (
      SELECT P.ELEMENT_ID 
      FROM TMT_CRI P 
      WHERE P.PARENT_RANK = 'WBS#' || LTRIM(W.RANK)
      AND P.ELEMENT_ID = C.PARENT_ID)))
      WHERE W.RANK LIKE h_wbs_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 970+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(971) : cri.sql(10049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Copy Task Assignments
   h_temp_sc_state := FC_CRI_ASSIGNMENTS(h_x_old_project_id, h_x_old_cri_rank, h_x_new_project_id
                                      , h_currency_id, h_x_wbs_start_dt, h_source_date
                                      , h_current_datetime, h_rec_user, h_source_type_id, Coalesce(
                                      h_c_participants, 0));
   
   h_table := PMO_CNST.SC_TABLE_CRI;
   If Coalesce(h_doc_count, 0) > 0 Then
      h_temp_sc_state := FC_C_DOC(h_table, h_old_id, h_new_id, h_rec_user);
   End If;
   
   --find all root cri elements
   
   OPEN C_DEPEND_1;
   
   LOOP
      FETCH C_DEPEND_1 INTO h_c_dep_rank;
      IF C_DEPEND_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      OPEN CX3DEPENDENCY_1;
      
      LOOP
         FETCH CX3DEPENDENCY_1 INTO
         h_c_old_pred_id, h_c_old_succ_id, h_c_pred_object_type, h_c_succ_object_type,
         h_c_dep_type, h_c_lead_or_lag_type, h_c_amount, h_c_lag_display_unit;
         IF CX3DEPENDENCY_1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         BEGIN
            SELECT NEW_ID INTO h_c_pred_id
            FROM PMO_TMP_CRI_DEPND
            WHERE OLD_ID = h_c_old_pred_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 1027+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(1028) : cri.sql(10106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT NEW_ID INTO h_c_succ_id
            FROM PMO_TMP_CRI_DEPND
            WHERE OLD_ID = h_c_old_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 1042+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(1043) : cri.sql(10121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(Length(h_c_pred_id), 0) <> 0) AND (Coalesce(Length(h_c_succ_id), 0) <> 0) Then
            h_c_depend_id := SYS_GUID();
            
            BEGIN
               INSERT INTO CRIDEPENDENCIES(
               DEPEND_ID,            PRED_ID,           PRED_PROJECT_ID,
               PRED_OBJECT_TYPE,   SUCC_ID,           SUCC_PROJECT_ID,
               SUCC_OBJECT_TYPE,   DEP_TYPE,          LEAD_OR_LAG_TYPE,
               AMOUNT,             LAG_DISPLAY_UNIT,  REC_STATUS,
               REC_USER,           REC_DATETIME)
               VALUES(
               h_c_depend_id,         h_c_pred_id,            h_x_new_project_id,
               h_c_pred_object_type,  h_c_succ_id,            h_x_new_project_id,
               h_c_succ_object_type,  h_c_dep_type,           h_c_lead_or_lag_type,
               h_c_amount,            h_c_lag_display_unit,   'U',
               h_rec_user,            h_current_datetime);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 1073+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(1074) : cri.sql(10152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE CX3DEPENDENCY_1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 1087+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(1088) : cri.sql(10166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_DEPEND_1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI_ITEM', 1101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI_ITEM(1102) : cri.sql(10180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_temp_sc_state := FC_Rollup(h_x_new_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI_ITEM', 1111+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI_ITEM(1112) : cri.sql(10190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_CRI_ITEM;
ALTER FUNCTION FC_C_CRI_ITEM COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_C_CRI ==
CREATE OR REPLACE FUNCTION SP_C_CRI
(
     p_table PLS_INTEGER
   , p_target_id VARCHAR2
   , p_foreign_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table PLS_INTEGER := 0;
   h_target_id VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_c_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_C_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_C_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_C_CRI(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_foreign_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_C_CRI', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_C_CRI(40) : cri.sql(10240) : ' || SYSTIMESTAMP);
   END IF; 

   h_table := p_table;
   h_target_id := p_target_id;
   h_foreign_id := p_foreign_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   --trace_printf("h_target_id: %d %s, h_source_id: %d %s, p_bitflag: %d\n", h_target_id_Ind,h_target_id,h_source_id_Ind,h_source_id,p_bitflag);
   
   BEGIN
      SELECT LEVEL_ID, PROJECT_ID INTO h_level_id, h_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_CRI', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_CRI(61) : cri.sql(10261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_level_id: %d, h_project_id: %d %s\n", SC_STATE,h_level_id,h_project_id_Ind,h_project_id);
   
   If Coalesce(h_level_id, 0) = 1 Then
      BEGIN
         SELECT TYPE_ID, RANK INTO h_type_id, h_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_CRI', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_CRI(78) : cri.sql(10278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_type_id: %d\n", SC_STATE,h_type_id);
      
      h_stage_id := 0;
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         h_c_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_REQUIREMENT;
         h_c_type_id := PMO_CNST.SC_CRI_REQUIREMENT;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         h_c_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_ACTION_ITEM;
         h_c_type_id := PMO_CNST.SC_CRI_ACTION_ITEM;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_DEFECT;
         h_c_type_id := PMO_CNST.SC_CRI_DEFECT;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_ISSUE;
         h_c_type_id := PMO_CNST.SC_CRI_ISSUE;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := PMO_CNST.SC_CRI_RISK;
         h_c_type_id := PMO_CNST.SC_CRI_RISK;
      End If;
      
      If Coalesce(h_stage_id, 0) <> 0 Then
         BEGIN
            SELECT ELEMENT_ID
            INTO h_temp_id
            FROM TMT_CRI
            WHERE PROJECT_ID = h_project_id
            
            AND TYPE_ID = PMO_CNST.SC_FOLDER
            AND STAGE_ID = PMO_CNST.SC_PROJECT;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_CRI', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_CRI(130) : cri.sql(10330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_target_id := h_temp_id;
         End If;
      End If;
   End If;
   --trace_printf("h_target_id: %d %s\n", h_target_id_Ind,h_target_id);
   
   PMO_DB2M.SC_STATE := FC_C_CRI_ITEM(h_table, h_source_id, h_target_id, h_foreign_id, h_element_id
                                   , h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_C_CRI', 145+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_C_CRI(146) : cri.sql(10346) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_CRI', 152+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_CRI(153) : cri.sql(10353) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_CRI', 164+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_CRI(165) : cri.sql(10365) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_C_CRI;
ALTER FUNCTION SP_C_CRI COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_ACROSS_M_CRI ==
CREATE OR REPLACE FUNCTION FC_ACROSS_M_CRI
(
     h_cri_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_project_id VARCHAR2(32);
   h_b_element_id VARCHAR2(32);
   h_b_chargecode_id VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_host_table PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_transfered_count PLS_INTEGER := 0;
   withDependencies PLS_INTEGER NOT NULL := 2;
   hasTranfer PLS_INTEGER NOT NULL := 4;
-- Declare Cursors
      CURSOR CCRIBUD IS
         SELECT ELEMENT_ID, CHARGECODE_ID
         FROM BUDGETS
         WHERE PROJECT_ID = h_source_project_id
         AND ELEMENT_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ACROSS_M_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ACROSS_M_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_ACROSS_M_CRI(' || 
       '''' || h_cri_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_target_project_id || ''''
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_error_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ACROSS_M_CRI', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ACROSS_M_CRI(44) : cri.sql(10425) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PROJECT_ID, RANK, SUBSTR(PARENT_RANK, 5, (LENGTH(PARENT_RANK) - 4)), ASSET_FLAG
      INTO h_source_project_id, h_source_rank, h_source_parent_rank, h_asset_flag
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(58) : cri.sql(10439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(ELEMENT_ID) INTO h_transfered_count
      FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%'
      AND WBS_ID IS NOT Null;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(74) : cri.sql(10455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_transfered_count, 0) > 0 Then
      h_error_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ACROSS_M_CRI', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_ACROSS_M_CRI(82) : cri.sql(10463) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   -- Can't move to another project if there is any assigned asset/client.
   BEGIN
      SELECT COUNT(ELEMENT_ID) INTO h_transfered_count
      FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%'
      AND ASSET_FLAG = PMO_CNST.SC_HAS_ASSET;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(99) : cri.sql(10480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_transfered_count, 0) > 0 Then
      h_error_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ACROSS_M_CRI', 106+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_ACROSS_M_CRI(107) : cri.sql(10488) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_CRI_WITH_ASSET;
   ElsIf Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CRI
         SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(138) : cri.sql(10519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TARGET_SOURCE';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TARGET_SOURCE
      (TARGET_START_FINSH_DATE, TARGET_MINUTES_PER_DAY, TARGET_PRIORITY, TARGET_PROJECT_ID)
      SELECT START_DT, MINUTE_PER_DAY, PRIORITY, ELEMENT_ID
      FROM TMT_WBS WHERE ELEMENT_ID = h_target_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(163) : cri.sql(10544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_TARGET_SOURCE
      SET (SOURCE_PROJECT_ID, SOURCE_RANK, SOURCE_START_FINSH_DATE) =
      (SELECT h_source_project_id, h_source_rank, START_DT
      FROM TMT_WBS WHERE ELEMENT_ID = h_source_project_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 182+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(183) : cri.sql(10564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_GET_CRI_ASSIGNMENTS(h_source_project_id, h_source_rank, h_rec_user);
   
   -- move resource assignmemnts to the new project
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET PROJECT_ID = h_target_project_id
      WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(219) : cri.sql(10600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CCRIBUD;
   
   LOOP
      FETCH CCRIBUD INTO h_b_element_id, h_b_chargecode_id;
      IF CCRIBUD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_ASSIGN_CHARGECODE(h_target_project_id, h_b_chargecode_id, h_rec_user);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE BUDGETS SET
            PROJECT_ID = h_target_project_id
            WHERE PROJECT_ID = h_source_project_id
            AND ELEMENT_ID = h_b_element_id
            AND CHARGECODE_ID = h_b_chargecode_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 255+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(256) : cri.sql(10637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CCRIBUD ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 270+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(271) : cri.sql(10652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update project break down to the new project
   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN SET
      PROJECT_ID = h_target_project_id,
      PROCESS_FLAG =  CASE
      WHEN PROCESS_FLAG = 'U' THEN 'I'
      ELSE 'T'
      END
      WHERE PROJECT_ID = h_source_project_id
      AND ELEMENT_ID IN (
      SELECT ELEMENT_ID
      FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%' );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 298+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(299) : cri.sql(10680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update project_id (parent_id column) in cri_rtf
   BEGIN
      UPDATE CRI_RTF
      SET PARENT_ID = h_target_project_id
      WHERE PARENT_ID = h_source_project_id
      AND ELEMENT_ID IN (
      SELECT ELEMENT_ID
      FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%' );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 322+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(323) : cri.sql(10704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update cri_count of the new wbs parent
   BEGIN
      UPDATE TMT_WBS
      SET CRI_COUNT = CRI_COUNT + 1
      WHERE RANK = h_target_parent_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 342+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(343) : cri.sql(10724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update cri_count in old project
   BEGIN
      UPDATE TMT_WBS
      SET CRI_COUNT = CRI_COUNT - (SELECT COUNT(C.PARENT_RANK)
      FROM TMT_CRI C, TMT_CRI P
      WHERE C.RANK LIKE h_source_rank || '%' AND C.PARENT_ID = P.ELEMENT_ID
      AND (C.LEVEL_ID = 2 OR C.PARENT_RANK <> P.PARENT_RANK))
      WHERE RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
      FROM TMT_CRI WHERE RANK LIKE h_source_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 366+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(367) : cri.sql(10748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update project_id and parent_rank
   BEGIN
      UPDATE TMT_CRI
      SET PROJECT_ID = h_target_project_id,
      PARENT_RANK =  'WBS#' || h_target_parent_rank,
      DUPLICATE_KEY = NULL
      WHERE RANK LIKE h_source_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ACROSS_M_CRI', 388+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ACROSS_M_CRI(389) : cri.sql(10770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bitflag := 0;
   h_error_id := h_source_id;
   h_host_table := withDependencies + hasTranfer;
   PMO_DB2M.SC_STATE := FC_M_ATTACH_CRI(h_host_table, h_cri_target_id, h_source_id, h_bitflag
                                     , h_rec_user, h_error_id, h_source_project_id);
   
   PMO_DB2M.SC_STATE := FC_M_ASSIGNMENTS(h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ACROSS_M_CRI', 402+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ACROSS_M_CRI(403) : cri.sql(10784) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ACROSS_M_CRI', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ACROSS_M_CRI(407) : cri.sql(10788) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ACROSS_M_CRI;
ALTER FUNCTION FC_ACROSS_M_CRI COMPILE DEBUG;

/*****************************************************************************************
SP_T_CRI
	target_id: wbs element_id
	source_id: cri element_id
	bitflag:
		first bit (insert option):
			0 --> insert as last child
			1 --> insert as previous sibling
		second bit (cross project option):
			0 --> same project
			1 --> different project
		third bit (transfer option):
			0 --> cross project move without transfer
			1 --> cross project move with transfer
*****************************************************************************************/

Prompt == FUNCTION SP_T_CRI ==
CREATE OR REPLACE FUNCTION SP_T_CRI
(
     p_target_id VARCHAR2
   , p_source_id_list VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target_id VARCHAR2(32);
   h_cri_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_remain_id_list VARCHAR2(2047);
   h_target_project_id VARCHAR2(32);
   h_source_project_id VARCHAR2(32);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_flag PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_source_old_type_id PLS_INTEGER := 0;
   h_source_new_type_id PLS_INTEGER := 0;
   h_checkout_cnt PLS_INTEGER := 0;
   h_marked_as_checkedout PLS_INTEGER := 0;
   h_marked_as_checkedout_id VARCHAR2(32);
   h_asset_flag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_sys_folder_stage_id PLS_INTEGER := 0;
   h_target_wbs_type_id PLS_INTEGER := 0;
   h_wbs_type_id PLS_INTEGER := 0;
   errorCode PLS_INTEGER NOT NULL := 0;
   h_element_name VARCHAR2(255);
   h_temp_id VARCHAR2(32);
   h_closed_count PLS_INTEGER := 0;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_T_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_T_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_T_CRI(' || 
       '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id_list || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_T_CRI', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_T_CRI(52) : cri.sql(10864) : ' || SYSTIMESTAMP);
   END IF; 

   -- id and parent_id are both required
   If (p_source_id_list IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_T_CRI', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_T_CRI(58) : cri.sql(10870) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_T_CRI', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_T_CRI(61) : cri.sql(10873) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variable
   
   h_target_id := p_target_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   h_remain_id_list := p_source_id_list;
   
   If (Coalesce(h_bitflag, 0) > 0) AND ((h_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_T_CRI', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_T_CRI(75) : cri.sql(10887) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_T_CRI', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_T_CRI(78) : cri.sql(10890) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If Coalesce(h_bitflag, 0) > 1 Then
      BEGIN
         SELECT PROJECT_ID, RANK, TYPE_ID
         INTO h_target_project_id, h_target_parent_rank, h_target_wbs_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(95) : cri.sql(10907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID
         INTO h_cri_target_id
         FROM TMT_CRI
         WHERE PROJECT_ID = h_target_project_id
         AND LEVEL_ID = 1
         AND SUBSTR(PARENT_RANK, 1, 4) = 'WBS#';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(113) : cri.sql(10925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_len := Coalesce(Length(h_remain_id_list), 0);
   h_len := Coalesce(h_len, 0);
   PMO_DB2M.SC_STATE := 0;
   h_marked_as_checkedout := 0;
   h_marked_as_checkedout_id := '';
   
   h_source_project_id := NULL;
   
   WHILE (Coalesce(h_len, 0) >= 32) AND (PMO_DB2M.SC_STATE >= 0) LOOP
      h_source_id := SubStr(h_remain_id_list, 1, 32);
      
      BEGIN
         SELECT PROJECT_ID, RTRIM(RANK), TYPE_ID, ASSET_FLAG, PARENT_RANK, STAGE_ID
         INTO h_source_project_id, h_source_rank, h_source_old_type_id,
         h_asset_flag, h_source_parent_rank, h_stage_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(142) : cri.sql(10954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT CASE when h_len> 32 then SUBSTR(h_remain_id_list, 33, h_len-32)
         ELSE '' END
         INTO h_remain_id_list FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 156+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(157) : cri.sql(10969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_len := Coalesce(Length(h_remain_id_list), 0);
      h_len := Coalesce(h_len, 0);
      h_error_id := h_source_id;
      
      If (Coalesce(h_source_old_type_id, 0) = PMO_CNST.SC_FOLDER) AND (IsCRISystemFolder(Coalesce(
             h_source_old_type_id, 0), Coalesce(h_stage_id, 0)) = 1) Then
         h_error_id := h_source_id;
         errorCode := PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
         GOTO Continue0000;
      End If;
      
      h_checkout_cnt := 0;
      -- check if item is checked out or has any checked out subitems
      h_closed_count := 0;
      --      BEGIN_SQL
      --          SELECT COUNT(*)
      --          INTO HOST(h_checkout_cnt)
      --          FROM TMT_CRI
      --          WHERE RANK LIKE HOST(h_source_rank) || '%'
      --          AND REC_STATUS = 'O';
      --      END_SQL;
      
      BEGIN
         SELECT SUM(CASE WHEN REC_STATUS = 'O' THEN 1 ELSE 0 END),
         SUM(CASE WHEN STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) OR CLOSED_DATETIME IS NOT Null THEN 1 ELSE 0 END)
         into h_checkout_cnt, h_closed_count
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 195+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(196) : cri.sql(11008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_checkout_cnt, 0) > 0 Then
         If Coalesce(h_marked_as_checkedout, 0) = 0 Then
            h_marked_as_checkedout := 1;
            h_marked_as_checkedout_id := h_source_id;
         End If;
         PMO_DB2M.SC_STATE := 0;
         GOTO Continue0000;
      End If;
      
      If Coalesce(h_closed_count, 0) > 0 Then
         h_error_id := h_source_id;
         errorCode := PMO_CNST.CANNOT_TRANSFER_CRI_CLOSED_ITE;
         GOTO Continue0000;
      End If;
      
      BEGIN
         SELECT COUNT(ELEMENT_ID)
         INTO h_count
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%' AND WBS_ID IS NOT NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(227) : cri.sql(11039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_error_id := h_source_id;
         errorCode := PMO_CNST.CRI_CHILD_ALREADY_TRANSFERED;
         GOTO Continue0000;
      End If;
      
      If (h_target_id IS NULL) Then
         BEGIN
            SELECT ELEMENT_ID INTO h_target_id
            FROM TMT_WBS
            WHERE RANK = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 248+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(249) : cri.sql(11061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_error_id := h_source_id;
            errorCode := PMO_CNST.INVALID_PARAMS;
            GOTO Continue0000;
         End If;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
      If Coalesce(h_bitflag, 0) > 1 Then
         --trace_printf("\n before FC_ACROSS_M_CRI ");
         --InitializeHost(SC_PARAM(h_sys_folder_stage_id), 0);
         
         If isPureCRIDeliv(Coalesce(h_source_old_type_id, 0)) <> 0 OR isCRIConvertTask(Coalesce(
               h_source_old_type_id, 0)) <> 0 Then
            --InitializeHost(SC_PARAM(h_sys_folder_stage_id), h_source_old_type_id);
            BEGIN
               SELECT ELEMENT_ID
               INTO h_cri_target_id
               FROM TMT_CRI
               WHERE PROJECT_ID = h_target_project_id
               AND TYPE_ID = PMO_CNST.SC_FOLDER
               AND STAGE_ID = PMO_CNST.SC_PROJECT;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 281+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(282) : cri.sql(11094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_source_old_type_id, 0) = PMO_CNST.SC_FOLDER Then
            -- select cri project system folder name
            BEGIN
               SELECT TYPE_ID
               INTO h_wbs_type_id
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_target_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 298+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(299) : cri.sql(11111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If NOT isProjectType(Coalesce(h_target_wbs_type_id, 0)) <> 0 Then
               BEGIN
                  SELECT ELEMENT_ID
                  INTO h_cri_target_id
                  FROM TMT_CRI
                  WHERE PROJECT_ID = h_target_project_id
                  AND TYPE_ID = PMO_CNST.SC_FOLDER
                  AND STAGE_ID = PMO_CNST.SC_PROJECT;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 317+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(318) : cri.sql(11130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         --          if ((h_sys_folder_stage_id != 0)  (h_source_old_type_id != SC_FOLDER))
         --          {
         --              BEGIN_SQL
         --                  SELECT ELEMENT_ID
         --                  INTO HOST(h_temp_id)
         --                  FROM TMT_CRI
         --                  WHERE PROJECT_ID = HOST(h_target_project_id)
         --                      AND LEVEL_ID = 3
         --                      AND TYPE_ID = SC_FOLDER
         --                      AND STAGE_ID = HOST(h_sys_folder_stage_id);
         --              END_SQL;
         --
         --              if (SC_SUCCESS)
         --              {
         --                  InitializeHost(SC_PARAM(h_cri_target_id), SC_PARAM(h_temp_id));
         --              }
         --          }
         --
         
         PMO_DB2M.SC_STATE := FC_ACROSS_M_CRI(h_cri_target_id, h_source_id, h_target_project_id
                                     , h_target_parent_rank, h_error_id, h_rec_user);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_source_project_id);
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND ((Coalesce(h_bitflag, 0) > 3) OR (Coalesce(
            h_bitflag, 0) < 2)) Then
         h_flag := BITAND(Coalesce(h_bitflag, 0), 1);
         --trace_printf("\n before FC_T_CRI_WBS ");
         PMO_DB2M.SC_STATE := FC_T_CRI_WBS(h_target_id, h_source_id, h_error_id, h_flag, h_rec_user);
      End If;
      <<Continue0000>>
      NULL;
   END LOOP;
   
   If (h_source_project_id IS NOT NULL) Then
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_REMOVE_UNASSIGNED_RESOURCES(h_source_project_id);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   End If;
   
   If Coalesce(h_marked_as_checkedout, 0) = 1 Then
      h_error_id := h_marked_as_checkedout_id;
      PMO_DB2M.SC_STATE := PMO_CNST.MARKED_AS_CHECKOUT;
   ElsIf errorCode <> 0 Then
      PMO_DB2M.SC_STATE := errorCode;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_T_CRI', 375+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_T_CRI(376) : cri.sql(11188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 383+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(384) : cri.sql(11196) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_CRI', 395+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_CRI(396) : cri.sql(11208) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_T_CRI;
ALTER FUNCTION SP_T_CRI COMPILE DEBUG;

/************************************************************************************************
  Parameter:
	id:         the id of the wbs element
	parent_id:  the id of the requirement
	res_user:   the id of the user who create the current element
*************************************************************************************************/

Prompt == FUNCTION SP_A_WBS_TO_CRI ==
CREATE OR REPLACE FUNCTION SP_A_WBS_TO_CRI
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_WBS_TO_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_WBS_TO_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_A_WBS_TO_CRI(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TO_CRI', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_WBS_TO_CRI(25) : cri.sql(11254) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_WBS_TO_CRI', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_WBS_TO_CRI(30) : cri.sql(11259) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TO_CRI', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_WBS_TO_CRI(33) : cri.sql(11262) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   --VALIDATE_RECORD(TMT_CRI, h_parent_id, h_rec_status);
   BEGIN
      SELECT REC_STATUS, TYPE_ID
      INTO h_rec_status, h_type_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TO_CRI', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TO_CRI(56) : cri.sql(11285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_WBS_TO_CRI', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_WBS_TO_CRI(63) : cri.sql(11292) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TO_CRI', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_WBS_TO_CRI(66) : cri.sql(11295) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True);
   End If;
   
   If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_WBS_TO_CRI', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_WBS_TO_CRI(79) : cri.sql(11308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_CHILDREN), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TO_CRI', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_WBS_TO_CRI(82) : cri.sql(11311) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_CHILDREN, h_parent_id
            , True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_WBS_TO_CRI', 89+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_WBS_TO_CRI(90) : cri.sql(11319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TO_CRI', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_WBS_TO_CRI(93) : cri.sql(11322) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_parent_id
            , True);
   End If;
   
   PMO_DB2M.SC_STATE := FC_A_WBS_TO_CRI(h_id, h_parent_id, h_rec_user, h_uniqueID);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_WBS_TO_CRI', 101+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_WBS_TO_CRI(102) : cri.sql(11331) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TO_CRI', 108+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TO_CRI(109) : cri.sql(11338) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TO_CRI', 120+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TO_CRI(121) : cri.sql(11350) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_WBS_TO_CRI;
ALTER FUNCTION SP_A_WBS_TO_CRI COMPILE DEBUG;

/******************************************************************************************
	Create a cri element under the parent_id node in tmt_cri after creating a wbs element
	the transfer_flag of its parent is not null.
*******************************************************************************************/

Prompt == FUNCTION FC_INSERT_CRI_AFTER_WBS ==
CREATE OR REPLACE FUNCTION FC_INSERT_CRI_AFTER_WBS
(
     h_parent_id IN OUT NOCOPY VARCHAR2
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_flag PLS_INTEGER := sh_h_flag;
   h_element_name VARCHAR2(255);
   h_type_id PLS_INTEGER := 0;
   h_full_name VARCHAR2(255);
   h_full_name1 VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cri_number VARCHAR2(100);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_start TIMESTAMP;
   h_finish TIMESTAMP;
   h_temp_sc_state PLS_INTEGER := 0;
   h_old_wbs_id VARCHAR2(32);
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_CRI_AFTER_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_CRI_AFTER_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_CRI_AFTER_WBS(' || 
       '''' || h_parent_id || ''''
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI_AFTER_WBS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_CRI_AFTER_WBS(38) : cri.sql(11407) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   -- h_flag = 0 then wbs_id is in tmt_wbs
   -- otherwise wbs_id is in temorary table and is not added to wbs yet
   If Coalesce(h_flag, 0) = 0 Then
      BEGIN
         SELECT ELEMENT_NAME, TYPE_ID, REC_USER, PLANNED_START, PLANNED_FINISH
         INTO h_element_name, h_type_id, h_rec_user, h_start, h_finish
         FROM  TMT_WBS
         WHERE ELEMENT_ID = h_wbs_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(57) : cri.sql(11426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT ELEMENT_NAME, TYPE_ID, PLANNED_START, OLD_WBS_ID
         INTO h_element_name, h_type_id, h_start, h_old_wbs_id
         FROM  PMO_COPY_WBS
         WHERE ELEMENT_ID = h_wbs_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 72+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(73) : cri.sql(11442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      h_finish := h_start;
   End If;
   
   BEGIN
      SELECT CASE WHEN FULL_NAME IS NuLL THEN FULL_NAME ELSE FULL_NAME || ';' END, REPLACE( RTRIM(FULL_NAME), '''', '''''' )
      INTO h_full_name, h_full_name1
      FROM RESOURCES WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(90) : cri.sql(11459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK, PARENT_RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, ASSET_FLAG, FINANCIAL_CATEGORY
      INTO h_rank, h_parent_rank, h_project_id, h_level_id,
      h_parent_type_id, h_asset_flag, h_financial_category
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(107) : cri.sql(11476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI_AFTER_WBS', 113+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI_AFTER_WBS(114) : cri.sql(11483) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_HAS_ASSET Then
      h_asset_flag := PMO_CNST.SC_PARENT_HAS_ASSET;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   --  sprintf(h_cri_number, "%s.%d", h_cri_number, h_max_rank);
   
   BEGIN
      INSERT INTO TMT_CRI(RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, PARENT_TYPE_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, WBS_ID,
      CREATED_DATETIME, MINOR_REVISION, IMPACT_LEVEL_ID, STAGE_ID, PRECISION_RANK_ID,
      ASSET_FLAG, FINANCIAL_CATEGORY,
      REC_USER, ASSIGN_NAMES, PROPOSED_BY, PROPOSED_DATETIME)
      VALUES(RTRIM(h_rank) || h_rankBase64, h_parent_rank,
      CASE WHEN h_type_id = PMO_CNST.SC_DELIVERABLE THEN PMO_CNST.SC_CRI_DELIVERABLE
      WHEN h_type_id = PMO_CNST.SC_WORK_PRODUCT THEN PMO_CNST.SC_CRI_WORK_PRODUCT
      WHEN h_type_id = PMO_CNST.SC_MILESTONE THEN PMO_CNST.SC_CRI_MILESTONE
      WHEN h_type_id = PMO_CNST.SC_SUMMARY_TASK THEN PMO_CNST.SC_CRI_SUMMARY_TASK
      WHEN h_type_id = PMO_CNST.SC_TASK THEN PMO_CNST.SC_CRI_TASK END,
      h_level_id, h_project_id,
      h_parent_id, h_parent_type_id, h_wbs_id, h_element_name, h_rec_user, h_wbs_id,
      SYSTIMESTAMP, 1, 0, 786, 0, h_asset_flag, h_financial_category, h_rec_user,
      h_full_name,
      h_full_name1, SYSTIMESTAMP);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(154) : cri.sql(11523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_flag, 0) = 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET (ASSIGN_COUNT, REC_STATUS, ACTUAL_BUDGET,
         R_ACTUAL_BUDGET, S_ACTUAL_BUDGET, CURRENT_BUDGET, R_CURRENT_BUDGET,
         S_CURRENT_BUDGET, FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL, REC_FLAGS,
         SD, FD, START_DATETIME, DURATION, FINISH_DATETIME, CONSTRAINT_DT, CONSTRAINT_TYPE,
         ACTUAL_START, ACTUAL_DURATION, ACTUAL_FINISH,
         SCHED_START, SCHED_DURATION, SCHED_FINISH,
         PLANNED_START, PLANNED_DURATION, PLANNED_FINISH,
         FORECAST_START, FORECAST_DURATION, FORECAST_FINISH,
         PROPOSED_START, PROPOSED_DURATION, PROPOSED_FINISH,
         UNRESOLVED_START, UNRESOLVED_DURATION, UNRESOLVED_FINISH,
         BASELINE1_START, BASELINE1_DURATION, BASELINE1_FINISH,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ETC, WORK_TODATE, BASELINE_WORK_TODATE,
         SCHED_EFFORT, PLANNED_EFFORT, FORECAST_EFFORT, PROPOSED_EFFORT,
         MILESTONE_PERCENT) =
         (SELECT ASSIGN_COUNT, REC_STATUS, ACTUAL_BUDGET,
         R_ACTUAL_BUDGET, S_ACTUAL_BUDGET, CURRENT_BUDGET, R_CURRENT_BUDGET,
         S_CURRENT_BUDGET, FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL, REC_FLAGS,
         SD, FD, START_DT, DURATION, FINISH_DT, CONSTRAINT_DT, CONSTRAINT_TYPE,
         ACTUAL_START, ACTUAL_DURATION, ACTUAL_FINISH,
         SCHED_START, SCHED_DURATION, SCHED_FINISH,
         PLANNED_START, PLANNED_DURATION, PLANNED_FINISH,
         FORECAST_START, FORECAST_DURATION, FORECAST_FINISH,
         PROPOSED_START, PROPOSED_DURATION, PROPOSED_FINISH,
         UNRESOLVED_START, UNRESOLVED_DURATION, UNRESOLVED_FINISH,
         BASELINE1_START, BASELINE1_DURATION, BASELINE1_FINISH,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ETC, WORK_TODATE, BASELINE_WORK_TODATE,
         SCHED_EFFORT, PLANNED_EFFORT, FORECAST_EFFORT, PROPOSED_EFFORT,
         MILESTONE_PERCENT
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_wbs_id)
         WHERE PROJECT_ID = h_project_id AND WBS_ID = h_wbs_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(209) : cri.sql(11578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET (ASSIGN_COUNT, REC_STATUS, ACTUAL_BUDGET,
         R_ACTUAL_BUDGET, S_ACTUAL_BUDGET, CURRENT_BUDGET, R_CURRENT_BUDGET,
         S_CURRENT_BUDGET, FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL, REC_FLAGS,
         SD, FD, START_DATETIME, DURATION, FINISH_DATETIME, CONSTRAINT_DT, CONSTRAINT_TYPE,
         ACTUAL_START, ACTUAL_DURATION, ACTUAL_FINISH,
         SCHED_START, SCHED_DURATION, SCHED_FINISH,
         PLANNED_START, PLANNED_DURATION, PLANNED_FINISH,
         FORECAST_START, FORECAST_DURATION, FORECAST_FINISH,
         PROPOSED_START, PROPOSED_DURATION, PROPOSED_FINISH,
         UNRESOLVED_START, UNRESOLVED_DURATION, UNRESOLVED_FINISH,
         BASELINE1_START, BASELINE1_DURATION, BASELINE1_FINISH,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ETC, WORK_TODATE, BASELINE_WORK_TODATE,
         SCHED_EFFORT, PLANNED_EFFORT, FORECAST_EFFORT, PROPOSED_EFFORT,
         MILESTONE_PERCENT) =
         (SELECT ASSIGN_COUNT, REC_STATUS, ACTUAL_BUDGET,
         R_ACTUAL_BUDGET, S_ACTUAL_BUDGET, CURRENT_BUDGET, R_CURRENT_BUDGET,
         S_CURRENT_BUDGET, FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL, REC_FLAGS,
         SD, FD, START_DT, DURATION, FINISH_DT, CONSTRAINT_DT, CONSTRAINT_TYPE,
         ACTUAL_START, ACTUAL_DURATION, ACTUAL_FINISH,
         SCHED_START, SCHED_DURATION, SCHED_FINISH,
         PLANNED_START, PLANNED_DURATION, PLANNED_FINISH,
         FORECAST_START, FORECAST_DURATION, FORECAST_FINISH,
         PROPOSED_START, PROPOSED_DURATION, PROPOSED_FINISH,
         UNRESOLVED_START, UNRESOLVED_DURATION, UNRESOLVED_FINISH,
         BASELINE1_START, BASELINE1_DURATION, BASELINE1_FINISH,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ETC, WORK_TODATE, BASELINE_WORK_TODATE,
         SCHED_EFFORT, PLANNED_EFFORT, FORECAST_EFFORT, PROPOSED_EFFORT,
         MILESTONE_PERCENT
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_old_wbs_id)
         WHERE PROJECT_ID = h_project_id AND WBS_ID = h_wbs_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI_AFTER_WBS', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI_AFTER_WBS(263) : cri.sql(11632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI_AFTER_WBS', 270+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI_AFTER_WBS(271) : cri.sql(11640) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_CRI_AFTER_WBS;
ALTER FUNCTION FC_INSERT_CRI_AFTER_WBS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_TRANSFERRED_CRI ==
CREATE OR REPLACE FUNCTION FC_UPDATE_TRANSFERRED_CRI
(
     id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_rollup_bits PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CUP_TRN_CRI001 IS
         SELECT * FROM (SELECT RES_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%')
         ) WHERE ROWNUM<=1;

      CURSOR C_BUG1 IS
         SELECT ELEMENT_ID, TYPE_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_TRANSFERRED_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_TRANSFERRED_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_TRANSFERRED_CRI(' || 
       '''' || id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_TRANSFERRED_CRI', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_TRANSFERRED_CRI(32) : cri.sql(11682) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := id;
   
   BEGIN
      SELECT RTRIM(RANK),PROJECT_ID INTO h_rank,h_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_TRANSFERRED_CRI', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_TRANSFERRED_CRI(49) : cri.sql(11699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CUP_TRN_CRI001;
   
   FETCH CUP_TRN_CRI001 INTO h_resource_id;
   IF CUP_TRN_CRI001%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_rollup_bits := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_rollup_bits := PMO_CNST.SC_SET_ALL_NON_ACTUAL_ASS_BITS;
   End If;
   BEGIN
      CLOSE CUP_TRN_CRI001;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_TRANSFERRED_CRI', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_TRANSFERRED_CRI(76) : cri.sql(11726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CRI
      SET ROLLUP_BITS = h_rollup_bits,
      WBS_ID = Null,
      STAGE_ID = CASE WHEN TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 786
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 4830
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 4809
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 4852
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 5365
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 5396
      WHEN TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 6063
      ELSE STAGE_ID END,
      LAST_TRANSFER_DT = Null
      WHERE RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_TRANSFERRED_CRI', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_TRANSFERRED_CRI(118) : cri.sql(11768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --update budgets
   
   OPEN C_BUG1;
   
   LOOP
      FETCH C_BUG1 INTO h_element_id, h_type_id;
      IF C_BUG1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE BUDGETS SET TYPE_ID = h_type_id
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_TRANSFERRED_CRI', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_TRANSFERRED_CRI(151) : cri.sql(11801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_BUG1  ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_TRANSFERRED_CRI', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_TRANSFERRED_CRI(164) : cri.sql(11814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_TRANSFERRED_CRI', 171+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_TRANSFERRED_CRI(172) : cri.sql(11822) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_TRANSFERRED_CRI;
ALTER FUNCTION FC_UPDATE_TRANSFERRED_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_MOVE_CRI_APPEND ==
CREATE OR REPLACE FUNCTION FC_MOVE_CRI_APPEND
(
     h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_source_level PLS_INTEGER := 0;
   h_target_level PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_CRI_APPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_CRI_APPEND'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_CRI_APPEND(' || 
       '''' || h_source_id || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_CRI_APPEND', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_CRI_APPEND(30) : cri.sql(11862) : ' || SYSTIMESTAMP);
   END IF; 

   PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI', h_target_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID, PARENT_ID, LEVEL_ID, PROJECT_ID
      INTO h_source_rank, h_len, h_source_type_id, h_source_parent_id, h_source_level, h_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(47) : cri.sql(11879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK, TYPE_ID, PARENT_ID, LEVEL_ID
      INTO h_target_rank, h_target_type_id, h_target_parent_id, h_target_level
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(63) : cri.sql(11895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- REMOVE EXTERNAL DEPENDENCIES
   BEGIN
      DELETE FROM CRIDEPENDENCIES
      WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%')
      AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%'))
      OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%')
      AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
      WHERE RANK LIKE h_source_rank || '%'));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(102) : cri.sql(11934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   BEGIN
      UPDATE TMT_CRI
      SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP,
      REC_STATUS = 'U',
      PARENT_TYPE_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_type_id
      ELSE PARENT_TYPE_ID END,
      PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
      ELSE PARENT_ID END,
      RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
      ELSE SUBSTR(RANK,h_len +1,LENGTH(RANK)-h_len) END
      WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(131) : cri.sql(11963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_source_type_id, 0) = PMO_CNST.SC_DOCUMENT Then
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET PARENT_ID = h_target_id,
         PARENT_TYPE_ID = h_target_type_id
         WHERE ELEMENT_ID = h_source_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(152) : cri.sql(11984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET CHILD_COUNT = CHILD_COUNT - 1
      WHERE ELEMENT_ID = h_source_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_CRI_APPEND', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_CRI_APPEND(172) : cri.sql(12004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_Rollup(h_project_id);
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_CRI_APPEND', 180+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_CRI_APPEND(181) : cri.sql(12013) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_CRI_APPEND;
ALTER FUNCTION FC_MOVE_CRI_APPEND COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_PROP ==
CREATE OR REPLACE FUNCTION SP_U_CRI_PROP
(
     p_id VARCHAR2
   , p_reassign_count PLS_INTEGER
   , p_duplicate_ref_id VARCHAR2
   , p_occured_datetime TIMESTAMP
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_PROP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_PROP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_PROP(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_reassign_count), 'NULL')
          || ', ' || '''' || p_duplicate_ref_id || ''''
          || ', ' || COALESCE(NULLIF('''' || p_occured_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PROP', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_PROP(24) : cri.sql(12047) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_CRI SET
      REASSIGN_COUNT   = p_reassign_count,
      OCCURED_DATETIME = p_occured_datetime,
      REC_USER         = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PROP', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PROP(43) : cri.sql(12066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_PROP', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_PROP(49) : cri.sql(12072) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PROP', 56+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PROP(57) : cri.sql(12080) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PROP', 68+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PROP(69) : cri.sql(12092) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_PROP;
ALTER FUNCTION SP_U_CRI_PROP COMPILE DEBUG;

/******************************************************************/

Prompt == FUNCTION SP_I_CRI ==
CREATE OR REPLACE FUNCTION SP_I_CRI
(
     p_table PLS_INTEGER
   , p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_foreign_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_element_name VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_wbs_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_element_name VARCHAR2(255);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CRI(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CRI', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CRI(44) : cri.sql(12152) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_CRI', 48+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_CRI(49) : cri.sql(12157) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CRI', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_CRI(52) : cri.sql(12160) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_c_element_name := p_name;
   h_parent_id := p_parent_id;
   h_foreign_id := p_foreign_id;
   h_rec_user := p_rec_user;
   h_foreign_table := p_table;
   h_type_id := p_type_id;
   
   h_project_id := NULL;
   h_host_table := PMO_CNST.SC_TABLE_CRI;
   
   If (Coalesce(h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) AND (Coalesce(
             h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER2) Then
      BEGIN
         SELECT ASSET_FLAG, FINANCIAL_CATEGORY, PROJECT_ID
         INTO h_asset_flag, h_financial_category, h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(80) : cri.sql(12188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      If (isPureCRIDeliv(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(
            h_type_id, 0) = PMO_CNST.SC_FOLDER) Then
         BEGIN
            SELECT ELEMENT_ID
            INTO h_parent_id
            FROM TMT_CRI
            WHERE PROJECT_ID = h_project_id
            AND TYPE_ID = PMO_CNST.SC_FOLDER
            AND STAGE_ID = PMO_CNST.SC_PROJECT;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(102) : cri.sql(12210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   h_temp_sc_state := 0;
   h_source_id := NULL;
   BEGIN
      SELECT ELEMENT_ID INTO h_source_id
      FROM PMO_DEFAULTS
      WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(121) : cri.sql(12229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_type_id: %d, h_project_id: %d %s, h_source_id: %d %s\n",SC_STATE,h_type_id,h_project_id_Ind,h_project_id,h_source_id_Ind,h_source_id); //trace_flush();
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMO_DB2M.SC_STATE := FC_C_CRI_ITEM(h_foreign_table, h_source_id, h_parent_id, h_foreign_id
                                   , h_element_id, h_rec_user);
      --trace_printf("SC_STATE: %d, h_element_id: %d %s, h_c_element_name: %s\n",SC_STATE,h_element_id_Ind,h_element_id,h_c_element_name); //trace_flush();
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE TMT_CRI SET ELEMENT_NAME = h_c_element_name WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(145) : cri.sql(12253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_temp_sc_state := 1;
      ElsIf PMO_DB2M.SC_STATE = PMO_CNST.RECORD_NOT_FOUND Then
         BEGIN
            DELETE FROM PMO_DEFAULTS WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id
            AND NOT EXISTS(SELECT ELEMENT_ID FROM TMT_CRI WHERE ELEMENT_ID = h_source_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 163+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(164) : cri.sql(12272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_temp_sc_state := 1;
      End If;
   End If;
   If Coalesce(h_temp_sc_state, 0) = 0 Then
      If Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS Then
         PMO_DB2M.SC_STATE := FC_I_ATTACH_WBS_CRI(h_host_table, h_foreign_table, h_c_element_name
                                         , h_parent_id, h_project_id, h_foreign_id, h_type_id
                                         , h_rec_user, h_element_id);
      ElsIf Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_CRI Then
         PMO_DB2M.SC_STATE := FC_I_ATTACH_CRI(h_host_table, h_foreign_table, h_c_element_name, h_parent_id
                                     , h_project_id, h_foreign_id, h_type_id, h_rec_user
                                     , h_element_id);
      End If;
      
      If PMO_DB2M.SC_STATE = 0 Then
         If (Coalesce(h_type_id, 0) = 210) OR (Coalesce(h_type_id, 0) = 211) OR (Coalesce(
               h_type_id, 0) = 175) OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS) Then
            BEGIN
               UPDATE TMT_CRI SET T_RANK = RANK, TEMPLATED = 'Y', T_PARENT_ID = PARENT_ID
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 198+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(199) : cri.sql(12307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         PMO_DB2M.SC_STATE := FC_A_SC_DEFAULT(h_host_table, h_c_element_name, h_parent_id, h_element_id
                                     , h_type_id, h_rec_user);
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         --if (h_type_id == SC_FOLDER)
         --{
         --  BEGIN_SQL
         --      UPDATE TMT_CRI
         --      SET PRIVATE = 'Y'
         --      WHERE ELEMENT_ID = HOST(h_element_id);
         --  END_SQL;
         --}
         --else
         If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
            If Coalesce(h_asset_flag, 0) <> PMO_CNST.SC_WITHOUT_ASSET Then
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
                  FINANCIAL_CATEGORY = h_financial_category
                  WHERE ELEMENT_ID = h_element_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 235+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(236) : cri.sql(12344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (Coalesce(h_financial_category, 0) <> 0) AND (Coalesce(
                  h_financial_category, 0) <> PMO_CNST.SC_NONE_FINANCIAL_CATEGORY) Then
               BEGIN
                  UPDATE TMT_CRI
                  SET FINANCIAL_CATEGORY = h_financial_category
                  WHERE ELEMENT_ID = h_element_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 255+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(256) : cri.sql(12364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   --for resources that have executive access to a project, if we already dont have any project_assignments records
   -- we insert a record when we create a document.
   If (PMO_DB2M.SC_STATE = 0) AND (Coalesce(h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) AND (Coalesce(
         h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER2) Then
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_A_RESOURCE_TO_PROJECT(h_project_id, h_rec_user);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CRI', 274+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CRI(275) : cri.sql(12383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 282+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(283) : cri.sql(12391) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CRI', 294+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CRI(295) : cri.sql(12403) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CRI;
ALTER FUNCTION SP_I_CRI COMPILE DEBUG;

/**********************************************************************************/

Prompt == FUNCTION SP_M_CRI ==
CREATE OR REPLACE FUNCTION SP_M_CRI
(
     p_target_id VARCHAR2
   , p_source_id_list VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_remain_id_list VARCHAR2(2047);
   h_source_project_id VARCHAR2(32);
   h_x_element_id VARCHAR2(32);
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
   h_transfered_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_target_type_id PLS_INTEGER := 0;
   h_target_level_id PLS_INTEGER := 0;
   h_target_project_id VARCHAR2(32);
   h_sys_folder_id VARCHAR2(32);
   h_sys_folder_asset_flag PLS_INTEGER := 0;
   h_sys_folder_parent_id VARCHAR2(32);
   h_sys_folder_financial_cat PLS_INTEGER := 0;
   h_sys_folder_rank VARCHAR2(200);
   isAttrubute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
   hasTranfer PLS_INTEGER NOT NULL := 4;
   withError PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CRI(' || 
       '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id_list || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CRI', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CRI(52) : cri.sql(12471) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_host_table := withDependencies + hasTranfer;
   
   -- Validate target  source id
   If (p_source_id_list IS NULL) OR (p_target_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_CRI', 61+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_CRI(62) : cri.sql(12481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CRI', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CRI(65) : cri.sql(12484) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Parse parameters to local variables
   h_target_id := p_target_id;
   h_remain_id_list := p_source_id_list;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) > 0 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   h_len := Coalesce(Length(h_remain_id_list), 0);
   h_len := Coalesce(h_len, 0);
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT ASSET_FLAG, PARENT_ID, FINANCIAL_CATEGORY, RANK, TYPE_ID, LEVEL_ID, PROJECT_ID
      INTO h_asset_flag, h_parent_id, h_financial_category, h_target_rank,
      h_target_type_id, h_target_level_id, h_target_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(96) : cri.sql(12515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- if move to the root node of CRI tree, it should be directed to the cri folder
   If (Coalesce(h_target_type_id, 0) = PMO_CNST.SC_CUSTOM_FOLDER) AND (Coalesce(
             h_target_level_id, 0) = 1) Then
      -- select cri system folder
      BEGIN
         SELECT ELEMENT_ID, ASSET_FLAG, PARENT_ID, FINANCIAL_CATEGORY, RANK
         INTO h_sys_folder_id, h_sys_folder_asset_flag, h_sys_folder_parent_id, h_sys_folder_financial_cat, h_sys_folder_rank
         FROM TMT_CRI
         WHERE STAGE_ID = PMO_CNST.SC_PROJECT
         AND TYPE_ID = PMO_CNST.SC_FOLDER
         AND PROJECT_ID = h_target_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(118) : cri.sql(12537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- if cri system folder is not there then continue to move into root
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_target_id := h_sys_folder_id;
         h_asset_flag := h_sys_folder_asset_flag;
         h_parent_id := h_sys_folder_parent_id;
         h_financial_category := h_sys_folder_financial_cat;
         h_target_rank := h_sys_folder_rank;
      End If;
   End If;
   --trace_printf("\n h_target_id:%s", h_target_id);
   --trace_printf("\n h_parent_id:%s", h_parent_id);
   --trace_printf("\n h_target_rank:%s", h_target_rank);
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) > 0 Then
      BEGIN
         SELECT ASSET_FLAG, FINANCIAL_CATEGORY, RANK
         INTO h_asset_flag, h_financial_category, h_target_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 147+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(148) : cri.sql(12567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_transfered_count := 0;
   h_count := 0;
   BEGIN
      SELECT SUM(CASE WHEN WBS_ID IS NOT NuLL THEN 1 ELSE 0 END), COUNT(ELEMENT_ID)
      INTO h_transfered_count, h_count
      FROM TMT_CRI
      WHERE (SUBSTR(h_target_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_target_rank, 1, 12) || '%'))
      AND LEVEL_ID > 1
      AND TYPE_ID <> PMO_CNST.SC_FOLDER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(170) : cri.sql(12589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_transfered_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_CRI', 176+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_CRI(177) : cri.sql(12596) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI), 'NULL') || ' ID: ' || '''' || h_target_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CRI', 179+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CRI(180) : cri.sql(12599) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI, h_target_id
            , True);
   End If;
   
   WHILE (Coalesce(h_len, 0) >= 32) AND (PMO_DB2M.SC_STATE >= 0) LOOP
      h_source_id := SubStr(h_remain_id_list, 1, 32);
      h_host_table := Coalesce(h_host_table, 0);
      h_element_id := h_source_id;
      
      h_type_id := 0;
      h_stage_id := 0;
      
      BEGIN
         SELECT RANK, ASSET_FLAG, TYPE_ID, STAGE_ID
         INTO h_source_rank, h_asset_flag, h_type_id, h_stage_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(205) : cri.sql(12624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If IsCRISystemFolder(Coalesce(h_type_id, 0), Coalesce(h_stage_id, 0)) = 1 Then
         withError := PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
         PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
      End If;
      
      If (PMO_DB2M.SC_STATE = 0) AND (Coalesce(h_count, 0) > 0) Then
         h_transfered_count := 0;
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_transfered_count
            FROM TMT_CRI
            WHERE RANK LIKE h_source_rank || '%'
            AND WBS_ID IS NOT NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(228) : cri.sql(12647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_transfered_count, 0) > 0 Then
            withError := PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
            PMO_DB2M.SC_STATE := PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
         Else
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = 0 Then
         h_source_project_id := NULL;
         PMO_DB2M.SC_STATE := FC_M_ATTACH_CRI(h_host_table, h_target_id, h_source_id, h_bitflag, h_rec_user
                                     , h_element_id, h_source_project_id);
      End If;
      
      If PMO_DB2M.SC_STATE = 0 Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_source_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_source_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, True); 
         	End If; 
         END;
         If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET Then
            If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET Then
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
                  FINANCIAL_CATEGORY = CASE WHEN h_financial_category = PMO_CNST.SC_NONE_FINANCIAL_CATEGORY
                  THEN FINANCIAL_CATEGORY ELSE h_financial_category END
                  WHERE RANK LIKE h_source_rank || '%';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 278+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(279) : cri.sql(12698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_financial_category, 0) <> PMO_CNST.SC_NONE_FINANCIAL_CATEGORY Then
               BEGIN
                  UPDATE TMT_CRI
                  SET FINANCIAL_CATEGORY = h_financial_category
                  WHERE RANK LIKE h_source_rank || '%';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(298) : cri.sql(12717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'D'
               WHERE (ELEMENT_ID, PARENT_ID) IN (SELECT ELEMENT_ID, ASSET_ID FROM TMT_CRI
               WHERE RANK LIKE h_source_rank || '%' AND ASSET_ID IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 318+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(319) : cri.sql(12738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CRI
               SET FINANCIAL_CATEGORY = CASE WHEN h_financial_category = PMO_CNST.SC_NONE_FINANCIAL_CATEGORY
               THEN FINANCIAL_CATEGORY ELSE h_financial_category END,
               ASSET_ID = NuLL,
               ASSET_NAME = NuLL,
               ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET
               WHERE RANK LIKE h_source_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 341+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(342) : cri.sql(12761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         COMMIT;
      Else
         withError := PMO_DB2M.SC_STATE;
         h_x_element_id := h_source_id;
         
ROLLBACK;      End If;
      
      h_remain_id_list := SubStr(h_remain_id_list, 33, Coalesce(Length(h_remain_id_list), 0));
      h_len := Coalesce(Length(h_remain_id_list), 0);
      h_len := Coalesce(h_len, 0);
   END LOOP;
   
   If withError <> 0 Then
      h_element_id := h_x_element_id;
      PMO_DB2M.SC_STATE := withError;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CRI', 365+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CRI(366) : cri.sql(12785) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 372+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(373) : cri.sql(12792) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CRI', 384+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CRI(385) : cri.sql(12804) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CRI;
ALTER FUNCTION SP_M_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_CLIENT ==
CREATE OR REPLACE FUNCTION SP_U_CRI_CLIENT
(
     p_id VARCHAR2
   , p_client_id VARCHAR2
   , p_client_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_name VARCHAR2(255);
   h_new_client_id VARCHAR2(32);
   h_old_client_id VARCHAR2(32);
   h_client_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_asset_id VARCHAR2(32);
   h_asset_flag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_financial_category PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_client_id || ''''
          || ', ' || '''' || p_client_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_CLIENT', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_CLIENT(36) : cri.sql(12856) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_client_id := p_client_id;
   h_name := p_client_name;
   h_rec_user := p_rec_user;
   h_type_id := PMO_CNST.SC_CLIENTS;
   
   BEGIN
      SELECT PROJECT_ID, RANK, CLIENT_ID, ASSET_ID, ASSET_FLAG, FINANCIAL_CATEGORY
      INTO h_project_id, h_rank, h_old_client_id, h_asset_id,
      h_asset_flag, h_financial_category
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_CLIENT', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_CLIENT(57) : cri.sql(12877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_CLIENT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_CLIENT(64) : cri.sql(12884) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_CLIENT', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_CLIENT(67) : cri.sql(12887) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   --  if (h_asset_flag == SC_PARENT_HAS_ASSET)
   --  {
   --      RETURN_ERROR(CANNOT_ASSIGN_ASSET, *p_id);
   --  }
   
   If (h_name IS NULL) Then
      h_client_id := NULL;
   ElsIf (h_client_id IS NULL) Then
      h_client_id := SYS_GUID();
      h_client_id := h_client_id;
      h_temp_sc_state := FC_I_CLIENT(h_name, h_client_id, h_project_id, h_type_id, h_rec_user);
   End If;
   
   /*  if (h_asset_flag == SC_HAS_ASSET)
   	{
   		BEGIN_SQL
   			UPDATE TMT_CRI
   			SET CLIENT_ID   = HOST(h_new_client_id),
   				CLIENT_NAME = HOST(h_name),
   				REC_USER = HOST(h_rec_user),
   				REC_DATETIME = SC_NOW
   			WHERE ELEMENT_ID =  HOST(h_id);
   		END_SQL;
   
   		if ((IsNullParam(h_client_id))
   			 (IsNullParam(h_asset_id))
   			 ((h_financial_category == 0) || (h_financial_category == SC_NONE_FINANCIAL_CATEGORY)))
   		{
   PMO_VERIFY_RANK(h_rank, 0);
   			BEGIN_SQL
   				UPDATE TMT_CRI
   				SET ASSET_FLAG = SC_WITHOUT_ASSET
   				WHERE RANK LIKE HOST(h_rank) || '%';
   			END_SQL;
   		}
   	}
   	else
   	{
   		BEGIN_SQL
   			SELECT 1 INTO HOST(h_count)
   			FROM TMT_WBS
   			WHERE PROJECT_ID = HOST(h_project_id)
   				AND ELEMENT_ID = HOST(h_project_id)
   				AND ASSET_FLAG != SC_WITHOUT_ASSET;
   		END_SQL;
   
   		if (SC_SUCCESS)
   		{
   			RETURN_ERROR(CANNOT_ASSIGN_ASSET, *p_id);
   		}
   
   		BEGIN_SQL
   			SELECT 1 INTO HOST(h_count)
   			FROM DUAL
   			WHERE EXISTS(SELECT PROJECT_ID FROM TMT_CRI
   				WHERE PROJECT_ID = HOST(h_project_id)
   					AND ASSET_FLAG != SC_WITHOUT_ASSET
   					AND (RANK LIKE HOST(h_rank) || '%'
   						OR (PMO_FAST_LOCATE(RANK, HOST(h_rank), 8))));
   		END_SQL;
   
   		if (SC_SUCCESS)
   		{
   			RETURN_ERROR(CANNOT_ASSIGN_ASSET, *p_id);
   		}
   
   PMO_VERIFY_RANK(h_rank, 0);
   		BEGIN_SQL
   			UPDATE TMT_CRI
   			SET ASSET_FLAG = SC_PARENT_HAS_ASSET
   			WHERE RANK LIKE HOST(h_rank) || '%';
   		END_SQL;
   */
   BEGIN
      UPDATE TMT_CRI
      SET CLIENT_ID   = h_client_id,
      CLIENT_NAME = h_name,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID =  h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_CLIENT', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_CLIENT(162) : cri.sql(12982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  }
   
   If (h_old_client_id IS NOT NULL) Then
      h_bitflag := 3;
      h_temp_sc_state := FC_D_CLIENT(h_old_client_id, h_bitflag, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_CLIENT', 173+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_CLIENT(174) : cri.sql(12994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_client_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_client_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_CLIENT', 180+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_CLIENT(181) : cri.sql(13001) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_CLIENT', 192+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_CLIENT(193) : cri.sql(13013) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_CLIENT;
ALTER FUNCTION SP_U_CRI_CLIENT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_PLANNED ==
CREATE OR REPLACE FUNCTION SP_U_CRI_PLANNED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_rollup_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assigned_effort_count PLS_INTEGER := 0;
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_xsql VARCHAR2(29999);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_PLANNED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_PLANNED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_PLANNED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rollup_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PLANNED', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_PLANNED(54) : cri.sql(13083) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_PLANNED', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_PLANNED(59) : cri.sql(13088) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PLANNED', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_PLANNED(62) : cri.sql(13091) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, CHILD_COUNT, START_DATETIME, FINISH_DATETIME, ASSIGN_COUNT
      INTO h_project_id, h_type_id, h_count, h_start_date, h_finish_date, h_assigned_effort_count
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(82) : cri.sql(13111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_PLANNED', 88+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_PLANNED(89) : cri.sql(13118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PLANNED', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_PLANNED(92) : cri.sql(13121) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_PLANNED', 98+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_PLANNED(99) : cri.sql(13128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_ASSIGNED), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PLANNED', 101+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_PLANNED(102) : cri.sql(13131) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_ASSIGNED, p_id, True);
   End If;
   
   If Coalesce(h_assigned_effort_count, 0) = 0 Then
      If isChangeToTask(Coalesce(h_type_id, 0)) <> 0 Then
         h_id := p_id;
         h_rec_user := p_rec_user;
         h_temp_sc_state := FC_CHANGE_TYPE_BY_ASSIGN(h_type_id, h_id, h_rec_user);
         
         If Coalesce(h_temp_sc_state, 0) <> 0 Then
            If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_PLANNED', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_PLANNED(116) : cri.sql(13145) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PLANNED', 118+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_PLANNED(119) : cri.sql(13148) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
            End If;
         End If;
      End If;
      
      If (p_start_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)))
            INTO h_SC
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(139) : cri.sql(13168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            --Should be replace with c function
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
               INTO h_SC
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 155+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(156) : cri.sql(13185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         h_SC := NULL;
         NULL;
      End If;
      
      If (p_end_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(178) : cri.sql(13207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            --Should be replace with c function
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
               INTO h_FC
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 194+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(195) : cri.sql(13224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         h_FC := NULL;
         NULL;
      End If;
      
      BEGIN
         UPDATE TMT_CRI SET
         PLANNED_START = h_SC,
         PLANNED_FINISH = h_FC,
         PLANNED_DURATION = p_duration
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(221) : cri.sql(13250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(p_rollup_flag, 0) = 1) Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_PLANNED', 231+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_PLANNED(232) : cri.sql(13261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 238+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(239) : cri.sql(13268) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PLANNED', 250+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PLANNED(251) : cri.sql(13280) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_PLANNED;
ALTER FUNCTION SP_U_CRI_PLANNED COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_SCHED ==
CREATE OR REPLACE FUNCTION SP_U_CRI_SCHED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assigned_effort_count PLS_INTEGER := 0;
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_SCHED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_SCHED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_SCHED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_SCHED', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_SCHED(50) : cri.sql(13346) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_SCHED', 54+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_SCHED(55) : cri.sql(13351) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_SCHED', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_SCHED(58) : cri.sql(13354) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME, ASSIGN_COUNT
      INTO h_project_id, h_start_date, h_finish_date, h_assigned_effort_count
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(78) : cri.sql(13374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_SCHED', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_SCHED(85) : cri.sql(13381) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_SCHED', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_SCHED(88) : cri.sql(13384) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If Coalesce(h_assigned_effort_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_SCHED', 94+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_SCHED(95) : cri.sql(13391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_ASSIGNED), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_SCHED', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_SCHED(98) : cri.sql(13394) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_ASSIGNED, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)))
         INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(116) : cri.sql(13412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
            INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 132+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(133) : cri.sql(13429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(155) : cri.sql(13451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
            INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(172) : cri.sql(13468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      SCHED_START = h_SC,
      SCHED_FINISH = h_FC,
      SCHED_DURATION = p_duration
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(198) : cri.sql(13494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_SCHED', 203+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_SCHED(204) : cri.sql(13500) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 210+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(211) : cri.sql(13507) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_SCHED', 222+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_SCHED(223) : cri.sql(13519) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_SCHED;
ALTER FUNCTION SP_U_CRI_SCHED COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_ESTIMATED ==
CREATE OR REPLACE FUNCTION SP_U_CRI_ESTIMATED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_effort PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_ESTIMATED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_ESTIMATED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_ESTIMATED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_effort), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_ESTIMATED(52) : cri.sql(13587) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME, WBS_ID, ELEMENT_ID
      INTO h_project_id, h_start_date, h_finish_date, h_wbs_id, h_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(70) : cri.sql(13605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ESTIMATED', 76+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ESTIMATED(77) : cri.sql(13612) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ESTIMATED(80) : cri.sql(13615) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(97) : cri.sql(13632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
            INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 113+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(114) : cri.sql(13649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      --      InitializeHost(SC_PARAM(h_SC), SC_PARAM(h_start_date));
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(136) : cri.sql(13671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
            INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(153) : cri.sql(13688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      --      InitializeHost(SC_PARAM(h_FC), SC_PARAM(h_finish_date));
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      ESTIMATED_START     = h_SC,
      ESTIMATED_FINISH    = h_FC,
      ESTIMATED_DURATION  = p_duration,
      ESTIMATED_EFFORT    = p_effort,
      ROLLUP_BITS     = PMO_CNST.SC_ESTIMATED_BIT
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 180+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(181) : cri.sql(13716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_wbs_id, h_id) = PMO_CNST.SC_MATCH Then
      BEGIN
         UPDATE TMT_WBS
         SET START_FINISH_DATE = TO_DATE(SubStr(h_SC, 1, 10)),
         FINISH_START_DATE = TO_DATE(SubStr(h_FC, 1, 10))
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 201+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(202) : cri.sql(13737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_ESTIMATED', 208+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_ESTIMATED(209) : cri.sql(13744) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 215+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(216) : cri.sql(13751) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED', 227+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED(228) : cri.sql(13763) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_ESTIMATED;
ALTER FUNCTION SP_U_CRI_ESTIMATED COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_ESTIMATED_LOW ==
CREATE OR REPLACE FUNCTION SP_U_CRI_ESTIMATED_LOW
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_effort PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_ESTIMATED_LOW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_ESTIMATED_LOW'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_ESTIMATED_LOW(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_effort), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED_LOW', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_ESTIMATED_LOW(51) : cri.sql(13830) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME
      INTO h_project_id, h_start_date, h_finish_date
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(69) : cri.sql(13848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ESTIMATED_LOW', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ESTIMATED_LOW(76) : cri.sql(13855) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED_LOW', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ESTIMATED_LOW(79) : cri.sql(13858) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(96) : cri.sql(13875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
            INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(113) : cri.sql(13892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(135) : cri.sql(13914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
            INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(152) : cri.sql(13931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      LOW_ESTIMATED_START     = h_SC,
      LOW_ESTIMATED_FINISH    = h_FC,
      LOW_ESTIMATED_DURATION  = p_duration,
      LOW_ESTIMATED_EFFORT    = p_effort,
      ROLLUP_BITS     = PMO_CNST.SC_LOW_ESTIMATED_BIT
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(180) : cri.sql(13959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_ESTIMATED_LOW', 185+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_ESTIMATED_LOW(186) : cri.sql(13965) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 192+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(193) : cri.sql(13972) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_LOW', 204+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_LOW(205) : cri.sql(13984) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_ESTIMATED_LOW;
ALTER FUNCTION SP_U_CRI_ESTIMATED_LOW COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_ESTIMATED_HIGH ==
CREATE OR REPLACE FUNCTION SP_U_CRI_ESTIMATED_HIGH
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_effort PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_ESTIMATED_HIGH') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_ESTIMATED_HIGH'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_ESTIMATED_HIGH(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_effort), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED_HIGH', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_ESTIMATED_HIGH(51) : cri.sql(14051) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME
      INTO h_project_id, h_start_date, h_finish_date
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(69) : cri.sql(14069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ESTIMATED_HIGH', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ESTIMATED_HIGH(76) : cri.sql(14076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ESTIMATED_HIGH', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ESTIMATED_HIGH(79) : cri.sql(14079) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(96) : cri.sql(14096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
            INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(113) : cri.sql(14113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(135) : cri.sql(14135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
            INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(152) : cri.sql(14152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      HIGH_ESTIMATED_START    = h_SC,
      HIGH_ESTIMATED_FINISH   = h_FC,
      HIGH_ESTIMATED_DURATION = p_duration,
      HIGH_ESTIMATED_EFFORT   = p_effort,
      ROLLUP_BITS     = PMO_CNST.SC_HIGH_ESTIMATED_BIT
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(180) : cri.sql(14180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_ESTIMATED_HIGH', 185+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_ESTIMATED_HIGH(186) : cri.sql(14186) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 192+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(193) : cri.sql(14193) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ESTIMATED_HIGH', 204+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ESTIMATED_HIGH(205) : cri.sql(14205) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_ESTIMATED_HIGH;
ALTER FUNCTION SP_U_CRI_ESTIMATED_HIGH COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_APPROVED ==
CREATE OR REPLACE FUNCTION SP_U_CRI_APPROVED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_duration PLS_INTEGER
   , p_effort PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FC TIMESTAMP;
   h_SC TIMESTAMP;
   h_calendar_id VARCHAR2(32);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_xsql VARCHAR2(29999);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_duration_day PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_APPROVED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_APPROVED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_APPROVED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_effort), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_APPROVED', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_APPROVED(51) : cri.sql(14272) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT PROJECT_ID, START_DATETIME, FINISH_DATETIME
      INTO h_project_id, h_start_date, h_finish_date
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(69) : cri.sql(14290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_APPROVED', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_APPROVED(76) : cri.sql(14297) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_APPROVED', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_APPROVED(79) : cri.sql(14300) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_SC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(96) : cri.sql(14317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date))
            INTO h_SC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(113) : cri.sql(14334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_SC := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_FC
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(135) : cri.sql(14356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --Should be replace with c function
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date))
            INTO h_FC
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(152) : cri.sql(14373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_FC := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_CRI SET
      APPROVED_START      = h_SC,
      APPROVED_FINISH     = h_FC,
      APPROVED_DURATION   = p_duration,
      APPROVED_EFFORT     = p_effort,
      ROLLUP_BITS     = PMO_CNST.SC_APPROVED_BIT
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(180) : cri.sql(14401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_APPROVED', 185+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_APPROVED(186) : cri.sql(14407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 192+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(193) : cri.sql(14414) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_APPROVED', 204+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_APPROVED(205) : cri.sql(14426) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_APPROVED;
ALTER FUNCTION SP_U_CRI_APPROVED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_CRI_PUBLISHED ==
CREATE OR REPLACE FUNCTION SP_U_CRI_PUBLISHED
(
     p_id VARCHAR2
   , p_published VARCHAR2
   , p_visible_at_parent VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_published VARCHAR2(1);
   h_visible_at_parent VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_PUBLISHED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_PUBLISHED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_PUBLISHED(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_published || ''''
          || ', ' || '''' || p_visible_at_parent || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PUBLISHED', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_PUBLISHED(27) : cri.sql(14469) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_PUBLISHED', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_PUBLISHED(32) : cri.sql(14474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_PUBLISHED', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_PUBLISHED(35) : cri.sql(14477) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_published := p_published;
   h_visible_at_parent := p_visible_at_parent;
   h_rec_user := p_rec_user;
   h_error_id := h_id;
   
   PMO_DB2M.SC_STATE := FC_U_PRIVATE_CRI(h_host_table, h_id, h_published, h_visible_at_parent
                                      , h_rec_user, h_error_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_PUBLISHED', 51+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_PUBLISHED(52) : cri.sql(14494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PUBLISHED', 58+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PUBLISHED(59) : cri.sql(14501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_PUBLISHED', 70+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_PUBLISHED(71) : cri.sql(14513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_PUBLISHED;
ALTER FUNCTION SP_U_CRI_PUBLISHED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_CRI_TARGET_DATE ==
CREATE OR REPLACE FUNCTION SP_U_CRI_TARGET_DATE
(
     p_id VARCHAR2
   , p_target_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_target_date DATE;
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_TARGET_DATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_TARGET_DATE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_TARGET_DATE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_target_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_TARGET_DATE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_TARGET_DATE(24) : cri.sql(14553) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_TARGET_DATE', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_TARGET_DATE(29) : cri.sql(14558) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_TARGET_DATE', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_TARGET_DATE(32) : cri.sql(14561) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_target_date := p_target_date;
   h_rec_user := p_rec_user;
   h_error_id := h_id;
   
   PMO_DB2M.SC_STATE := FC_U_ITEM_TARGET_CRI(h_host_table, h_id, h_target_date, h_rec_user, h_error_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_TARGET_DATE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_TARGET_DATE(47) : cri.sql(14576) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TARGET_DATE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TARGET_DATE(54) : cri.sql(14583) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TARGET_DATE', 65+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TARGET_DATE(66) : cri.sql(14595) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_TARGET_DATE;
ALTER FUNCTION SP_U_CRI_TARGET_DATE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_C_CRI ==
CREATE OR REPLACE FUNCTION FC_C_CRI
(
     sh_h_table PLS_INTEGER
   , h_old_id IN OUT NOCOPY VARCHAR2
   , h_new_id IN OUT NOCOPY VARCHAR2
   , sh_h_min_per_day PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_min_per_day PLS_INTEGER := sh_h_min_per_day;
   h_c_assign_names VARCHAR2(400);
   h_c_attached_id VARCHAR2(32);
   h_c_dep_rank VARCHAR2(200);
   h_c_depend_id VARCHAR2(32);
   h_c_doc_parent_rank VARCHAR2(200);
   h_c_doc_rank VARCHAR2(200);
   h_c_element_id VARCHAR2(32);
   h_c_element_name VARCHAR2(255);
   h_c_external_reference VARCHAR2(32);
   h_c_keywords VARCHAR2(255);
   h_c_old_pred_id VARCHAR2(32);
   h_c_old_succ_id VARCHAR2(32);
   h_c_parent_id VARCHAR2(32);
   h_c_planned_finish TIMESTAMP;
   h_c_planned_start TIMESTAMP;
   h_c_planning_unit VARCHAR2(1);
   h_c_pred_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_c_ref_number VARCHAR2(100);
   h_c_security_id VARCHAR2(32);
   h_c_succ_id VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_current_datetime TIMESTAMP;
   h_rankBase64 VARCHAR2(200);
   h_rankBase64_doc VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   h_x_cri_start_dt TIMESTAMP;
   h_x_full_name VARCHAR2(100);
   h_x_new_project_id VARCHAR2(32);
   h_x_new_wbs_rank VARCHAR2(200);
   h_x_old_project_id VARCHAR2(32);
   h_x_old_wbs_rank VARCHAR2(200);
   h_x_wbs_start_dt TIMESTAMP;
   h_history_id VARCHAR2(32);
   h_c_amount PLS_INTEGER := 0;
   h_c_assign_count PLS_INTEGER := 0;
   h_c_child_count PLS_INTEGER := 0;
   h_c_cost_rank_id PLS_INTEGER := 0;
   h_c_dep_type PLS_INTEGER := 0;
   h_c_doc_level_id PLS_INTEGER := 0;
   h_c_lag_display_unit PLS_INTEGER := 0;
   h_c_lead_or_lag_type PLS_INTEGER := 0;
   h_c_level_id PLS_INTEGER := 0;
   h_c_max_rank PLS_INTEGER := 0;
   h_c_parent_type_id PLS_INTEGER := 0;
   h_c_participant PLS_INTEGER := 0;
   h_c_planned_duration PLS_INTEGER := 0;
   h_c_planned_effort PLS_INTEGER := 0;
   h_c_planned_start_julian PLS_INTEGER := 0;
   h_c_planning_type PLS_INTEGER := 0;
   h_c_pred_object_type PLS_INTEGER := 0;
   h_c_quality_rank_id PLS_INTEGER := 0;
   h_c_schedule_rank_id PLS_INTEGER := 0;
   h_c_scope_rank_id PLS_INTEGER := 0;
   h_c_succ_object_type PLS_INTEGER := 0;
   h_c_type_id PLS_INTEGER := 0;
   h_c_rtf_bits PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_max_rank_doc PLS_INTEGER := 0;
   h_parent_max_rank_doc PLS_INTEGER := 0;
   h_prev_level PLS_INTEGER := 0;
   h_source_level_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_c_estimated_budget NUMBER := 0.00;
   h_c_mitigation_cost NUMBER := 0.00;
   h_c_probability_rank_id PLS_INTEGER := 0;
   h_c_precision_rank_id PLS_INTEGER := 0;
   h_c_impact_rank_id PLS_INTEGER := 0;
   h_c_exposure_id PLS_INTEGER := 0;
   h_c_impact_level_id PLS_INTEGER := 0;
   h_priority_id PLS_INTEGER := 0;
   h_c_consequense_cost NUMBER := 0.00;
   h_c_probability_cost NUMBER := 0.00;
   wbs_cri_count PLS_INTEGER NOT NULL := 0;
   h_level_dif PLS_INTEGER := 0;
   h_x_element_id VARCHAR2(32);
   h_x_level_id PLS_INTEGER := 0;
   h_x_rank VARCHAR2(200);
   h_c_doc_count PLS_INTEGER := 0;
   h_c_scd_count PLS_INTEGER := 0;
   h_c_estimated_start TIMESTAMP;
   h_c_high_start TIMESTAMP;
   h_c_low_start TIMESTAMP;
   h_c_estimated_finish TIMESTAMP;
   h_c_high_finish TIMESTAMP;
   h_c_low_finish TIMESTAMP;
   h_c_estimated_effort PLS_INTEGER := 0;
   h_c_high_effort PLS_INTEGER := 0;
   h_c_low_effort PLS_INTEGER := 0;
   h_c_estimated_duration PLS_INTEGER := 0;
   h_c_high_duration PLS_INTEGER := 0;
   h_c_low_duration PLS_INTEGER := 0;
   h_c_r_estimated_budget NUMBER := 0.00;
   h_c_s_estimated_budget NUMBER := 0.00;
   h_c_r_high_estimated_budget NUMBER := 0.00;
   h_c_s_high_estimated_budget NUMBER := 0.00;
   h_c_r_low_estimated_budget NUMBER := 0.00;
   h_c_s_low_estimated_budget NUMBER := 0.00;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_cri_table PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_root_level_id PLS_INTEGER := 0;
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_c_parent_rank VARCHAR2(200);
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_new_rank VARCHAR2(200);
   h_assign_string VARCHAR2(4000);
   h_private VARCHAR2(1);
   h_system_folder_exists PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR READ_TARGET IS
         SELECT RANK, PROJECT_ID
         FROM PMO_COPY_WBS
         ORDER BY RANK;

      CURSOR C_CCRI_DATE IS
         SELECT * FROM (SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_x_new_project_id AND DAY_YEAR >= TO_DATE(SYSDATE)
         ) WHERE ROWNUM<=1;

      CURSOR READ_WBS_FOLDER IS
         SELECT ELEMENT_ID, RANK, LEVEL_ID, MAX_RANK, CHILD_COUNT
         FROM TMT_CRI
         WHERE PROJECT_ID = h_x_new_project_id AND LEVEL_ID = 1
         AND SUBSTR(PARENT_RANK, 1, 3) = 'WBS'
         FOR UPDATE OF MAX_RANK, CHILD_COUNT;

      CURSOR C_READ_SRC IS
         WITH TEMP AS (SELECT C.ELEMENT_ID, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PARENT_ID, C.PARENT_RANK FROM TMT_CRI C
         WHERE C.PARENT_RANK LIKE 'WBS#' || h_x_old_wbs_rank || '%' AND LEVEL_ID > 1
         AND C.TYPE_ID IN (64, 5, 66, 35, 244, 247, 38)
         AND REC_STATUS NOT IN ('D', 'A')
         AND NOT EXISTS(SELECT P.ELEMENT_ID FROM TMT_CRI P
         WHERE P.PARENT_RANK LIKE 'WBS#' || h_x_old_wbs_rank || '%' AND P.LEVEL_ID > 1
         AND P.TYPE_ID NOT IN (64, 5, 66, 35, 244, 247, 38)
         AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(P.RANK)>LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END) = P.RANK))
         SELECT
         T.ELEMENT_ID, T.RANK, T.TYPE_ID,
         T.PARENT_ID, T.PARENT_RANK,
         T.LEVEL_ID,
         0,
         0,
         T.ELEMENT_NAME, T.PARENT_TYPE_ID,
         T.PLANNING_TYPE, T.PLANNING_UNIT, T.PLANNED_EFFORT,
         T.PLANNED_START, T.PLANNED_DURATION,
         T.EXTERNAL_REFERENCE,
         T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID,
         T.COST_RANK_ID, T.QUALITY_RANK_ID, T.RTF_BITS,
         T.ESTIMATED_BUDGET,
         T.MITIGATION_COST,
         T.PROBABILITY_RANK_ID,
         T.PRECISION_RANK_ID,
         T.IMPACT_RANK_ID,
         T.EXPOSURE_ID,
         T.CONSEQUENSE_COST,
         T.PROBABILITY_COST,
         T.IMPACT_LEVEL_ID,
         h_x_full_name || ';',
         0, T.PRIORITY_ID,
         T.DOC_COUNT,
         T.SCORECARD_COUNT,
         T.ESTIMATED_START,
         T.ESTIMATED_FINISH,
         T.ESTIMATED_DURATION,
         T.ESTIMATED_EFFORT,
         T.HIGH_ESTIMATED_START,
         T.HIGH_ESTIMATED_FINISH,
         T.HIGH_ESTIMATED_DURATION,
         T.HIGH_ESTIMATED_EFFORT,
         T.LOW_ESTIMATED_START,
         T.LOW_ESTIMATED_FINISH,
         T.LOW_ESTIMATED_DURATION,
         T.LOW_ESTIMATED_EFFORT,
         T.R_ESTIMATED_BUDGET,
         T.S_ESTIMATED_BUDGET,
         T.R_HIGH_ESTIMATED_BUDGET ,
         T.S_HIGH_ESTIMATED_BUDGET ,
         T.R_LOW_ESTIMATED_BUDGET ,
         T.S_LOW_ESTIMATED_BUDGET ,
         T.PRIVATE
         FROM TMT_CRI T, TEMP TM
         WHERE (TM.TYPE_ID <> PMO_CNST.SC_FOLDER OR
         EXISTS(SELECT CC.ELEMENT_ID FROM TEMP CC
         WHERE CC.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK)
         AND TM.RANK > SUBSTR(CC.RANK, 1, 8) AND TM.RANK < CC.RANK
         AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(TM.RANK)>LENGTH(CC.RANK) THEN 1 ELSE LENGTH(TM.RANK) END) = TM.RANK))
         AND T.ELEMENT_ID = TM.ELEMENT_ID
         ORDER BY T.RANK;

      CURSOR C_DEPEND IS
         SELECT RANK
         FROM PMO_COPY_CRI
         WHERE LEVEL_ID = 2 AND PARENT_ID = h_new_id
         ORDER BY RANK;

      CURSOR CX3DEPENDENCY IS
         SELECT PRED_ID, SUCC_ID, PRED_OBJECT_TYPE, SUCC_OBJECT_TYPE,
         DEP_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT
         FROM CRIDEPENDENCIES, PMO_COPY_CRI
         WHERE RANK LIKE h_c_dep_rank || '%'
         AND SUCC_ID = OLD_ID AND PRED_PROJECT_ID = SUCC_PROJECT_ID;

      CURSOR C_CRI_DOC IS
         SELECT OLD_ID, ELEMENT_ID, ELEMENT_NAME, PARENT_ID, TYPE_ID, SCORECARD_COUNT, RANK
         FROM PMO_COPY_CRI
         WHERE LEVEL_ID = 2
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_C_CRI(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_old_id || ''''
          || ', ' || '''' || h_new_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_min_per_day), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI', 236+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_CRI(237) : cri.sql(14848) : ' || SYSTIMESTAMP);
   END IF; 

   --local variable
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COPY_CRI';
   PMO_DB2M.SC_STATE := 0;
   
   -- validate wbs source element
   BEGIN
      SELECT RANK, PROJECT_ID
      INTO h_x_old_wbs_rank, h_x_old_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_old_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(258) : cri.sql(14869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI', 263+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI(264) : cri.sql(14875) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   OPEN READ_TARGET;
   
   FETCH READ_TARGET INTO h_x_new_wbs_rank, h_x_new_project_id;
   IF READ_TARGET%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI', 278+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI(279) : cri.sql(14890) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      CLOSE READ_TARGET;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 291+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(292) : cri.sql(14903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CCRI_DATE;
   
   FETCH C_CCRI_DATE INTO h_x_wbs_start_dt;
   IF C_CCRI_DATE%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE C_CCRI_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 313+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(314) : cri.sql(14925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- for target project if system folder exists then use it as a root node otherwise use wbs folder as root node
   BEGIN
      SELECT ELEMENT_ID, RANK, LEVEL_ID, MAX_RANK, CHILD_COUNT
      INTO h_root_id, h_root_rank, h_root_level_id, h_root_max_rank, h_root_child_count
      FROM TMT_CRI
      WHERE PROJECT_ID = h_x_new_project_id 
      AND TYPE_ID = PMO_CNST.SC_FOLDER
      AND STAGE_ID = PMO_CNST.SC_PROJECT;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 332+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(333) : cri.sql(14944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_system_folder_exists := 0;
      
      OPEN READ_WBS_FOLDER;
      
      FETCH READ_WBS_FOLDER INTO h_root_id, h_root_rank, h_root_level_id,
      h_root_max_rank, h_root_child_count;
      IF READ_WBS_FOLDER%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE READ_WBS_FOLDER;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 357+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(358) : cri.sql(14969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_system_folder_exists := 1;
   End If;
   
   BEGIN
      SELECT REPLACE( RTRIM(FULL_NAME), '''', '''''' )
      INTO h_x_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 376+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(377) : cri.sql(14988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI', 382+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI(383) : cri.sql(14994) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT SYSTIMESTAMP INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 396+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(397) : cri.sql(15008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --copy the cri structure (FOLDER, RISK, RISK_TASK, DELIVERABLE, SUMMARY_TASK, MILESTONE AND TASK ONLY)
   
   OPEN C_READ_SRC;
   
   LOOP
      FETCH C_READ_SRC INTO
      h_c_element_id, h_c_rank, h_c_type_id,
      h_c_parent_id, h_c_parent_rank, h_c_level_id,
      h_c_max_rank, h_c_child_count, h_c_element_name, h_c_parent_type_id,
      h_c_planning_type, h_c_planning_unit, h_c_planned_effort,
      h_c_planned_start, h_c_planned_duration,
      h_c_external_reference,
      h_c_scope_rank_id, h_c_schedule_rank_id,
      h_c_cost_rank_id, h_c_quality_rank_id, h_c_rtf_bits,
      h_c_estimated_budget,
      h_c_mitigation_cost,
      h_c_probability_rank_id,
      h_c_precision_rank_id,
      h_c_impact_rank_id,
      h_c_exposure_id,
      h_c_consequense_cost,
      h_c_probability_cost,
      h_c_impact_level_id,
      h_c_assign_names, h_c_assign_count, h_priority_id,
      h_c_doc_count,
      h_c_scd_count,
      h_c_estimated_start,
      h_c_estimated_finish,
      h_c_estimated_duration,
      h_c_estimated_effort,
      h_c_high_start,
      h_c_high_finish,
      h_c_high_duration,
      h_c_high_effort,
      h_c_low_start,
      h_c_low_finish,
      h_c_low_duration,
      h_c_low_effort,
      h_c_r_estimated_budget,
      h_c_s_estimated_budget,
      h_c_r_high_estimated_budget,
      h_c_s_high_estimated_budget,
      h_c_r_low_estimated_budget,
      h_c_s_low_estimated_budget,
      h_private;
      IF C_READ_SRC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      -- get new parent_id
      BEGIN
         SELECT ELEMENT_ID, RANK, LEVEL_ID + 1, MAX_RANK + 1
         INTO h_c_parent_id, h_new_rank, h_c_level_id, h_c_max_rank
         FROM PMO_COPY_CRI
         WHERE OLD_ID = h_c_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 468+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(469) : cri.sql(15080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE PMO_COPY_CRI
            SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
            WHERE ELEMENT_ID = h_c_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 488+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(489) : cri.sql(15100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_STPU.toBase64(Coalesce(h_c_max_rank, 0), h_rankBase64);
         h_new_rank := h_new_rank || h_rankBase64;
      Else
         h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
         h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
         
         h_c_level_id := Coalesce(h_root_level_id, 0) + 1;
         h_c_parent_id := h_root_id;
         PMO_STPU.toBase64(Coalesce(h_root_max_rank, 0), h_rankBase64);
         h_new_rank := h_root_rank;
         h_new_rank := h_new_rank || h_rankBase64;
      End If;
      
      --fix start date
      If PMO_ORASTD.strcmp(h_c_planned_start, h_x_wbs_start_dt) < 0 Then
         h_c_planned_start := h_x_wbs_start_dt;
      End If;
      
      If (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
             h_c_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 4830;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 4809;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 5365;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 5396;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 4852;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 6063;
      ElsIf (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
                h_c_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK) Then
         h_stage_id := 5470;
      Else
         h_stage_id := 786;
         NULL;
      End If;
      
      h_uniqueID := SYS_GUID();
      
      BEGIN
         INSERT INTO PMO_COPY_CRI (
         OLD_ID, OLD_RANK, ELEMENT_ID, RANK,
         PROJECT_ID, PARENT_ID, PARENT_RANK,
         TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
         ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
         PLANNED_START, PLANNED_DURATION,
         PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
         EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
         COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
         ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
         PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
         CONSEQUENSE_COST, PROBABILITY_COST,
         IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
         ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
         HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
         LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
         R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
         R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
         R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,PRIVATE)
         VALUES (
         h_c_element_id, h_c_rank, h_uniqueID, h_new_rank,
         h_x_new_project_id, h_c_parent_id, h_c_parent_rank,
         h_c_type_id, h_c_level_id, 0, 0,
         h_c_element_name, h_c_assign_names, h_c_assign_count,
         h_c_planned_start, h_c_planned_duration,
         h_c_planning_type, h_c_planning_unit, h_c_planned_effort,
         h_c_external_reference, h_c_scope_rank_id, h_c_schedule_rank_id,
         h_c_cost_rank_id, h_c_quality_rank_id, h_c_rtf_bits,
         h_c_estimated_budget, h_c_mitigation_cost, h_c_probability_rank_id,
         h_c_precision_rank_id, h_c_impact_rank_id, h_c_exposure_id,
         h_c_consequense_cost, h_c_probability_cost,
         h_c_impact_level_id, h_stage_id, h_priority_id, h_c_doc_count, h_c_scd_count,
         h_c_estimated_start, h_c_estimated_finish, h_c_estimated_duration, h_c_estimated_effort,
         h_c_high_start, h_c_high_finish, h_c_high_duration, h_c_high_effort,
         h_c_low_start, h_c_low_finish, h_c_low_duration, h_c_low_effort,
         h_c_r_estimated_budget, h_c_s_estimated_budget,
         h_c_r_high_estimated_budget, h_c_s_high_estimated_budget,
         h_c_r_low_estimated_budget, h_c_s_low_estimated_budget,
         h_private);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 589+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(590) : cri.sql(15201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Insert into temporary table PMO_TMP_CRI_DEPND
      BEGIN
         INSERT INTO PMO_TMP_CRI_DEPND (OLD_ID, NEW_ID, ELEMENT_NAME)
         VALUES(h_c_element_id, h_uniqueID, h_c_element_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 608+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(609) : cri.sql(15220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_assign_string := '';
      
      h_temp_sc_state := 0;
      PMO_DB2M.SC_STATE := FC_RESPONSIBLE(h_x_new_project_id, h_uniqueID, h_x_old_project_id
                                    , h_c_element_id, h_c_type_id, h_c_assign_names, h_rec_user
                                    , h_rec_user, h_temp_sc_state, h_assign_string);
      
      --do not copy budgets
      --copy attributes
      
      PMO_DB2M.SC_STATE := FC_A_ALL_ATTRIBUTE(h_x_new_project_id, h_x_old_project_id, h_uniqueID
                                        , h_c_element_id, h_c_type_id, h_rec_user);
      
      If (Coalesce(h_c_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
             h_c_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_cri_table := PMO_CNST.SC_TABLE_CRI;
         If Coalesce(h_c_doc_count, 0) > 0 Then
            h_temp_sc_state := FC_C_DOC(h_cri_table, h_c_element_id, h_uniqueID, h_rec_user);
         End If;
         
         h_temp_sc_state := FC_COPY_FAC(h_c_element_id, h_uniqueID, h_rec_user);
         
         BEGIN
            INSERT INTO CRI_RTF( PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
            SELECT h_x_new_project_id, h_uniqueID, BIT_FLAG, CLOB_DATA
            FROM CRI_RTF
            WHERE PARENT_ID = h_x_old_project_id
            AND ELEMENT_ID = h_c_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 651+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(652) : cri.sql(15263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_READ_SRC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 665+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(666) : cri.sql(15277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_COPY_CRI T
      SET T.PARENT_RANK = 'WBS#' || (SELECT W.RANK
      FROM PMO_COPY_WBS W
      WHERE W.OLD_RANK = SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK) - 4));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 685+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(686) : cri.sql(15297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_x_new_wbs_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_x_new_wbs_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_x_new_wbs_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_WBS W
      SET W.CRI_COUNT = CASE WHEN W.ELEMENT_ID = W.PROJECT_ID THEN 1 ELSE 0 END +
      (SELECT COUNT(DISTINCT C.ELEMENT_ID)
      FROM PMO_COPY_CRI C, PMO_COPY_CRI P
      WHERE W.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK) - 4)				
      AND (C.LEVEL_ID = 2 + h_system_folder_exists
      OR (C.PARENT_ID = P.ELEMENT_ID AND C.PARENT_RANK <> P.PARENT_RANK)))
      WHERE RANK LIKE h_x_new_wbs_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 722+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(723) : cri.sql(15334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TMT_CRI (
      ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      CREATED_BY, CREATED_DATETIME, PROPOSED_BY, PROPOSED_BY_NAME, PROPOSED_DATETIME, REC_USER, REC_DATETIME, REC_STATUS,
      ROLLUP_BITS,PRIVATE)
      SELECT
      ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      h_rec_user, SYSTIMESTAMP, h_rec_user, h_x_full_name, SYSTIMESTAMP, h_rec_user, SYSTIMESTAMP, 'U',
      PMO_CNST.SC_PLANNED_BIT,PRIVATE
      FROM PMO_COPY_CRI;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 781+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(782) : cri.sql(15393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO HISTORY_CRI (
      HISTORY_ID, REVISION_HISTORY, ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      CREATED_BY, CREATED_DATETIME, PROPOSED_BY, PROPOSED_BY_NAME, PROPOSED_DATETIME, REC_USER, REC_DATETIME, REC_STATUS)
      SELECT
      SYS_GUID(), OLD_ID, ELEMENT_ID, RANK,
      PROJECT_ID, PARENT_ID, PARENT_RANK,
      TYPE_ID, LEVEL_ID, MAX_RANK, CHILD_COUNT,
      ELEMENT_NAME, ASSIGN_NAMES, ASSIGN_COUNT,
      PLANNED_START, PLANNED_DURATION,
      PLANNING_TYPE, PLANNING_UNIT, PLANNED_EFFORT,
      EXTERNAL_REFERENCE, SCOPE_RANK_ID, SCHEDULE_RANK_ID,
      COST_RANK_ID, QUALITY_RANK_ID, RTF_BITS,
      ESTIMATED_BUDGET, MITIGATION_COST, PROBABILITY_RANK_ID,
      PRECISION_RANK_ID, IMPACT_RANK_ID, EXPOSURE_ID,
      CONSEQUENSE_COST, PROBABILITY_COST,
      IMPACT_LEVEL_ID, STAGE_ID, PRIORITY_ID, DOC_COUNT, SCORECARD_COUNT,
      ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION, ESTIMATED_EFFORT,
      HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION, HIGH_ESTIMATED_EFFORT,
      LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION, LOW_ESTIMATED_EFFORT,
      R_ESTIMATED_BUDGET, S_ESTIMATED_BUDGET,
      R_HIGH_ESTIMATED_BUDGET, S_HIGH_ESTIMATED_BUDGET ,
      R_LOW_ESTIMATED_BUDGET, S_LOW_ESTIMATED_BUDGET,
      h_rec_user, SYSTIMESTAMP, h_rec_user, h_x_full_name, SYSTIMESTAMP, h_rec_user, SYSTIMESTAMP, 'U'
      FROM PMO_COPY_CRI;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 838+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(839) : cri.sql(15450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI
      SET CHILD_COUNT = h_root_child_count, MAX_RANK = h_root_max_rank
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 857+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(858) : cri.sql(15469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --find all root cri elements
   
   OPEN C_DEPEND;
   
   LOOP
      FETCH C_DEPEND INTO h_c_dep_rank;
      IF C_DEPEND%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      OPEN CX3DEPENDENCY;
      
      LOOP
         FETCH CX3DEPENDENCY INTO
         h_c_old_pred_id, h_c_old_succ_id, h_c_pred_object_type, h_c_succ_object_type,
         h_c_dep_type, h_c_lead_or_lag_type, h_c_amount, h_c_lag_display_unit;
         IF CX3DEPENDENCY%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         BEGIN
            SELECT NEW_ID INTO h_c_pred_id
            FROM PMO_TMP_CRI_DEPND
            WHERE OLD_ID = h_c_old_pred_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 903+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(904) : cri.sql(15515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT NEW_ID INTO h_c_succ_id
            FROM PMO_TMP_CRI_DEPND
            WHERE OLD_ID = h_c_old_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 918+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(919) : cri.sql(15530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(Length(h_c_pred_id), 0) <> 0) AND (Coalesce(Length(h_c_succ_id), 0) <> 0) Then
            h_c_depend_id := SYS_GUID();
            
            BEGIN
               INSERT INTO CRIDEPENDENCIES(
               DEPEND_ID,          PRED_ID,           PRED_PROJECT_ID,
               PRED_OBJECT_TYPE,   SUCC_ID,           SUCC_PROJECT_ID,
               SUCC_OBJECT_TYPE,   DEP_TYPE,          LEAD_OR_LAG_TYPE,
               AMOUNT,             LAG_DISPLAY_UNIT,  REC_STATUS,
               REC_USER,           REC_DATETIME)
               VALUES(
               h_c_depend_id,         h_c_pred_id,            h_x_new_project_id,
               h_c_pred_object_type,  h_c_succ_id,            h_x_new_project_id,
               h_c_succ_object_type,  h_c_dep_type,           h_c_lead_or_lag_type,
               h_c_amount,            h_c_lag_display_unit,   'U',
               h_rec_user,            h_current_datetime);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 949+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(950) : cri.sql(15561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE CX3DEPENDENCY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 963+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(964) : cri.sql(15575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_DEPEND ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 977+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(978) : cri.sql(15589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CRI_DOC;
   
   LOOP
      FETCH C_CRI_DOC INTO h_source_id, h_target_id, h_c_element_name, h_c_parent_id, h_c_type_id, h_c_scd_count, h_new_rank;
      IF C_CRI_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      h_table := PMO_CNST.SC_TABLE_CRI;
      --trace_printf("2__* h_table: %d\n", h_table);
      PMO_DB2M.SC_STATE := FC_C_DOC(h_table, h_source_id, h_target_id, h_rec_user);
      
      If Coalesce(h_c_scd_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := FC_C_SCD(h_c_type_id, h_source_id, h_c_rank, h_target_id, h_new_rank
                              , h_x_new_project_id, h_rec_user);
      Else
         PMO_DB2M.SC_STATE := FC_A_SC_DEFAULT(h_table, h_c_element_name, h_c_parent_id, h_target_id
                                     , h_c_type_id, h_rec_user);
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_CRI_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_CRI', 1017+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_CRI(1018) : cri.sql(15629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_CRI', 1023+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_CRI(1024) : cri.sql(15635) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_CRI;
ALTER FUNCTION FC_C_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_ATTACH_CRI ==
CREATE OR REPLACE FUNCTION FC_UPDATE_ATTACH_CRI
(
     h_old_parent_rank IN OUT NOCOPY VARCHAR2
   , h_new_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_old_rank VARCHAR2(200);
   h_table_type PLS_INTEGER := 0;
   h_old_level_id PLS_INTEGER := 0;
   h_source_project_id VARCHAR2(32);
   isFirst PLS_INTEGER NOT NULL := 1;
-- Declare Cursors
      CURSOR r_mdoc_root IS
         SELECT RANK, ELEMENT_ID, MAX_RANK, CHILD_COUNT
         FROM TMT_CRI
         WHERE LEVEL_ID = 1 AND PROJECT_ID = h_target_project_id
         AND SUBSTR(PARENT_RANK, 1, 4) = 'WBS#';

      CURSOR D_PRANK IS
         SELECT C.ELEMENT_ID , C.PARENT_ID , C.RANK,C.LEVEL_ID
         FROM TMT_CRI C, TMT_CRI P
         WHERE C.PARENT_RANK LIKE ('WBS#' || h_new_parent_rank || '%')
         AND C.PARENT_ID = P.ELEMENT_ID
         AND P.PARENT_RANK LIKE ('WBS#' || SUBSTR(h_new_parent_rank, 1, 8) || '%')
         AND P.PARENT_RANK <> C.PARENT_RANK
         AND SUBSTR(P.PARENT_RANK, 5,
         CASE WHEN LENGTH(P.PARENT_RANK) > (LENGTH(h_new_parent_rank) + 4)
         THEN 1 ELSE LENGTH(h_new_parent_rank) END) <> h_new_parent_rank;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_ATTACH_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_ATTACH_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_ATTACH_CRI(' || 
       '''' || h_old_parent_rank || ''''
          || ', ' || '''' || h_new_parent_rank || ''''
          || ', ' || '''' || h_target_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_ATTACH_CRI(50) : cri.sql(15695) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := PMO_CNST.SC_TABLE_CRI;
   
   h_len := Coalesce(Length(h_old_parent_rank), 0);
   h_len := Coalesce(h_len, 0);
   
   BEGIN
      SELECT PROJECT_ID INTO h_source_project_id
      FROM TMT_WBS
      WHERE RANK = h_old_parent_rank;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(68) : cri.sql(15713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_old_parent_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_old_parent_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_old_parent_rank, False); 
   	End If; 
   END;
   If PMO_ORASTD.strcmp(h_source_project_id, h_target_project_id) <> 0 Then
      BEGIN
         UPDATE RESOURCE_ASSIGNMENTS
         SET PROJECT_ID = h_target_project_id
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE PARENT_RANK LIKE ('WBS#' || h_old_parent_rank || '%') AND LEVEL_ID > 1);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(102) : cri.sql(15747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_CRI
      SET PROJECT_ID = h_target_project_id,
      PARENT_RANK =  'WBS#' || 
      CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN h_new_parent_rank
      ELSE RTRIM(h_new_parent_rank) || SUBSTR(PARENT_RANK, h_len +5,LENGTH(PARENT_RANK)-h_len -4) END
      WHERE PARENT_RANK LIKE ('WBS#' || h_old_parent_rank || '%') AND LEVEL_ID > 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(124) : cri.sql(15769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- using cursor to lock the row
   
   OPEN r_mdoc_root;
   
   FETCH r_mdoc_root INTO h_root_rank,h_root_id, h_root_max_rank,h_root_child_count;
   IF r_mdoc_root%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE r_mdoc_root;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 147+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(148) : cri.sql(15793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN D_PRANK;
   
   LOOP
      FETCH D_PRANK INTO h_element_id,h_parent_id,h_old_rank,h_old_level_id;
      IF D_PRANK%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
      h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
      
      PMO_STPU.toBase64(Coalesce(h_root_max_rank, 0), h_rankBase64);
      h_rank := h_root_rank;
      h_rank := h_rank || h_rankBase64;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_old_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_old_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_old_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CRI
         SET RANK = CASE WHEN ELEMENT_ID = h_element_id THEN h_rank
         ELSE RTRIM(h_rank) || 
         SUBSTR(RANK, LENGTH(h_old_rank) + 1, LENGTH(RANK) - LENGTH(h_old_rank)) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_element_id THEN h_root_id
         ELSE PARENT_ID END,
         LEVEL_ID = LEVEL_ID - h_old_level_id + 2
         WHERE RANK LIKE h_old_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(205) : cri.sql(15850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(224) : cri.sql(15869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_UPDATE_ATTACH_DOC(h_table_type, h_old_rank, h_rank, h_target_project_id);
      
      PMO_DB2M.SC_STATE := FC_UPDATE_ATTACH_SCD(h_table_type, h_old_rank, h_rank, h_target_project_id);
   END LOOP;
   BEGIN
      CLOSE D_PRANK;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 240+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(241) : cri.sql(15886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI
      SET MAX_RANK = h_root_max_rank, CHILD_COUNT = h_root_child_count
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_CRI', 259+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_CRI(260) : cri.sql(15905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_CRI', 265+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_ATTACH_CRI(266) : cri.sql(15911) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_CRI', 269+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_ATTACH_CRI(270) : cri.sql(15915) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_ATTACH_CRI;
ALTER FUNCTION FC_UPDATE_ATTACH_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_DUPLICATE_CRI_VIEW ==
CREATE OR REPLACE FUNCTION SP_DUPLICATE_CRI_VIEW
(
     p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_source_duplicate PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_keywords VARCHAR2(8000);
   h_fieldName VARCHAR2(255);
   h_search_by_name_condition VARCHAR2(8000);
   h_search_option PLS_INTEGER := 0;
   h_xsql VARCHAR2(2048);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      assigned_dup_cri PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      dup_cri_list PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DUPLICATE_CRI_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DUPLICATE_CRI_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_DUPLICATE_CRI_VIEW(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DUPLICATE_CRI_VIEW', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DUPLICATE_CRI_VIEW(39) : cri.sql(15964) : ' || SYSTIMESTAMP);
   END IF; 

   h_keywords := NULL;
   
   h_bitflag := p_bitflag;
   h_id := p_id;
   h_keywords := p_keywords;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      BEGIN
         SELECT DUPLICATE_KEY, SUBSTR(PARENT_RANK,1,12), PROJECT_ID
         INTO h_source_duplicate, h_parent_rank, h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(60) : cri.sql(15985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN assigned_dup_cri FOR SELECT CASE WHEN LEVEL_ID > 2 THEN 2 ELSE LEVEL_ID END AS LEVEL_ID,
      TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, 0 AS CHILD_COUNT,
      STAGE_ID, PRIORITY_ID, PRIORITY, REC_DATETIME, TARGET_DATE, CLIENT_NAME, REFERENCE_NUMBER, EXTERNAL_REFERENCE, PROPOSED_BY,
      CASE WHEN BITAND(RTF_BITS, 1) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 1)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF0 ,
      CASE WHEN BITAND(RTF_BITS, 2) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 2)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF1 ,
      CASE WHEN BITAND(RTF_BITS, 4) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 4)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF2 ,
      CASE WHEN BITAND(RTF_BITS, 8) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 8)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF3 ,
      CASE WHEN BITAND(RTF_BITS, 16) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 16)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF4 ,
      CASE WHEN BITAND(RTF_BITS, 32) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 32)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF5 ,
      CASE WHEN BITAND(RTF_BITS, 64) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 64)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF6 ,
      CASE WHEN BITAND(RTF_BITS, 128) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 128) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF7 ,
      CASE WHEN BITAND(RTF_BITS, 256) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 256) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF8 ,
      CASE WHEN BITAND(RTF_BITS, 512) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 512) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF9 ,
      WBS_ID, SUBSTR(ASSIGN_NAMES, 1, (InStr(ASSIGN_NAMES, ';') -1)) AS ASSIGN_RESPONSIBLE
      FROM TMT_CRI cri
      WHERE cri.PARENT_RANK LIKE  h_parent_rank || '%'
      AND cri.PROJECT_ID = h_project_id
      AND DUPLICATE_KEY = h_source_duplicate
      AND ELEMENT_ID <> h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DUPLICATE_CRI_VIEW', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_DUPLICATE_CRI_VIEW(95) : cri.sql(16020) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN assigned_dup_cri;
   Else
      -- select all cris with a specified type
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_DUP_VIEW';
      PMO_DB2M.SC_STATE := 0;
      
      -- build search by name or attribute name condition
      h_search_by_name_condition := '';
      
      BEGIN
         SELECT SUBSTR(PARENT_RANK, 1, 12), TYPE_ID, PROJECT_ID
         INTO h_parent_rank, h_source_type_id, h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(118) : cri.sql(16043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strcmp(h_keywords, 'EMPTY_TREE_FLAG') = 0 Then
         BEGIN
            INSERT INTO PMO_CRI_DUP_VIEW(ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, LEVEL_ID, TYPE_ID, EXTERNAL_REFERENCE, REFERENCE_NUMBER)
            SELECT C.ELEMENT_ID, C.PROJECT_ID, C.ELEMENT_NAME, C.LEVEL_ID, C.TYPE_ID, C.EXTERNAL_REFERENCE, C.REFERENCE_NUMBER
            FROM TMT_CRI C
            WHERE  C.ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(139) : cri.sql(16064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If ((h_keywords IS NOT NULL)) AND Coalesce(Length(h_keywords), 0) > 0 Then
            h_fieldName := 'C.ELEMENT_NAME(C),C.EXTERNAL_REFERENCE(C),C.REFERENCE_NUMBER(N)';
            h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
            
            If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
               h_keywords := NULL;
               h_search_by_name_condition := NULL;
            End If;
         End If;
         h_type_id := GetTaskType(Coalesce(h_source_type_id, 0));
         
         h_xsql := 
               'INSERT INTO PMO_CRI_DUP_VIEW(ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, LEVEL_ID, TYPE_ID, EXTERNAL_REFERENCE, REFERENCE_NUMBER) ';
         h_xsql := h_xsql || 
                    'SELECT C.ELEMENT_ID, C.PROJECT_ID, C.ELEMENT_NAME, C.LEVEL_ID, C.TYPE_ID, C.EXTERNAL_REFERENCE, C.REFERENCE_NUMBER ';
         h_xsql := h_xsql || 'FROM TMT_CRI C ';
         h_xsql := h_xsql || ' WHERE C.PROJECT_ID = ''';
         h_xsql := h_xsql || h_project_id;
         h_xsql := h_xsql || ''' AND ((C.PARENT_RANK LIKE ''';
         h_xsql := h_xsql || h_parent_rank;
         h_xsql := h_xsql || ''' || ''%'' ';
         h_xsql := h_xsql || ' AND (C.TYPE_ID IN (';
         h_xsql := h_xsql || TO_CHAR(h_source_type_id);
         h_xsql := h_xsql || ', ';
         h_xsql := h_xsql || TO_CHAR(h_type_id);
         h_xsql := h_xsql || ')))';
         h_xsql := h_xsql || ' OR C.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_project_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || ' AND C.ELEMENT_ID <> ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         
         If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
            h_xsql := h_xsql || ' AND ((';
            h_xsql := h_xsql || h_search_by_name_condition;
            h_xsql := h_xsql || ') OR C.ELEMENT_ID = ''';
            h_xsql := h_xsql || h_project_id;
            h_xsql := h_xsql || ''' ) ';
         End If;
         
         --trace_printf("\n h_xsql:%s", (char *)h_xsql);
         
         BEGIN
            EXECUTE IMMEDIATE h_xsql;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 198+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(199) : cri.sql(16124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
               END IF; 
            END;
         END;
         
         If ((h_search_by_name_condition IS NOT NULL)) 
               AND (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
               h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
            ora_temp_sc_state := PMO_DB2M.SC_STATE;
            null_return := FC_CLEANS_DUP_CRI_BY_NAME(h_search_option);
            PMO_DB2M.SC_STATE := ora_temp_sc_state;
         End If;
      End If;
      
      OPEN dup_cri_list FOR SELECT CASE WHEN cri.LEVEL_ID > 1 THEN 1 ELSE cri.LEVEL_ID END AS LEVEL_ID,
      CASE WHEN cri.LEVEL_ID = 0 THEN PMO_CNST.SC_FOLDER ELSE cri.TYPE_ID END AS TYPE_ID,
      cri.RANK, cri.PARENT_ID, cri.ELEMENT_ID, cri.ELEMENT_NAME, 0 AS CHILD_COUNT,
      cri.STAGE_ID, cri.PRIORITY_ID, cri.PRIORITY, cri.REC_DATETIME, cri.TARGET_DATE, cri.CLIENT_NAME, cri.REFERENCE_NUMBER, cri.EXTERNAL_REFERENCE, cri.PROPOSED_BY,
      COALESCE(r1.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF0,
      COALESCE(r2.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF1,
      COALESCE(r4.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF2,
      COALESCE(r8.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF3,
      COALESCE(r16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF4,
      COALESCE(r32.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF5,
      COALESCE(r64.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF6,
      COALESCE(r128.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF7,
      COALESCE(r512.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF8,
      WBS_ID, SUBSTR(ASSIGN_NAMES, 1, (InStr(ASSIGN_NAMES, ';') -1)) AS ASSIGN_RESPONSIBLE
      FROM TMT_CRI cri
      join PMO_CRI_DUP_VIEW C on  cri.ELEMENT_ID = C.ELEMENT_ID AND cri.PROJECT_ID = C.PROJECT_ID
      left join CRI_RTF r1 on r1.ELEMENT_ID = cri.ELEMENT_ID AND r1.BIT_FLAG = 1
      left join CRI_RTF r2 on r2.ELEMENT_ID = cri.ELEMENT_ID AND r2.BIT_FLAG = 2
      left join CRI_RTF r4 on r4.ELEMENT_ID = cri.ELEMENT_ID AND r4.BIT_FLAG = 4
      left join CRI_RTF r8 on r8.ELEMENT_ID = cri.ELEMENT_ID AND r8.BIT_FLAG = 8
      left join CRI_RTF r16 on r16.ELEMENT_ID = cri.ELEMENT_ID AND r16.BIT_FLAG = 16
      left join CRI_RTF r32 on r32.ELEMENT_ID = cri.ELEMENT_ID AND r32.BIT_FLAG = 32
      left join CRI_RTF r64 on r64.ELEMENT_ID = cri.ELEMENT_ID AND r64.BIT_FLAG = 64
      left join CRI_RTF r128 on r128.ELEMENT_ID = cri.ELEMENT_ID AND r128.BIT_FLAG = 128
      left join CRI_RTF r512 on  r512.ELEMENT_ID = cri.ELEMENT_ID AND r512.BIT_FLAG = 512
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DUPLICATE_CRI_VIEW', 240+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_DUPLICATE_CRI_VIEW(241) : cri.sql(16166) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN dup_cri_list;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_DUPLICATE_CRI_VIEW', 246+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_DUPLICATE_CRI_VIEW(247) : cri.sql(16172) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 253+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(254) : cri.sql(16179) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DUPLICATE_CRI_VIEW', 265+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DUPLICATE_CRI_VIEW(266) : cri.sql(16191) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DUPLICATE_CRI_VIEW;
ALTER FUNCTION SP_DUPLICATE_CRI_VIEW COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_DUPLICATE_CRI ==
CREATE OR REPLACE FUNCTION SP_S_DUPLICATE_CRI
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_source_duplicate PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_DUPLICATE PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_ALL_CRI PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_DUPLICATE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_DUPLICATE_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_S_DUPLICATE_CRI(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DUPLICATE_CRI', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_DUPLICATE_CRI(30) : cri.sql(16237) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      BEGIN
         SELECT DUPLICATE_KEY, SUBSTR(PARENT_RANK,1,12)
         INTO h_source_duplicate, h_parent_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DUPLICATE_CRI', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DUPLICATE_CRI(47) : cri.sql(16254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_DUPLICATE FOR SELECT CASE WHEN LEVEL_ID > 2 THEN 2 ELSE LEVEL_ID END AS LEVEL_ID,
      TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, 0 AS CHILD_COUNT,
      STAGE_ID, PRIORITY_ID, PRIORITY, REC_DATETIME, TARGET_DATE, CLIENT_NAME, REFERENCE_NUMBER, EXTERNAL_REFERENCE, PROPOSED_BY,
      CASE WHEN BITAND(RTF_BITS, 1) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 1)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF0 ,
      CASE WHEN BITAND(RTF_BITS, 2) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 2)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF1 ,
      CASE WHEN BITAND(RTF_BITS, 4) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 4)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF2 ,
      CASE WHEN BITAND(RTF_BITS, 8) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 8)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF3 ,
      CASE WHEN BITAND(RTF_BITS, 16) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 16)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF4 ,
      CASE WHEN BITAND(RTF_BITS, 32) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 32)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF5 ,
      CASE WHEN BITAND(RTF_BITS, 64) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 64)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF6 ,
      CASE WHEN BITAND(RTF_BITS, 128) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 128) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF7 ,
      CASE WHEN BITAND(RTF_BITS, 256) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 256) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF8 ,
      CASE WHEN BITAND(RTF_BITS, 512) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 512) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF9 ,
      WBS_ID, SUBSTR(ASSIGN_NAMES, 1, (InStr(ASSIGN_NAMES, ';') -1)) AS ASSIGN_RESPONSIBLE
      FROM TMT_CRI cri
      WHERE cri.PARENT_RANK LIKE  h_parent_rank || '%'
      AND DUPLICATE_KEY = h_source_duplicate
      AND ELEMENT_ID <> p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DUPLICATE_CRI', 80+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_DUPLICATE_CRI(81) : cri.sql(16288) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_DUPLICATE;
   Else
      BEGIN
         SELECT SUBSTR(PARENT_RANK, 1, 12), TYPE_ID, PROJECT_ID
         INTO h_parent_rank, h_source_type_id, h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DUPLICATE_CRI', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DUPLICATE_CRI(96) : cri.sql(16303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_type_id := GetTaskType(Coalesce(h_source_type_id, 0));
      
      OPEN C_ALL_CRI FOR SELECT CASE WHEN LEVEL_ID > 1 THEN 1 ELSE LEVEL_ID END AS LEVEL_ID,
      CASE WHEN LEVEL_ID = 0 THEN PMO_CNST.SC_FOLDER ELSE TYPE_ID END AS TYPE_ID,
      RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, 0 AS CHILD_COUNT,
      STAGE_ID, PRIORITY_ID, PRIORITY, REC_DATETIME, TARGET_DATE, CLIENT_NAME, REFERENCE_NUMBER, EXTERNAL_REFERENCE, PROPOSED_BY,
      CASE WHEN BITAND(RTF_BITS, 1) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 1)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF0 ,
      CASE WHEN BITAND(RTF_BITS, 2) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 2)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF1 ,
      CASE WHEN BITAND(RTF_BITS, 4) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 4)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF2 ,
      CASE WHEN BITAND(RTF_BITS, 8) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 8)   ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF3 ,
      CASE WHEN BITAND(RTF_BITS, 16) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 16)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF4 ,
      CASE WHEN BITAND(RTF_BITS, 32) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 32)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF5 ,
      CASE WHEN BITAND(RTF_BITS, 64) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 64)  ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF6 ,
      CASE WHEN BITAND(RTF_BITS, 128) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 128) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF7 ,
      CASE WHEN BITAND(RTF_BITS, 256) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 256) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF8 ,
      CASE WHEN BITAND(RTF_BITS, 512) > 0
      THEN (SELECT CLOB_DATA FROM CRI_RTF RTF WHERE RTF.ELEMENT_ID = cri.ELEMENT_ID AND BIT_FLAG = 512) ELSE (SELECT CLOB_DATA FROM EMPTYLOB) END AS RTF9 ,
      WBS_ID, SUBSTR(ASSIGN_NAMES, 1, (InStr(ASSIGN_NAMES, ';') -1)) AS ASSIGN_RESPONSIBLE
      FROM TMT_CRI cri
      WHERE ((cri.PARENT_RANK LIKE h_parent_rank || '%'
      AND (cri.TYPE_ID IN (h_source_type_id, h_type_id)))
      OR cri.ELEMENT_ID = h_project_id)
      AND ELEMENT_ID <> p_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DUPLICATE_CRI', 134+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_DUPLICATE_CRI(135) : cri.sql(16342) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_ALL_CRI;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_S_DUPLICATE_CRI', 140+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_S_DUPLICATE_CRI(141) : cri.sql(16348) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DUPLICATE_CRI', 147+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DUPLICATE_CRI(148) : cri.sql(16355) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DUPLICATE_CRI', 159+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DUPLICATE_CRI(160) : cri.sql(16367) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_DUPLICATE_CRI;
ALTER FUNCTION SP_S_DUPLICATE_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_DUPLICATE_CRI ==
CREATE OR REPLACE FUNCTION SP_A_DUPLICATE_CRI
(
     p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_source_duplicate PLS_INTEGER := 0;
   h_target_duplicate PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DUPLICATE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DUPLICATE_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DUPLICATE_CRI(' || 
       '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DUPLICATE_CRI', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DUPLICATE_CRI(21) : cri.sql(16404) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT DUPLICATE_KEY
      INTO h_source_duplicate
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(35) : cri.sql(16418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT DUPLICATE_KEY
      INTO h_target_duplicate
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(51) : cri.sql(16434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_source_duplicate IS NULL) Then
      BEGIN
         UPDATE TMT_SETTINGS
         SET SETTING_VALUE = SETTING_VALUE + 1
         WHERE ELEMENT_ID = 'MAX_CRI_DUPLICATE_KEY';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(71) : cri.sql(16454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT SETTING_VALUE
         INTO h_source_duplicate
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_CRI_DUPLICATE_KEY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(87) : cri.sql(16470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET DUPLICATE_KEY = h_source_duplicate
         WHERE ELEMENT_ID = p_source_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(106) : cri.sql(16489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_target_duplicate IS NULL) Then
      BEGIN
         UPDATE TMT_CRI
         SET DUPLICATE_KEY = h_source_duplicate
         WHERE ELEMENT_ID = p_target_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(127) : cri.sql(16510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET DUPLICATE_KEY = h_source_duplicate
         WHERE DUPLICATE_KEY = h_target_duplicate;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(146) : cri.sql(16529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DUPLICATE_CRI', 152+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DUPLICATE_CRI(153) : cri.sql(16536) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(h_source_duplicate), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_source_duplicate, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 159+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(160) : cri.sql(16543) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DUPLICATE_CRI', 171+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DUPLICATE_CRI(172) : cri.sql(16555) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DUPLICATE_CRI;
ALTER FUNCTION SP_A_DUPLICATE_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_UA_DUPLICATE_CRI ==
CREATE OR REPLACE FUNCTION SP_UA_DUPLICATE_CRI
(
     p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_DUPLICATE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_DUPLICATE_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_DUPLICATE_CRI(' || 
       '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DUPLICATE_CRI', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_DUPLICATE_CRI(19) : cri.sql(16590) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_CRI
      SET DUPLICATE_KEY = NULL
      WHERE ELEMENT_ID = p_source_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DUPLICATE_CRI', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DUPLICATE_CRI(36) : cri.sql(16607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_DUPLICATE_CRI', 41+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_DUPLICATE_CRI(42) : cri.sql(16613) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DUPLICATE_CRI', 48+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DUPLICATE_CRI(49) : cri.sql(16620) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DUPLICATE_CRI', 60+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DUPLICATE_CRI(61) : cri.sql(16632) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_DUPLICATE_CRI;
ALTER FUNCTION SP_UA_DUPLICATE_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CRI_ASSET ==
CREATE OR REPLACE FUNCTION SP_U_CRI_ASSET
(
     p_id VARCHAR2
   , p_asset_id VARCHAR2
   , p_asset_name VARCHAR2
   , p_financial_category PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_asset_id VARCHAR2(32);
   h_client_id VARCHAR2(32);
   h_asset_name VARCHAR2(100);
   h_old_asset_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_wbs_rank VARCHAR2(200);
   h_financial_category PLS_INTEGER := 0;
   h_old_financial_category PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_asset_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_financial_category), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ASSET', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_ASSET(40) : cri.sql(16688) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ASSET', 44+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ASSET(45) : cri.sql(16693) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ASSET', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ASSET(48) : cri.sql(16696) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_financial_category := p_financial_category;
   h_id := p_id;
   h_asset_id := p_asset_id;
   h_asset_name := p_asset_name;
   h_rec_user := p_rec_user;
   h_table_type := PMO_CNST.SC_TABLE_CRI;
   
   If (h_asset_name IS NULL) Then
      h_asset_id := NULL;
   End If;
   
   BEGIN
      SELECT PROJECT_ID, WBS_ID, ASSET_ID, RANK, ASSET_FLAG, CLIENT_ID,  FINANCIAL_CATEGORY, TYPE_ID, ELEMENT_NAME
      INTO h_project_id, h_wbs_id, h_old_asset_id, h_rank, h_asset_flag,
      h_client_id, h_old_financial_category, h_type_id, h_element_name
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(76) : cri.sql(16724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ASSET', 82+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ASSET(83) : cri.sql(16731) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ASSET(86) : cri.sql(16734) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (h_asset_id IS NOT NULL) Then
      If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ASSET', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ASSET(94) : cri.sql(16742) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ASSET', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ASSET(97) : cri.sql(16745) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
      ElsIf Coalesce(h_asset_flag, 0) = PMO_CNST.SC_HAS_ASSET Then
         If Coalesce(h_financial_category, 0) <> Coalesce(h_old_financial_category, 0) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            BEGIN
               UPDATE TMT_CRI
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 129+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(130) : cri.sql(16778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE ELEMENT_ID IN (SELECT WBS_ID FROM TMT_CRI
               WHERE RANK LIKE h_rank || '%'
               AND WBS_ID IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 151+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(152) : cri.sql(16800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If PMO_ORASTD.strcmp(h_old_asset_id, h_asset_id) <> 0 Then
            BEGIN
               UPDATE TMT_CRI
               SET ASSET_ID = h_asset_id,
               ASSET_NAME = h_asset_name,
               REC_USER = h_rec_user,
               REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID =  h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 175+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(176) : cri.sql(16824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_wbs_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_WBS
                  SET ASSET_ID = h_asset_id,
                  ASSET_NAME = h_asset_name,
                  REC_USER = h_rec_user,
                  REC_DATETIME = SYSTIMESTAMP
                  WHERE ELEMENT_ID =  h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 198+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(199) : cri.sql(16847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'I'
               WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 218+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(219) : cri.sql(16867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_id, h_element_name, h_asset_id, h_type_id
                                , h_rec_user);
            End If;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'D'
               WHERE PARENT_ID = h_old_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(243) : cri.sql(16891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U'
               WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 261+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(262) : cri.sql(16910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         -- there is asset assigned at project
         BEGIN
            SELECT 1 INTO h_count
            FROM TMT_WBS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id
            AND ASSET_FLAG = PMO_CNST.SC_HAS_ASSET;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 280+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(281) : cri.sql(16929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ASSET', 287+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ASSET(288) : cri.sql(16936) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ASSET', 290+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ASSET(291) : cri.sql(16939) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'D'
            WHERE (PARENT_ID, ELEMENT_ID) IN (SELECT ASSET_ID, ELEMENT_ID FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 323+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(324) : cri.sql(16972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI
            SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
            ASSET_ID = NuLL,
            ASSET_NAME = NuLL,
            FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 346+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(347) : cri.sql(16995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS
            SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
            ASSET_ID = NuLL,
            ASSET_NAME = NuLL,
            FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE ELEMENT_ID IN (SELECT WBS_ID FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%'
            AND WBS_ID IS NOT NuLL);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 371+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(372) : cri.sql(17020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI
            SET ASSET_ID = h_asset_id,
            ASSET_NAME = h_asset_name,
            ASSET_FLAG = PMO_CNST.SC_HAS_ASSET,
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID =  h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 394+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(395) : cri.sql(17043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_wbs_id IS NOT NULL) Then
            BEGIN
               UPDATE TMT_WBS
               SET ASSET_ID = h_asset_id,
               ASSET_NAME = h_asset_name,
               ASSET_FLAG = PMO_CNST.SC_HAS_ASSET,
               REC_USER = h_rec_user,
               REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID =  h_wbs_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 418+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(419) : cri.sql(17067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'I'
            WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 438+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(439) : cri.sql(17087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_id, h_element_name, h_asset_id, h_type_id
                                , h_rec_user);
         End If;
      End If;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      If (Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET) OR (Coalesce(
             h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET) Then
         If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U'
               WHERE (PARENT_ID, ELEMENT_ID) IN (SELECT ASSET_ID, ELEMENT_ID FROM TMT_CRI
               WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 480+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(481) : cri.sql(17129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TMT_CRI
            SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 501+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(502) : cri.sql(17150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS
            SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE ELEMENT_ID IN (SELECT WBS_ID FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%'
            AND WBS_ID IS NOT NuLL);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 523+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(524) : cri.sql(17172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CRI
            SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
            ASSET_ID = NuLL,
            ASSET_NAME = NuLL,
            FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 546+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(547) : cri.sql(17195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS
            SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
            ASSET_ID = NuLL,
            ASSET_NAME = NuLL,
            FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
            THEN h_financial_category ELSE FINANCIAL_CATEGORY END
            WHERE ELEMENT_ID IN (SELECT WBS_ID FROM TMT_CRI
            WHERE RANK LIKE h_rank || '%'
            AND WBS_ID IS NOT NuLL);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 571+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(572) : cri.sql(17220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'D'
            WHERE PARENT_ID = h_old_asset_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 590+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(591) : cri.sql(17239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_ASSET', 602+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_ASSET(603) : cri.sql(17251) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 610+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(611) : cri.sql(17259) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ASSET', 622+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ASSET(623) : cri.sql(17271) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_ASSET;
ALTER FUNCTION SP_U_CRI_ASSET COMPILE DEBUG;

/***************************************************************/

Prompt == FUNCTION SP_U_CRI_ELEMENT_FLAG ==
CREATE OR REPLACE FUNCTION SP_U_CRI_ELEMENT_FLAG
(
     p_id VARCHAR2
   , p_element_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_id VARCHAR2(32);
   h_element_flag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_ELEMENT_FLAG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_ELEMENT_FLAG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_ELEMENT_FLAG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_element_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ELEMENT_FLAG', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_ELEMENT_FLAG(22) : cri.sql(17309) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_ELEMENT_FLAG', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_ELEMENT_FLAG(27) : cri.sql(17314) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_ELEMENT_FLAG', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRI_ELEMENT_FLAG(30) : cri.sql(17317) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_element_flag := p_element_flag;
   
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_FLAG = h_element_flag
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ELEMENT_FLAG', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ELEMENT_FLAG(53) : cri.sql(17340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_ELEMENT_FLAG', 58+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_ELEMENT_FLAG(59) : cri.sql(17346) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ELEMENT_FLAG', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ELEMENT_FLAG(67) : cri.sql(17354) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_ELEMENT_FLAG', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_ELEMENT_FLAG(79) : cri.sql(17366) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_ELEMENT_FLAG;
ALTER FUNCTION SP_U_CRI_ELEMENT_FLAG COMPILE DEBUG;

