-- already in pmo_sqlprep.h : #include "pmodefines.h"

/**************************************************************************/

Prompt == FUNCTION FC_CHECK_NEW_ID ==
CREATE OR REPLACE FUNCTION FC_CHECK_NEW_ID
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_res_id IN OUT NOCOPY VARCHAR2
   , h_plan_id IN OUT NOCOPY VARCHAR2
   , h_sched_id IN OUT NOCOPY VARCHAR2
   , data_flag IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := 0;
   h_assign_flag VARCHAR2(1);
-- Declare Cursors
      CURSOR C_OLD_ID IS
         SELECT * FROM (SELECT BIT_FLAG FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id AND RESOURCE_ID = h_res_id
         ) WHERE ROWNUM<=1;

      CURSOR C_NEW_PA1 IS
         SELECT * FROM (SELECT BIT_FLAG FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_plan_id ) WHERE ROWNUM<=1;

      CURSOR C_NEW_PA2 IS
         SELECT * FROM (SELECT BIT_FLAG FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_sched_id ) WHERE ROWNUM<=1;

      CURSOR C_NEW_TA1 IS
         SELECT * FROM (SELECT BIT_FLAG FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id AND RESOURCE_ID = h_plan_id ) WHERE ROWNUM<=1;

      CURSOR C_NEW_TA2 IS
         SELECT * FROM (SELECT BIT_FLAG FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id AND RESOURCE_ID = h_sched_id ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_NEW_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_NEW_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_NEW_ID(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_res_id || ''''
          || ', ' || '''' || h_plan_id || ''''
          || ', ' || '''' || h_sched_id || ''''
          || ', ' || COALESCE(TO_CHAR(data_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_NEW_ID', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_NEW_ID(45) : unassign_res.sql(50) : ' || SYSTIMESTAMP);
   END IF; 

   -- Check if the old res id has PA (if YES, set h_bitflag = 1)
   
   OPEN C_OLD_ID;
   
   FETCH C_OLD_ID INTO h_assign_flag;
   IF C_OLD_ID%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_bitflag := 1;
   Else
      h_bitflag := 0;
   End If;
   
   BEGIN
      CLOSE C_OLD_ID ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_NEW_ID', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_NEW_ID(73) : unassign_res.sql(78) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   data_flag := 0;
   
   If Coalesce(h_bitflag, 0) = 1 Then
      If (h_plan_id IS NOT NULL) Then
         OPEN C_NEW_PA1;
         
         FETCH C_NEW_PA1 INTO h_assign_flag;
         IF C_NEW_PA1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            data_flag := 1;
         End If;
         
         BEGIN
            CLOSE C_NEW_PA1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_NEW_ID', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_NEW_ID(103) : unassign_res.sql(108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (data_flag = 0) AND ((h_sched_id IS NOT NULL)) Then
         OPEN C_NEW_PA2;
         
         FETCH C_NEW_PA2 INTO h_assign_flag;
         IF C_NEW_PA2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            data_flag := 2;
         End If;
         
         BEGIN
            CLOSE C_NEW_PA2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_NEW_ID', 130+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_NEW_ID(131) : unassign_res.sql(136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If (h_plan_id IS NOT NULL) Then
         OPEN C_NEW_TA1;
         
         FETCH C_NEW_TA1 INTO h_assign_flag;
         IF C_NEW_TA1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            data_flag := 1;
         End If;
         
         BEGIN
            CLOSE C_NEW_TA1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_NEW_ID', 158+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_NEW_ID(159) : unassign_res.sql(164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (data_flag = 0) AND ((h_sched_id IS NOT NULL)) Then
         OPEN C_NEW_TA2;
         
         FETCH C_NEW_TA2 INTO h_assign_flag;
         IF C_NEW_TA2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            data_flag := 2;
         End If;
         
         BEGIN
            CLOSE C_NEW_TA2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_NEW_ID', 186+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_NEW_ID(187) : unassign_res.sql(192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_NEW_ID', 194+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_NEW_ID(195) : unassign_res.sql(200) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_NEW_ID;
ALTER FUNCTION FC_CHECK_NEW_ID COMPILE DEBUG;

/**************************************************************************
    Always reschedule or ETC the new assignment.
        1. If new assignment is in plan mode reschedule the old remaining
        2. If new assignment is in schedule mode etc the old remaining

    If old assignment has no actual delete RA  TA.
**************************************************************************/

Prompt == FUNCTION FC_MERGE_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_MERGE_ASSIGN
(
     sh_h_bitflag PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_task_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_assign_id IN OUT NOCOPY VARCHAR2
   , h_res_assignment_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_effort PLS_INTEGER
   , sh_l_has_actual PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_effort PLS_INTEGER := sh_h_effort;
   l_has_actual PLS_INTEGER := Coalesce(sh_l_has_actual, 0);
   h_temp_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_start_D DATE;
   h_start_DT TIMESTAMP;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_remaining PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_minutes PLS_INTEGER := 0;
   h_skip PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_planned_work PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_reg_sale NUMBER := 0.00;
   h_reg_cost NUMBER := 0.00;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_ASSIGN(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_task_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_assign_id || ''''
          || ', ' || '''' || h_res_assignment_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_effort), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_l_has_actual), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_ASSIGN', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_ASSIGN(56) : unassign_res.sql(272) : ' || SYSTIMESTAMP);
   END IF; 

   h_skip := 0;
   --trace_printf("l_has_actual: %d, h_effort: %d, h_assign_id: %s, h_resource_id: %s, h_bitflag: %d\n",l_has_actual,h_effort,h_assign_id,h_resource_id,h_bitflag);
   
   BEGIN
      SELECT RES_ASSIGNMENT_ID, PARTICIPANT INTO h_res_assignment_id, h_participant
      FROM RESOURCE_ASSIGNMENTS
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND RESOURCE_ID = h_resource_id
      AND RES_ASSIGNMENT_ID <> h_assign_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(73) : unassign_res.sql(289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RA_* SC_STATE: %d, h_task_id: %s, h_res_assignment_id: %d:%s, h_participant: %d\n",SC_STATE,h_task_id,h_res_assignment_id_Ind,h_res_assignment_id,h_participant);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_prj_assignment_id := NULL;
      If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) > 0 Then
         BEGIN
            SELECT TSK_ASSIGNMENT_ID, WORK_TODATE, PLANNED_WORK, SCHED_WORK - WORK_TODATE, C_EFFORT, C_CONTOUR,
            CASE WHEN WORK_TODATE = 0 THEN TO_DATE(SubStr(COALESCE(SCHED_FINISH, PLANNED_START), 1, 10)) ELSE LAST_SUBMITTED END,
            TO_DATE(SubStr(START_DT, 1, 10)), TO_DATE(SubStr(FINISH_DT, 1, 10)), BILLABLE, CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE
            INTO h_tsk_assignment_id, h_work_todate, h_planned_work, h_remaining, h_work, h_contour,
            h_start_D,
            h_SD, h_FD, h_billable, h_capital_expense, h_reg_cost, h_reg_sale
            FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 95+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(96) : unassign_res.sql(312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("TA_* SC_STATE: %d, h_tsk_assignment_id: %s, h_remaining: %d, h_planned_work: %d, h_work_todate: %d, h_start_D: %s, h_start_DT: %s\n",SC_STATE,h_tsk_assignment_id,h_remaining,h_planned_work,h_work_todate,h_start_D,h_start_DT);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(h_start_D, 1, 10)), PMO_ORASTD.TIME('08:00') ) + 1      INTO h_start_DT
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 111+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(112) : unassign_res.sql(328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("l_has_actual: %d, h_work_todate: %d, h_res_assignment_id: %s\n",l_has_actual,h_work_todate,h_res_assignment_id);
            If l_has_actual = 1 Then
               -- get old res TA
               BEGIN
                  SELECT TSK_ASSIGNMENT_ID, LAST_SUBMITTED, SCHED_WORK - WORK_TODATE, C_EFFORT
                  INTO h_temp_id, h_start_D, h_sched_work, h_work
                  FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 129+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(130) : unassign_res.sql(346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("OLD_ACTUAL SC_STATE: %d, h_temp_id: %s, h_sched_work: %d, h_start_D: %s\n",SC_STATE,h_temp_id,h_sched_work,h_start_D);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  h_temp_var := 0;
                  h_skip := FC_DEL_WITHACTUAL(h_project_id, h_temp_id, h_start_D, h_sched_work, h_work
                            , h_prj_assignment_id, h_temp_var);
                  
                  h_temp_var := 3;
                  h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_temp_id, h_temp_var, 0, 0);
               End If;
            Else
               -- get old res TA
               BEGIN
                  SELECT TSK_ASSIGNMENT_ID, PLANNED_WORK, SCHED_WORK
                  INTO h_temp_id, h_minutes, h_sched_work
                  FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 155+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(156) : unassign_res.sql(372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("OLD_SCHED SC_STATE: %d, h_temp_id: %s, h_minutes: %d, h_sched_work: %d\n",SC_STATE,h_temp_id,h_minutes,h_sched_work);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  If Coalesce(h_minutes, 0) = 0 Then
                     -- fix new res TA
                     h_skip := FC_DEL_NOACTUAL(h_project_id, h_temp_id, 0);
                     
                     h_remaining := Coalesce(h_sched_work, 0);
                  Else
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR 
                        WHERE PROJECT_ID = h_project_id 
                        AND TSK_ASSIGNMENT_ID = h_temp_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 182+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(183) : unassign_res.sql(399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     h_remaining := Coalesce(h_minutes, 0);
                  End If;
               End If;
            End If;
            
            --trace_printf("*** h_remaining: %d\n", h_remaining);
            If Coalesce(h_remaining, 0) > 0 Then
               --trace_printf("h_effort: %d, h_planned_work: %d, h_tsk_assignment_id: %d:%s, h_start_DT: %d:%s\n",h_effort,h_remaining,h_tsk_assignment_id_Ind,h_tsk_assignment_id,h_start_DT_Ind,h_start_DT);
               If Coalesce(h_planned_work, 0) > 0 Then
                  h_tph_delete := -1;
                  PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_SD, h_FD
                                            , h_reg_cost, h_reg_sale, h_tph_delete
                                            , h_capital_expense, h_billable);
                  
                  h_temp_var := 2;
                  h_temp_sc_state := FC_RESCHEDULE(h_tsk_assignment_id, h_start_DT, h_remaining, h_temp_var, h_contour
                                 , h_rec_user, 0, 0);
                  
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET ETC = h_remaining, FORECAST_START = NuLL, FORECAST_FINISH = NuLL, FORECAST_DURATION = 0
                     WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 218+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(219) : unassign_res.sql(435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET ETC = h_remaining, FORECAST_START = NuLL, FORECAST_FINISH = NuLL, FORECAST_DURATION = 0
                     WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 236+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(237) : unassign_res.sql(453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         
         If l_has_actual = 0 Then
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 257+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(258) : unassign_res.sql(474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("DELETE_RA: SC_STATE: %d,h_assign_id: %d:%s\n",SC_STATE,h_assign_id_Ind,h_assign_id);
            
            BEGIN
               DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_temp_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSIGN', 275+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSIGN(276) : unassign_res.sql(492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("DELETE: SC_STATE: %d,h_temp_id: %d:%s\n",SC_STATE,h_temp_id_Ind,h_temp_id);
         End If;
         
         PMO_DB2M.SC_STATE := 1;
      End If;
   Else
      PMO_DB2M.SC_STATE := 200;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_ASSIGN', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_ASSIGN(290) : unassign_res.sql(506) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_ASSIGN;
ALTER FUNCTION FC_MERGE_ASSIGN COMPILE DEBUG;

/****************************************************************************************************************
 delete resource/profile assignment with actual
 from RES_ASSIGNMENTS, TASK_ASSIGNMENTS, TASK_DAY_OF_YEAR for a given tsk_assignment_id
*****************************************************************************************************************
DeCommission Project --------------------------------------------------------------------------------------------
 p_id      = PROJECT_ID
 p_res_id  = NULL
 p_bitflag = 15 then delete            all assignments with effort
           = 14 then delete to profile all assignments with effort

BOTTOM  window --------------------------------------------------------------------------------------------------
 TASK
 if data_flag = 1 then check for actual
              = 0 then delete assignment
 p_bitflag = 0 remove the current assignment (id = TSK_ASSIGNMENT_ID)
           = 3 check for actual If exists then return error 200123 (CANNOT_DEL_ACTUAL_EXISTS) (id = PROJECT_ID)

******************************************************************************************************************/

Prompt == FUNCTION SP_D_TSKRES_ACT ==
CREATE OR REPLACE FUNCTION SP_D_TSKRES_ACT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_res_id VARCHAR2
   , p_rec_user VARCHAR2
   , data_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_week_of DATE;
   h_start_D DATE;
   h_bitflag PLS_INTEGER := 0;
   h_data_flag PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_mls_percent PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_TSKRES_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_TSKRES_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_TSKRES_ACT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_res_id || ''''
          || ', ' || '''' || p_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(data_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TSKRES_ACT', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_TSKRES_ACT(34) : unassign_res.sql(567) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_id := p_id;
   h_res_id := p_res_id;
   h_rec_user := p_rec_user;
   h_data_flag := data_flag;
   
   --    if ( (h_data_flag == 1)  (h_bitflag == 0) ) //check for bitflag and existance of actual
   --    {
   --        BEGIN_SQL
   --            SELECT RES_ASSIGNMENT_ID INTO HOST(h_assign_id)
   --            FROM RESOURCE_ASSIGNMENTS
   --            WHERE RES_ASSIGNMENT_ID = HOST(h_id) ;
   --        END_SQL;
   --
   --        if (SC_NODATA)
   --        {
   --            h_mls_percent = 0;
   --            Nullify(SC_PARAM(h_start_D));
   --            BEGIN_SQL
   --                SELECT PROJECT_ID, DATE(LAST_SUBMITTED), MILESTONE_PERCENT
   --                INTO HOST(h_project_id), HOST(h_start_D), HOST(h_mls_percent)
   --                FROM TASK_ASSIGNMENTS
   --                WHERE TSK_ASSIGNMENT_ID = HOST(h_id) AND ACTUAL_START IS NOT NuLL ;
   --            END_SQL;
   --
   --            if ( (SC_SUCCESS)  (IsNotNullParam(h_start_D)))
   --            {
   --                if (h_mls_percent == 10000)
   --                {
   --                    Nullify(SC_PARAM(h_week_of));
   --                    BEGIN_SQL
   --                        SELECT MAX(WEEK_OF) + 7 DAYS INTO HOST(h_week_of)
   --      FROM TIMESHEET_APPROVAL_STATUS
   --                        WHERE ELEMENT_ID = HOST(h_project_id) AND RESOURCE_ID = HOST(h_res_id)
   --                        AND CURRENT_STATE IN (SC_APV_STATE_RM_APPROVED,SC_APV_STATE_PM_APPROVED);
   --                    END_SQL;
   --
   --                    if ( (IsNotNullParam(h_week_of))  (strcmp(h_week_of,h_start_D) > 0) )
   --                    {
   --                        RETURN_ERROR(TS_APPROVAL_EXISTS, h_id);
   --                    }
   --                }
   --
   --                RETURN_ERROR(CANNOT_DEL_ACTUAL_EXISTS, h_id);
   --            }
   --        }
   --
   --        SC_STATE = FC_D_TSKRES_ACT(SC_PARAM(h_id), SC_PARAM(h_bitflag), SC_PARAM(h_res_id), SC_PARAM(h_rec_user));
   --    }
   --    else
   --    {
   PMO_DB2M.SC_STATE := FC_D_TSKRES_ACT(h_id, h_bitflag, h_res_id, h_rec_user);
   --    }
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_TSKRES_ACT', 95+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_TSKRES_ACT(96) : unassign_res.sql(629) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TSKRES_ACT', 102+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TSKRES_ACT(103) : unassign_res.sql(636) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TSKRES_ACT', 114+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TSKRES_ACT(115) : unassign_res.sql(648) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_TSKRES_ACT;
ALTER FUNCTION SP_D_TSKRES_ACT COMPILE DEBUG;

/****************************************************************************************************************
 delete resource/profile assignment from RES_ASSIGNMENTS, TASK_ASSIGNMENTS, TASK_DAY_OF_YEAR for a given tsk_assignment_id
 *** only for MSP ***
*****************************************************************************************************************
BOTTOM  window --------------------------------------------------------------------------------------------------
 TASK
 p_bitflag = 0 remove the current assignment                            (id = TSK_ASSIGNMENT_ID)
           = 1 replace the current assignment with a profile            (id = TSK_ASSIGNMENT_ID)

******************************************************************************************************************/

Prompt == FUNCTION SP_D_TSKRES ==
CREATE OR REPLACE FUNCTION SP_D_TSKRES
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_res_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   iRet PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_TSKRES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_TSKRES'), '-- ' || SYSTIMESTAMP, ':r := SP_D_TSKRES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_res_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TSKRES', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_TSKRES(27) : unassign_res.sql(700) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_id := p_id;
   h_res_id := p_res_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_28 Then
      h_rollup := 1;
      -- set do not rollup (import from MSP)
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_00FFFFFF));
      -- remove set do not rollup
   Else
      h_rollup := 0;
      -- set rollup
   End If;
   
   -- delete or replace from top window (at project level) moved to another store procedure
   If ((Coalesce(h_bitflag, 0) > 110) AND (Coalesce(h_bitflag, 0) < 333)) OR ((Coalesce(
              h_bitflag, 0) > 3) AND (Coalesce(h_bitflag, 0) < 10)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_TSKRES', 48+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_TSKRES(49) : unassign_res.sql(722) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TSKRES', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_TSKRES(52) : unassign_res.sql(725) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   iRet := FC_D_TSKRES_ACT(h_id, h_bitflag, h_res_id, h_rec_user);
   
   If iRet = 100 Then
      iRet := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_TSKRES', 63+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_TSKRES(64) : unassign_res.sql(737) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(iRet), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(iRet, h_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TSKRES', 71+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TSKRES(72) : unassign_res.sql(745) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TSKRES', 83+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TSKRES(84) : unassign_res.sql(757) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_TSKRES;
ALTER FUNCTION SP_D_TSKRES COMPILE DEBUG;

/******************************************************************************************************************
TOP     window --------------------------------------------------------------------------------------------------
    Proposed Effort (Planned):
        1   Remove proposed effort
        2   Maitain proposed effort
        3   Replace proposed effort

    Planned Effort (Sched):
        1   Remove planned effort
        2   Maitain planned effort
        3   Replace planned effort

    Participant:
        1   Maintain all participant
        2   Remove all participant

    p_bitflag:
        111 Remove proposed and planned effort. Don't delete any participant.               (5)
        112 Remove proposed and planned effort. Delete all participant.                     (20)
        121 Remove proposed effort. Don't delete any participant.                           (7)
        122 Remove proposed effort. Delete all participant.                                 (26)
        131 Remove proposed effort. Replace planned effort. Don't delete any participant.   (7  8)
        132 Remove proposed effort. Replace planned effort. Delete all participant.         (7  32) or (26  8)

        211 Remove planned effort. Don't delete any participant.                            (6)
        212 Remove planned effort. Delete all participant.                                  (23)
        221 Do Nothing.
        222 Delete all participant.                                                         (new)
        231 Replace planned effort. Don't delete any participant.                           (8)
        232 Replace planned effort. Delete all participant.                                 (32)

        311 Replace proposed effort. Remove planned effort. Don't delete any participant.   (9  6)
        312 Replace proposed effort. Remove planned effort. Delete all participant.         (9  23) or (35  6)
        321 Replace proposed effort. Don't delete any participant.                          (9)
        322 Replace proposed effort. Delete all participant.                                (35)
        331 Replace proposed effort. Replace planned effort. Don't delete any participant.  (9  8)
        332 Replace proposed effort. Replace planned effort. Delete all participant.        (9  32) or (35  8)
******************************************************************************************************************/

Prompt == FUNCTION SP_D_PRJRES ==
CREATE OR REPLACE FUNCTION SP_D_PRJRES
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_res_id VARCHAR2
   , p_plan_id VARCHAR2
   , p_sched_id VARCHAR2
   , p_participant_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_plan_id VARCHAR2(32);
   h_sched_id VARCHAR2(32);
   h_participant_id VARCHAR2(32);
   h_profile_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_start_DT TIMESTAMP;
   h_finish_DT TIMESTAMP;
   h_participant PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_res_type VARCHAR2(1);
   iRet PLS_INTEGER NOT NULL := 0;
   l_data_flag PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CDPRJ2 IS
         SELECT WORK_TODATE
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id AND WORK_TODATE > 0;

      CURSOR C_D_ALL_RES IS
         SELECT RESOURCE_ID FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID = h_project_id;

      CURSOR CDRP1 IS
         SELECT PROFILE_ID
         FROM PMO_TMP_DELETE;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PRJRES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PRJRES'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PRJRES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_res_id || ''''
          || ', ' || '''' || p_plan_id || ''''
          || ', ' || '''' || p_sched_id || ''''
          || ', ' || '''' || p_participant_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PRJRES', 58+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PRJRES(59) : unassign_res.sql(869) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_project_id := p_id;
   h_res_id := p_res_id;
   h_plan_id := p_plan_id;
   h_sched_id := p_sched_id;
   h_participant_id := p_participant_id;
   h_rec_user := p_rec_user;
   h_duration := 0;
   --trace_printf("0__* START: h_res_id = %d;%s\n", h_res_id_Ind,h_res_id);
   
   -- delete or replace from top window (at project level) moved to another store procedure
   If Coalesce(h_bitflag, 0) < 111 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_PRJRES', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_PRJRES(75) : unassign_res.sql(885) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PRJRES', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_PRJRES(78) : unassign_res.sql(888) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   If ((h_plan_id IS NOT NULL)) OR ((h_sched_id IS NOT NULL)) Then
      iRet := FC_CHECK_NEW_ID(h_project_id, h_res_id, h_plan_id, h_sched_id, l_data_flag);
      
      If l_data_flag <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_PRJRES', 87+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_PRJRES(88) : unassign_res.sql(898) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_REPLACE_PA_EXISTS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PRJRES', 90+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_PRJRES(91) : unassign_res.sql(901) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_REPLACE_PA_EXISTS, True);
      End If;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DELETE';
   PMO_DB2M.SC_STATE := 0;
   
   h_start_DT := '';
   h_finish_DT := '';
   h_participant := 0;
   h_work_todate := 0;
   
   BEGIN
      SELECT UNRESOLVED_START INTO h_start_DT FROM TMT_WBS WHERE ELEMENT_ID=h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(114) : unassign_res.sql(924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE = %d, h_start_DT = %d;%s, h_project_id = %d:%s\n", SC_STATE,h_start_DT_Ind,h_start_DT,h_project_id_Ind,h_project_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_PRJRES', 121+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_PRJRES(122) : unassign_res.sql(932) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PRJRES', 124+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_PRJRES(125) : unassign_res.sql(935) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True);
   ElsIf Coalesce(Length(h_start_DT), 0) > 9 Then
      OPEN CDPRJ2;
      
      FETCH CDPRJ2 INTO h_work_todate;
      IF CDPRJ2%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE CDPRJ2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(146) : unassign_res.sql(956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("*** h_work_todate = %d\n",h_work_todate);
   Else
      h_participant := 1;
   End If;
   --trace_printf("h_start_DT: %d;%s, h_participant: %d, h_work_todate: %d, h_bitflag: %d\nh_project_id: %d:%s, h_res_id: %s\n", h_start_DT_Ind,h_start_DT,h_participant,h_work_todate,h_bitflag,h_project_id_Ind,h_project_id,h_res_id);
   
   If (Coalesce(h_participant, 0) = 0) AND (Coalesce(h_work_todate, 0) > 0) Then
      h_temp_sc_state := FC_DECLARE_PMO_TMP_SEARCH();
      h_temp_sc_state := FC_CREATE_CDY(h_project_id, h_start_DT, h_finish_DT, h_duration);
   End If;
   
   If Coalesce(h_bitflag, 0) = 131 Then
      h_temp_bitflag := 121;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 231;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   ElsIf Coalesce(h_bitflag, 0) = 132 Then
      h_temp_bitflag := 121;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 232;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   ElsIf Coalesce(h_bitflag, 0) = 311 Then
      h_temp_bitflag := 321;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 211;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   ElsIf Coalesce(h_bitflag, 0) = 312 Then
      h_temp_bitflag := 321;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 212;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   ElsIf Coalesce(h_bitflag, 0) = 331 Then
      h_temp_bitflag := 321;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 231;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   ElsIf Coalesce(h_bitflag, 0) = 332 Then
      h_temp_bitflag := 321;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      
      h_temp_bitflag := 232;
      iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_temp_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
   Else
      If (h_res_id IS NOT NULL) Then
         iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
      Else
         -- Decommission, get all resources whitin the project
         
         OPEN C_D_ALL_RES;
         
         LOOP
            FETCH C_D_ALL_RES INTO h_res_id;
            IF C_D_ALL_RES%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            --trace_printf("i_* SC_STATE: %d, h_res_id: %d %s\n",SC_STATE, h_res_id_Ind,h_res_id);
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            iRet := FC_D_RES_FROM_PROJECT(h_project_id, h_res_id, h_bitflag, h_plan_id, h_sched_id
                              , h_participant_id, h_rec_user);
         END LOOP;
         
         BEGIN
            CLOSE C_D_ALL_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(243) : unassign_res.sql(1053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   --trace_printf("iRet = %d, h_bitflag = %d\n", iRet,h_bitflag);
   
   If iRet = 0 Then
      OPEN CDRP1;
      
      LOOP
         FETCH CDRP1 INTO h_profile_id;
         IF CDRP1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_temp_res_type := '1';
         h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_profile_id, h_temp_res_type);
      END LOOP;
      
      BEGIN
         CLOSE CDRP1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(277) : unassign_res.sql(1087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_res_type := '0';
      h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_res_id, h_temp_res_type);
      --trace_printf("h_temp_sc_state  =%d, h_project_id = %d, %s\n", h_temp_sc_state,h_project_id_Ind,h_project_id);
      
      h_temp_sc_state := FC_U_APVS_PROJECT(h_project_id);
      --      BEGIN_SQL
      --          DELETE FROM TIMESHEET_APPROVAL_STATUS
      --          WHERE ELEMENT_ID = HOST(h_project_id)
      --              AND RESOURCE_ID NOT IN (SELECT DISTINCT RESOURCE_ID
      --                  FROM TASK_ASSIGNMENTS
      --                  WHERE PROJECT_ID = HOST(h_project_id) AND TASK_ID <> PROJECT_ID);
      --      END_SQL;
      --trace_printf("SC_STATE  =%d, h_project_id = %s\n", SC_STATE,h_project_id);
      
      h_temp_sc_state := FC_Rollup(h_project_id);
      -- New Rollup
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PRJRES', 300+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PRJRES(301) : unassign_res.sql(1111) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(iRet), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(iRet, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 307+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(308) : unassign_res.sql(1118) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PRJRES', 319+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PRJRES(320) : unassign_res.sql(1130) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PRJRES;
ALTER FUNCTION SP_D_PRJRES COMPILE DEBUG;

/****************************************************************************************************************
 delete a given resource (h_res_id) from a given project (h_project_id) or all projects (h_project_id is null)

 bitflag:
        111 Remove proposed and planned effort. Don't delete any participant.               (5)
        112 Remove proposed and planned effort. Delete all participant.                     (20)
        121 Remove proposed effort. Don't delete any participant.                           (7)
        122 Remove proposed effort. Delete all participant.                                 (26)
        131 Remove proposed effort. Replace planned effort. Don't delete any participant.   (7  8)
        132 Remove proposed effort. Replace planned effort. Delete all participant.         (7  32) or (26  8)

        211 Remove planned effort. Don't delete any participant.                            (6)
        212 Remove planned effort. Delete all participant.                                  (23)
        221 Do Nothing.
        222 Delete all participant.                                                         (new)
        231 Replace planned effort. Don't delete any participant.                           (8)
        232 Replace planned effort. Delete all participant.                                 (32)

        311 Replace proposed effort. Remove planned effort. Don't delete any participant.   (9  6)
        312 Replace proposed effort. Remove planned effort. Delete all participant.         (9  23) or (35  6)
        321 Replace proposed effort. Don't delete any participant.                          (9)
        322 Replace proposed effort. Delete all participant.                                (35)
        331 Replace proposed effort. Replace planned effort. Don't delete any participant.  (9  8)
        332 Replace proposed effort. Replace planned effort. Delete all participant.        (9  32) or (35  8)

******************************************************************************************************************/

Prompt == FUNCTION FC_D_RES_FROM_PROJECT ==
CREATE OR REPLACE FUNCTION FC_D_RES_FROM_PROJECT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_res_id IN OUT NOCOPY VARCHAR2
   , sh_bitflag001 PLS_INTEGER
   , h_plan_id IN OUT NOCOPY VARCHAR2
   , h_sched_id IN OUT NOCOPY VARCHAR2
   , h_participant_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   bitflag001 PLS_INTEGER := sh_bitflag001;
   h_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_assign_flag VARCHAR2(1);
   h_temp_var PLS_INTEGER := 0;
   iRet PLS_INTEGER := 0;
   h_participant_res_id VARCHAR2(32);
   h_plan_res_id VARCHAR2(32);
   h_sched_res_id VARCHAR2(32);
-- Declare Cursors
      CURSOR C_D_ALL_E IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID, BIT_FLAG
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND MILESTONE_PERCENT <> 10000 AND
         (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL);

      CURSOR C_D_SCHED_E IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '2'
         AND (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL)
         AND MILESTONE_PERCENT <> 10000;

      CURSOR C_D_PLANNED_E IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '0'
         AND (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL);

      CURSOR C_R_ALL_E IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID, BIT_FLAG
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL)
         AND MILESTONE_PERCENT <> 10000;

      CURSOR C_R_SCHED_E IS
         SELECT TSK_ASSIGNMENT_ID,PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND BIT_FLAG = '2'
         AND RESOURCE_ID = h_res_id
         AND (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL)
         AND MILESTONE_PERCENT <> 10000;

      CURSOR C_R_PLANNED_E IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND BIT_FLAG = '0'
         AND RESOURCE_ID = h_res_id
         AND (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL);

      CURSOR C_D_ALL_P IS
         SELECT ra.RES_ASSIGNMENT_ID
         FROM RESOURCE_ASSIGNMENTS ra LEFT JOIN TASK_ASSIGNMENTS TA
         ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID
         WHERE ra.PROJECT_ID = h_project_id
         AND ra.RESOURCE_ID = h_res_id
         AND TA.TSK_ASSIGNMENT_ID IS NuLL;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_RES_FROM_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_RES_FROM_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_RES_FROM_PROJECT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_res_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_bitflag001), 'NULL')
          || ', ' || '''' || h_plan_id || ''''
          || ', ' || '''' || h_sched_id || ''''
          || ', ' || '''' || h_participant_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_RES_FROM_PROJECT', 93+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_RES_FROM_PROJECT(94) : unassign_res.sql(1265) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_participant_id IS NULL) Then
      h_participant_res_id := h_rec_user;
   Else
      h_participant_res_id := h_participant_id;
   End If;
   
   If (h_plan_id IS NULL) Then
      h_plan_res_id := h_rec_user;
   Else
      h_plan_res_id := h_plan_id;
   End If;
   
   If (h_sched_id IS NULL) Then
      h_sched_res_id := h_rec_user;
   Else
      h_sched_res_id := h_sched_id;
   End If;
   
   --trace_printf("bitflag: %d\n", bitflag);
   -- delete participants
   If (Coalesce(bitflag001, 0) MOD 10) = 2 Then
      BEGIN
         UPDATE TMT_WBS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_participant_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(136) : unassign_res.sql(1307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_participant_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(155) : unassign_res.sql(1326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_participant_res_id ELSE AUTHOR_ID END
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(174) : unassign_res.sql(1345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("h_res_id: %d:%s\n", h_res_id_Ind,h_res_id);
   --trace_printf("h_plan_id: %d:%s\n", h_plan_id_Ind,h_plan_id);
   --trace_printf("h_sched_id: %d:%s\n", h_sched_id_Ind,h_sched_id);
   --trace_printf("h_participant_id: %d:%s\n", h_participant_id_Ind,h_participant_id);
   
   If (((Trunc(Coalesce(bitflag001, 0) / 100)) = 1) AND ((Trunc((Coalesce(
                     bitflag001, 0) MOD 100) / 10)) = 1)) OR (((Trunc(Coalesce(
                     bitflag001, 0) / 100)) = 3) AND ((Trunc((Coalesce(
                     bitflag001, 0) MOD 100) / 10)) = 3)) Then
      --trace_printf("Remove or replace all effort\n");
      BEGIN
         UPDATE TMT_WBS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_plan_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '1');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 206+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(207) : unassign_res.sql(1378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_sched_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '2');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(230) : unassign_res.sql(1401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_plan_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 251+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(252) : unassign_res.sql(1423) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf ((Trunc(Coalesce(bitflag001, 0) / 100)) = 1) OR ((Trunc(Coalesce(
                       bitflag001, 0) / 100)) = 3) Then
      --trace_printf("Remove or replace planed effort\n");
      BEGIN
         UPDATE TMT_WBS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_plan_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '1');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(277) : unassign_res.sql(1448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_plan_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 298+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(299) : unassign_res.sql(1470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf ((Trunc((Coalesce(bitflag001, 0) MOD 100) / 10)) = 1) OR ((Trunc((Coalesce(
                        bitflag001, 0) MOD 100) / 10)) = 3) Then
      --trace_printf("Remove or replace sched effort\n");
      BEGIN
         UPDATE TMT_WBS
         SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_sched_res_id ELSE CREATED_BY END
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID NOT IN (SELECT TASK_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND BIT_FLAG = '2');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 323+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(324) : unassign_res.sql(1495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- remove all effort (planned and sched)
   If ((Trunc(Coalesce(bitflag001, 0) / 100)) = 1) AND ((Trunc((Coalesce(
                    bitflag001, 0) MOD 100) / 10)) = 1) Then
      --trace_printf("Delete all Effort\n");
      
      OPEN C_D_ALL_E;
      
      LOOP
         FETCH C_D_ALL_E INTO h_id, h_prj_assignment_id, h_assign_flag;
         IF C_D_ALL_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("1_* SC_STATE: %d, h_id: %d %s\n",SC_STATE, h_id_Ind,h_id);
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 3 + PMO_CNST.SC_BIT_28;
         Else
            h_temp_var := PMO_CNST.SC_BIT_28;
            --InitializeHost(SC_PARAM(h_temp_var), SC_BIT_30);
         End If;
         
         If (SubStr(h_assign_flag, 1, 1) = '2') Then
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_sched_id, h_rec_user);
         Else
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_plan_id, h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_D_ALL_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 370+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(371) : unassign_res.sql(1542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Trunc((Coalesce(bitflag001, 0) MOD 100) / 10)) = 1 Then
      --trace_printf("Delete sched effort\n");
      
      OPEN C_D_SCHED_E;
      
      LOOP
         FETCH C_D_SCHED_E INTO h_id, h_prj_assignment_id;
         IF C_D_SCHED_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 3 + PMO_CNST.SC_BIT_28;
         Else
            h_temp_var := PMO_CNST.SC_BIT_28;
            --InitializeHost(SC_PARAM(h_temp_var), SC_BIT_27 + SC_BIT_30);
         End If;
         iRet := FC_D_TSKRES(h_id, h_temp_var, h_sched_id, h_rec_user);
      END LOOP;
      BEGIN
         CLOSE C_D_SCHED_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 406+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(407) : unassign_res.sql(1578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Trunc(Coalesce(bitflag001, 0) / 100)) = 1 Then
      --trace_printf("Delete planned effort\n");
      
      OPEN C_D_PLANNED_E;
      
      LOOP
         FETCH C_D_PLANNED_E INTO h_id, h_prj_assignment_id;
         IF C_D_PLANNED_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 3 + PMO_CNST.SC_BIT_28;
         Else
            h_temp_var := PMO_CNST.SC_BIT_28;
            --InitializeHost(SC_PARAM(h_temp_var), SC_BIT_30);
         End If;
         iRet := FC_D_TSKRES(h_id, h_temp_var, h_plan_id, h_rec_user);
      END LOOP;
      BEGIN
         CLOSE C_D_PLANNED_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 443+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(444) : unassign_res.sql(1615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf ((Trunc(Coalesce(bitflag001, 0) / 100)) = 3) AND ((Trunc((Coalesce(
                       bitflag001, 0) MOD 100) / 10)) = 3) Then
      --trace_printf("Replace all effort\n");
      
      OPEN C_R_ALL_E;
      
      LOOP
         FETCH C_R_ALL_E INTO h_id, h_prj_assignment_id, h_assign_flag;
         IF C_R_ALL_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 2 + PMO_CNST.SC_BIT_28;
         Else
            h_temp_var := 1 + PMO_CNST.SC_BIT_28;
         End If;
         
         If (SubStr(h_assign_flag, 1, 1) = '2') Then
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_sched_id, h_rec_user);
         Else
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_plan_id, h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_R_ALL_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 484+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(485) : unassign_res.sql(1656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Trunc((Coalesce(bitflag001, 0) MOD 100) / 10)) = 3 Then
      --trace_printf("Replace sched effort\n");
      
      OPEN C_R_SCHED_E;
      
      LOOP
         FETCH C_R_SCHED_E INTO h_id,h_prj_assignment_id;
         IF C_R_SCHED_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 2 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_sched_id, h_rec_user);
         Else
            h_temp_var := 1 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_sched_id, h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_R_SCHED_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 521+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(522) : unassign_res.sql(1693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Trunc(Coalesce(bitflag001, 0) / 100)) = 3 Then
      --trace_printf("Replace planned effort\n");
      
      OPEN C_R_PLANNED_E;
      
      LOOP
         FETCH C_R_PLANNED_E INTO h_id,h_prj_assignment_id;
         IF C_R_PLANNED_E%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 2 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_plan_id, h_rec_user);
         Else
            h_temp_var := 1 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_plan_id, h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_R_PLANNED_E ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 558+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(559) : unassign_res.sql(1730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(bitflag001, 0) MOD 10) = 2 Then
      --trace_printf("Delete all participant\n");
      If (h_participant_id IS NOT NULL) Then
         BEGIN
            SELECT RESOURCE_ID INTO h_participant_id FROM RESOURCES WHERE RESOURCE_ID = h_participant_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 575+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(576) : unassign_res.sql(1747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         PMO_DB2M.SC_STATE := 0;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         OPEN C_D_ALL_P;
         
         LOOP
            FETCH C_D_ALL_P INTO h_id;
            IF C_D_ALL_P%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            --trace_printf("2.0_* SC_STATE: %d, h_id: %d %s\n",SC_STATE, h_id_Ind,h_id);
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            h_temp_var := 3 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_participant_id, h_rec_user);
         END LOOP;
         BEGIN
            CLOSE C_D_ALL_P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RES_FROM_PROJECT', 610+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RES_FROM_PROJECT(611) : unassign_res.sql(1782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_RES_FROM_PROJECT', 618+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_RES_FROM_PROJECT(619) : unassign_res.sql(1790) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_RES_FROM_PROJECT;
ALTER FUNCTION FC_D_RES_FROM_PROJECT COMPILE DEBUG;

/****************************************************************************************************************
 delete resource/profile assignment from RES_ASSIGNMENTS, TASK_ASSIGNMENTS
 *****************************************************************************************************************
Deletes resource assignments: bitflag = 0 --> deletes assignmnets without actual
                                      = 3 --> deletes assignmnets with actual
******************************************************************************************************************/

Prompt == FUNCTION FC_D_TSKRES_ACT ==
CREATE OR REPLACE FUNCTION FC_D_TSKRES_ACT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_res_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_last_id VARCHAR2(32);
   h_profile_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_start_DT TIMESTAMP;
   h_finish_DT TIMESTAMP;
   h_start_D DATE;
   h_finish_D DATE;
   h_pa_timephase VARCHAR2(1);
   h_res_type VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_participant PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_task_actual PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_temp_res_type VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
   h_reg_cost NUMBER := 0;
   h_reg_sale NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_task_type PLS_INTEGER := 0;
   h_per_day PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   iRet PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CDWA1 IS
         SELECT WORK_TODATE, RESOURCE_TYPE
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND WORK_TODATE > 0;

      CURSOR CDWA2 IS
         SELECT WORK_TODATE, RESOURCE_TYPE
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id AND WORK_TODATE > 0;

      CURSOR CDBF15 IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, PROJECT_ASSIGNMENT_ID,
         TO_DATE(SubStr(BAK_START_DT, 1, 10)), TO_DATE(SubStr(BAK_FINISH_DT, 1, 10)), BILLABLE, CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE
         FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_id AND NOT MILESTONE_PERCENT = 10000 AND
         (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL);

      CURSOR CDBF14 IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS TA WHERE PROJECT_ID = h_id AND RESOURCE_TYPE = '0' AND
         (TSK_ASSIGNMENT_ID = PROJECT_ASSIGNMENT_ID OR PROJECT_ASSIGNMENT_ID IS NuLL) AND NOT MILESTONE_PERCENT = 10000
         ORDER BY RESOURCE_ID;

      CURSOR CDTSK1 IS
         SELECT PROFILE_ID FROM PMO_TMP_DELETE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_TSKRES_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_TSKRES_ACT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_TSKRES_ACT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_res_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES_ACT', 78+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_TSKRES_ACT(79) : unassign_res.sql(1884) : ' || SYSTIMESTAMP);
   END IF; 

   h_prj_assignment_id := '';
   h_last_id := '';
   h_project_id := h_id;
   h_duration := 0;
   h_pa_timephase := 'N';
   h_reg_cost := 0.00;
   h_reg_sale := 0.00;
   
   h_resource_id := NULL;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DELETE';
   PMO_DB2M.SC_STATE := 0;
   
   h_start_DT := '';
   h_finish_DT := '';
   h_participant := 0;
   h_work_todate := 0;
   
   BEGIN
      SELECT B.TASK_TYPE, B.UNRESOLVED_START, B.UNRESOLVED_FINISH, B.PROJECT_ID,
      COALESCE(A.MINUTE_PER_DAY, 480), B.ETC, B.WORK_TODATE, B.REC_STATUS
      INTO h_task_type, h_start_DT, h_finish_DT, h_project_id,
      h_per_day, h_etc, h_task_actual, h_rec_status
      FROM TMT_WBS A, TMT_WBS B WHERE B.ELEMENT_ID = h_id AND A.ELEMENT_ID = B.PROJECT_ID;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(113) : unassign_res.sql(1918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE = %d, h_start_DT = %d;%s, h_project_id = %d:%s\n", SC_STATE,h_start_DT_Ind,h_start_DT,h_project_id_Ind,h_project_id);
   --trace_printf("h_bitflag: %d, h_task_type: %d\n", h_bitflag,h_task_type);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_project_id := '';
      BEGIN
         SELECT PROJECT_ID, TASK_ID, WORK_TODATE, RESOURCE_TYPE, RES_ASSIGNMENT_ID
         INTO h_project_id, h_task_id, h_work_todate, h_res_type, h_res_assignment_id
         FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID=h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(132) : unassign_res.sql(1937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE = %d, h_project_id: %s\n", SC_STATE,h_project_id);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            SELECT B.TASK_TYPE, B.UNRESOLVED_START, B.UNRESOLVED_FINISH, B.PROJECT_ID,
            COALESCE(A.MINUTE_PER_DAY, 480), B.ETC, B.WORK_TODATE
            INTO h_task_type, h_start_DT, h_finish_DT, h_project_id,
            h_per_day, h_etc, h_task_actual
            FROM TMT_WBS A, TMT_WBS B WHERE B.ELEMENT_ID = h_task_id AND A.ELEMENT_ID = B.PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 150+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(151) : unassign_res.sql(1956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE = %d, h_task_type: %d\n", SC_STATE,h_task_type);
      Else
         h_participant := 1;
      End If;
   ElsIf Coalesce(Length(h_start_DT), 0) > 9 Then
      If (Coalesce(h_bitflag, 0) = 14) OR (Coalesce(h_bitflag, 0) = 15) Then
         If SubStr(h_rec_status, 1, 1) = 'L' Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_TSKRES_ACT', 162+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_TSKRES_ACT(163) : unassign_res.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ITEM_IS_LOCKED), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES_ACT', 165+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES_ACT(166) : unassign_res.sql(1971) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ITEM_IS_LOCKED, h_project_id, False);
         End If;
         
         h_temp_var := 0;
         BEGIN
            SELECT LEVEL_LOCK INTO h_temp_var
            FROM PROJECT_DETAILS
            WHERE PROJECT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(182) : unassign_res.sql(1987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_temp_var, 0) > 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_TSKRES_ACT', 188+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_TSKRES_ACT(189) : unassign_res.sql(1994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LEV_LOCKED_BY_COPY), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES_ACT', 191+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES_ACT(192) : unassign_res.sql(1997) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.LEV_LOCKED_BY_COPY, h_project_id, False);
         End If;
         
         OPEN CDWA1;
         
         FETCH CDWA1 INTO h_work_todate, h_res_type;
         IF CDWA1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         BEGIN
            CLOSE CDWA1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(214) : unassign_res.sql(2019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_work_todate, 0) > 0) AND (Coalesce(h_bitflag, 0) = 15) Then
            BEGIN
               SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase FROM PROJECT_DETAILS WHERE PROJECT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 227+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(228) : unassign_res.sql(2033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("Project SC_STATE: %d, h_pa_timephase: %s\n", SC_STATE,h_pa_timephase);
         End If;
      Else
         OPEN CDWA2;
         
         FETCH CDWA2 INTO h_work_todate, h_res_type;
         IF CDWA2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         BEGIN
            CLOSE CDWA2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 251+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(252) : unassign_res.sql(2057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("*** h_work_todate = %d, h_task_type: %d\n",h_work_todate,h_task_type);
   Else
      h_participant := 1;
   End If;
   --trace_printf("h_start_DT: %d;%s, h_participant: %d, h_work_todate: %d, h_bitflag: %d\nh_project_id: %d:%s, h_id: %s\n", h_start_DT_Ind,h_start_DT,h_participant,h_work_todate,h_bitflag,h_project_id_Ind,h_project_id,h_id);
   --trace_printf("*** h_task_type: %d, h_bitflag: %d\n",h_task_type,h_bitflag);
   
   /*if ( (h_task_type == SC_FD_EFFORT_DRIVEN)  ((h_bitflag == 0) || (h_bitflag == 3) || (h_bitflag == 15)) )
       {
           BEGIN_SQL
               SELECT COUNT(*) INTO HOST(h_count)
               FROM TASK_ASSIGNMENTS
               WHERE PROJECT_ID = HOST(h_project_id) AND TASK_ID = HOST(h_task_id);
           END_SQL;
   //trace_printf("SC_STATE: %d, h_etc: %d, h_task_actual: %d, h_count: %d\n", SC_STATE,h_etc,h_task_actual,h_count);//trace_flush();
   
           if (h_count > 0)    // there is other assignments
           {
               h_temp_sc_state = FC_FD_EFFORT_DRIVEN(
                               SC_PARAM(h_project_id),
                               SC_PARAM(h_task_id),
                               SC_PARAM(h_res_id),
                               SC_PARAM(h_res_type),
                               SC_PARAM(h_start_DT),
                               SC_PARAM(h_finish_DT),
                               SC_PARAM(h_etc),
                               SC_PARAM(h_task_actual),
                               SC_PARAM(h_count),
                               SC_PARAM(h_per_day), 1);
   //trace_printf("h_temp_sc_state: %d, h_start_DT: %d %s, h_finish_DT: %d %s\n", h_temp_sc_state,h_start_DT_Ind,h_start_DT,h_finish_DT_Ind,h_finish_DT);//trace_flush();
           }
       }*/
   
   h_finish_DT := '';
   If (Coalesce(h_participant, 0) = 0) AND (Coalesce(h_work_todate, 0) > 0) Then
      h_temp_sc_state := FC_DECLARE_PMO_TMP_SEARCH();
      h_temp_sc_state := FC_CREATE_CDY(h_project_id, h_start_DT, h_finish_DT, h_duration);
   End If;
   
   If Coalesce(h_bitflag, 0) = 15 Then
      -- Tudor please change FC_D_TSKRES don't generate timephased_delta for this option.
      iRet := FC_Rollup_Timephase(h_project_id);
      
      --remove all planned and sched assignments within the project (id = PROJECT_ID)
      
      OPEN CDBF15;
      
      LOOP
         FETCH CDBF15 INTO h_id, h_res_id, h_prj_assignment_id, h_start_D, h_finish_D, h_billable, h_capital_expense, h_reg_cost, h_reg_sale;
         IF CDBF15%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := PMO_FUNC.BIT_OR(3 + PMO_CNST.SC_BIT_28_30, PMO_CNST.SC_BIT_27);
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_resource_id, h_rec_user);
            
            If (iRet = 0) AND (SubStr(h_pa_timephase, 1, 1) = 'Y') Then
               h_tph_delete := 0;
               iRet := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_prj_assignment_id, h_start_D
                               , h_finish_D, h_reg_cost, h_reg_sale, h_tph_delete, h_capital_expense
                               , h_billable);
            End If;
         Else
            h_temp_var := PMO_FUNC.BIT_OR(PMO_CNST.SC_BIT_28_30, PMO_CNST.SC_BIT_27);
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_resource_id, h_rec_user);
         End If;
         --trace_printf("iRet = %d, h_id: %s, h_prj_assignment_id = %d:%s\n", iRet,h_id,h_prj_assignment_id_Ind,h_prj_assignment_id);
      END LOOP;
      
      BEGIN
         CLOSE CDBF15 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 340+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(341) : unassign_res.sql(2146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 14 Then
      --replace all sched or planned assignments with a profile (id = PROJECT_ID)
      
      OPEN CDBF14;
      
      LOOP
         FETCH CDBF14 INTO h_id, h_res_id, h_prj_assignment_id;
         IF CDBF14%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If PMO_ORASTD.strcmp(h_last_id, h_res_id) <> 0 Then
            --strcpy(h_last_id,h_res_id);
            h_last_id := h_res_id;
            
            -- Clean up the profiles table
            BEGIN
               DELETE FROM PMO_TMP_DELETE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 377+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(378) : unassign_res.sql(2183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (h_prj_assignment_id IS NOT NULL) Then
            h_temp_var := 2 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_resource_id, h_rec_user);
            --trace_printf("iRet: %d, h_prj_assignment_id:%d:%s\n",iRet,h_prj_assignment_id_Ind,h_prj_assignment_id);
            
            If iRet = 0 Then
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL
                  WHERE PROJECT_ID = h_project_id AND PROJECT_ASSIGNMENT_ID = h_prj_assignment_id
                  AND RESOURCE_TYPE = '0' AND PROJECT_ID <> TASK_ID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 403+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(404) : unassign_res.sql(2209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE: %d\n",SC_STATE);
               
               BEGIN
                  UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = TSK_ASSIGNMENT_ID
                  WHERE PROJECT_ID = h_project_id 
                  AND PARENT_ID = h_prj_assignment_id 
                  AND ACTUAL_FLAG = 1;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 424+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(425) : unassign_res.sql(2230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_temp_var := 3;
               h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_prj_assignment_id, h_temp_var, 0, 0);
               --trace_printf("SC_STATE:: %d\n",SC_STATE);
            End If;
         Else
            h_temp_var := 1 + PMO_CNST.SC_BIT_28;
            iRet := FC_D_TSKRES(h_id, h_temp_var, h_resource_id, h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE CDBF14 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 446+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(447) : unassign_res.sql(2252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --if ( (h_bitflag == 0) || (h_bitflag == 3) )
      --{
      --    h_temp_var = (h_bitflag | SC_BIT_30);       // set don't replace with profile if actual
      --}
      --else
      --{
      --    h_temp_var = h_bitflag;
      --}
      
      --iRet = FC_D_TSKRES( SC_PARAM(h_id), SC_PARAM(h_temp_var), SC_PARAM(h_resource_id), SC_PARAM(h_rec_user));
      iRet := FC_D_TSKRES(h_id, h_bitflag, h_resource_id, h_rec_user);
      
      If (Coalesce(h_bitflag, 0) = 0) AND (Coalesce(h_work_todate, 0) > 0) AND (iRet = 0) Then
         BEGIN
            UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = 2048, SECURITY_ID = 'SCTASKPARTICIPANT'
            WHERE RES_ASSIGNMENT_ID = h_res_assignment_id AND SECURITY_ID = 'SCTASKTEAMMEMBER';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 477+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(478) : unassign_res.sql(2283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   --trace_printf("iRet = %d, h_bitflag = %d, h_prj_assignment_id = %s, _Ind = %d\n", iRet,h_bitflag,h_prj_assignment_id,h_prj_assignment_id_Ind);
   
   If iRet = 0 Then
      If ((h_prj_assignment_id IS NOT NULL)) AND (Coalesce(h_bitflag, 0) > 3) AND (Coalesce(
            h_work_todate, 0) = 0) Then
         BEGIN
            UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL
            WHERE PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND MILESTONE_PERCENT = 10000;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 501+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(502) : unassign_res.sql(2307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(h_bitflag, 0) > 3 Then
         OPEN CDTSK1;
         
         LOOP
            FETCH CDTSK1 INTO h_profile_id;
            IF CDTSK1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            h_temp_res_type := '1';
            h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_profile_id, h_temp_res_type);
         END LOOP;
         
         BEGIN
            CLOSE CDTSK1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 533+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(534) : unassign_res.sql(2339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_res_type := '0';
         h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_res_id, h_temp_res_type);
      End If;
      --trace_printf("h_rollup  =%d, h_project_id = %d, %s\n", h_rollup,h_project_id_Ind,h_project_id);
      
      h_temp_sc_state := FC_U_APVS_PROJECT(h_project_id);
      --      BEGIN_SQL
      --          DELETE FROM TIMESHEET_APPROVAL_STATUS WHERE ELEMENT_ID = HOST(h_project_id) AND RESOURCE_ID NOT IN (
      --          SELECT DISTINCT RESOURCE_ID FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = HOST(h_project_id) AND TASK_ID <> PROJECT_ID);
      --      END_SQL;
      --trace_printf("SC_STATE  =%d, h_project_id = %s\n", SC_STATE,h_project_id);
      
      -- delete non actual timephase
      If Coalesce(h_bitflag, 0) = 15 Then
         BEGIN
            DELETE FROM TIMEPHASED_DELTA WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 564+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(565) : unassign_res.sql(2370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND BUDGET_TYPE <> PMO_CNST.SC_ACTUAL_BUDGET
            AND CHARGECODE_ID <> 'PMO_PROJECT_TIMEPHASE_CALENDAR__';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 584+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(585) : unassign_res.sql(2390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
            MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
            MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT, PROCESS_FLAG)
            SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, PMO_CNST.SC_SCHED_BUDGET, BUDGET_YEAR,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
            MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
            MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT, PROCESS_FLAG
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES_ACT', 613+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES_ACT(614) : unassign_res.sql(2419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(h_rollup, 0) = 0 Then
         h_temp_sc_state := FC_Rollup(h_project_id);
         -- New Rollup
      End If;
   Else
      PMO_DB2M.SC_STATE := iRet;
   End If;
   
   -- END -- FC_D_TSKRES_ACT
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES_ACT', 629+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES_ACT(630) : unassign_res.sql(2435) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_TSKRES_ACT;
ALTER FUNCTION FC_D_TSKRES_ACT COMPILE DEBUG;

/****************************************************************************************************************
 delete resource/profile assignment from RES_ASSIGNMENTS, TASK_ASSIGNMENTS, TASK_DAY_OF_YEAR
*****************************************************************************************************************
 bitflag = 0 remove the current assignment (normal assignment)
         = 3 remove all assignments from project assignment

         = 1 replace the current assignment with profile (normal assignment)
         = 2 replace all assignments from project assignment with profile

 1. IF actual work (MILESTONE_PERCENT > 0) THEN flaged the resource as deleted (ETC = 0, put ACTUAL_FINISH, FD = 42)
    and create a new profile based on resource (new sched work = old etc  new etc = 0)
 2. IF delete PROJECT assignment THEN delete all instances created from this PROJECT assignment if sched or bitflag = 3.
 3. IF delete TASK assignment created from PROJECT assignment THEN put back the effort to PROJECT assignment.
 4. IF delete TASK assignment in schedule THEN put back the effort to resource calendar.
 5. Can't delete if PBFS task and assignment is scheduled.
******************************************************************************************************************/

Prompt == FUNCTION FC_D_TSKRES ==
CREATE OR REPLACE FUNCTION FC_D_TSKRES
(
     id IN OUT NOCOPY VARCHAR2
   , sh_bitflag001 PLS_INTEGER
   , res_id001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   bitflag001 PLS_INTEGER := sh_bitflag001;
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_type_id PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_role_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_profile_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_names_task_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_day_year DATE;
   h_uniqueID VARCHAR2(32);
   h_created_by VARCHAR2(32);
   h_full_name VARCHAR2(100);
   h_creator_name VARCHAR2(100);
   h_profile_name VARCHAR2(100);
   h_start_D DATE;
   h_finish_D DATE;
   h_SD DATE;
   h_FD DATE;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_fs_project PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_work_type PLS_INTEGER := 0;
   h_minutes PLS_INTEGER := 0;
   h_owner PLS_INTEGER := 1;
   h_owner1 PLS_INTEGER := 0;
   h_owner2 PLS_INTEGER := 0;
   h_from_prj PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_occurrence PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_number PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_bitflag1 PLS_INTEGER := 0;
   h_bitflag_27 PLS_INTEGER := 0;
   h_donot_replace PLS_INTEGER := 0;
   h_donot_remove_name PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_eunit PLS_INTEGER := 0;
   h_unit PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   h_mls_percent PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_planned_work PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_exists PLS_INTEGER := 0;
   h_bit_minutes PLS_INTEGER := 0;
   h_rollup_bits PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_reg_cost NUMBER := 0.00;
   h_spec_cost NUMBER := 0.00;
   h_reg_sale NUMBER := 0.00;
   h_spec_sale NUMBER := 0.00;
   h_rate_echange NUMBER := 0.00;
   h_table_type PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_temp_day DATE;
   h_temp_res_type VARCHAR2(1);
   h_temp_participant PLS_INTEGER := 0;
   h_temp_security_id VARCHAR2(32);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_continue_01 PLS_INTEGER := 0;
   h_continue_02 PLS_INTEGER := 0;
   h_temp_id VARCHAR2(32);
   h_security_name VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_cri_security_id VARCHAR2(32);
   h_pa_timephase VARCHAR2(1);
   a_security_value PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_resp_exists PLS_INTEGER := 0;
   h_transfered_cri PLS_INTEGER := 0;
   h_close_task VARCHAR2(1);
   h_labor_code VARCHAR2(50);
   h_temp_role_id VARCHAR2(32);
   h_replace_type VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_null_str VARCHAR2(1);
   h_assign_string VARCHAR2(4000);
   h_task_assign_flag PLS_INTEGER := 0;
   h_cri_element_type PLS_INTEGER := 0;
   h_cri_table_type PLS_INTEGER := 0;
   i_has_actual PLS_INTEGER NOT NULL := 0;
   deleteCreator PLS_INTEGER NOT NULL := 0;
   i_prj_manager PLS_INTEGER;
   l_data_flag PLS_INTEGER;
   i_pa_exists PLS_INTEGER;
   l_data_flag001 PLS_INTEGER;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CPEXS IS
         SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND /*RESOURCE_TYPE = '1' AND*/ PROJECT_ID <> TASK_ID;

      CURSOR C_COUNT2 IS
         SELECT * FROM (SELECT RESOURCE_ID FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id
         ) WHERE ROWNUM<=1;

      CURSOR CPASS IS
         SELECT DAY_YEAR, SCHED_MIN, TSK_ASSIGNMENT_ID, PARENT_ID, BIT_SCHED
         FROM TASK_DAY_OF_YEAR 
         WHERE PROJECT_ID = h_project_id 
         AND TSK_ASSIGNMENT_ID <> PARENT_ID AND TSK_ASSIGNMENT_ID = h_id;

      CURSOR srch003 IS
         SELECT * FROM (SELECT RES_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_assign_id
         ) WHERE ROWNUM<=1;

      CURSOR srch001 IS
         SELECT * FROM (SELECT TASK_ID
         FROM TASK_ASSIGNMENTS
         WHERE TASK_ID = h_task_id
         ) WHERE ROWNUM<=1;

      CURSOR CPAS2T IS
         SELECT * FROM (SELECT PARENT_ID 
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id 
         AND TSK_ASSIGNMENT_ID <> PARENT_ID 
         AND TSK_ASSIGNMENT_ID = h_id 
         ) WHERE ROWNUM<=1;

      CURSOR srch002 IS
         SELECT * FROM (SELECT TASK_ID
         FROM TASK_ASSIGNMENTS
         WHERE TASK_ID = h_task_id
         ) WHERE ROWNUM<=1;

      CURSOR CFSASS1 IS
         SELECT RESOURCE_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_task_id AND RESOURCE_TYPE = '0';

      CURSOR CPAS2 IS
         SELECT * FROM (SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND PROJECT_ID <> TASK_ID AND PROJECT_ASSIGNMENT_ID IS NOT NuLL
         AND TSK_ASSIGNMENT_ID = h_id ) WHERE ROWNUM<=1;

      CURSOR CPAS9 IS
         SELECT * FROM (SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND PROJECT_ID <> TASK_ID AND PROJECT_ASSIGNMENT_ID = h_id ) WHERE ROWNUM<=1;

      CURSOR CRNAME1 IS
         SELECT ra.RES_ASSIGNMENT_ID, ta.TSK_ASSIGNMENT_ID, ta.TASK_ID, ta.WORK_TODATE, ra.PARTICIPANT,
         TO_DATE(SubStr(PROPOSED_START, 1, 10)), TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)), BILLABLE, CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE
         FROM TASK_ASSIGNMENTS ta JOIN RESOURCE_ASSIGNMENTS ra ON ra.RES_ASSIGNMENT_ID = ta.RES_ASSIGNMENT_ID
         WHERE ta.PROJECT_ID = h_project_id AND ta.PROJECT_ASSIGNMENT_ID = h_prj_assignment_id
         ORDER BY ta.WORK_TODATE DESC;

      CURSOR CPAS3 IS
         SELECT ra.RES_ASSIGNMENT_ID, ra.ELEMENT_TYPE, ta.TSK_ASSIGNMENT_ID, ta.TASK_ID, ta.MILESTONE_PERCENT,
         CASE WHEN BIT_FLAG = '2' THEN ta.SCHED_WORK - ta.WORK_TODATE ELSE ta.PLANNED_WORK END, ta.CONTOUR_TYPE, ta.C_EFFORT, ta.T_UNIT, ta.C_UNIT, ta.C_CONTOUR, ra.PARTICIPANT,
         CASE WHEN CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END,
         CASE WHEN EXISTS(SELECT tb.TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS tb WHERE tb.PROJECT_ID = ta.PROJECT_ID AND tb.TASK_ID = ta.TASK_ID AND tb.RESOURCE_TYPE = h_replace_type AND tb.RESOURCE_ID = h_profile_id) THEN 1 ELSE 0 END,
         TO_DATE(SubStr(ta.PROPOSED_START, 1, 10)), TO_DATE(SubStr(ta.PROPOSED_FINISH, 1, 10)), ta.BILLABLE, ta.CAPITAL_EXPENSE
         FROM RESOURCE_ASSIGNMENTS ra JOIN TASK_ASSIGNMENTS ta ON ra.RES_ASSIGNMENT_ID=ta.RES_ASSIGNMENT_ID
         WHERE ta.PROJECT_ID <> ta.TASK_ID AND ta.PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND NOT ta.MILESTONE_PERCENT = 10000;

      CURSOR CFSASS2 IS
         SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_task_id AND RESOURCE_TYPE = '0';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_TSKRES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_TSKRES'), '-- ' || SYSTIMESTAMP, ':r := FC_D_TSKRES(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_bitflag001), 'NULL')
          || ', ' || '''' || res_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 196+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_TSKRES(197) : unassign_res.sql(2657) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --1 if task_assignmnet, 0 if project_assignment
   
   h_id := id;
   h_rec_user := rec_user001;
   h_bitflag := bitflag001;
   h_uniqueID := '';
   h_profile_id := '';
   h_security_name := '';
   a_security_value := 0;
   h_type_id := 0;
   h_table_type := 0;
   h_close_task := 'N';
   h_res_assignment_id := NULL;
   h_resource_id := res_id001;
   h_null_str := NULL;
   h_names_task_id := '';
   h_task_assign_flag := 0;
   
   If (h_resource_id IS NOT NULL) Then
      h_rec_user := h_resource_id;
      h_replace_type := '0';
   Else
      h_replace_type := '1';
   End If;
   
   /********************************************************
       h_assign_id = RES_ASSIGNMENT_ID
       h_id        = TA.TSK_ASSIGNMENT_ID
   *********************************************************/
   --trace_printf("*___START h_bitflag: %d, h_resource_id: %d:%s\n", h_bitflag,h_resource_id_Ind,h_resource_id);
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_30 Then
      h_donot_replace := 1;
      -- set don't replace with profile if actual
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_30));
      -- remove don't replace with profile if actual
   End If;
   
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_29 Then
      h_close_task := 'Y';
      -- set delete FS resource assignment
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_29));
      -- set to 0
   End If;
   
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_28 Then
      h_rollup := 1;
      -- set do not rollup (import from MSP)
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_28));
      -- remove set do not rollup
   End If;
   
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_27 Then
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_27));
      h_bitflag_27 := PMO_CNST.SC_BIT_27;
      -- keep assignments with actual and remove the remaining
      --when deleted from upper window in the staffing, proect resources tab
   End If;
   --trace_printf("after assigning the bitflag: h_bitflag: %d\n", h_bitflag);
   h_resp_exists := 0;
   
   BEGIN
      SELECT TA.PROJECT_ID, TA.TASK_ID, TA.PROJECT_ASSIGNMENT_ID, TA.RES_ASSIGNMENT_ID, TA.MILESTONE_PERCENT, TABLE_TYPE,
      TA.PLANNED_WORK, TA.SCHED_WORK, TA.SCHED_WORK - TA.WORK_TODATE, Trunc(TA.BIT_FLAG),
      C_EFFORT, CONTOUR_TYPE, T_UNIT, C_UNIT, C_CONTOUR, C_OCCURRENCE,
      TO_DATE(SubStr(START_DT, 1, 10)), TO_DATE(SubStr(FINISH_DT, 1, 10)), BILLABLE, CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE
      INTO h_project_id, h_task_id, h_prj_assignment_id, h_assign_id, h_mls_percent, h_table_type,
      h_planned_work, h_sched_work, h_effort, h_work_type,
      h_work, h_bitflag1, h_eunit, h_unit, h_contour, h_occurrence,
      h_SD, h_FD, h_billable, h_capital_expense, h_reg_cost, h_reg_sale
      FROM TASK_ASSIGNMENTS TA WHERE TA.TSK_ASSIGNMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 276+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(277) : unassign_res.sql(2737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("TA__ SC_STATE = %d, h_id = %s, h_work_type: %d, h_effort: %d,h_planned_work: %d\n", SC_STATE,h_id,h_work_type,h_effort,h_planned_work);
   --trace_printf("h_prj_assignment_id: %s, h_id: %s\n", h_prj_assignment_id, h_id);
   
   If PMO_ORASTD.strcmp(h_prj_assignment_id, h_id) = 0 Then
      h_task_assign_flag := 0;
   Else
      h_task_assign_flag := 1;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         SELECT PROJECT_ID, RES_ASSIGNMENT_ID, PARTICIPANT, ELEMENT_TYPE,
         CASE WHEN RESOURCE_TYPE = '1' THEN PROFILE_ID ELSE RESOURCE_ID END, RESOURCE_TYPE, ELEMENT_ID, TABLE_TYPE,
         SECURITY_ID, CRI_SECURITY_ID,
         CASE WHEN CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END
         INTO h_project_id, h_assign_id, h_owner, h_type_id,
         h_res_id, h_res_type, h_task_id, h_table_type,
         h_security_id, h_cri_security_id, h_transfered_cri
         FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 305+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(306) : unassign_res.sql(2766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("RA h_owner: %d; h_type_id: %d, h_task_id: %d %s\n", h_owner, h_type_id,h_task_id_Ind, h_task_id);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 313+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(314) : unassign_res.sql(2774) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      ElsIf ((h_resource_id IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_resource_id, h_res_id) = 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 318+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(319) : unassign_res.sql(2779) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN 0;
      End If;
      
      If ((h_table_type IS NULL)) OR (Coalesce(h_table_type, 0) = 0) Then
         h_table_type := GetTable(Coalesce(h_type_id, 0));
      End If;
      
      h_temp_var := 0;
      BEGIN
         SELECT LEVEL_LOCK INTO h_temp_var
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 338+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(339) : unassign_res.sql(2799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_temp_var, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_TSKRES', 345+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_TSKRES(346) : unassign_res.sql(2806) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 348+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(349) : unassign_res.sql(2809) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC, h_project_id
               , False);
      End If;
      --trace_printf("1_* switch h_table_type: %d; h_res_id: %s\nrec_user: %s, h_rec_user: %s\n", h_table_type, h_res_id, rec_user,h_rec_user);
      CASE h_table_type
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_WBS SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 372+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(373) : unassign_res.sql(2833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_WBS
               SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_rec_user ELSE CREATED_BY END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 393+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(394) : unassign_res.sql(2854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_transfered_cri, 0) = 1 Then
               If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
                  BEGIN
                     UPDATE TMT_CRI SET REC_STATUS = 'U'
                     WHERE ELEMENT_ID = h_task_id
                     AND REC_USER = h_res_id AND REC_STATUS = 'O';
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 414+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(415) : unassign_res.sql(2875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               BEGIN
                  UPDATE TMT_CRI
                  SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_rec_user ELSE CREATED_BY END,
                  REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
                  WHERE ELEMENT_ID = h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 435+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(436) : unassign_res.sql(2896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            --trace_printf("1_a* SC_STATE: %d; h_transfered_cri: %d, h_task_id: %d %s\n", SC_STATE, h_transfered_cri,h_task_id_Ind,h_task_id);
            
            BEGIN
               SELECT CREATED_BY, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 452+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(453) : unassign_res.sql(2913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1_b* SC_STATE: %d; h_created_by: %s, h_task_id: %d %s\n", SC_STATE, h_created_by, h_task_id_Ind,h_task_id);
            
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 476+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(477) : unassign_res.sql(2937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_CRI
               SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_rec_user ELSE CREATED_BY END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 497+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(498) : unassign_res.sql(2958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT CREATED_BY, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 512+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(513) : unassign_res.sql(2973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_POL THEN
            --TMT_POOLS
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_POOLS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 536+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(537) : unassign_res.sql(2997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_POOLS
               SET MANAGER_ID = CASE WHEN MANAGER_ID = h_res_id THEN h_rec_user ELSE MANAGER_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 557+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(558) : unassign_res.sql(3018) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT MANAGER_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_POOLS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 572+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(573) : unassign_res.sql(3033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 595+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(596) : unassign_res.sql(3056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 616+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(617) : unassign_res.sql(3077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 631+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(632) : unassign_res.sql(3092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_SCD THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_ASSIGNED_SCORECARDS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 654+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(655) : unassign_res.sql(3115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_ASSIGNED_SCORECARDS
               SET CREATED_BY = CASE WHEN CREATED_BY = h_res_id THEN h_rec_user ELSE CREATED_BY END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 675+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(676) : unassign_res.sql(3136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT CREATED_BY, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_ASSIGNED_SCORECARDS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 690+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(691) : unassign_res.sql(3151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_POOL_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 713+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(714) : unassign_res.sql(3174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 734+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(735) : unassign_res.sql(3195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_POOL_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 749+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(750) : unassign_res.sql(3210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_RESOURCE_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 772+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(773) : unassign_res.sql(3233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 793+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(794) : unassign_res.sql(3254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 808+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(809) : unassign_res.sql(3269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_CLIENT_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 831+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(832) : unassign_res.sql(3292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 852+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(853) : unassign_res.sql(3313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_CLIENT_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 867+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(868) : unassign_res.sql(3328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_ASSET_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 890+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(891) : unassign_res.sql(3351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 911+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(912) : unassign_res.sql(3372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_ASSET_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 926+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(927) : unassign_res.sql(3387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
            If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
               BEGIN
                  UPDATE TMT_VENDOR_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 949+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(950) : unassign_res.sql(3410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS
               SET AUTHOR_ID = CASE WHEN AUTHOR_ID = h_res_id THEN h_rec_user ELSE AUTHOR_ID END,
               REC_USER = CASE WHEN REC_USER = h_res_id THEN h_rec_user ELSE REC_USER END
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 970+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(971) : unassign_res.sql(3431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT AUTHOR_ID, ASSIGN_NAMES INTO h_created_by, h_assign_string
               FROM TMT_VENDOR_DOCUMENTS
               WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 985+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(986) : unassign_res.sql(3446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
      
      --trace_printf("1_c* SC_STATE: %d; h_created_by: %s\n", SC_STATE, h_created_by);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 996+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(997) : unassign_res.sql(3457) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      If (h_resource_id IS NOT NULL) Then
         h_created_by := h_resource_id;
      End If;
      
      If (BITAND(Coalesce(h_owner, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
         --trace_printf("DD_* h_owner: %d; h_created_by: %s, h_res_id: %s\n", h_owner, h_created_by, h_res_id);
         --check if the deleteing resoiurce is the task responsible, return an error message
         If PMO_ORASTD.strcmp(h_res_id, h_created_by) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1010+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1011) : unassign_res.sql(3471) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_MANAGER;
            
            /*              h_temp_var = PMO_InStr(h_security_id, "RESPONSIBLE");
            //trace_printf("RESPONSIBLE_* h_temp_var: %d, h_security_id: %s\n", h_temp_var,h_security_id);
                            if( (h_temp_var > 0) )
                            {
                                return CANNOT_DELETE_MANAGER;
                            }
                            else
                            {
                                h_temp_var = PMO_InStr(h_security_id, "MANAGER");
            //trace_printf("MANAGER_* h_temp_var: %d\n", h_temp_var);
                                if( (h_temp_var > 0) )
                                {
                                    return CANNOT_DELETE_MANAGER;
                                }
                            }
            
                            if (h_transfered_cri == 1)
                            {
                                h_temp_var = PMO_InStr(h_cri_security_id, "RESPONSIBLE");
            
                                if(h_temp_var > 0)
                                {
                                    return CANNOT_DELETE_CRI_MANAGER_RESPONSIBLE;
                                }
                                else
                                {
                                    h_temp_var = PMO_InStr(h_cri_security_id, "MANAGER");
            
                                    if(h_temp_var > 0)
                                    {
                                        return CANNOT_DELETE_CRI_MANAGER_RESPONSIBLE;
            
                                    }
                                }
                            }
            */
            /*if ( isProjectType(h_type_id) )
                            {
                                if ( (strncmp(h_security_id, "SCPROJECTMANAGER", strlen("SCPROJECTMANAGER"))==0) 
                                     (strcmp(h_res_id, h_created_by) == 0) )
                                {
                                    return CANNOT_DELETE_MANAGER;
                                }
                            }*/
         End If;
         
         a_security_value := BITAND(Coalesce(h_owner, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
         
         BEGIN
            SELECT RES_ASSIGNMENT_ID, PARTICIPANT INTO h_uniqueID, h_participant
            FROM RESOURCE_ASSIGNMENTS
            WHERE ELEMENT_ID = h_task_id AND RESOURCE_ID = h_created_by;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1072+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1073) : unassign_res.sql(3533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            If BITAND(Coalesce(h_participant, 0), CASE WHEN 
                   PMO_CNST.SC_TEAMMEMBER > 0 THEN 1 ELSE 0 END) <> 0 Then
               a_security_value := PMO_FUNC.BIT_OR(Coalesce(a_security_value, 0), PMO_CNST.SC_TEAMMEMBER);
            End If;
            If Coalesce(h_transfered_cri, 0) = 0 Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = a_security_value,
                  SECURITY_ID = h_security_id
                  WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1098+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1099) : unassign_res.sql(3559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = a_security_value,
                  SECURITY_ID = h_security_id,
                  CRI_SECURITY_ID = h_cri_security_id
                  WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1119+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1120) : unassign_res.sql(3580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_owner := 1;
         Else
            If Coalesce(h_transfered_cri, 0) = 0 Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PROFILE_ID = NuLL,
                  RESOURCE_ID = h_created_by,
                  PARTICIPANT = a_security_value,
                  SECURITY_ID = h_security_id
                  WHERE RES_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1144+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1145) : unassign_res.sql(3605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PROFILE_ID = NuLL,
                  RESOURCE_ID = h_created_by,
                  PARTICIPANT = a_security_value,
                  SECURITY_ID = h_security_id,
                  CRI_SECURITY_ID = h_cri_security_id
                  WHERE RES_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1167+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1168) : unassign_res.sql(3628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_owner := 2;
         End If;
         --trace_printf("2.A_* SC_STATE: %d, h_owner: %d,a_security_value: %d, h_security_id: %s\n", SC_STATE,h_owner,a_security_value,h_security_id);
      Else
         h_owner := 3;
         If (h_resource_id IS NOT NULL) Then
            If PMO_ORASTD.strcmp(h_created_by, h_res_id) = 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1180+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1181) : unassign_res.sql(3641) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN 0;
            End If;
            
            BEGIN
               SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
               WHERE ELEMENT_ID = h_task_id AND RESOURCE_ID = h_created_by;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1194+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1195) : unassign_res.sql(3655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PROFILE_ID = NuLL,
                  RESOURCE_ID = h_created_by
                  WHERE RES_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1215+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1216) : unassign_res.sql(3676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_owner := 4;
            End If;
         End If;
      End If;
      
      If Coalesce(h_owner, 0) = 3 Then
         h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_id);
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1240+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1241) : unassign_res.sql(3701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_owner, 0) = 1 Then
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_uniqueID);
         h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_id);
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGNMENTS
            WHERE RES_ASSIGNMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1261+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1262) : unassign_res.sql(3722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_owner, 0) = 2) OR (Coalesce(h_owner, 0) = 4) Then
         h_temp_res_type := '0';
         h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_res_id, h_temp_res_type);
         
         h_temp_res_type := '0';
         h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_created_by, h_temp_res_type);
      End If;
      
      h_full_name := NULL;
      If SubStr(h_res_type, 1, 1) = '0' Then
         BEGIN
            SELECT NICK_NAME || ';' INTO h_full_name
            FROM RESOURCES
            WHERE RESOURCE_ID = h_res_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1285+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1286) : unassign_res.sql(3746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT PROFILE_NAME || ';' INTO h_full_name
            FROM PROFILES
            WHERE PROFILE_ID = h_res_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1300+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1301) : unassign_res.sql(3761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_creator_name := NULL;
      If Coalesce(h_owner, 0) <> 3 Then
         BEGIN
            SELECT NICK_NAME || ';' INTO h_creator_name
            FROM RESOURCES
            WHERE RESOURCE_ID = h_created_by;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1318+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1319) : unassign_res.sql(3779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_full_name IS NOT NULL) Then
         BEGIN
            SELECT REPLACE(h_assign_string, h_full_name, '') INTO h_assign_string
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1334+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1335) : unassign_res.sql(3795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_creator_name IS NOT NULL) Then
         If Coalesce(h_owner, 0) = 1 Then
            BEGIN
               SELECT REPLACE(h_assign_string, h_creator_name, '') INTO h_assign_string
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1351+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1352) : unassign_res.sql(3812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_owner, 0) = 1) OR (Coalesce(h_owner, 0) = 2) Then
            BEGIN
               SELECT h_creator_name || h_assign_string INTO h_assign_string
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1367+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1368) : unassign_res.sql(3828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_owner, 0) = 4 Then
            BEGIN
               SELECT h_assign_string || h_creator_name INTO h_assign_string
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1381+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1382) : unassign_res.sql(3842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      CASE h_table_type
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            BEGIN
               UPDATE TMT_WBS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1405+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1406) : unassign_res.sql(3866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_transfered_cri, 0) = 1 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSIGN_NAMES = h_assign_string
                  WHERE ELEMENT_ID = h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1425+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1426) : unassign_res.sql(3886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            BEGIN
               UPDATE TMT_CRI
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1447+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1448) : unassign_res.sql(3908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_DOC THEN
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1468+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1469) : unassign_res.sql(3929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_POL THEN
            BEGIN
               UPDATE TMT_POOLS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1489+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1490) : unassign_res.sql(3950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_SCD THEN
            BEGIN
               UPDATE TMT_ASSIGNED_SCORECARDS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1511) : unassign_res.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1531+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1532) : unassign_res.sql(3992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1552+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1553) : unassign_res.sql(4013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1573+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1574) : unassign_res.sql(4034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1594+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1595) : unassign_res.sql(4055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
         
         WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS
               SET ASSIGN_NAMES = h_assign_string
               WHERE ELEMENT_ID = h_task_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1615+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1616) : unassign_res.sql(4076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1624+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1625) : unassign_res.sql(4085) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   ElsIf Coalesce(h_mls_percent, 0) = 10000 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1629+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1630) : unassign_res.sql(4090) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   Else
      h_temp_var := 0;
      BEGIN
         SELECT LEVEL_LOCK INTO h_temp_var
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1644+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1645) : unassign_res.sql(4105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_temp_var, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_TSKRES', 1651+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_TSKRES(1652) : unassign_res.sql(4112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1654+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1655) : unassign_res.sql(4115) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC, h_project_id
               , False);
      End If;
      
      h_tph_delete := -1;
      BEGIN
         SELECT PROJECT_ID, PROFILE_ID, ELEMENT_ID, ELEMENT_TYPE,
         CASE WHEN RESOURCE_TYPE = '1' THEN PROFILE_ID ELSE RESOURCE_ID END, RESOURCE_TYPE, PARTICIPANT, TABLE_TYPE,
         CASE WHEN CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END
         INTO h_project_id, h_profile_id, h_task_id,
         h_type_id, h_res_id, h_res_type, h_owner, h_table_type, h_transfered_cri
         FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1674+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1675) : unassign_res.sql(4135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("TA_RA: SC_STATE: %d, h_bitflag: %d, h_owner: %d, h_table_type: %d, h_transfered_cri: %d\nh_assign_id: %s, h_profile_id: %d:%s\n", SC_STATE,h_bitflag,h_owner,h_table_type,h_transfered_cri,h_assign_id,h_profile_id_Ind,h_profile_id);
      --trace_printf("RES_* h_res_id: %d:%s,h_res_type: %s\n",h_res_id_Ind,h_res_id,h_res_type);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1683+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1684) : unassign_res.sql(4144) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      ElsIf ((Coalesce(bitflag001, 0) = 1) OR (Coalesce(bitflag001, 0) = 2)) 
                 AND ((h_resource_id IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_resource_id
                 , h_res_id) = 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 1690+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(1691) : unassign_res.sql(4151) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN 0;
      End If;
      
      --trace_printf("2_* switch h_table_type: %d; h_res_id: %s\nrec_user: %s, h_rec_user: %s\n", h_table_type, h_res_id, rec_user,h_rec_user);
      If PMO_ORASTD.strcmp(h_res_id, rec_user001) <> 0 Then
         CASE h_table_type
            WHEN PMO_CNST.SC_TABLE_WBS THEN
               BEGIN
                  UPDATE TMT_WBS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1714+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1715) : unassign_res.sql(4175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_CRI THEN
               BEGIN
                  UPDATE TMT_CRI
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1736+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1737) : unassign_res.sql(4197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_POL THEN
               --TMT_POOLS
               BEGIN
                  UPDATE TMT_POOLS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1759+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1760) : unassign_res.sql(4220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_DOC THEN
               BEGIN
                  UPDATE TMT_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1781+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1782) : unassign_res.sql(4242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_SCD THEN
               BEGIN
                  UPDATE TMT_ASSIGNED_SCORECARDS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1803+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1804) : unassign_res.sql(4264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
               BEGIN
                  UPDATE TMT_POOL_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1825+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1826) : unassign_res.sql(4286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
               BEGIN
                  UPDATE TMT_RESOURCE_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1847+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1848) : unassign_res.sql(4308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
               BEGIN
                  UPDATE TMT_CLIENT_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1869+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1870) : unassign_res.sql(4330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
               BEGIN
                  UPDATE TMT_ASSET_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1891+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1892) : unassign_res.sql(4352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
            
            WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
               BEGIN
                  UPDATE TMT_VENDOR_DOCUMENTS
                  SET REC_STATUS = 'U'
                  WHERE ELEMENT_ID = h_task_id
                  AND REC_USER = h_res_id AND REC_STATUS = 'O';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1913+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1914) : unassign_res.sql(4374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ELSE
               NULL;
         END CASE;
      End If;
      
      h_owner2 := h_owner;
      
      If ((h_table_type IS NULL)) OR (Coalesce(h_table_type, 0) = 0) Then
         h_table_type := GetTable(Coalesce(h_type_id, 0));
      End If;
      -- new res id
      If (h_profile_id IS NOT NULL) Then
         If ((Coalesce(h_bitflag, 0) = 0) AND (Coalesce(h_mls_percent, 0) > 0)) OR (Coalesce(
               h_bitflag, 0) = 1) Then
            BEGIN
               SELECT MILESTONE_PERCENT INTO h_count FROM TASK_ASSIGNMENTS
               WHERE TASK_ID = h_task_id AND RESOURCE_ID = h_profile_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1940+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1941) : unassign_res.sql(4401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_exists := 1;
            End If;
         ElsIf (Coalesce(h_bitflag, 0) = 2) OR (Coalesce(h_bitflag, 0) = 3) Then
            -- ??? Tudor ( I think is RESOURCE_ASSIGNMENTS insted TASK_ASSIGNMENTS in DECLARE CPEXS CURSOR)
            
            OPEN CPEXS;
            
            LOOP
               FETCH CPEXS INTO h_uniqueID;
               IF CPEXS%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               BEGIN
                  SELECT MILESTONE_PERCENT INTO h_count FROM TASK_ASSIGNMENTS
                  WHERE TSK_ASSIGNMENT_ID = h_uniqueID AND RESOURCE_ID = h_res_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1972+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1973) : unassign_res.sql(4433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND ((Coalesce(h_bitflag, 0) = 2) OR ((Coalesce(
                     h_bitflag, 0) = 3) AND (Coalesce(h_count, 0) > 0))) Then
                  h_exists := 1;
                  EXIT;
               End If;
            END LOOP;
            
            BEGIN
               CLOSE CPEXS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 1991+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(1992) : unassign_res.sql(4452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      BEGIN
         SELECT CASE WHEN tw.FS_CODE IS NuLL THEN 0 ELSE 1 END, COALESCE(tw.MINUTE_PER_DAY, 480), tw.PRIORITY, PMO_ORASTD.TODECIMAL(td.ELEMENT_NAME,20,4)
         INTO h_fs_project, h_min_per_day, h_priority, h_rate_echange
         FROM TMT_WBS tw JOIN TMT_DATAFIELDS td on tw.CURRENCY_ID = td.ELEMENT_ID
         WHERE tw.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2009+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2010) : unassign_res.sql(4470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_resource_id IS NULL) Then
         If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            BEGIN
               SELECT CREATED_BY INTO h_created_by FROM TMT_WBS WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2024+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2025) : unassign_res.sql(4485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT CREATED_BY INTO h_created_by FROM TMT_CRI WHERE ELEMENT_ID = h_task_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2037+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2038) : unassign_res.sql(4498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 2044+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(2045) : unassign_res.sql(4505) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_MANAGER;
            End If;
         End If;
      Else
         h_created_by := h_resource_id;
      End If;
      
      i_prj_manager := PMO_FUNC.BIT_OR(PMO_CNST.SC_CO_MANAGER, PMO_CNST.SC_MANAGER);
      
      --trace_printf("h_table_type: %d, h_created_by: %s, h_resource_id: %d %s\n",h_table_type,h_created_by,h_resource_id_Ind,h_resource_id);
      --trace_printf("h_mls_percent = %d, h_bitflag = %d, h_owner = %d, h_type_id = %d\n", h_mls_percent,h_bitflag, h_owner,h_type_id);
      If ((BITAND(Coalesce(h_owner, 0), i_prj_manager)) > 0) OR (Coalesce(h_mls_percent, 0) > 0) 
                     OR (SubStr(h_close_task, 1, 1) = 'Y') Then
         h_owner1 := Coalesce(h_owner, 0);
         h_owner := 0;
         -- don't delete Resource Assignments
         h_donot_remove_name := 1;
         --trace_printf("h_owner = 0, don't delete Resource Assignments\n");//trace_flush();
      Else
         If (BITAND(Coalesce(h_owner, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
            If ((Coalesce(h_bitflag, 0) = 1) OR (Coalesce(h_bitflag, 0) = 2)) 
                  AND ((h_resource_id IS NOT NULL)) Then
               a_security_value := Coalesce(h_owner, 0);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  a_security_value := BITAND(Coalesce(h_owner, 0), PMO_CNST.SC_CLEAR_VISITOR);
               Else
                  a_security_value := BITAND(Coalesce(h_owner, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
               End If;
            End If;
            
            h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_name);
            If Coalesce(h_transfered_cri, 0) = 1 Then
               h_cri_element_type := FC_MIRROR_TYPE(h_type_id);
               h_cri_table_type := PMO_CNST.SC_TABLE_CRI;
               h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table_type, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_cri_security_id);
            End If;
            --trace_printf("\n 10822 a_security_value: %d, h_security_name: %d:%s\n",a_security_value,h_security_name_Ind,h_security_name);//trace_flush();
            h_owner := 0;
            --trace_printf("b.1__* h_created_by: %s, h_res_id: %s\n",h_created_by,h_res_id);//trace_flush();
            If PMO_ORASTD.strcmp(h_created_by, h_res_id) = 0 Then
               If Coalesce(h_transfered_cri, 0) = 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = a_security_value,
                     SECURITY_ID = h_security_name
                     WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2105+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2106) : unassign_res.sql(4566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = a_security_value,
                     SECURITY_ID = h_security_name,
                     CRI_SECURITY_ID = h_cri_security_id
                     WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2126+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2127) : unassign_res.sql(4587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               BEGIN
                  SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
                  WHERE ELEMENT_ID = h_task_id AND RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2141+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2142) : unassign_res.sql(4602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("b.2__* SC_STATE: %d, h_uniqueID: %s\n",SC_STATE,h_uniqueID);//trace_flush();
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  If (h_resource_id IS NULL) Then
                     If Coalesce(h_transfered_cri, 0) = 0 Then
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS
                           SET PARTICIPANT = a_security_value,
                           SECURITY_ID = h_security_name
                           WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2165+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2166) : unassign_res.sql(4626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS
                           SET PARTICIPANT = a_security_value,
                           SECURITY_ID = h_security_name,
                           CRI_SECURITY_ID = h_cri_security_id
                           WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2186+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2187) : unassign_res.sql(4647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  Else
                     If Coalesce(h_transfered_cri, 0) = 0 Then
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS
                           SET PARTICIPANT = PMO_STPU.BIT_OR(PARTICIPANT,a_security_value),
                           SECURITY_ID = h_security_name
                           WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2208+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2209) : unassign_res.sql(4669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS
                           SET PARTICIPANT = PMO_STPU.BIT_OR(PARTICIPANT,a_security_value),
                           SECURITY_ID = h_security_name,
                           CRI_SECURITY_ID = h_cri_security_id
                           WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2229+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2230) : unassign_res.sql(4690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  End If;
                  
                  h_owner := PMO_CNST.SC_MANAGER;
                  h_resp_exists := 1;
                  --trace_printf("2.B_* SC_STATE: %d, h_owner: %d,a_security_value: %d, h_security_id: %s\n", SC_STATE,h_owner,a_security_value,h_security_id);
               Else
                  If Coalesce(h_transfered_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PROFILE_ID  = NuLL,
                        RESOURCE_ID = h_created_by,
                        PARTICIPANT = a_security_value,
                        SECURITY_ID = h_security_name
                        WHERE RES_ASSIGNMENT_ID = h_assign_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2258+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2259) : unassign_res.sql(4719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PROFILE_ID  = NuLL,
                        RESOURCE_ID = h_created_by,
                        PARTICIPANT = a_security_value,
                        SECURITY_ID = h_security_name,
                        CRI_SECURITY_ID = h_cri_security_id
                        WHERE RES_ASSIGNMENT_ID = h_assign_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2281+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2282) : unassign_res.sql(4742) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  h_total := Coalesce(h_total, 0) + 1;
                  --trace_printf("2.C_* SC_STATE: %d, h_owner: %d,a_security_value: %d, h_security_id: %s\n", SC_STATE,h_owner,a_security_value,h_security_id);
                  
                  OPEN C_COUNT2;
                  
                  FETCH C_COUNT2 INTO h_temp_id;
                  IF C_COUNT2%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     BEGIN
                        DELETE FROM PROJECT_ASSIGNMENTS
                        WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2312+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2313) : unassign_res.sql(4773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("PA__*** SC_STATE: %d\n",SC_STATE);//trace_flush();
                  End If;
                  BEGIN
                     CLOSE C_COUNT2 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2326+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2327) : unassign_res.sql(4787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               --trace_printf("b.3__* SC_STATE: %d, h_assign_id: %s, h_owner: %d, h_total: %d\n",SC_STATE,h_assign_id,h_owner,h_total);//trace_flush();
               
               If Coalesce(h_total, 0) = 0 Then
                  If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                     h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_uniqueID);
                  Else
                     h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_assign_id);
                  End If;
               Else
                  --trace_printf("h_res_id: %s, h_created_by: %s\n",h_res_id,h_created_by);
                  h_temp_res_type := '0';
                  h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_created_by, h_temp_res_type);
                  
                  If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                     BEGIN
                        UPDATE PROJECT_ASSIGNMENTS
                        SET (ESTIMATED_SCHED_START, ESTIMATED_SCHED_FINISH,ESTIMATED_SCHED_EFFORT,
                        ESTIMATED_PLANNED_START, ESTIMATED_PLANNED_FINISH,ESTIMATED_PLANNED_EFFORT)
                        = (SELECT ESTIMATED_SCHED_START, ESTIMATED_SCHED_FINISH,ESTIMATED_SCHED_EFFORT,
                        ESTIMATED_PLANNED_START, ESTIMATED_PLANNED_FINISH,ESTIMATED_PLANNED_EFFORT
                        FROM PROJECT_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id)
                        WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_created_by;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2363+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2364) : unassign_res.sql(4824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  h_temp_res_type := '0';
                  h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_res_id, h_temp_res_type);
               End If;
            End If;
         Else
            h_owner := PMO_CNST.SC_MANAGER;
         End If;
         
         If ((h_resource_id IS NOT NULL)) AND ((Coalesce(h_bitflag, 0) = 1) OR (Coalesce(
               h_bitflag, 0) = 2)) Then
            h_owner := 0;
            -- don't delete Resource Assignments
            --trace_printf("TA_new_res h_bitflag: %d, h_type_id: %d, h_work_type: %d\n", h_bitflag,h_type_id,h_work_type);
            If (Coalesce(h_bitflag, 0) = 1) AND (isTask(Coalesce(h_type_id, 0))) <> 0 Then
               If Coalesce(h_work_type, 0) = 2 Then
                  BEGIN
                     SELECT TSK_ASSIGNMENT_ID INTO h_tsk_assignment_id FROM TASK_ASSIGNMENTS
                     WHERE PROJECT_ID = h_project_id AND TASK_ID = h_task_id AND RESOURCE_ID = h_resource_id AND BIT_FLAG = '0';
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2393+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2394) : unassign_res.sql(4854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("TA_new_plan SC_STATE: %d, h_tsk_assignment_id: %s\n", SC_STATE,h_tsk_assignment_id);
               End If;
            End If;
            
            h_resp_exists := 2;
         End If;
      End If;
      --trace_printf("h_owner = %d, h_total = %d, h_created_by = %s,h_res_id = %s, h_res_type = %s\n",h_owner,h_total,h_created_by,h_res_id,h_res_type);
      --trace_printf("h_resp_exists: %d, h_profile_id: %d:%s\n",h_resp_exists,h_profile_id_Ind,h_profile_id);
      
      -- get ROLE_ID
      h_role_id := 'DEFAULTLEVEL';
      If SubStr(h_res_type, 1, 1) = '0' Then
         BEGIN
            DELETE FROM PROFILES WHERE PROJECT_ID = h_project_id AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2422+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2423) : unassign_res.sql(4883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT NICK_NAME, FS_LABOR_CODE INTO h_full_name,h_labor_code
            FROM RESOURCES WHERE RESOURCE_ID = h_res_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2436+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2437) : unassign_res.sql(4897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_bitflag, 0) = 0) AND (Coalesce(h_mls_percent, 0) = 0) Then
            h_profile_name := '';
         Else
            If (h_profile_id IS NOT NULL) Then
               BEGIN
                  SELECT ROLE_ID,PROFILE_NAME INTO h_temp_role_id,h_profile_name FROM PROFILES WHERE PROFILE_ID = h_profile_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2453+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2454) : unassign_res.sql(4914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((h_temp_role_id IS NOT NULL)) Then
                  h_role_id := h_temp_role_id;
               End If;
               
               If Coalesce(h_bitflag, 0) = 1 Then
                  BEGIN
                     SELECT COUNT(TSK_ASSIGNMENT_ID) INTO h_exists FROM TASK_ASSIGNMENTS
                     WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND RESOURCE_TYPE = '1'
                     AND TASK_ID = PROJECT_ID;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2473+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2474) : unassign_res.sql(4934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_exists, 0) > 0 Then
                     h_profile_id := NULL;
                     h_exists := 1;
                  End If;
               End If;
            Else
               If (h_prj_assignment_id IS NULL) Then
                  BEGIN
                     SELECT ROLE_ID INTO h_temp_role_id FROM RESOURCE_ASSIGN_ROLES
                     WHERE RES_ASSIGNMENT_ID = h_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2494+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2495) : unassign_res.sql(4955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("AA_* SC_STATE: %d, h_temp_role_id: %d:%s\n",SC_STATE,h_temp_role_id_Ind,h_temp_role_id);
                  
                  If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((h_temp_role_id IS NOT NULL)) Then
                     h_role_id := h_temp_role_id;
                  End If;
               Else
                  BEGIN
                     SELECT ROLE_ID INTO h_temp_role_id FROM RESOURCE_ASSIGN_ROLES
                     WHERE RES_ASSIGNMENT_ID = h_prj_assignment_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2513+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2514) : unassign_res.sql(4974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("BB_* SC_STATE: %d, h_temp_role_id: %d:%s\n",SC_STATE,h_temp_role_id_Ind,h_temp_role_id);
                  
                  If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((h_temp_role_id IS NOT NULL)) Then
                     h_role_id := h_temp_role_id;
                  End If;
               End If;
               
               --trace_printf("PROF_* SC_STATE: %d, h_role_id: %d:%s\n",SC_STATE,h_role_id_Ind,h_role_id);
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     SELECT PRIMARY_ROLE INTO h_temp_role_id FROM RESOURCES WHERE RESOURCE_ID=h_res_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2534+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2535) : unassign_res.sql(4995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((h_temp_role_id IS NOT NULL)) Then
                     h_role_id := h_temp_role_id;
                  End If;
               End If;
            End If;
         End If;
         h_role_id := h_role_id;
         --h_role_id_Ind = 0;
      ElsIf (h_profile_id IS NOT NULL) Then
         BEGIN
            SELECT ROLE_ID,PROFILE_NAME INTO h_role_id,h_full_name FROM PROFILES WHERE PROFILE_ID = h_profile_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2556+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2557) : unassign_res.sql(5017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("h_rollup = %d, h_bitflag = %d, h_res_type = %s, h_profile_id_Ind = %d\n", h_rollup,h_bitflag,h_res_type,h_profile_id_Ind);
      --trace_printf("h_res_id: %s, h_full_name: %s\n", h_res_id,h_full_name);
      
      If (Coalesce(h_bitflag, 0) < 2) AND (isTask(Coalesce(h_type_id, 0))) <> 0 Then
         PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_id, h_SD, h_FD, h_reg_cost
                                            , h_reg_sale, h_tph_delete, h_capital_expense
                                            , h_billable);
         --trace_printf("1__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d, h_id: %s\n",h_tph_delete,h_id); //trace_flush();
      End If;
      
      -- if TASK: replace the resource, Get PROFILE_ID
      If (Coalesce(h_bitflag, 0) < 2) AND (SubStr(h_res_type, 1, 1) = '0') Then
         If ((h_resource_id IS NOT NULL)) Then
            BEGIN
               SELECT NICK_NAME INTO h_profile_name FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2582+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2583) : unassign_res.sql(5043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 2589+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(2590) : unassign_res.sql(5050) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_DB2M.SC_STATE;
            End If;
            
            h_profile_id := h_resource_id;
            h_replace_type := '0';
         ElsIf ((h_profile_id IS NULL)) OR (Coalesce(h_exists, 0) = 1) Then
            h_replace_type := '1';
            -- create profile
            BEGIN
               SELECT PROFILE_ID, PROFILE_NAME INTO h_profile_id, h_profile_name
               FROM PMO_TMP_DELETE WHERE ROLE_ID = h_role_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2608+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2609) : unassign_res.sql(5069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1__ SC_STATE = %d, h_role_id = %s, h_role_id_Ind = %d\nh_profile_id = %s, h_profile_id_Ind = %d, h_profile_name = %s\n", SC_STATE,h_role_id,h_role_id_Ind,h_profile_id,h_profile_id_Ind,h_profile_name);
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               h_profile_id := '';
               h_profile_id := SYS_GUID();
               --h_profile_id_Ind = 0;
               
               BEGIN
                  SELECT COALESCE(MAX(PROF_NUMBER),0)+1 INTO h_number
                  FROM PROFILES WHERE PROJECT_ID=h_project_id AND ROLE_ID=h_role_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2628+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2629) : unassign_res.sql(5089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(TCP.ELEMENT_NAME), ', '), RTRIM(TC.ELEMENT_NAME)), '('), RTRIM(TO_CHAR(h_number))), ')') INTO h_profile_name
                  FROM TMT_COMPETENCIES TC, TMT_COMPETENCIES TCP WHERE TC.ELEMENT_ID = h_role_id AND TCP.ELEMENT_ID = TC.PARENT_ID;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2642+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2643) : unassign_res.sql(5103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PROFILES(PROFILE_ID,PROJECT_ID,ROLE_ID,PROF_NUMBER, PROFILE_NAME)
                  VALUES(h_profile_id, h_project_id, h_role_id, h_number, h_profile_name);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2660+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2661) : unassign_res.sql(5121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_DELETE (ROLE_ID, PROFILE_ID, PROFILE_NAME) VALUES(h_role_id, h_profile_id, h_profile_name);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2677+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2678) : unassign_res.sql(5138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         --trace_printf("h_profile_id = %s, h_profile_id_Ind = %d, h_profile_name = %s\n", h_profile_id,h_profile_id_Ind,h_profile_name);
         --trace_printf("h_bitflag: %d, h_mls_percent: %d\n", h_bitflag,h_mls_percent);
         
         If (Coalesce(h_bitflag, 0) = 1) AND (Coalesce(h_mls_percent, 0) = 0) Then
            -- get profile/resource cost  rates
            l_data_flag := 0;
            If ((h_resource_id IS NOT NULL)) Then
               h_temp_sc_state := FC_GET_RES_RATES(h_project_id, h_resource_id, h_replace_type, h_null_str
                                    , h_null_str, l_data_flag, h_reg_cost, h_spec_cost, h_spec_sale
                                    , h_spec_sale);
            Else
               h_temp_sc_state := FC_GET_RES_RATES(h_project_id, h_profile_id, h_replace_type, h_null_str
                                    , h_null_str, l_data_flag, h_reg_cost, h_spec_cost, h_spec_sale
                                    , h_spec_sale);
            End If;
            --trace_printf("%$%$_SC_STATE: %d, h_reg_cost: %.2f, h_reg_sale: %.2f, h_rate_echange: %.2f\n",SC_STATE,h_reg_cost,h_reg_sale,h_rate_echange);
            
            h_temp_var := 0;
            PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_id, h_SD, h_FD, h_reg_cost
                                            , h_reg_sale, h_temp_var, h_capital_expense, h_billable);
            --trace_printf("1.P__TPHASE_SCHED_ASSIGN__ h_temp_var: %d, h_id: %s\n",h_temp_var,h_id); //trace_flush();
            
            If Coalesce(h_transfered_cri, 0) = 1 Then
               BEGIN
                  SELECT PARTICIPANT, CRI_SECURITY_ID INTO h_count, h_temp_security_id
                  FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID  = h_assign_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2716+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2717) : unassign_res.sql(5177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT PARTICIPANT, SECURITY_ID INTO h_count, h_temp_security_id
                  FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID  = h_assign_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2730+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2731) : unassign_res.sql(5191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            --trace_printf("1.0_* SC_STATE: %d, h_resp_exists: %d, h_temp_security_id: %s, h_count: %d\n", SC_STATE,h_resp_exists,h_temp_security_id,h_count);
            
            If (Coalesce(h_resp_exists, 0) = 0) AND ((BITAND(Coalesce(
                  h_count, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0) Then
               -- if manager insert a new record in Resource_Assignments
               h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
               --trace_printf("\n 13175 h_temp_security_id %s\n",h_temp_security_id);//trace_flush();
               
               h_uniqueID := '';
               h_uniqueID := SYS_GUID();
               h_temp_res_type := '0';
               h_temp_bitflag := 1;
               h_temp_participant := PMO_CNST.SC_TEAMMEMBER;
               
               h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_profile_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
               
               If ((h_resource_id IS NOT NULL)) Then
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,
                     RESOURCE_TYPE, RESOURCE_ID, PARTICIPANT, SECURITY_ID, TABLE_TYPE, REC_DATETIME)
                     SELECT h_uniqueID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,
                     '0', h_resource_id, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, h_table_type, SYSTIMESTAMP
                     FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2770+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2771) : unassign_res.sql(5231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,
                     RESOURCE_TYPE, PROFILE_ID, RESOURCE_ID, PARTICIPANT, SECURITY_ID, TABLE_TYPE, REC_DATETIME)
                     SELECT h_uniqueID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,
                     '1', h_profile_id, PROFILE_ID, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, h_table_type, SYSTIMESTAMP
                     FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2791+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2792) : unassign_res.sql(5252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               --trace_printf("1.1__ SC_STATE = %d, h_uniqueID = %s, h_profile_id = %d:%s\n", SC_STATE,h_uniqueID,h_profile_id_Ind,h_profile_id);
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 2799+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(2800) : unassign_res.sql(5260) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_DB2M.SC_STATE;
               End If;
               
               If (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(h_rollup, 0) = 1) Then
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id,
                     RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                     WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2819+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2820) : unassign_res.sql(5280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id,
                     RESOURCE_TYPE = h_replace_type, PROJECT_ASSIGNMENT_ID = NuLL, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                     WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2838+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2839) : unassign_res.sql(5299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A1__ SC_STATE: %d, h_replace_type: %s, h_id: %s\n", SC_STATE,h_replace_type,h_id);
               End If;
               
               If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                  BEGIN
                     UPDATE TMT_WBS SET ASSIGN_NAMES = ASSIGN_NAMES || h_profile_name || ';' WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2858+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2859) : unassign_res.sql(5319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TMT_CRI SET ASSIGN_NAMES = ASSIGN_NAMES || h_profile_name || ';' WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2875+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2876) : unassign_res.sql(5336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               --trace_printf("COUNT_1: SC_STATE = %d, h_task_id= %s, h_profile_name = %s\n",SC_STATE,h_task_id,h_profile_name);
            Else
               --trace_printf("1.2__ SC_STATE = %d, h_assign_id = %s, h_profile_id = %d:%s\n", SC_STATE,h_assign_id,h_profile_id_Ind,h_profile_id);
               --trace_printf("h_transfered_cri: %d, h_res_id: %s, h_full_name: %s\n", h_transfered_cri,h_res_id,h_full_name);
               
               If ((h_resource_id IS NOT NULL)) Then
                  If Coalesce(h_work_type, 0) = 0 Then
                     h_effort := Coalesce(h_planned_work, 0);
                  End If;
                  
                  h_res_assignment_id := '';
                  h_temp_sc_state := FC_MERGE_ASSIGN(h_bitflag, h_project_id, h_task_id, h_resource_id, h_assign_id
                                   , h_res_assignment_id, h_rec_user, h_effort, 0);
                  h_temp_sc_state := BITAND(Coalesce(h_count, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE);
                  --trace_printf("h_temp_sc_state: %d, h_count: %d, h_assign_id: %s, h_res_assignment_id: %d:%s\n", h_temp_sc_state,h_count,h_assign_id,h_res_assignment_id_Ind,h_res_assignment_id);
                  
                  If Coalesce(h_temp_sc_state, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL, RESOURCE_TYPE = '0', RESOURCE_ID = h_resource_id
                        WHERE RES_ASSIGNMENT_ID = h_assign_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2910+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2911) : unassign_res.sql(5371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("UPDATE_TEAMMEMBER: SC_STATE = %d, h_resource_id: %d:%s\n",SC_STATE,h_resource_id_Ind,h_resource_id);
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                        BEGIN
                           UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_res_assignment_id
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2930+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2931) : unassign_res.sql(5391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        h_assign_id := h_res_assignment_id;
                     End If;
                  Else
                     If Coalesce(Length(h_res_assignment_id), 0) = 32 Then
                        BEGIN
                           SELECT RES_ASSIGNMENT_ID INTO h_res_assignment_id FROM RESOURCE_ASSIGNMENTS
                           WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND RESOURCE_ID = h_resource_id;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2948+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2949) : unassign_res.sql(5409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("RA_32 SC_STATE: %d, h_res_assignment_id: %d:%s\n",SC_STATE,h_res_assignment_id_Ind,h_res_assignment_id);
                        
                        If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_res_assignment_id
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 2968+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(2969) : unassign_res.sql(5429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           h_assign_id := h_res_assignment_id;
                        End If;
                     End If;
                  End If;
               Else
                  ora_temp_sc_state := PMO_DB2M.SC_STATE;
                  null_return := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                             , PMO_CNST.SC_TEAMMEMBER_GROUP, h_security_name);
                  PMO_DB2M.SC_STATE := ora_temp_sc_state;
                  If Coalesce(h_transfered_cri, 0) = 1 Then
                     h_cri_element_type := FC_MIRROR_TYPE(h_type_id);
                     h_cri_table_type := PMO_CNST.SC_TABLE_CRI;
                     ora_temp_sc_state := PMO_DB2M.SC_STATE;
                     null_return := GetSecurityID(Coalesce(h_cri_table_type, 0), Coalesce(h_cri_element_type, 0)
                             , PMO_CNST.SC_TEAMMEMBER_GROUP, h_cri_security_id);
                     PMO_DB2M.SC_STATE := ora_temp_sc_state;
                  Else
                     h_cri_security_id := NULL;
                  End If;
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS SET 
                     PROFILE_ID = h_profile_id, 
                     RESOURCE_TYPE = '1', 
                     RESOURCE_ID = NuLL,
                     PARTICIPANT = PMO_CNST.SC_TEAMMEMBER,
                     SECURITY_ID = h_security_name,
                     CRI_SECURITY_ID = h_cri_security_id
                     WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3011+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3012) : unassign_res.sql(5472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               --trace_printf("COUNT_2.0: h_full_name: %s, h_profile_name: %s\n",h_full_name,h_profile_name);
               If (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(h_transfered_cri, 0) = 0) Then
                  BEGIN
                     UPDATE TMT_WBS SET ASSIGN_NAMES =
                     CASE
                     WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') > 0
                     THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                     ELSE REPLACE (ASSIGN_NAMES, h_full_name || ';', h_profile_name || ';')
                     END
                     WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3037+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3038) : unassign_res.sql(5498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TMT_CRI SET ASSIGN_NAMES =
                     CASE
                     WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') > 0
                     THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                     ELSE REPLACE (ASSIGN_NAMES, h_full_name || ';', h_profile_name || ';')
                     END
                     WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3060+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3061) : unassign_res.sql(5521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               --trace_printf("COUNT_2: SC_STATE = %d, h_task_id= %s, h_profile_name = %s, h_rollup: %d\n",SC_STATE,h_task_id,h_profile_name,h_rollup);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  --strcpy(h_names_task_id,h_task_id);
                  h_names_task_id := h_task_id;
               End If;
               
               If (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(h_rollup, 0) = 1) Then
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id,
                     RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                     WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3087+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3088) : unassign_res.sql(5548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  --here don't update the prject_assignment_id with null at this point since it we have to check after if Prject assignmnet exists
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id,
                     RESOURCE_TYPE = h_replace_type, /*PROJECT_ASSIGNMENT_ID = NuLL,*/ REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                     WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3107+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3108) : unassign_res.sql(5568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A1__ SC_STATE = %d, h_profile_id_Ind = %d, h_id = %s\n", SC_STATE,h_profile_id_Ind,h_id);
               End If;
            End If;
            
            BEGIN
               UPDATE SUMMARY_TIMESHEETS SET RESOURCE_ID = h_profile_id,
               ACTUAL_REGULAR_COST = h_reg_cost,
               ACTUAL_SPECIAL_COST = h_spec_cost,
               REC_USER = h_rec_user, REC_DATETIME = SYSTIMESTAMP
               WHERE TSK_ASSIGNMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3131+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3132) : unassign_res.sql(5592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      --trace_printf("h_owner = %d, h_total = %d, h_type_id = %d, h_mls_percent = %d, h_prj_assignment_id_Ind = %d\nh_res_id = %s, h_res_type = %s\n",h_owner,h_total,h_type_id,h_mls_percent,h_prj_assignment_id_Ind,h_res_id,h_res_type);
      
      h_rollup_bits := PMO_CNST.SC_ASSIGNMENT_BIT;
      If isTask(Coalesce(h_type_id, 0)) <> 0 Then
         --trace_printf("isTask h_type_id: %d,h_effort: %d, h_mls_percent: %d, h_prj_assignment_id: %d:%s\n", h_type_id,h_effort,h_mls_percent,h_prj_assignment_id_Ind,h_prj_assignment_id);
         If (Coalesce(h_mls_percent, 0) = 0) AND ((h_prj_assignment_id IS NOT NULL)) Then
            -- fix task assignments from affected to project
            
            OPEN CPASS;
            
            LOOP
               FETCH CPASS INTO h_day_year, h_minutes, h_tsk_assignment_id, h_prj_assignment_id, h_bitID;
               IF CPASS%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               If Coalesce(h_from_prj, 0) = 0 Then
                  h_from_prj := 1;
               End If;
               
               --h_bit_minutes = FC_DCONSIDER_DAY(h_project_id, h_tsk_assignment_id, h_prj_assignment_id, h_day_year, h_bitID);
               
               If Coalesce(h_minutes, 0) > 0 Then
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET SCHED_MIN = SCHED_MIN + h_minutes, TASK_ID = h_project_id, BIT_SCHED = UTL_RAW.BIT_OR(BIT_SCHED, h_bitID)
                     WHERE PROJECT_ID = h_project_id 
                     AND TSK_ASSIGNMENT_ID = h_prj_assignment_id 
                     AND DAY_YEAR = h_day_year;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3180+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3181) : unassign_res.sql(5641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET TASK_ID = h_project_id, TSK_ASSIGNMENT_ID = h_prj_assignment_id
                        WHERE PROJECT_ID = h_project_id 
                        AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id 
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3201+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3202) : unassign_res.sql(5662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               --trace_printf("2__ SC_STATE = %d, h_day_year = %s, h_bit_minutes = %d\n",SC_STATE,h_day_year,h_bit_minutes);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  If Coalesce(h_bitflag, 0) = 0 Then
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR 
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3224+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3225) : unassign_res.sql(5685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               Else
                  If Coalesce(h_bitflag, 0) = 1 Then
                     BEGIN
                        INSERT INTO TASK_DAY_OF_YEAR(PROJECT_ID,TASK_ID,RESOURCE_ID,TSK_ASSIGNMENT_ID,DAY_YEAR,BIT_FLAG,SCHED_MIN,PARENT_ID,BIT_SCHED)
                        SELECT PROJECT_ID,TASK_ID,RESOURCE_ID,PARENT_ID,DAY_YEAR,BIT_FLAG,SCHED_MIN,PARENT_ID,BIT_SCHED 
                        FROM TASK_DAY_OF_YEAR
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3246+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3247) : unassign_res.sql(5707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, PARENT_ID = TSK_ASSIGNMENT_ID, BIT_FLAG = '0'
                        WHERE PROJECT_ID = h_project_id 
                        AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id 
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3266+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3267) : unassign_res.sql(5727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("2__ SC_STATE = %d, h_tsk_assignment_id = %s\n",SC_STATE,h_tsk_assignment_id);
                  ElsIf Coalesce(h_bitflag, 0) = 0 Then
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET TSK_ASSIGNMENT_ID = PARENT_ID, TASK_ID = h_project_id
                        WHERE PROJECT_ID = h_project_id 
                        AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id 
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3287+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3288) : unassign_res.sql(5748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            END LOOP;
            
            BEGIN
               CLOSE CPASS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3303+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3304) : unassign_res.sql(5764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If SubStr(h_res_type, 1, 1) = '0' Then
            If (Coalesce(h_total, 0) > 0) AND (PMO_ORASTD.strcmp(h_task_id, h_names_task_id) <> 0) Then
               BEGIN
                  SELECT NICK_NAME INTO h_creator_name FROM RESOURCES WHERE RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3319+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3320) : unassign_res.sql(5780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_WBS SET ASSIGN_NAMES =
                  CASE WHEN InStr( ASSIGN_NAMES, h_creator_name || ';') = 0 THEN
                  CASE
                  WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                  THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', h_creator_name || ';')
                  ELSE h_creator_name || ';' || ASSIGN_NAMES
                  END
                  ELSE ASSIGN_NAMES
                  END
                  WHERE ELEMENT_ID = h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3345+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3346) : unassign_res.sql(5806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("COUNT_3: SC_STATE = %d, h_task_id= %s, h_full_name: %s, h_creator_name = %s\n",SC_STATE,h_task_id,h_full_name,h_creator_name);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     UPDATE TMT_CRI SET ASSIGN_NAMES =
                     CASE WHEN InStr( ASSIGN_NAMES, h_creator_name || ';') = 0 THEN
                     CASE
                     WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                     THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', h_creator_name || ';')
                     ELSE h_creator_name || ';' || ASSIGN_NAMES
                     END
                     ELSE ASSIGN_NAMES
                     END
                     WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3373+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3374) : unassign_res.sql(5834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  --strcpy(h_names_task_id,h_task_id);
                  h_names_task_id := h_task_id;
               End If;
            End If;
            
            h_from_prj := 0;
            
            If Coalesce(h_mls_percent, 0) = 0 Then
               If Coalesce(h_bitflag, 0) = 0 Then
                  If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                     -- flag the task, for new rollup
                     If Coalesce(h_table_type, 0) = 1 Then
                        BEGIN
                           UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                           ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3406+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3407) : unassign_res.sql(5867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           UPDATE TMT_CRI SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                           ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3425+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3426) : unassign_res.sql(5886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     --trace_printf("COUNT-4: SC_STATE: %d, h_table_type: %d, h_task_id: %s, h_rollup_bits: %d, h_full_name: %s\n",SC_STATE,h_table_type,h_task_id,h_rollup_bits,h_full_name);
                  Else
                     If Coalesce(h_table_type, 0) = 1 Then
                        BEGIN
                           UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits)
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3446+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3447) : unassign_res.sql(5907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           UPDATE TMT_CRI SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits)
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3464+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3465) : unassign_res.sql(5925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     --trace_printf("COUNT-5: SC_STATE = %d, h_table_type: %d, h_task_id= %s, h_rollup_bits = %d\n",SC_STATE,h_table_type,h_task_id,h_rollup_bits);
                  End If;
                  --trace_printf("$$$_2_h_from_prj: %d\n",h_from_prj);
                  
                  If Coalesce(h_from_prj, 0) = 0 Then
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3486+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3487) : unassign_res.sql(5947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  BEGIN
                     DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3504+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3505) : unassign_res.sql(5965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3521+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3522) : unassign_res.sql(5982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (SubStr(h_close_task, 1, 1) = 'Y') AND (Coalesce(h_owner2, 0) = PMO_CNST.SC_TEAMMEMBER) Then
                     h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_temp_security_id);
                     h_temp_participant := BITAND(Coalesce(h_owner2, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_temp_participant, 
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_assign_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3546+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3547) : unassign_res.sql(6007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("2.D_* SC_STATE: %d, h_owner: %d,a_security_value: %d, h_security_id: %s\n", SC_STATE,h_owner,a_security_value,h_security_id);
                  ElsIf (SubStr(h_close_task, 1, 1) = 'N') AND (Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER) Then
                     OPEN srch003;
                     
                     FETCH srch003 INTO h_temp_id;
                     IF srch003%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     
                     If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                        h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
                        
                        BEGIN
                           DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3576+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3577) : unassign_res.sql(6037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     
                     BEGIN
                        CLOSE srch003 ;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3590+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3591) : unassign_res.sql(6051) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  -- Check for last assignment to current taks id
                  --BEGIN_SQL
                  --  SELECT TASK_ID FROM TASK_ASSIGNMENTS WHERE TASK_ID = HOST(h_task_id) ;
                  --END_SQL;
                  
                  OPEN srch001;
                  
                  FETCH srch001 INTO h_temp_id;
                  IF srch001%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS AND (isCRITask(Coalesce(h_type_id, 0)) <> 0 
                        OR isWBSTransferedTask(Coalesce(h_type_id, 0)) <> 0) Then
                     h_temp_sc_state := FC_CHANGE_TYPE_BY_UNASSIGN(h_type_id, h_task_id, h_rec_user);
                  End If;
                  
                  BEGIN
                     CLOSE srch001 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3623+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3624) : unassign_res.sql(6084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf Coalesce(h_bitflag, 0) = 1 Then
                  If Coalesce(h_work_type, 0) = 2 Then
                     If ((h_resource_id IS NOT NULL)) Then
                        h_res_assignment_id := '';
                        h_temp_sc_state := FC_MERGE_ASSIGN(h_bitflag, h_project_id, h_task_id, h_resource_id, h_assign_id
                                   , h_res_assignment_id, h_rec_user, h_effort, 0);
                        --trace_printf("h_temp_sc_state: %d, h_res_assignment_id: %d:%s\n", h_temp_sc_state,h_res_assignment_id_Ind,h_res_assignment_id);
                     Else
                        If Coalesce(h_rollup, 0) = 1 Then
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, BIT_FLAG = '0',
                              PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                              SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0
                              WHERE TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3651+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3652) : unassign_res.sql(6112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, BIT_FLAG = '0'
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3669+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3670) : unassign_res.sql(6130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, BIT_FLAG = '0',
                              PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                              SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0, PROJECT_ASSIGNMENT_ID = NuLL
                              WHERE TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3689+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3690) : unassign_res.sql(6150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, BIT_FLAG = '0', PARENT_ID = TSK_ASSIGNMENT_ID
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3707+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3708) : unassign_res.sql(6168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                     --trace_printf("A2__ SC_STATE = %d, h_rollup = %d, h_id = %s\n", SC_STATE,h_rollup,h_id);
                  Else
                     If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                        If Coalesce(h_rollup, 0) = 1 Then
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type
                              WHERE TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3730+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3731) : unassign_res.sql(6191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id 
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3748+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3749) : unassign_res.sql(6209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, PROJECT_ASSIGNMENT_ID = NuLL
                              WHERE TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3766+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3767) : unassign_res.sql(6227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, PARENT_ID = TSK_ASSIGNMENT_ID
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3784+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3785) : unassign_res.sql(6245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                        --trace_printf("A3__ SC_STATE = %d, h_rollup = %d, h_id = %s\n", SC_STATE,h_rollup,h_id);
                        
                        ora_temp_sc_state := PMO_DB2M.SC_STATE;
                        null_return := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                              , PMO_CNST.SC_TEAMMEMBER_GROUP, h_security_name);
                        PMO_DB2M.SC_STATE := ora_temp_sc_state;
                        If Coalesce(h_transfered_cri, 0) = 1 Then
                           h_cri_element_type := FC_MIRROR_TYPE(h_type_id);
                           h_cri_table_type := PMO_CNST.SC_TABLE_CRI;
                           ora_temp_sc_state := PMO_DB2M.SC_STATE;
                           null_return := GetSecurityID(Coalesce(h_cri_table_type, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_cri_security_id);
                           PMO_DB2M.SC_STATE := ora_temp_sc_state;
                        Else
                           h_cri_security_id := NULL;
                        End If;
                        
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS SET 
                           PROFILE_ID = h_profile_id, 
                           RESOURCE_TYPE = '1', 
                           RESOURCE_ID = NuLL,
                           PARTICIPANT = PMO_CNST.SC_TEAMMEMBER,
                           SECURITY_ID = h_security_name,
                           CRI_SECURITY_ID = h_cri_security_id
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3825+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3826) : unassign_res.sql(6286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, PARENT_ID = TSK_ASSIGNMENT_ID
                           WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3843+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3844) : unassign_res.sql(6304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  End If;
               Else
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'FC_D_TSKRES', 3851+1) THEN 
                     LFILE.FPUT('AllTrace', '      RETURN_INVALID: FC_D_TSKRES(3852) : unassign_res.sql(6312) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 3854+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(3855) : unassign_res.sql(6315) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS, False);
               End If;
            Else
               -- Check if created from PROJECT assignment
               
               OPEN CPAS2T;
               
               FETCH CPAS2T INTO h_uniqueID;
               IF CPAS2T%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE = 0 Then
                  h_from_prj := 1;
               Else
                  h_from_prj := 0;
               End If;
               
               BEGIN
                  CLOSE CPAS2T ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3884+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3885) : unassign_res.sql(6345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag1, 0) > 89 Then
                  If Coalesce(h_work, 0) = 0 Then
                     h_bitflag1 := 0;
                  Else
                     h_bitflag1 := 1;
                  End If;
               End If;
               
               If (Coalesce(h_from_prj, 0) = 1) AND (Coalesce(h_donot_replace, 0) = 1) Then
                  h_donot_replace := Coalesce(h_donot_replace, 0) + 1;
               End If;
               
               --trace_printf("h_bitflag: %d, h_bitflag27: %d\n", h_bitflag, h_bitflag_27);
               -- bitflag 0  1
               If Coalesce(h_bitflag_27, 0) <> PMO_CNST.SC_BIT_27 Then
                  PMO_DB2M.SC_STATE := FC_D_ACTUAL(h_table_type, h_type_id, h_assign_id, h_id, h_project_id, h_task_id
                                 , h_type_id, h_res_id, h_profile_id, h_bitflag, h_donot_replace
                                 , h_effort, h_eunit, h_work, h_unit, h_bitflag1, h_min_per_day
                                 , h_priority, h_contour, h_occurrence, h_rec_user);
               Else
                  --when deleted from upper window in staffing view keep assignmnets withactual passing bitfalg27
                  PMO_DB2M.SC_STATE := FC_D_ACTUAL(h_table_type, h_type_id, h_assign_id, h_id, h_project_id, h_task_id
                                 , h_type_id, h_res_id, h_profile_id, h_bitflag_27, h_donot_replace
                                 , h_effort, h_eunit, h_work, h_unit, h_bitflag1, h_min_per_day
                                 , h_priority, h_contour, h_occurrence, h_rec_user);
               End If;
               --trace_printf("SC_STATE = %d, h_donot_replace: %d, h_owner1: %d, h_profile_id = %s, h_profile_name = %s\n", SC_STATE,h_donot_replace,h_owner1,h_profile_id,h_profile_name);
               --trace_printf("h_assign_id: %s, h_res_assignment_id: %s\n",h_assign_id,h_res_assignment_id);
               
               --                  if ( (h_owner1  SC_TASK_RESPONSIBLE) == SC_TASK_RESPONSIBLE )
               If (BITAND(Coalesce(h_owner1, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
                  BEGIN
                     SELECT RES_ASSIGNMENT_ID INTO h_res_assignment_id FROM RESOURCE_ASSIGNMENTS
                     WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND RESOURCE_ID = h_resource_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3929+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3930) : unassign_res.sql(6390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("RA_1a SC_STATE: %d, h_res_assignment_id: %s\n",SC_STATE,h_res_assignment_id);
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     h_temp_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TASK_RESPONSIBLE, PMO_CNST.SC_TEAMMEMBER);
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = h_temp_participant, SECURITY_ID = 'SCTASKRESPONSIBLE'
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3950+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3951) : unassign_res.sql(6411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("RA_1b SC_STATE: %d, h_temp_participant: %d\n",SC_STATE,h_temp_participant);
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = PMO_CNST.SC_TEAMMEMBER, SECURITY_ID = 'SCTASKTEAMMEMBER'
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 3970+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(3971) : unassign_res.sql(6431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("RA_1c SC_STATE: %d, h_assign_id: %s\n",SC_STATE,h_assign_id);
                     End If;
                  ElsIf ((h_resource_id IS NOT NULL)) Then
                     h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
                     h_uniqueID := '';
                     h_uniqueID := SYS_GUID();
                     h_temp_res_type := '0';
                     h_temp_bitflag := 1;
                     h_temp_participant := PMO_CNST.SC_TASK_RESPONSIBLE;
                     --trace_printf("new RA_** h_uniqueID: %d:%s, h_temp_security_id: %d:%s\n",h_uniqueID_Ind,h_uniqueID,h_temp_security_id_Ind,h_temp_security_id);//trace_flush();
                     
                     h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_resource_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
                     
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                        RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,TABLE_TYPE,REC_USER,REC_DATETIME)
                        VALUES(h_uniqueID, h_project_id, h_task_id, h_type_id,
                        '0', h_resource_id, PMO_CNST.SC_TASK_RESPONSIBLE, h_temp_security_id, 'U', h_table_type, h_rec_user, SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4004+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4005) : unassign_res.sql(6465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                        --trace_printf("old RA_** h_temp_security_id %d:%s",h_temp_security_id_Ind,h_temp_security_id);//trace_flush();
                        
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = PMO_CNST.SC_TEAMMEMBER, SECURITY_ID = h_temp_security_id
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4027+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4028) : unassign_res.sql(6488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("old RA_** SC_STATE: %d, h_assign_id: %s, h_temp_security_id: %d\n",SC_STATE,h_assign_id,h_temp_security_id);
                     End If;
                  ElsIf Coalesce(h_bitflag, 0) = 0 Then
                     If Coalesce(h_mls_percent, 0) = 0 Then
                        h_temp_participant := BITAND(Coalesce(h_owner1, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
                        
                        BEGIN
                           UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = h_temp_participant
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4050+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4051) : unassign_res.sql(6511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        h_day_year := NULL;
                        BEGIN
                           SELECT MAX(WEEK_OF) INTO h_day_year FROM TIMESHEET_APPROVAL_STATUS
                           WHERE ELEMENT_ID = h_project_id AND RESOURCE_ID = h_res_id
                           AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED);
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4066+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4067) : unassign_res.sql(6527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        If (h_day_year IS NULL) Then
                           h_temp_participant := BITAND(Coalesce(h_owner1, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
                           
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = h_temp_participant
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4087+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4088) : unassign_res.sql(6548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                     --trace_printf("old RA_ SC_STATE: %d, h_assign_id: %s, h_temp_participant: %d\n",SC_STATE,h_assign_id,h_temp_participant);
                  End If;
               End If;
               --trace_printf("SC_STATE = %d, h_donot_replace: %d\n", SC_STATE,h_donot_replace);
               
               -- Add profile name
               If Coalesce(h_donot_replace, 0) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                     ASSIGN_NAMES =
                     CASE
                     WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') = 0
                     THEN ASSIGN_NAMES || h_profile_name || ';'
                     ELSE ASSIGN_NAMES
                     END
                     WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4119+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4120) : unassign_res.sql(6580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("COUNT+7.1: SC_STATE = %d, h_task_id= %s, h_profile_name = %s\n",SC_STATE,h_task_id,h_profile_name);
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                     BEGIN
                        UPDATE TMT_CRI SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                        ASSIGN_NAMES =
                        CASE
                        WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') = 0
                        THEN ASSIGN_NAMES || h_profile_name || ';'
                        ELSE ASSIGN_NAMES
                        END
                        WHERE ELEMENT_ID = h_task_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4145+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4146) : unassign_res.sql(6606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               Else
                  BEGIN
                     UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits)
                     WHERE ELEMENT_ID = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4164+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4165) : unassign_res.sql(6625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("COUNT+7.2: SC_STATE = %d, h_task_id= %s, h_profile_name = %s\n",SC_STATE,h_task_id,h_profile_name);
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                     BEGIN
                        UPDATE TMT_CRI SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits)
                        WHERE ELEMENT_ID = h_task_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4184+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4185) : unassign_res.sql(6645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
            
            --trace_printf("h_from_prj = %d, h_bitflag = %d, h_mls_percent = %d\n", h_from_prj,h_bitflag,h_mls_percent);
            If (Coalesce(h_from_prj, 0) = 0) AND ((Coalesce(h_bitflag, 0) = 1) OR (Coalesce(
                  h_mls_percent, 0) > 0)) Then
               BEGIN
                  SELECT TSK_ASSIGNMENT_ID INTO h_uniqueID FROM TASK_ASSIGNMENTS
                  WHERE TASK_ID = h_project_id AND RESOURCE_ID = h_profile_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4204+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4205) : unassign_res.sql(6665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE = %d, h_uniqueID = %d:%s\n", SC_STATE,h_uniqueID_Ind,h_uniqueID);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND ((h_uniqueID IS NOT NULL)) Then
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = h_uniqueID
                     WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND TSK_ASSIGNMENT_ID <> h_uniqueID;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4224+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4225) : unassign_res.sql(6685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("TASK_ASSIGNMENTS: SC_STATE = %d\n", SC_STATE);
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = h_uniqueID
                     WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND PARENT_ID <> h_uniqueID;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4243+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4244) : unassign_res.sql(6704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("TASK_DAY_OF_YEAR: SC_STATE = %d\n", SC_STATE);
               End If;
            End If;
         Else
            BEGIN
               DELETE FROM TASK_DAY_OF_YEAR 
               WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4264+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4265) : unassign_res.sql(6725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_prj_assignment_id := NULL;
            
            BEGIN
               SELECT PROJECT_ASSIGNMENT_ID INTO h_prj_assignment_id
               FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_id AND BIT_FLAG='0';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4281) : unassign_res.sql(6741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4297+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4298) : unassign_res.sql(6758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4314+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4315) : unassign_res.sql(6775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id AND NOT EXISTS(
               SELECT RES_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4334+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4335) : unassign_res.sql(6795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- flag the task, for new rollup
            If Coalesce(h_table_type, 0) = 1 Then
               BEGIN
                  UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                  ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                  WHERE ELEMENT_ID = h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4355+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4356) : unassign_res.sql(6816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_CRI SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                  ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                  WHERE ELEMENT_ID = h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4374+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4375) : unassign_res.sql(6835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            --trace_printf("COUNT-7: SC_STATE = %d, h_task_id= %s, h_rollup_bits = %d, h_full_name = %s\n",SC_STATE,h_task_id,h_rollup_bits,h_full_name);
            
            OPEN srch002;
            
            FETCH srch002 INTO h_temp_id;
            IF srch002%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            --trace_printf("COUNT-7.1: SC_STATE = %d\n",SC_STATE);
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS AND (isCRITask(Coalesce(h_type_id, 0)) <> 0 
                  OR isWBSTransferedTask(Coalesce(h_type_id, 0)) <> 0) Then
               h_temp_sc_state := FC_CHANGE_TYPE_BY_UNASSIGN(h_type_id, h_task_id, h_rec_user);
            End If;
            
            BEGIN
               CLOSE srch002 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4405+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4406) : unassign_res.sql(6866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_fs_project, 0) = 1) AND (SubStr(h_res_type, 1, 1) = '0') Then
            OPEN CFSASS1;
            
            FETCH CFSASS1 INTO h_uniqueID;
            IF CFSASS1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               BEGIN
                  UPDATE TMT_WBS SET FS_LABOR_CODE = Null
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID=h_task_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4435+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4436) : unassign_res.sql(6896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  SELECT FS_LABOR_CODE INTO h_labor_code FROM TMT_WBS
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND FS_LABOR_CODE = h_labor_code;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4449+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4450) : unassign_res.sql(6910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE = %d, h_labor_code = %d, %s, h_uniqueID = %s\n", SC_STATE,h_labor_code_Ind,h_labor_code,h_uniqueID);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  BEGIN
                     SELECT FS_LABOR_CODE INTO h_labor_code FROM RESOURCES WHERE RESOURCE_ID = h_uniqueID;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4464+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4465) : unassign_res.sql(6925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TMT_WBS SET FS_LABOR_CODE = h_labor_code
                     WHERE PROJECT_ID = h_project_id AND ELEMENT_ID=h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4482+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4483) : unassign_res.sql(6943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            BEGIN
               CLOSE CFSASS1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4497+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4498) : unassign_res.sql(6958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase FROM PROJECT_DETAILS WHERE PROJECT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4511+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4512) : unassign_res.sql(6972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("Project SC_STATE: %d, h_pa_timephase: %s\n", SC_STATE,h_pa_timephase);
         
         If SubStr(h_res_type, 1, 1) = '0' Then
            If (Coalesce(h_task_assign_flag, 0) = 1) Then
               -- Check if created from PROJECT assignment
               
               OPEN CPAS2;
               
               FETCH CPAS2 INTO h_uniqueID;
               IF CPAS2%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE = 0 Then
                  h_from_prj := 1;
               Else
                  h_from_prj := 0;
               End If;
               
               BEGIN
                  CLOSE CPAS2 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4544+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4545) : unassign_res.sql(7005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               OPEN CPAS9;
               
               FETCH CPAS9 INTO h_uniqueID;
               IF CPAS9%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE = 0 Then
                  h_from_prj := 1;
               Else
                  h_from_prj := 0;
               End If;
               
               BEGIN
                  CLOSE CPAS9 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4572+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4573) : unassign_res.sql(7033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            --trace_printf("h_bitflag = %d, h_from_prj = %d, h_profile_id_Ind = %d, h_profile_name = %s\n",h_bitflag,h_from_prj,h_profile_id_Ind,h_profile_name);
            
            If (Coalesce(h_bitflag, 0) = 0) AND (Coalesce(h_from_prj, 0) = 0) Then
               --trace_printf("*** CANNOT_DELETE_REMAINING_AFFECTED_WORK = %d\n",CANNOT_DELETE_REMAINING_AFFECTED_WORK);
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 4582+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(4583) : unassign_res.sql(7043) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_REMAINING_AFFECT;
            End If;
            --trace_printf("Project_PROF h_exists: %d, h_profile_id: %d:%s, h_resource_id_id: %d:%s\n", h_exists,h_profile_id_Ind,h_profile_id,h_resource_id_Ind,h_resource_id);
            
            If Coalesce(h_bitflag_27, 0) <> PMO_CNST.SC_BIT_27 Then
               If ((h_profile_id IS NOT NULL)) AND (Coalesce(h_exists, 0) <> 1) Then
                  BEGIN
                     SELECT COUNT(TSK_ASSIGNMENT_ID) INTO h_exists FROM TASK_ASSIGNMENTS
                     WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND RESOURCE_TYPE = '1'
                     AND TASK_ID <> PROJECT_ID;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4600+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4601) : unassign_res.sql(7061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_exists, 0) > 0 Then
                     h_exists := 1;
                  End If;
               End If;
               --trace_printf("h_exists: %d, h_resource_id: %d %s, h_bitflag: %d\n", h_exists,h_resource_id_Ind,h_resource_id,h_bitflag);
               
               If ((h_resource_id IS NOT NULL)) Then
                  h_profile_id := h_resource_id;
                  
                  BEGIN
                     SELECT NICK_NAME INTO h_profile_name FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4622+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4623) : unassign_res.sql(7083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf ((h_profile_id IS NULL)) OR (Coalesce(h_exists, 0) = 1) Then
                  --Get a unique id
                  h_profile_id := '';
                  h_profile_id := SYS_GUID();
                  
                  BEGIN
                     SELECT COALESCE(MAX(PROF_NUMBER),0)+1 INTO h_number
                     FROM PROFILES WHERE PROJECT_ID=h_project_id AND ROLE_ID=h_role_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4640+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4641) : unassign_res.sql(7101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(TCP.ELEMENT_NAME), ', '), RTRIM(TC.ELEMENT_NAME)), '('), RTRIM(TO_CHAR(h_number))), ')')
                     INTO h_profile_name FROM TMT_COMPETENCIES TC, TMT_COMPETENCIES TCP
                     WHERE TC.ELEMENT_ID = h_role_id AND TCP.ELEMENT_ID = TC.PARENT_ID;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4655+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4656) : unassign_res.sql(7116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     INSERT INTO PROFILES(PROFILE_ID,PROJECT_ID,ROLE_ID,PROF_NUMBER, PROFILE_NAME)
                     VALUES(h_profile_id, h_project_id, h_role_id, h_number, h_profile_name);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4673+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4674) : unassign_res.sql(7134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("PROFILES SC_STATE: %d, h_profile_id: %s\n", SC_STATE,h_profile_id);
                  
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 4681+1) THEN 
                        LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(4682) : unassign_res.sql(7142) : ' || SYSTIMESTAMP);
                     END IF; 
                     RETURN PMO_DB2M.SC_STATE;
                  End If;
                  
                  BEGIN
                     INSERT INTO PMO_TMP_DELETE (ROLE_ID, PROFILE_ID, PROFILE_NAME) VALUES(h_role_id, h_profile_id, h_profile_name);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4698+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4699) : unassign_res.sql(7159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         
         --trace_printf("h_prj_assignment_id = %d:%s, h_bitflag = %d, h_full_name = %s, h_owner = %d\n", h_prj_assignment_id_Ind,h_prj_assignment_id,h_bitflag,h_full_name, h_owner);
         --trace_printf("PROFILE_* h_profile_id: %d:%s, h_profile_name: %d:%s\n", h_profile_id_Ind,h_profile_id,h_profile_name_Ind,h_profile_name);
         --trace_printf("RESOURCE_* h_resource_id: %d:%s\n", h_resource_id_Ind,h_resource_id);
         
         If ((h_prj_assignment_id IS NOT NULL)) AND (Coalesce(Length(h_full_name), 0) > 0) AND ((Coalesce(
               h_owner, 0) = PMO_CNST.SC_MANAGER) OR ((h_resource_id IS NOT NULL))) Then
            If Coalesce(h_bitflag, 0) = 0 Then
               If SubStr(h_pa_timephase, 1, 1) = 'Y' Then
                  PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_id, h_SD, h_FD, h_reg_cost
                                            , h_reg_sale, h_tph_delete, h_capital_expense
                                            , h_billable);
                  --trace_printf("5__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
               End If;
               
               If SubStr(h_res_type, 1, 1) = '0' Then
                  BEGIN
                     DELETE FROM TASK_DAY_OF_YEAR
                     WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4734+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4735) : unassign_res.sql(7195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("5.Delete_Remaining SC_STATE: %d\n",SC_STATE); //trace_flush();
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     h_temp_var := 3;
                     h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_prj_assignment_id, h_temp_var, 0, 0);
                     
                     If SubStr(h_pa_timephase, 1, 1) = 'Y' Then
                        h_tph_delete := 0;
                        
                        PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_prj_assignment_id, h_SD
                                            , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                            , h_capital_expense, h_billable);
                        --trace_printf("5.ActPrj__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
                     End If;
                  End If;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 4755+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(4756) : unassign_res.sql(7216) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN 0;
               Else
                  BEGIN
                     UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                     ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                     WHERE ELEMENT_ID  = h_task_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4773+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4774) : unassign_res.sql(7234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("COUNT_8: SC_STATE = %d, h_task_id= %s, h_full_name = %s\n",SC_STATE,h_task_id,h_full_name);
               End If;
            ElsIf Coalesce(h_bitflag_27, 0) <> PMO_CNST.SC_BIT_27 Then
               OPEN CRNAME1;
               
               i_has_actual := 0;
               
               LOOP
                  h_continue_01 := 1;
                  h_continue_02 := 1;
                  
                  FETCH CRNAME1 INTO h_uniqueID,  h_tsk_assignment_id, h_task_id, h_work_todate, h_participant, h_start_D, h_finish_D, h_billable, h_capital_expense, h_reg_cost, h_reg_sale;
                  IF CRNAME1%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     EXIT;
                  End If;
                  --trace_printf("CRNAME1: h_uniqueID: %s, h_participant = %d, h_task_id = %s, h_work_todate: %d\n", h_uniqueID,h_participant,h_task_id,h_work_todate);
                  
                  If (PMO_ORASTD.strcmp(h_project_id, h_task_id) <> 0) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') Then
                     PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_start_D
                                            , h_finish_D, h_reg_cost, h_reg_sale, h_tph_delete
                                            , h_capital_expense, h_billable);
                     --trace_printf("4__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
                  End If;
                  
                  If Coalesce(h_work_todate, 0) > 0 Then
                     i_has_actual := i_has_actual + 1;
                  End If;
                  
                  If Coalesce(h_bitflag, 0) = 3 Then
                     /*h_count = 0;
                                                 if ( (strcmp(h_task_id,h_project_id) == 0)  (i_has_actual == 0) )
                                                 {
                                                     BEGIN_SQL
                                                         SELECT COUNT(*) INTO HOST(h_count) FROM TASK_ASSIGNMENTS
                                                         WHERE PROJECT_ID = HOST(h_project_id) AND RESOURCE_ID = HOST(h_res_id);
                                                     END_SQL;
                     //trace_printf("COUNT_9.3_c__ SC_STATE = %d, h_count = %d, h_res_id = %s\n", SC_STATE,h_count,h_res_id);
                                                 }
                     
                                                 if ( ((h_count < 2) || ((strcmp(h_task_id,h_project_id) != 0)  (h_work_todate == 0))) 
                                                      ((h_participant  SC_TASK_RESPONSIBLE) != SC_TASK_RESPONSIBLE) )*/
                     If ((i_has_actual = 0) OR ((PMO_ORASTD.strcmp(h_task_id, h_project_id) <> 0) AND (Coalesce(
                           h_work_todate, 0) = 0))) AND ((BITAND(Coalesce(
                           h_participant, 0), PMO_CNST.SC_TASK_RESPONSIBLE)) <> PMO_CNST.SC_TASK_RESPONSIBLE) Then
                        BEGIN
                           UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                           ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4840+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4841) : unassign_res.sql(7301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("COUNT_9.3_1* SC_STATE: %d, h_full_name: %s\n", SC_STATE,h_full_name);
                     Else
                        BEGIN
                           UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits)
                           WHERE ELEMENT_ID = h_task_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4859+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4860) : unassign_res.sql(7320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("COUNT_9.3_2* SC_STATE: %d, h_rollup_bits: %d\n", SC_STATE,h_rollup_bits);
                     End If;
                  ElsIf Coalesce(h_bitflag, 0) = 2 Then
                     If (BITAND(Coalesce(
                           h_participant, 0), PMO_CNST.SC_TASK_RESPONSIBLE)) = PMO_CNST.SC_TASK_RESPONSIBLE Then
                        If ((h_resource_id IS NOT NULL)) Then
                           BEGIN
                              UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                              ASSIGN_NAMES = h_profile_name || ';' || REPLACE (REPLACE (ASSIGN_NAMES, h_full_name || ';', ''), h_profile_name || ';', '')
                              WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4883+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4884) : unassign_res.sql(7344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           BEGIN
                              UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                              ASSIGN_NAMES = ASSIGN_NAMES || h_profile_name || ';'
                              WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4902+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4903) : unassign_res.sql(7363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     Else
                        If i_has_actual = 0 Then
                           If Coalesce(h_work_type, 0) = 2 Then
                              h_rollup_bits := PMO_CNST.SC_SCHED_BIT;
                           Else
                              h_rollup_bits := PMO_CNST.SC_PLANNED_BIT;
                           End If;
                           
                           BEGIN
                              UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                              ASSIGN_NAMES =
                              CASE
                              WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                              THEN CASE
                              WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') > 0
                              THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                              ELSE REPLACE (ASSIGN_NAMES, h_full_name || ';', h_profile_name || ';')
                              END
                              ELSE CASE
                              WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') > 0
                              THEN ASSIGN_NAMES
                              ELSE ASSIGN_NAMES || h_profile_name || ';'
                              END
                              END
                              WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4942+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4943) : unassign_res.sql(7403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           If Coalesce(h_work_type, 0) = 2 Then
                              h_rollup_bits := (PMO_FUNC.BIT_OR((PMO_FUNC.BIT_OR(PMO_CNST.SC_ACTUAL_BIT, PMO_CNST.SC_SCHED_BIT)), PMO_CNST.SC_PLANNED_BIT));
                           Else
                              h_rollup_bits := PMO_CNST.SC_PLANNED_BIT;
                           End If;
                           
                           If PMO_ORASTD.strcmp(h_project_id, h_task_id) = 0 Then
                              BEGIN
                                 UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                                 ASSIGN_NAMES = ASSIGN_NAMES || h_profile_name || ';'
                                 WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4968+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4969) : unassign_res.sql(7429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                        End If;
                     End If;
                     --trace_printf("COUNT_9.2: SC_STATE = %d, i_has_actual: %d, h_task_id= %s, h_profile_name = %s, h_full_name: %s\n",SC_STATE,i_has_actual,h_task_id,h_profile_name,h_full_name);
                     --trace_printf("h_participant: %d, h_creator_name: %s\n", h_participant,h_creator_name);
                  End If;
               END LOOP;
               -- end of while
               
               BEGIN
                  CLOSE CRNAME1 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 4989+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(4990) : unassign_res.sql(7450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT COUNT(*) INTO h_work_todate
                  FROM TASK_ASSIGNMENTS 
                  WHERE PROJECT_ID = h_project_id AND PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND WORK_TODATE > 0;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5004+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5005) : unassign_res.sql(7465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               i_has_actual := Coalesce(h_work_todate, 0);
            End If;
         End If;
         
         If SubStr(h_res_type, 1, 1) = '0' Then
            --trace_printf("PROJ: h_from_prj = %d, h_work_type = %d, h_prj_assignment_id = %s, h_rollup: %d\n", h_from_prj,h_work_type,h_prj_assignment_id,h_rollup);
            i_pa_exists := 0;
            
            If (Coalesce(h_bitflag, 0) = 2) OR (Coalesce(h_bitflag, 0) = 1) Then
               h_tph_delete := 0;
               
               -- get profile cost rates
               l_data_flag001 := 0;
               If ((h_resource_id IS NOT NULL)) Then
                  h_temp_sc_state := FC_GET_RES_RATES(h_project_id, h_resource_id, h_replace_type, h_null_str
                                    , h_null_str, l_data_flag001, h_reg_cost, h_spec_cost
                                    , h_spec_sale, h_spec_sale);
               Else
                  h_temp_sc_state := FC_GET_RES_RATES(h_project_id, h_profile_id, h_replace_type, h_null_str
                                    , h_null_str, l_data_flag001, h_reg_cost, h_spec_cost
                                    , h_spec_sale, h_spec_sale);
               End If;
            End If;
            
            If Coalesce(h_from_prj, 0) = 1 Then
               If (Coalesce(h_bitflag, 0) = 0) OR (Coalesce(h_bitflag, 0) = 1) Then
                  If Coalesce(h_bitflag, 0) = 0 Then
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5048+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5049) : unassign_res.sql(7509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        DELETE FROM TASK_ASSIGNMENTS
                        WHERE TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5066+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5067) : unassign_res.sql(7527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5083+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5084) : unassign_res.sql(7544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                        h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
                        
                        BEGIN
                           DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id AND NOT EXISTS(
                           SELECT RES_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id);
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5104+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5105) : unassign_res.sql(7565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  Else
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id AND BIT_FLAG = '0';
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5123+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5124) : unassign_res.sql(7584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                        WHERE TSK_ASSIGNMENT_ID = h_id AND BIT_FLAG = '0';
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5141+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5142) : unassign_res.sql(7602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                        If ((h_resource_id IS NOT NULL)) Then
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS SET RESOURCE_ID = h_resource_id, PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5161+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5162) : unassign_res.sql(7622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           ora_temp_sc_state := PMO_DB2M.SC_STATE;
                           null_return := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_security_name);
                           PMO_DB2M.SC_STATE := ora_temp_sc_state;
                           If Coalesce(h_transfered_cri, 0) = 1 Then
                              h_cri_element_type := FC_MIRROR_TYPE(h_type_id);
                              h_cri_table_type := PMO_CNST.SC_TABLE_CRI;
                              ora_temp_sc_state := PMO_DB2M.SC_STATE;
                              null_return := GetSecurityID(Coalesce(h_cri_table_type, 0), Coalesce(h_cri_element_type, 0)
                                    , PMO_CNST.SC_TEAMMEMBER_GROUP, h_cri_security_id);
                              PMO_DB2M.SC_STATE := ora_temp_sc_state;
                           Else
                              h_cri_security_id := NULL;
                           End If;
                           
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS SET 
                              PROFILE_ID = h_profile_id, 
                              RESOURCE_TYPE = '1', 
                              RESOURCE_ID = NuLL,
                              PARTICIPANT = PMO_CNST.SC_TEAMMEMBER,
                              SECURITY_ID = h_security_name,
                              CRI_SECURITY_ID = h_cri_security_id
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5200+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5201) : unassign_res.sql(7661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                  End If;
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = TSK_ASSIGNMENT_ID
                     WHERE PROJECT_ID = h_project_id AND PARENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5221+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5222) : unassign_res.sql(7682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL WHERE PROJECT_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5238+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5239) : unassign_res.sql(7699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A4__ SC_STATE = %d, h_rollup = %d, h_prj_assignment_id = %s\n", SC_STATE,h_rollup,h_prj_assignment_id);
                  
                  If (Coalesce(h_bitflag, 0) = 1) AND ((PMO_ORASTD.strcmp(h_project_id, h_task_id) <> 0) 
                        OR (SubStr(h_pa_timephase, 1, 1) = 'Y')) Then
                     PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_id, h_SD, h_FD, h_reg_cost
                                            , h_reg_sale, h_tph_delete, h_capital_expense
                                            , h_billable);
                     --trace_printf("5.0__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
                  End If;
               Else
                  If Coalesce(h_bitflag, 0) = 2 Then
                     h_temp_id := '';
                     h_temp_id := SYS_GUID();
                  End If;
                  
                  OPEN CPAS3;
                  
                  LOOP
                     h_continue_01 := 1;
                     
                     FETCH CPAS3 INTO h_uniqueID, h_count, h_tsk_assignment_id, h_task_id, h_mls_percent, h_effort, h_bitflag1, h_work, h_eunit, h_unit, h_contour, h_owner1,
                     h_transfered_cri, h_exists, h_start_D, h_finish_D, h_billable, h_capital_expense;
                     IF CPAS3%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     
                     If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                        EXIT;
                     End If;
                     
                     If Coalesce(h_exists, 0) = 1 Then
                        BEGIN
                           UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5287+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5288) : unassign_res.sql(7748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        h_continue_01 := 0;
                     End If;
                     --trace_printf("h_exists = %d, h_effort: %d, h_continue_01 = %d\n", h_exists,h_effort,h_continue_01);
                     
                     If Coalesce(h_continue_01, 0) = 1 Then
                        --trace_printf("h_mls_percent = %d, element_type = %d, h_task_id = %s, h_bitflag = %d\n", h_mls_percent,h_count,h_task_id,h_bitflag);
                        If Coalesce(h_mls_percent, 0) > 0 Then
                           If Coalesce(h_bitflag1, 0) > 89 Then
                              If Coalesce(h_work, 0) = 0 Then
                                 h_bitflag1 := 0;
                              Else
                                 h_bitflag1 := 1;
                              End If;
                           End If;
                           
                           If Coalesce(h_donot_replace, 0) = 1 Then
                              h_donot_replace := Coalesce(h_donot_replace, 0) + 1;
                           End If;
                           
                           h_temp_var := 3;
                           If Coalesce(h_bitflag_27, 0) <> PMO_CNST.SC_BIT_27 Then
                              PMO_DB2M.SC_STATE := FC_D_ACTUAL(h_table_type, h_count, h_uniqueID, h_tsk_assignment_id
                                    , h_project_id, h_task_id, h_temp_var, h_res_id, h_profile_id
                                    , h_bitflag, h_donot_replace, h_effort, h_eunit, h_work, h_unit
                                    , h_bitflag1, h_min_per_day, h_priority, h_contour, h_occurrence
                                    , h_rec_user);
                           Else
                              --when deleted from upper window in staffing view keep assignmnets withactual passing bitfalg27
                              PMO_DB2M.SC_STATE := FC_D_ACTUAL(h_table_type, h_count, h_uniqueID, h_tsk_assignment_id
                                    , h_project_id, h_task_id, h_temp_var, h_res_id, h_profile_id
                                    , h_bitflag_27, h_donot_replace, h_effort, h_eunit, h_work
                                    , h_unit, h_bitflag1, h_min_per_day, h_priority, h_contour
                                    , h_occurrence, h_rec_user);
                           End If;
                           --trace_printf("h_donot_replace = %d, SC_STATE = %d, h_profile_id: %s, h_profile_name = %s\n", h_donot_replace,SC_STATE,h_profile_id,h_profile_name);
                           
                           -- Add profile name old model that used to add profile after removing the assignment
                           /*  if ( (h_donot_replace == 0)  (SC_STATE == 0) )
                                                               {
                                                                   BEGIN_SQL
                                                                       UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = HOST(h_temp_id) WHERE TSK_ASSIGNMENT_ID = HOST(h_tsk_assignment_id);
                                                                   END_SQL;
                           //trace_printf("A.9.UPDATE__TA SC_STATE = %d, h_temp_id = %d:%s\n", SC_STATE,h_temp_id_Ind,h_temp_id);
                           
                                                                   BEGIN_SQL
                                                                       UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = HOST(h_temp_id) 
                           											WHERE PROJECT_ID = HOST(h_project_id) 
                           												AND TSK_ASSIGNMENT_ID = HOST(h_tsk_assignment_id);
                                                                   END_SQL;
                           //trace_printf("A.9.UPDATE_TDY SC_STATE = %d, h_temp_id = %d:%s\n", SC_STATE,h_temp_id_Ind,h_temp_id);
                           
                                                                   if ( h_effort > 0 )
                                                                   {
                                                                       BEGIN_SQL
                                                                           UPDATE TMT_WBS SET ASSIGN_NAMES =
                                                                               CASE
                                                                                   WHEN LENGTH(HOST(h_profile_name)) + LENGTH(ASSIGN_NAMES) > 2040 THEN ASSIGN_NAMES
                                                                                   ELSE ASSIGN_NAMES || HOST(h_profile_name) || ';'
                                                                               END
                                                                           WHERE ELEMENT_ID = HOST(h_task_id);
                                                                       END_SQL;
                           //trace_printf("COUNT_10: SC_STATE = %d, h_task_id= %s, h_profile_name = %s\n",SC_STATE,h_task_id,h_profile_name);
                           
                                                                       if( SC_NODATA)
                                                                       {
                                                                           BEGIN_SQL
                                                                               UPDATE TMT_CRI SET ASSIGN_NAMES = ASSIGN_NAMES || HOST(h_profile_name) || ';'
                                                                               WHERE ELEMENT_ID = HOST(h_task_id);
                                                                           END_SQL;
                                                                       }
                                                                   }
                                                               }*/
                           
                           i_has_actual := i_has_actual + 1;
                        Else
                           BEGIN
                              DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_tsk_assignment_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5379+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5380) : unassign_res.sql(7840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              DELETE FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID = h_tsk_assignment_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5396+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5397) : unassign_res.sql(7857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           If Coalesce(h_bitflag, 0) = 3 Then
                              If Coalesce(h_rollup, 0) = 1 Then
                                 BEGIN
                                    DELETE FROM TASK_DAY_OF_YEAR 
                                    WHERE PROJECT_ID = h_project_id 
                                    AND PARENT_ID = h_prj_assignment_id AND ACTUAL_FLAG = 0;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5417+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5418) : unassign_res.sql(7878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              Else
                                 BEGIN
                                    DELETE FROM TASK_DAY_OF_YEAR 
                                    WHERE PROJECT_ID = h_project_id 
                                    AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5436+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5437) : unassign_res.sql(7897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              End If;
                              
                              --trace_printf("SC_STATE = %d, h_tsk_assignment_id = %s\n", SC_STATE,h_tsk_assignment_id);
                              
                              h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_uniqueID);
                              
                              --here to check if any element's responsible then do not delete, before it was checking against
                              --SC_TASK_RESPONSIBLE
                              BEGIN
                                 DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_uniqueID AND
                                 BITAND(PARTICIPANT,PMO_CNST.SC_MANAGER_RESPONSIBLE) = 0;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5461+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5462) : unassign_res.sql(7922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              
                              If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                                 h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_count, 0)
                                       , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
                                 h_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TASK_RESPONSIBLE, (BITAND(Coalesce(
                                                                                h_owner1, 0), PMO_CNST.SC_CLEAR_WBS_RESPONSIBLE)));
                                 
                                 If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL, RESOURCE_ID = h_created_by,
                                       PARTICIPANT = PMO_CNST.SC_TASK_RESPONSIBLE, SECURITY_ID = h_temp_security_id
                                       WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5487+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5488) : unassign_res.sql(7948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    --trace_printf("2.E_* SC_STATE = %d, h_uniqueID = %s\n", SC_STATE,h_uniqueID);
                                 Else
                                    h_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TASK_RESPONSIBLE, (BITAND(Coalesce(
                                                                                h_owner1, 0), PMO_CNST.SC_CLEAR_CRI_RESPONSIBLE)));
                                    
                                    If Coalesce(h_transfered_cri, 0) = 0 Then
                                       BEGIN
                                          UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL, RESOURCE_ID = h_created_by,
                                          PARTICIPANT = h_participant, SECURITY_ID = h_temp_security_id
                                          WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                          IF SQL%FOUND = TRUE THEN
                                             PMO_DB2M.SC_STATE := 0;
                                          ELSE
                                             PMO_DB2M.SC_STATE := 100;
                                          END IF;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                          BEGIN
                                             PMO_DB2M.SC_STATE := SQLCODE;
                                             IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5511+1) THEN 
                                                LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5512) : unassign_res.sql(7972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                             END IF; 
                                          END;
                                       END;
                                    Else
                                       BEGIN
                                          UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL, RESOURCE_ID = h_created_by,
                                          PARTICIPANT = h_participant, CRI_SECURITY_ID = h_temp_security_id
                                          WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                          IF SQL%FOUND = TRUE THEN
                                             PMO_DB2M.SC_STATE := 0;
                                          ELSE
                                             PMO_DB2M.SC_STATE := 100;
                                          END IF;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                          BEGIN
                                             PMO_DB2M.SC_STATE := SQLCODE;
                                             IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5530+1) THEN 
                                                LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5531) : unassign_res.sql(7991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                             END IF; 
                                          END;
                                       END;
                                    End If;
                                    --trace_printf("2.F_* SC_STATE = %d, h_uniqueID = %s, h_participant: %d\n", SC_STATE,h_uniqueID,h_participant);
                                 End If;
                                 --trace_printf("Q.1__ SC_STATE = %d\n", SC_STATE);
                                 h_total := Coalesce(h_total, 0) + 1;
                                 h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_assign_id);
                              End If;
                           ElsIf Coalesce(h_bitflag, 0) = 2 Then
                              --trace_printf("h_owner1 = %d, h_uniqueID = %s, h_created_by: %s\n", h_owner1,h_uniqueID,h_created_by);
                              If (BITAND(Coalesce(h_owner1, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
                                 h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_count, 0)
                                       , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
                                 
                                 If (h_resource_id IS NOT NULL) Then
                                    BEGIN
                                       DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5560+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5561) : unassign_res.sql(8021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    
                                    BEGIN
                                       SELECT RES_ASSIGNMENT_ID INTO h_uniqueID
                                       FROM RESOURCE_ASSIGNMENTS
                                       WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
                                       AND RESOURCE_TYPE = h_replace_type AND RESOURCE_ID = h_resource_id;
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5576+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5577) : unassign_res.sql(8037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL, RESOURCE_ID = h_created_by,
                                       PARTICIPANT = PMO_CNST.SC_TASK_RESPONSIBLE, SECURITY_ID = h_temp_security_id
                                       WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5595+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5596) : unassign_res.sql(8056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    h_total := Coalesce(h_total, 0) + 1;
                                    --trace_printf("2.G_* SC_STATE = %d, h_uniqueID = %s\n", SC_STATE,h_uniqueID);
                                    
                                    h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_uniqueID);
                                    
                                    BEGIN
                                       SELECT RES_ASSIGNMENT_ID INTO h_uniqueID
                                       FROM RESOURCE_ASSIGNMENTS
                                       WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
                                       AND RESOURCE_TYPE = h_replace_type AND PROFILE_ID = h_profile_id;
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5615+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5616) : unassign_res.sql(8076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 
                                 If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                                    h_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TASK_RESPONSIBLE, PMO_CNST.SC_TEAMMEMBER);
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NuLL,
                                       PARTICIPANT = h_participant, SECURITY_ID = h_temp_security_id
                                       WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5637+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5638) : unassign_res.sql(8098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    --trace_printf("2.F_* SC_STATE = %d, h_uniqueID = %s, h_participant: %d\n", SC_STATE,h_uniqueID,h_participant);
                                    
                                    h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_uniqueID);
                                 Else
                                    If (h_resource_id IS NULL) Then
                                       h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_count, 0)
                                             , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                                    End If;
                                    
                                    h_uniqueID := SYS_GUID();
                                    
                                    --trace_printf("14325 h_temp_security_id %s\n",h_temp_security_id);//trace_flush();
                                    If ((h_resource_id IS NOT NULL)) Then
                                       BEGIN
                                          INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                          RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,TABLE_TYPE,REC_USER,REC_DATETIME)
                                          VALUES(h_uniqueID, h_project_id, h_task_id, h_count,
                                          '0', h_resource_id, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, 'U', h_table_type, h_rec_user, SYSTIMESTAMP);
                                          IF SQL%FOUND = TRUE THEN
                                             PMO_DB2M.SC_STATE := 0;
                                          ELSE
                                             PMO_DB2M.SC_STATE := 100;
                                          END IF;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                          BEGIN
                                             PMO_DB2M.SC_STATE := SQLCODE;
                                             IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5669+1) THEN 
                                                LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5670) : unassign_res.sql(8130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                             END IF; 
                                          END;
                                       END;
                                    Else
                                       BEGIN
                                          INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                          RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,TABLE_TYPE,REC_USER,REC_DATETIME)
                                          VALUES(h_uniqueID, h_project_id, h_task_id, h_count,
                                          '1', h_profile_id, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, 'U', h_table_type, h_rec_user, SYSTIMESTAMP);
                                          IF SQL%FOUND = TRUE THEN
                                             PMO_DB2M.SC_STATE := 0;
                                          ELSE
                                             PMO_DB2M.SC_STATE := 100;
                                          END IF;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                          BEGIN
                                             PMO_DB2M.SC_STATE := SQLCODE;
                                             IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5689+1) THEN 
                                                LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5690) : unassign_res.sql(8150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                             END IF; 
                                          END;
                                       END;
                                    End If;
                                 End If;
                                 --trace_printf("A5.3__ SC_STATE = %d, h_task_id = %s, h_uniqueID = %s\n", SC_STATE,h_task_id,h_uniqueID);
                              Else
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = h_resource_id
                                       WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5712+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5713) : unassign_res.sql(8173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = NuLL
                                       WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5731+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5732) : unassign_res.sql(8192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 --trace_printf("A5.0__ SC_STATE = %d, h_profile_id = %s, h_uniqueID = %s, h_replace_type: 5s\n", SC_STATE,h_profile_id,h_uniqueID,h_replace_type);
                              End If;
                              
                              BEGIN
                                 UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, BIT_FLAG = '0' --, PARENT_ID = h_tsk_assignment_id
                                 WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND PARENT_ID = h_prj_assignment_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5752+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5753) : unassign_res.sql(8213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              
                              If Coalesce(h_work_type, 0) = 2 Then
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, BIT_FLAG = '0',
                                    PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                                    SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost --, PROJECT_ASSIGNMENT_ID = NuLL
                                    WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5773+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5774) : unassign_res.sql(8234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("A5.1__ SC_STATE = %d, h_tsk_assignment_id = %s, h_uniqueID = %s\n", SC_STATE,h_tsk_assignment_id,h_uniqueID);
                              Else
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost --, PROJECT_ASSIGNMENT_ID = NuLL
                                    WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5792+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5793) : unassign_res.sql(8253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("A6__ SC_STATE = %d, h_rollup = %d, h_tsk_assignment_id = %s\n", SC_STATE,h_rollup,h_tsk_assignment_id);
                              End If;
                              
                              If (PMO_ORASTD.strcmp(h_project_id, h_task_id) <> 0) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') Then
                                 PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_start_D
                                            , h_finish_D, h_reg_cost, h_reg_sale, h_tph_delete
                                            , h_capital_expense, h_billable);
                                 --trace_printf("5.2__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
                              End If;
                           End If;
                           
                           --trace_printf("h_total = %d, h_task_id  =%s\nh_profile_name = %s, h_full_name = %s\n",h_total,h_task_id,h_profile_name,h_full_name);
                           If Coalesce(h_total, 0) > 0 Then
                              If Coalesce(h_bitflag, 0) = 2 Then
                                 BEGIN
                                    UPDATE TMT_WBS SET ASSIGN_NAMES =
                                    CASE
                                    WHEN InStr( ASSIGN_NAMES, h_profile_name || ';') > 0
                                    THEN ASSIGN_NAMES
                                    ELSE ASSIGN_NAMES || h_profile_name || ';'
                                    END
                                    WHERE ELEMENT_ID = h_task_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5828+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5829) : unassign_res.sql(8289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("COUNT_11: SC_STATE = %d, h_task_id= %s, h_profile_name = %s\n",SC_STATE,h_task_id,h_profile_name);
                              End If;
                              
                              BEGIN
                                 SELECT NICK_NAME INTO h_creator_name FROM RESOURCES WHERE RESOURCE_ID = h_created_by;
                                 PMO_DB2M.SC_STATE := SQLCODE;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5843+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5844) : unassign_res.sql(8304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              
                              If PMO_ORASTD.strcmp(h_profile_name, h_creator_name) = 0 Then
                                 BEGIN
                                    UPDATE TMT_WBS SET ASSIGN_NAMES =
                                    CASE
                                    WHEN InStr( ASSIGN_NAMES, h_full_name || ';') = 0
                                    THEN ASSIGN_NAMES
                                    ELSE REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                                    END
                                    WHERE ELEMENT_ID = h_task_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5867+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5868) : unassign_res.sql(8328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              Else
                                 BEGIN
                                    UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_rollup_bits),
                                    ASSIGN_NAMES =
                                    CASE
                                    WHEN InStr( ASSIGN_NAMES, h_creator_name || ';') > 0
                                    THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                                    WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                                    THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', h_creator_name || ';')
                                    ELSE h_creator_name || ';' || ASSIGN_NAMES
                                    END
                                    WHERE ELEMENT_ID = h_task_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5893+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5894) : unassign_res.sql(8354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("COUNT_12: SC_STATE = %d, h_task_id= %s, h_creator_name = %s\n",SC_STATE,h_task_id,h_creator_name);
                              End If;
                           End If;
                           
                           If (Coalesce(h_fs_project, 0) = 1) AND (SubStr(h_res_type, 1, 1) = '0') Then
                              OPEN CFSASS2;
                              
                              FETCH CFSASS2 INTO h_uniqueID;
                              IF CFSASS2%FOUND THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                              
                              If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                                 BEGIN
                                    UPDATE TMT_WBS SET FS_LABOR_CODE = Null WHERE ELEMENT_ID=h_task_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5924+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5925) : unassign_res.sql(8385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                                 BEGIN
                                    SELECT FS_LABOR_CODE INTO h_labor_code FROM TMT_WBS
                                    WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND FS_LABOR_CODE = h_labor_code;
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5938+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5939) : unassign_res.sql(8399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("SC_STATE = %d, h_labor_code = %d, %s, h_uniqueID = %s\n", SC_STATE,h_labor_code_Ind,h_labor_code,h_uniqueID);
                                 
                                 If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                                    BEGIN
                                       SELECT FS_LABOR_CODE INTO h_labor_code FROM RESOURCES WHERE RESOURCE_ID = h_uniqueID;
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5953+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5954) : unassign_res.sql(8414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    
                                    BEGIN
                                       UPDATE TMT_WBS SET FS_LABOR_CODE = h_labor_code
                                       WHERE PROJECT_ID = h_project_id AND ELEMENT_ID=h_task_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5971+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5972) : unassign_res.sql(8432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                              End If;
                              
                              BEGIN
                                 CLOSE CFSASS2 ;
                                 PMO_DB2M.SC_STATE := SQLCODE;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 5986+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(5987) : unassign_res.sql(8447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                        End If;
                     End If;
                  END LOOP;
                  -- end of while
                  BEGIN
                     CLOSE CPAS3 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6003+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6004) : unassign_res.sql(8464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("1_*********** h_bitflag: %d,h_task_id: %s\n",h_bitflag,h_task_id);
                  
                  If Coalesce(h_bitflag, 0) = 3 Then
                     BEGIN
                        DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID IN (SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND NOT MILESTONE_PERCENT = 10000);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6022+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6023) : unassign_res.sql(8483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR 
                        WHERE PROJECT_ID = h_project_id 
                        AND TSK_ASSIGNMENT_ID = h_prj_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6041+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6042) : unassign_res.sql(8502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If i_has_actual = 0 Then
                        BEGIN
                           DELETE FROM TASK_ASSIGNMENTS WHERE PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND NOT MILESTONE_PERCENT = 10000;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6059+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6060) : unassign_res.sql(8520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           DELETE FROM TASK_ASSIGNMENTS WHERE PROJECT_ID <> TASK_ID AND PROJECT_ASSIGNMENT_ID = h_prj_assignment_id AND NOT MILESTONE_PERCENT = 10000;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6076+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6077) : unassign_res.sql(8537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     --trace_printf("DELETE TA_* SC_STATE: %d, i_has_actual: %d, h_donot_remove_name: %d\n", SC_STATE,i_has_actual,h_donot_remove_name);
                     
                     If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                        h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
                        
                        BEGIN
                           DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id AND NOT EXISTS(
                           SELECT RES_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id) AND
                           BITAND(PARTICIPANT,PMO_CNST.SC_TASK_RESPONSIBLE) = 0;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6100+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6101) : unassign_res.sql(8561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = BITAND(PARTICIPANT, PMO_CNST.SC_CLEAR_TEAMMEMBER)
                              WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6119+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6120) : unassign_res.sql(8580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_assign_id);
                           --trace_printf("2.H_* SC_STATE = %d, h_uniqueID = %s\n", SC_STATE,h_uniqueID);
                        End If;
                     End If;
                     
                     If (i_has_actual = 0) AND (Coalesce(h_total, 0) > 0) AND (Coalesce(h_donot_remove_name, 0) = 0) Then
                        BEGIN
                           SELECT NICK_NAME INTO h_creator_name FROM RESOURCES WHERE RESOURCE_ID = h_created_by;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6137+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6138) : unassign_res.sql(8598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        BEGIN
                           UPDATE TMT_WBS SET ASSIGN_NAMES =
                           CASE
                           WHEN InStr( ASSIGN_NAMES, h_creator_name || ';') > 0
                           THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                           WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                           THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', h_creator_name || ';')
                           ELSE h_creator_name || ';' || ASSIGN_NAMES
                           END
                           WHERE ELEMENT_ID = h_project_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6162+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6163) : unassign_res.sql(8623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("COUNT_P3: SC_STATE: %d, h_full_name: %s, h_creator_name: %s\n",SC_STATE,h_full_name,h_creator_name);
                     End If;
                  ElsIf Coalesce(h_bitflag, 0) = 2 Then
                     --trace_printf("h_work_type = %d, h_sched_work = %d, h_planned_work = %d, h_owner = %d, h_assign_id: %s\n", h_work_type,h_sched_work,h_planned_work,h_owner,h_assign_id);
                     If i_has_actual > 0 Then
                        h_res_assignment_id := '';
                        h_res_assignment_id := SYS_GUID();
                        
                        h_temp_security_id := 'SCPROJECTASSIGNMENT';
                        h_temp_participant := PMO_CNST.SC_AFFECTED;
                        h_temp_res_type := '0';
                        h_temp_bitflag := 1;
                        
                        h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_profile_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
                        
                        BEGIN
                           SELECT PARTICIPANT INTO h_temp_var
                           FROM RESOURCE_ASSIGNMENTS
                           WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id
                           AND RESOURCE_ID = h_res_id;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6193+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6194) : unassign_res.sql(8654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                           BEGIN
                              INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                              RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                              VALUES(h_res_assignment_id, h_project_id, h_project_id, 1,
                              '0', h_res_id, h_temp_participant, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6214+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6215) : unassign_res.sql(8675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                        
                        BEGIN
                           INSERT INTO TASK_ASSIGNMENTS(TSK_ASSIGNMENT_ID, RES_ASSIGNMENT_ID, TASK_ID, PROJECT_ID, RESOURCE_ID,RESOURCE_TYPE, BIT_FLAG,
                           PLANNED_START, PLANNED_FINISH, PLANNED_WORK, BEST, SCHED_START, SCHED_FINISH, SCHED_WORK, ETC, BAK_START_DT, BAK_FINISH_DT, BAK_WORK,
                           REGULAR_COST, REGULAR_RATE, SPECIAL_COST, SPECIAL_RATE, PROJECT_ASSIGNMENT_ID, BILLABLE, CAPITAL_EXPENSE, TABLE_TYPE, RATES_EDITED,
                           T_UNIT, C_EFFORT, C_UNIT, C_CONTOUR, CONTOUR_TYPE, C_OCCURRENCE, TIMECODE_1_ID, TIMECODE_2_ID )
                           SELECT h_temp_id, h_res_assignment_id, h_project_id, h_project_id, h_res_id, '0', BIT_FLAG,
                           PLANNED_START, PLANNED_FINISH, PLANNED_WORK, BEST, SCHED_START, SCHED_FINISH, SCHED_WORK, ETC, BAK_START_DT, BAK_FINISH_DT, BAK_WORK,
                           REGULAR_COST, REGULAR_RATE, SPECIAL_COST, SPECIAL_RATE, h_temp_id, BILLABLE, CAPITAL_EXPENSE, TABLE_TYPE, RATES_EDITED,
                           T_UNIT, C_EFFORT, C_UNIT, C_CONTOUR, CONTOUR_TYPE, C_OCCURRENCE, TIMECODE_1_ID, TIMECODE_2_ID
                           FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id AND RESOURCE_ID = h_res_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6240+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6241) : unassign_res.sql(8701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("A.9.TA__ SC_STATE: %d, h_res_id: %s, h_temp_id: %s\n",SC_STATE,h_res_id,h_temp_id);
                        
                        If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                           h_temp_var := 3;
                           h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_temp_id, h_temp_var, 0, 0);
                           
                           If SubStr(h_pa_timephase, 1, 1) = 'Y' Then
                              PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_temp_id, h_SD, h_FD
                                            , h_reg_cost, h_reg_sale, h_tph_delete
                                            , h_capital_expense, h_billable);
                              --trace_printf("5.ActPrj__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
                           End If;
                        End If;
                     End If;
                     
                     BEGIN
                        SELECT ra.RES_ASSIGNMENT_ID INTO h_res_assignment_id
                        FROM RESOURCE_ASSIGNMENTS ra JOIN TASK_ASSIGNMENTS ta
                        ON ra.RES_ASSIGNMENT_ID = ta.RES_ASSIGNMENT_ID
                        WHERE ra.PROJECT_ID = h_project_id AND ra.ELEMENT_ID = h_project_id
                        AND ra.RESOURCE_TYPE = h_replace_type AND ra.PROFILE_ID = h_profile_id;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6271+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6272) : unassign_res.sql(8732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("A17.a__ SC_STATE = %d, h_res_assignment_id = %s\n", SC_STATE,h_res_assignment_id);//trace_flush();
                     --trace_printf("PROFILE_* h_owner: %d, h_replace_type: %s, h_profile_id: %d:%s\n", h_owner,h_replace_type,h_profile_id_Ind,h_profile_id);
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        i_pa_exists := 1;
                     Else
                        --                              if ( (h_work_type == 2)  (h_sched_work > 0) )
                        If Coalesce(h_work_type, 0) = 2 Then
                           If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                              BEGIN
                                 SELECT COUNT(*) INTO h_count FROM TASK_ASSIGNMENTS
                                 WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                 PMO_DB2M.SC_STATE := SQLCODE;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6293+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6294) : unassign_res.sql(8754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              --trace_printf("P7a__ SC_STATE = %d, h_count = %d,h_id = %s\n", SC_STATE,h_count,h_id);
                              
                              If Coalesce(h_count, 0) = 2 Then
                                 h_uniqueID := SYS_GUID();
                                 h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                       , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                                 --trace_printf("\n 14657 h_type_id: %d, h_security_id: %s",h_type_id,h_temp_security_id);//trace_flush();
                                 
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                       '0', h_resource_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6321+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6322) : unassign_res.sql(8782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                       '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6341+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6342) : unassign_res.sql(8802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 --trace_printf("P7b__ SC_STATE = %d, h_uniqueID = %s,h_profile_id = %s\n", SC_STATE,h_uniqueID,h_profile_id);
                                 
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type,
                                    BIT_FLAG = '0', PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                                    SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0,
                                    REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                    WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '2';
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6364+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6365) : unassign_res.sql(8825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              Else
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = h_resource_id
                                       WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6384+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6385) : unassign_res.sql(8845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = NuLL
                                       WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6403+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6404) : unassign_res.sql(8864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 --trace_printf("A7.b__*** SC_STATE = %d, h_assign_id = %s\n", SC_STATE,h_assign_id);
                                 
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, BIT_FLAG = '0',
                                    PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                                    SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                    WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '2';
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6425+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6426) : unassign_res.sql(8886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("A7.c__*** SC_STATE = %d, h_prj_assignment_id = %d:%s\n", SC_STATE,h_prj_assignment_id_Ind,h_prj_assignment_id);
                              End If;
                           Else
                              If ((h_resource_id IS NOT NULL)) Then
                                 BEGIN
                                    SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
                                    WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id
                                    AND RESOURCE_TYPE = '0' AND RESOURCE_ID = h_profile_id;
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6443+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6444) : unassign_res.sql(8904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              Else
                                 BEGIN
                                    SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
                                    WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id
                                    AND RESOURCE_TYPE = '1' AND PROFILE_ID = h_profile_id;
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6458+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6459) : unassign_res.sql(8919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              End If;
                              --trace_printf("A18.a__ SC_STATE = %d, h_uniqueID = %d:%s\n", SC_STATE,h_uniqueID_Ind,h_uniqueID);//trace_flush();
                              
                              If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                                 BEGIN
                                    UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = PMO_STPU.BIT_OR(PARTICIPANT,PMO_CNST.SC_AFFECTED)
                                    WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6479+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6480) : unassign_res.sql(8940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 
                                 BEGIN
                                    DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6496+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6497) : unassign_res.sql(8957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 
                                 BEGIN
                                    UPDATE TMT_WBS SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                                    WHERE ELEMENT_ID = h_project_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6514+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6515) : unassign_res.sql(8975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("COUNT_PA3: SC_STATE: %d, h_full_name: %s\n",SC_STATE,h_full_name);
                              Else
                                 h_uniqueID := SYS_GUID();
                                 
                                 h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                       , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                                 
                                 --trace_printf("\n 14708 h_temp_security_id %s",h_temp_security_id);//trace_flush();
                                 h_temp_participant := PMO_CNST.SC_AFFECTED;
                                 h_temp_res_type := '1';
                                 h_temp_bitflag := 1;
                                 
                                 h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_profile_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
                                 
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, 1,
                                       '0', h_resource_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6549+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6550) : unassign_res.sql(9010) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, 1,
                                       '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6569+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6570) : unassign_res.sql(9030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                              End If;
                              
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id,
                                 RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost, BIT_FLAG = '0'
                                 WHERE TSK_ASSIGNMENT_ID = h_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6590+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6591) : unassign_res.sql(9051) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              --trace_printf("A18.b__ SC_STATE = %d, h_id = %s\n", SC_STATE,h_id);//trace_flush();
                           End If;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, BIT_FLAG = '0'
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '2';
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6610+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6611) : unassign_res.sql(9071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           --trace_printf("A7.x__ SC_STATE = %d, h_task_id: %s, h_prj_assignment_id = %d:%s\n", SC_STATE,h_task_id,h_prj_assignment_id_Ind,h_prj_assignment_id);
                           --trace_printf("A7.y__ SC_STATE = %d, h_profile_id: %s, h_project_id = %s\n", SC_STATE,h_profile_id,h_project_id);
                           
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = h_prj_assignment_id
                              WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id AND PROJECT_ID <> TASK_ID;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6630+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6631) : unassign_res.sql(9091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           --trace_printf("A7.0__ SC_STATE = %d, h_prj_assignment_id: %d:%s, h_uniqueID = %s\n", SC_STATE,h_prj_assignment_id_Ind,h_prj_assignment_id,h_uniqueID);
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = h_prj_assignment_id
                              WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6649+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6650) : unassign_res.sql(9110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           --trace_printf("A7.1__ SC_STATE = %d\n", SC_STATE);
                        Else
                           If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                              BEGIN
                                 SELECT COUNT(*) INTO h_count FROM TASK_ASSIGNMENTS
                                 WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                 PMO_DB2M.SC_STATE := SQLCODE;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6665+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6666) : unassign_res.sql(9126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                              --trace_printf("P0a__ SC_STATE = %d, h_count = %d,h_id = %s\n", SC_STATE,h_count,h_id);
                              
                              If Coalesce(h_count, 0) = 2 Then
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       SELECT RES_ASSIGNMENT_ID,PARTICIPANT INTO h_uniqueID, h_count
                                       FROM RESOURCE_ASSIGNMENTS
                                       WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND RESOURCE_ID = h_resource_id;
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6683+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6684) : unassign_res.sql(9144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                    --trace_printf("RES_PA1__ SC_STATE = %d, h_count = %d,h_uniqueID = %s\n", SC_STATE,h_count,h_uniqueID);
                                    
                                    If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND ((BITAND(Coalesce(
                                          h_count, 0), PMO_CNST.SC_AFFECTED)) = 0) Then
                                       BEGIN
                                          DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                          IF SQL%FOUND = TRUE THEN
                                             PMO_DB2M.SC_STATE := 0;
                                          ELSE
                                             PMO_DB2M.SC_STATE := 100;
                                          END IF;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                          BEGIN
                                             PMO_DB2M.SC_STATE := SQLCODE;
                                             IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6703+1) THEN 
                                                LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6704) : unassign_res.sql(9164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                             END IF; 
                                          END;
                                       END;
                                       --                                              else error
                                    End If;
                                    
                                    h_uniqueID := SYS_GUID();
                                    h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                          , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                                    
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                       '0', h_resource_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6729+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6730) : unassign_res.sql(9190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    h_uniqueID := SYS_GUID();
                                    h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                          , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                                    
                                    BEGIN
                                       INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                       RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                       VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                       '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6753+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6754) : unassign_res.sql(9214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 --trace_printf("P0b__ SC_STATE = %d, h_uniqueID = %s,h_profile_id = %s\n", SC_STATE,h_uniqueID,h_profile_id);
                                 
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type,
                                    REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                    WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '0';
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6774+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6775) : unassign_res.sql(9235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              Else
                                 If ((h_resource_id IS NOT NULL)) Then
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = h_resource_id
                                       WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6794+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6795) : unassign_res.sql(9255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    BEGIN
                                       UPDATE RESOURCE_ASSIGNMENTS
                                       SET PROFILE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = NuLL
                                       WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6813+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6814) : unassign_res.sql(9274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 End If;
                                 
                                 BEGIN
                                    UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                    WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '0';
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6832+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6833) : unassign_res.sql(9293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              End If;
                           Else
                              If ((h_resource_id IS NOT NULL)) Then
                                 BEGIN
                                    SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
                                    WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND RESOURCE_ID = h_resource_id;
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6848+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6849) : unassign_res.sql(9309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("RES_PA2__ SC_STATE = %d, h_count = %d,h_uniqueID = %s\n", SC_STATE,h_count,h_uniqueID);
                                 
                                 If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                                    BEGIN
                                       DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                       IF SQL%FOUND = TRUE THEN
                                          PMO_DB2M.SC_STATE := 0;
                                       ELSE
                                          PMO_DB2M.SC_STATE := 100;
                                       END IF;
                                    EXCEPTION
                                       WHEN OTHERS THEN
                                       BEGIN
                                          PMO_DB2M.SC_STATE := SQLCODE;
                                          IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6867+1) THEN 
                                             LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6868) : unassign_res.sql(9328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                          END IF; 
                                       END;
                                    END;
                                 Else
                                    h_uniqueID := h_assign_id;
                                 End If;
                                 
                                 BEGIN
                                    UPDATE RESOURCE_ASSIGNMENTS
                                    SET PROFILE_ID = NuLL, RESOURCE_ID = h_resource_id, PARTICIPANT = PMO_STPU.BIT_OR(PARTICIPANT,PMO_CNST.SC_AFFECTED)
                                    WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6889+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6890) : unassign_res.sql(9350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 
                                 BEGIN
                                    UPDATE TMT_WBS SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_full_name || ';', '')
                                    WHERE ELEMENT_ID = h_project_id;
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6907+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6908) : unassign_res.sql(9368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                                 --trace_printf("COUNT_PA4: SC_STATE: %d, h_full_name: %s\n",SC_STATE,h_full_name);
                              Else
                                 h_uniqueID := SYS_GUID();
                                 
                                 --                                          h_temp_sc_state = GetSecurityID(h_table_type , h_type_id, SC_TEAMMEMBER_GROUP, SC_PARAM(h_temp_security_id));
                                 h_temp_security_id := 'SCPROJECTASSIGNMENT';
                                 h_temp_participant := PMO_CNST.SC_AFFECTED;
                                 h_temp_res_type := '1';
                                 h_temp_bitflag := 1;
                                 
                                 h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_profile_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
                                 
                                 BEGIN
                                    INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                    RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                    VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                    '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                    IF SQL%FOUND = TRUE THEN
                                       PMO_DB2M.SC_STATE := 0;
                                    ELSE
                                       PMO_DB2M.SC_STATE := 100;
                                    END IF;
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                    BEGIN
                                       PMO_DB2M.SC_STATE := SQLCODE;
                                       IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6939+1) THEN 
                                          LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6940) : unassign_res.sql(9400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                       END IF; 
                                    END;
                                 END;
                              End If;
                              
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                 WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '0';
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6958+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6959) : unassign_res.sql(9419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                           
                           BEGIN
                              UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id
                              WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '0';
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 6977+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(6978) : unassign_res.sql(9438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                  End If;
               End If;
            Else
               If Coalesce(h_bitflag, 0) = 2 Then
                  --trace_printf("P1__ h_owner = %d, h_work_type = %d, h_assign_id = %s\n", h_owner,h_work_type,h_assign_id);
                  If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                     If ((h_resource_id IS NOT NULL)) Then
                        BEGIN
                           SELECT ra.RES_ASSIGNMENT_ID INTO h_res_assignment_id
                           FROM RESOURCE_ASSIGNMENTS ra JOIN TASK_ASSIGNMENTS ta
                           ON ra.RES_ASSIGNMENT_ID = ta.RES_ASSIGNMENT_ID
                           WHERE ra.PROJECT_ID = h_project_id AND ra.ELEMENT_ID = h_project_id
                           AND ra.RESOURCE_TYPE = '0' AND ra.RESOURCE_ID = h_profile_id;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7002+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7003) : unassign_res.sql(9463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           SELECT ra.RES_ASSIGNMENT_ID INTO h_res_assignment_id
                           FROM RESOURCE_ASSIGNMENTS ra JOIN TASK_ASSIGNMENTS ta
                           ON ra.RES_ASSIGNMENT_ID = ta.RES_ASSIGNMENT_ID
                           WHERE ra.PROJECT_ID = h_project_id AND ra.ELEMENT_ID = h_project_id
                           AND ra.RESOURCE_TYPE = '1' AND ra.PROFILE_ID = h_profile_id;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7019+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7020) : unassign_res.sql(9480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     --trace_printf("A8.a___ SC_STATE = %d, h_res_assignment_id = %s, h_profile_id: %d:%s\n", SC_STATE,h_res_assignment_id,h_profile_id_Ind,h_profile_id);//trace_flush();
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        i_pa_exists := 1;
                     Else
                        BEGIN
                           SELECT COUNT(*) INTO h_count FROM TASK_ASSIGNMENTS
                           WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7038+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7039) : unassign_res.sql(9499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("P2__ SC_STATE = %d, h_count = %d,h_id = %s\n", SC_STATE,h_count,h_id);
                        
                        If Coalesce(h_count, 0) = 2 Then
                           h_uniqueID := SYS_GUID();
                           h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                           --trace_printf("\n 14656 h_type_id: %d, h_security_id: %s",h_type_id,h_temp_security_id);//trace_flush();
                           
                           If ((h_resource_id IS NOT NULL)) Then
                              BEGIN
                                 INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                 RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                 VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                 '0', h_resource_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7066+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7067) : unassign_res.sql(9527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           Else
                              BEGIN
                                 INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                                 RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                                 VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                                 '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7086+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7087) : unassign_res.sql(9547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                           --trace_printf("P3__ SC_STATE = %d, h_uniqueID = %s,h_profile_id = %s\n", SC_STATE,h_uniqueID,h_profile_id);
                           
                           If Coalesce(h_work_type, 0) = 2 Then
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type,
                                 BIT_FLAG = '0', PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                                 SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0,
                                 REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                 WHERE TSK_ASSIGNMENT_ID = h_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7110+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7111) : unassign_res.sql(9571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           Else
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type,
                                 REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                 WHERE TSK_ASSIGNMENT_ID = h_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7129+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7130) : unassign_res.sql(9590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                        Else
                           If ((h_resource_id IS NOT NULL)) Then
                              BEGIN
                                 UPDATE RESOURCE_ASSIGNMENTS
                                 SET PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = h_resource_id
                                 WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7150+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7151) : unassign_res.sql(9611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           Else
                              BEGIN
                                 UPDATE RESOURCE_ASSIGNMENTS
                                 SET PROFILE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = NuLL
                                 WHERE RES_ASSIGNMENT_ID = h_assign_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7169+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7170) : unassign_res.sql(9630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                           
                           --trace_printf("A8.b__*** SC_STATE = %d, h_assign_id = %s\n", SC_STATE,h_assign_id);
                           
                           If Coalesce(h_work_type, 0) = 2 Then
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, BIT_FLAG = '0',
                                 PLANNED_START = SCHED_START, PLANNED_FINISH = SCHED_FINISH, PLANNED_WORK = SCHED_WORK,
                                 SCHED_START = NuLL, SCHED_FINISH = NuLL, ETC = SCHED_WORK, SCHED_WORK = 0, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                 WHERE TSK_ASSIGNMENT_ID = h_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7193+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7194) : unassign_res.sql(9654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           Else
                              BEGIN
                                 UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                                 WHERE TSK_ASSIGNMENT_ID = h_id;
                                 IF SQL%FOUND = TRUE THEN
                                    PMO_DB2M.SC_STATE := 0;
                                 ELSE
                                    PMO_DB2M.SC_STATE := 100;
                                 END IF;
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    PMO_DB2M.SC_STATE := SQLCODE;
                                    IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7211+1) THEN 
                                       LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7212) : unassign_res.sql(9672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                    END IF; 
                                 END;
                              END;
                           End If;
                        End If;
                     End If;
                  Else
                     If ((h_resource_id IS NOT NULL)) Then
                        BEGIN
                           SELECT RES_ASSIGNMENT_ID, PARTICIPANT, SECURITY_ID
                           INTO h_uniqueID, h_owner1, h_temp_security_id
                           FROM RESOURCE_ASSIGNMENTS
                           WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND
                           RESOURCE_ID = h_resource_id AND RESOURCE_TYPE = '0';
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7232+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7233) : unassign_res.sql(9693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           SELECT RES_ASSIGNMENT_ID INTO h_uniqueID FROM RESOURCE_ASSIGNMENTS
                           WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND
                           PROFILE_ID = h_profile_id AND RESOURCE_TYPE = '1';
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7247+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7248) : unassign_res.sql(9708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        h_owner1 := 0;
                     End If;
                     --trace_printf("PA_EXISTS_? SC_STATE: %d, h_owner1: %d, h_resource_id: %d:%s, h_uniqueID: %d:%s\n",SC_STATE, h_owner1,h_resource_id_Ind,h_resource_id,h_uniqueID_Ind,h_uniqueID);//trace_flush();
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        BEGIN
                           DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_uniqueID;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7269+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7270) : unassign_res.sql(9730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("PA_DELETE_RA SC_STATE: %d, h_uniqueID: %s, h_temp_security_id: %s\n",SC_STATE, h_uniqueID,h_temp_security_id);//trace_flush();
                        
                        If ((h_resource_id IS NOT NULL)) Then
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS
                              SET PROFILE_ID = NuLL, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = h_resource_id,
                              PARTICIPANT = PMO_STPU.BIT_OR(PARTICIPANT,h_owner1),SECURITY_ID = h_temp_security_id
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7291+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7292) : unassign_res.sql(9752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           --trace_printf("2.I_* SC_STATE = %d, h_assign_id = %s, h_owner1: %d\n", SC_STATE,h_assign_id,h_owner1);
                        Else
                           BEGIN
                              UPDATE RESOURCE_ASSIGNMENTS
                              SET PROFILE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, RESOURCE_ID = NuLL
                              WHERE RES_ASSIGNMENT_ID = h_assign_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7311+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7312) : unassign_res.sql(9772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                        --trace_printf("PA_EXISTS_RA SC_STATE: %d, h_replace_type:%s, h_assign_id: %s\n",SC_STATE, h_replace_type,h_assign_id);//trace_flush();
                        
                        BEGIN
                           UPDATE TASK_ASSIGNMENTS SET RESOURCE_ID = h_profile_id, RESOURCE_TYPE = h_replace_type, REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                           WHERE TSK_ASSIGNMENT_ID = h_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7331+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7332) : unassign_res.sql(9792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        --trace_printf("PA_EXISTS_TA SC_STATE: %d, h_id: %s\n",SC_STATE, h_id);//trace_flush();
                     Else
                        h_uniqueID := SYS_GUID();
                        
                        h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                        
                        --trace_printf("\n 14707 h_temp_security_id %s",h_temp_security_id);//trace_flush();
                        h_temp_participant := PMO_CNST.SC_AFFECTED;
                        h_temp_res_type := '1';
                        h_temp_bitflag := 1;
                        
                        h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_profile_id, h_type_id, h_temp_participant
                                          , h_temp_security_id, h_temp_res_type, h_temp_bitflag);
                        
                        If ((h_resource_id IS NOT NULL)) Then
                           BEGIN
                              INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                              RESOURCE_TYPE,RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                              VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                              '0', h_resource_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7366+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7367) : unassign_res.sql(9827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_resource_id, RESOURCE_TYPE = '0', REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                              WHERE TSK_ASSIGNMENT_ID = h_id;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7384+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7385) : unassign_res.sql(9845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        Else
                           BEGIN
                              INSERT INTO RESOURCE_ASSIGNMENTS (RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,
                              RESOURCE_TYPE,PROFILE_ID,PARTICIPANT,SECURITY_ID,REC_STATUS,REC_USER,REC_DATETIME)
                              VALUES(h_uniqueID, h_project_id, h_project_id, h_type_id,
                              '1', h_profile_id, PMO_CNST.SC_AFFECTED, h_temp_security_id, 'U',h_rec_user, SYSTIMESTAMP);
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7404+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7405) : unassign_res.sql(9865) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                           
                           BEGIN
                              UPDATE TASK_ASSIGNMENTS SET RES_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, RESOURCE_TYPE = '1', REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                              WHERE TSK_ASSIGNMENT_ID = h_id AND BIT_FLAG = '0';
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7422+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7423) : unassign_res.sql(9883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                  End If;
                  
                  If ((h_resource_id IS NOT NULL)) Then
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_resource_id
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7444+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7445) : unassign_res.sql(9905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET RESOURCE_ID = h_profile_id, BIT_FLAG = '0'
                        WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7462+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7463) : unassign_res.sql(9923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               Else
                  BEGIN
                     DELETE FROM TASK_DAY_OF_YEAR 
                     WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7481+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7482) : unassign_res.sql(9942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7498+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7499) : unassign_res.sql(9959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7515+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7516) : unassign_res.sql(9976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = TSK_ASSIGNMENT_ID 
                     WHERE PROJECT_ID = h_project_id AND PARENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7533+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7534) : unassign_res.sql(9994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL WHERE PROJECT_ASSIGNMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7550+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7551) : unassign_res.sql(10011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_owner, 0) = PMO_CNST.SC_MANAGER Then
                     h_count := 0;
                     BEGIN
                        SELECT COUNT('X') INTO h_count FROM DUAL WHERE EXISTS (
                        SELECT 'X' FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id);
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7566+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7567) : unassign_res.sql(10027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("SC_STATE: %d, h_assign_id: %s, h_count: %d\n", SC_STATE,h_assign_id,h_count);
                     
                     If Coalesce(h_count, 0) = 0 Then
                        h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
                        BEGIN
                           DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7586+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7587) : unassign_res.sql(10047) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  End If;
                  
                  If Coalesce(h_total, 0) > 0 Then
                     BEGIN
                        SELECT NICK_NAME INTO h_creator_name FROM RESOURCES WHERE RESOURCE_ID = h_created_by;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7602+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7603) : unassign_res.sql(10063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        UPDATE TMT_WBS SET ASSIGN_NAMES =
                        CASE
                        WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0
                        THEN REPLACE (ASSIGN_NAMES, h_full_name || ';', h_creator_name || ';')
                        ELSE h_creator_name || ';' || ASSIGN_NAMES
                        END
                        WHERE ELEMENT_ID = h_project_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7625+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7626) : unassign_res.sql(10086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("COUNT_3P: SC_STATE = %d, h_task_id= %s, h_creator_name = %s\n",SC_STATE,h_task_id,h_creator_name);
                  End If;
               End If;
            End If;
            
            If Coalesce(h_bitflag, 0) = 2 Then
               --trace_printf("###_* i_pa_exists: %d, h_pa_timephase: %s, h_prj_assignment_id: %d:%s, h_id: %d:%s\n",i_pa_exists,h_pa_timephase,h_prj_assignment_id_Ind,h_prj_assignment_id,h_id_Ind,h_id); //trace_flush();
               If SubStr(h_pa_timephase, 1, 1) = 'Y' Then
                  PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_id, h_SD, h_FD, h_reg_cost
                                            , h_reg_sale, h_tph_delete, h_capital_expense
                                            , h_billable);
                  --trace_printf("5.2Prj__TPHASE_SCHED_ASSIGN__ h_tph_delete: %d\n",h_tph_delete); //trace_flush();
               End If;
               
               If i_pa_exists = 1 Then
                  If Coalesce(h_work_type, 0) = 2 Then
                     BEGIN
                        SELECT TSK_ASSIGNMENT_ID INTO h_uniqueID
                        FROM TASK_ASSIGNMENTS
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id AND BIT_FLAG = '2';
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7655+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7656) : unassign_res.sql(10116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        SELECT TSK_ASSIGNMENT_ID INTO h_uniqueID
                        FROM TASK_ASSIGNMENTS
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id AND BIT_FLAG = '0';
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7670+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7671) : unassign_res.sql(10131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  --trace_printf("A7.b1__ SC_STATE = %d, h_uniqueID = %s\n", SC_STATE,h_uniqueID);//trace_flush();
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET TSK_ASSIGNMENT_ID = h_uniqueID, PARENT_ID = h_uniqueID,
                     RESOURCE_ID = h_profile_id, BIT_FLAG = '0'
                     WHERE PROJECT_ID = h_project_id 
                     AND (TSK_ASSIGNMENT_ID = h_prj_assignment_id OR PARENT_ID = h_prj_assignment_id);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7692+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7693) : unassign_res.sql(10153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A7.b2__ SC_STATE = %d, h_prj_assignment_id: %s\n", SC_STATE,h_prj_assignment_id);//trace_flush();
                  
                  BEGIN
                     DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7710+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7711) : unassign_res.sql(10171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A7.b3__ SC_STATE = %d, h_assign_id: %s\n", SC_STATE,h_assign_id);//trace_flush();
                  
                  BEGIN
                     DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7728+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7729) : unassign_res.sql(10189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A7.b4__ SC_STATE = %d, h_prj_assignment_id: %s\n", SC_STATE,h_prj_assignment_id);//trace_flush();
                  
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = h_uniqueID, RESOURCE_ID = h_profile_id, BIT_FLAG = '0', REGULAR_COST = h_reg_cost, SPECIAL_COST = h_spec_cost
                     WHERE PROJECT_ID = h_project_id AND PROJECT_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7747+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7748) : unassign_res.sql(10208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("A7.b5__ SC_STATE = %d, h_project_id: %s\n", SC_STATE,h_project_id);//trace_flush();
                  
                  h_prj_assignment_id := h_uniqueID;
               End If;
            End If;
         ElsIf SubStr(h_res_type, 1, 1) = '1' Then
            --trace_printf("PROF: h_prj_assignment_id = %d:%s, h_id = %s\n",h_prj_assignment_id_Ind,h_prj_assignment_id,h_id);
            
            If Coalesce(h_bitflag, 0) = 3 Then
               BEGIN
                  DELETE FROM TASK_DAY_OF_YEAR 
                  WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7773+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7774) : unassign_res.sql(10234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7790+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7791) : unassign_res.sql(10251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM SUMMARY_TIMESHEETS WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7807+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7808) : unassign_res.sql(10268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
               BEGIN
                  DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7825+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7826) : unassign_res.sql(10286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (h_prj_assignment_id IS NOT NULL) Then
                  BEGIN
                     DELETE FROM RESOURCE_ASSIGNMENTS
                     WHERE PROJECT_ID = h_project_id AND PROFILE_ID = h_profile_id AND RESOURCE_TYPE = '1';
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7844+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7845) : unassign_res.sql(10305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               BEGIN
                  DELETE FROM TASK_DAY_OF_YEAR 
                  WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7863+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7864) : unassign_res.sql(10324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7880+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7881) : unassign_res.sql(10341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7897+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7898) : unassign_res.sql(10358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_temp_sc_state := FC_BEFORE_D_RES_ASSIGN(h_assign_id);
               BEGIN
                  DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_assign_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7915+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7916) : unassign_res.sql(10376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (h_prj_assignment_id IS NOT NULL) Then
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET PROJECT_ASSIGNMENT_ID = NuLL WHERE PROJECT_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7933+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7934) : unassign_res.sql(10394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET PARENT_ID = TSK_ASSIGNMENT_ID 
                     WHERE PROJECT_ID = h_project_id 
                     AND TSK_ASSIGNMENT_ID = h_prj_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7952+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7953) : unassign_res.sql(10413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   End If;
   
   If SubStr(h_res_type, 1, 1) = '0' Then
      /*      if ( h_work_type == 2 )
              {
                  h_temp_sc_state = FIX_RESCAL(SC_PARAM(h_project_id), SC_PARAM(h_res_id));
              }*/
      --trace_printf("h_bitflag = %d, h_id = %s, h_res_id: %s\n",h_bitflag,h_id,h_res_id);
      
      If (Coalesce(h_bitflag, 0) = 0) OR (Coalesce(h_bitflag, 0) = 1) Then
         BEGIN
            DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7982+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(7983) : unassign_res.sql(10443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 7999+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8000) : unassign_res.sql(10460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If ((h_resource_id IS NULL)) Then
         BEGIN
            DELETE FROM PROFILES WHERE PROFILE_ID = h_profile_id AND 
            NOT EXISTS (SELECT 'X' FROM PMO_TMP_DELETE WHERE PROFILE_ID = h_profile_id) AND
            (SELECT COUNT(*) FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND PROFILE_ID = h_profile_id) = 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8020+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8021) : unassign_res.sql(10481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("SC_STATE: %d, h_profile_id: %d:%s\n",SC_STATE,h_profile_id_Ind,h_profile_id);
   Else
      If Coalesce(h_bitflag, 0) = 3 Then
         BEGIN
            DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_profile_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8040+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8041) : unassign_res.sql(10501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID = h_profile_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8057+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8058) : unassign_res.sql(10518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PROFILES WHERE PROFILE_ID = h_profile_id AND
            (SELECT COUNT(*) FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND PROFILE_ID = h_profile_id) = 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8075+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8076) : unassign_res.sql(10536) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE PROFILES SET REC_STATUS = 'D' WHERE PROFILE_ID = h_profile_id AND
            (SELECT COUNT(*) FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND PROFILE_ID = h_profile_id) = 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8093+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8094) : unassign_res.sql(10554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --trace_printf("SC_STATE: %d, h_type_id = %d, h_prj_assignment_id: %d:%s, h_from_prj = %d\n",SC_STATE,h_type_id,h_prj_assignment_id_Ind,h_prj_assignment_id,h_from_prj);
   
   If (h_prj_assignment_id IS NOT NULL) Then
      -- CALL UPDATE assign string function
      h_temp_var := 3;
      h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_prj_assignment_id, h_temp_var, 0, 0);
   End If;
   
   --trace_printf("h_bitflag = %d, h_mls_percent = %d, h_type_id = %d\n",h_bitflag,h_mls_percent,h_type_id);
   If (Coalesce(h_bitflag, 0) = 2) OR (Coalesce(h_bitflag, 0) = 1) OR (Coalesce(
             h_mls_percent, 0) > 0) Then
      --trace_printf("2____* h_replace_type: %s, h_profile_id: %s\n", h_replace_type,h_profile_id);
      h_temp_res_type := h_replace_type;
      h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_profile_id, h_temp_res_type);
      
      If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         If SubStr(h_replace_type, 1, 1) = '1' Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET (ESTIMATED_PLANNED_START, ESTIMATED_PLANNED_FINISH,ESTIMATED_PLANNED_EFFORT)
               = (SELECT COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START), COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH),
               CASE WHEN ESTIMATED_PLANNED_EFFORT = 0 THEN ESTIMATED_SCHED_EFFORT ELSE ESTIMATED_PLANNED_EFFORT END
               FROM PROJECT_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id)
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8134+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8135) : unassign_res.sql(10595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1_ SC_STATE: %d, h_profile_id: %d:%s\n",SC_STATE,h_profile_id_Ind,h_profile_id);
         Else
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET (ESTIMATED_SCHED_START, ESTIMATED_SCHED_FINISH,ESTIMATED_SCHED_EFFORT,
               ESTIMATED_PLANNED_START, ESTIMATED_PLANNED_FINISH,ESTIMATED_PLANNED_EFFORT)
               = (SELECT ESTIMATED_SCHED_START, ESTIMATED_SCHED_FINISH,ESTIMATED_SCHED_EFFORT,
               ESTIMATED_PLANNED_START, ESTIMATED_PLANNED_FINISH,ESTIMATED_PLANNED_EFFORT
               FROM PROJECT_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id)
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8158+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8159) : unassign_res.sql(10619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("0_ SC_STATE: %d, h_profile_id: %d:%s\n",SC_STATE,h_profile_id_Ind,h_profile_id);
         End If;
      End If;
      
      h_temp_res_type := '0';
      h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_res_id, h_temp_res_type);
   ElsIf (Coalesce(h_bitflag, 0) = 0) AND (isProjectType(Coalesce(h_type_id, 0))) <> 0 Then
      If SubStr(h_replace_type, 1, 1) = '1' Then
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS SET
            ESTIMATED_PLANNED_START = NULL, ESTIMATED_PLANNED_FINISH = NULL,ESTIMATED_PLANNED_EFFORT = 0,
            ESTIMATED_PLANNED_COST = 0, ESTIMATED_PLANNED_REVENUE = 0
            WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_profile_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_TSKRES', 8185+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_TSKRES(8186) : unassign_res.sql(10646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("DP1_ SC_STATE: %d, h_profile_id: %d:%s\n",SC_STATE,h_profile_id_Ind,h_profile_id);
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   -- END -- FC_D_TSKRES
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_TSKRES', 8199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_TSKRES(8200) : unassign_res.sql(10660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_TSKRES;
ALTER FUNCTION FC_D_TSKRES COMPILE DEBUG;

